//	Cu
#include "lib\udx.h"

//	萔E}N
#include "Const.h"
#include "Macro.h"

extern const float RAIL_TIE_INTERVAL = 0.5f;	//	؊Ԋu
extern const float RAIL_PIER_INTERVAL = 5.0f;	//	rԊu
extern const float LINE_VERT_INTERVAL = 5.0f;	//	ːcԊu
extern const float CUS_3D_SELECT = 1.5f;		//	Hڑ̃J[\͈

const float RAIL_THICKNESS = 0.05f;				//	[̑
const float RAIL_PIER_TSD = 0.3f;				//	rݒuŒፂx
const float RAIL_PIER_GROUND = 0.4f;			//	rߍݐ[
const float RAIL_PIER_RACK = 0.1f;				//	[x̌
const float POINT_RESERVE_LEN = 12.0f;			//	|Cg\񋗗
const float POINT_CHECK_DIST = 5.0f;			//	|Cĝ߂̒T
const float TRAIN_SET_TSD = 0.5001f;				//	qݒuA̋̃`bvɑ΂銄̂l
const float LINE_POS_LOW = 1.272321428f;		//	orig1.25
												//	g[
const VEC3 LINE_POS_HIGH(0.0f, 0.10f, 0.0f);	//	g[ƒ݉ː̊Ԋu

//	c[֐
#include "ValueArea.h"
#include "SystemCover.h"
#include "CameraControl.h"

//	NX
#include "CRail.h"
#include "CPlugin.h"
#include "CRailModel.h"
#include "CTieModel.h"
#include "CPierModel.h"
#include "CTrainGroup.h"

//	OO[o
extern char g_TieReplace[][FILE_NAME_MAX];
extern char g_PierReplace[][FILE_NAME_MAX];
extern int g_MiscOptionShadowFlag;
extern int g_MiscOptionTieFlag;
extern int g_MiscOptionLineFlag;
extern int g_MiscOptionRailMode;
extern int g_CSVersion;
extern int g_AltSwitch;
extern float g_RailFarDraw;
extern float g_RailFarHide;
extern float g_TieFarDraw;
extern float g_TieFarHide;
extern float g_PierFarDraw;
extern float g_PierFarHide;
extern float g_LineFarDraw;
extern float g_LineFarHide;
extern POINT g_Pointer;
extern POINT g_AreaPos1;
extern POINT g_AreaPos2;
extern VEC3 g_ArrowPost;
extern CObject g_LinkObject;
extern CObject g_AnchorObject;
extern CObject g_SurfaceObject;
extern CRailModel *g_RailOptionModelSeed;
extern CRailModel *g_RailOptionModelSelect;
extern CTieModel *g_TieOptionModelSeed;
extern CTieModel *g_TieOptionModelSelect;
extern CPierModel *g_PierOptionModelSeed;
extern CPierModel *g_PierOptionModelSelect;
extern CTrainGroup *g_TrainGroupParent;

//	O[o
float g_RailOptionNearestDist;			//	Iɔ͈͓ōł߂̂̋
CRail **g_RailOptionLinkFrom = NULL;	//	ڑ̃N|C^
CRail *g_RailOptionLinkMaster;			//	ڑ̃N[
CRail *g_RailOptionLastInstalled;		//	Ōɒǉꂽ[
CRail *g_RailOptionTrainCheck;			//	[TJn[ ([vh~p)
CRail *g_RailOptionNearest1 = NULL;		//	ł߂[ (\p)
CRail *g_RailOptionNearest2 = NULL;		//	ł߂[ (vZp)

int g_RailSelectFlag;	//	[IIvV
int g_RailCreate = 1;	//	[ݒuIvV
int g_TieCreate = 0;	//	ؐݒuIvV
int g_PierCreate = 0;	//	rݒuIvV
int g_LineCreate = 0;	//	ːݒuIvV

float g_RailTie;				//	؊Jnn_vZp
float g_RailPier;				//	rJnn_vZp
float g_RailLine;				//	ːcn_vZp
float g_LinkMin;				//	ڑɃJ[\ɍł߂̂̋
float g_RailLength;				//	Hvl
float g_MiddleLength = -1.0f;	//	܂ł̐H

D3DCOLOR g_LineColor = 0xff000000;	//	ː̐F

VEC3 g_LinkPos;		//	ڑW
VEC3 g_LinkUp;		//	ڑ up xNg
VEC3 g_LinkNormal;	//	ڑ
VEC3 g_RailScanDir;	//	

CRail *g_HomeMiddle;	//	Ã[̒

/*
 *	RXgN^
 */
CRail::CRail(){
	int i, j;
	m_User = m_Update = m_SUpdate = -1;
	m_Selected = m_HomeAnchor = m_LineFlag = false;
	m_RailModel = NULL;
	m_TieModel = NULL;
	m_PierModel = NULL;
	m_PierNum = 0;
	m_PHigh = NULL;
	for(i = 0; i<2; i++){
		m_Point[i] = 0;
		m_Pos[i] = V3ZERO;
		m_Up[i] = V3UP;
		for(j = 0; j<2; j++) m_Next[i][j] = NULL;
	}
	for(i = 0; i<3; i++) m_Dir[i] = V3ZERO;
}

/*
 *	fXgN^
 */
CRail::~CRail(){
	if(m_PHigh) delete [] m_PHigh;
}

/*
 *	[̐ݒu
 *
 *	߂l: Aݒup̐ڑp|C^
 */
CRail **CRail::Install(
	VEC3 *p1,	//	Jnn_W
	VEC3 *p2,	//	In_W
	VEC3 *n1,	//	Jnn_
	VEC3 *n2,	//	In_
	VEC3 *u1,	//	Jnn_ up xNg
	VEC3 *u2	//	In_ up xNg
){
	int i, j;
	float a, b, t1, t2, width, height, gauge;
	m_RailModel = g_RailOptionModelSelect;
	m_TieModel = g_TieOptionModelSelect;
	m_PierModel = g_PierOptionModelSelect;
	if(m_RailModel){
		width = m_RailModel->m_Width;
		height = m_RailModel->m_Height;
		gauge = m_RailModel->m_Gauge;
	}else{
		width = height = gauge = 0.0f;
	}
	VEC3 r = *p2-*p1, pp, pick;
	m_Pos[0] = *p1;
	m_Pos[1] = *p2;
	m_Normal[0] = *n1;
	m_Normal[1] = *n2;
	m_Up[0] = *u1;
	m_Up[1] = *u2;
	V3Norm(&m_Up[2], &(*u1+*u2));
	V3Norm(&m_Dir[2], &r);
	V3Norm(&m_Right[0], V3Cross(&m_Right[0], &m_Dir[2], u1));
	V3Norm(&m_Right[1], V3Cross(&m_Right[1], &m_Dir[2], u2));
	m_Length[2] = V3Len(&r);
	a = gauge*0.5f/(t1 = tan(acos(V3Dot(n1, &m_Right[0]))));
	m_Start[0] = -a;
	m_Start[1] = a;
	a = gauge*0.5f/(t2 = tan(acos(V3Dot(n2, &m_Right[1]))));
	m_Length[0] = m_Length[2]-a-m_Start[0];
	m_Length[1] = m_Length[2]+a-m_Start[1];
	V3Norm(&m_Dir[0], &((m_Pos[0]-gauge*0.5f*m_Right[0]+(m_Length[0]+m_Start[0])*m_Dir[2])-(m_Pos[0]-gauge*0.5f*m_Right[1]+m_Start[0]*m_Dir[2])));
	V3Norm(&m_Dir[1], &((m_Pos[0]+gauge*0.5f*m_Right[0]+(m_Length[1]+m_Start[1])*m_Dir[2])-(m_Pos[0]+gauge*0.5f*m_Right[1]+m_Start[1]*m_Dir[2])));
	a = fabsf(width*0.5f/t1);
	if((b = V3Dot(&m_Dir[2], u1))<0.0f) a -= height/tan(acos(b));
	m_Start[0] -= a;
	m_Start[1] -= a;
	a += fabsf(width*0.5f/t2);
	if((b = V3Dot(&m_Dir[2], u2))>0.0f) a += height/tan(acos(b));
	m_Length[0] += a;
	m_Length[1] += a;
	m_Mid = (*p1+*p2)*0.5f;
	m_Next[0][0] = g_RailOptionLastInstalled;
	g_RailOptionLastInstalled = this;
	if(g_RailLength>=0.0f){
		if(g_HomeMiddle){
			//	z[AJ[ݒuW̌vZ
			g_RailLength += m_Length[2];
			if(g_MiddleLength<0.5f*g_RailLength){
				CRail *mmn[2] = {NULL, NULL};
				for(i = 0; i<2; i++){
					for(j = 0; j<2; j++){
						if(g_HomeMiddle->m_Next[i][j]){
							mmn[i] = g_HomeMiddle->m_Next[i][j];
							break;
						}
					}
				}
				if(mmn[0] && V3Dot(&g_RailScanDir, &(mmn[0]->m_Mid-g_HomeMiddle->m_Mid))>0.0f){
					g_HomeMiddle = mmn[0];
					g_MiddleLength += mmn[0]->m_Length[2];
					g_RailScanDir = mmn[0]->m_Mid-g_HomeMiddle->m_Mid;
				}else if(mmn[1]){
					g_HomeMiddle = mmn[1];
					g_MiddleLength += mmn[1]->m_Length[2];
					g_RailScanDir = mmn[1]->m_Mid-g_HomeMiddle->m_Mid;
				}else{
					g_RailLength = -1.0f;
					g_HomeMiddle = NULL;
				}
			}
		}else{
			g_HomeMiddle = this;
			g_MiddleLength = m_Length[2];
		}
	}
	m_LineFlag = !!g_LineCreate;
	if(m_TieModel){
		if(g_RailTie<0.0f) g_RailTie = m_TieModel->m_Interval;
		m_Tie = m_TieModel->m_Interval-g_RailTie;
		while(m_Tie<0.0f) m_Tie += m_TieModel->m_Interval;
		g_RailTie += m_Length[2];
		ValueCircular(&g_RailTie, 0.0f, m_TieModel->m_Interval);
	}else{
		g_RailTie = m_Tie = 0.0f;
	}
	if(m_PierModel){
		if(g_RailPier<0.0f) g_RailPier = m_PierModel->m_Interval;
		m_Pier = m_PierModel->m_Interval-g_RailPier;
		while(m_Pier<0.0f) m_Pier += m_PierModel->m_Interval;
		g_RailPier += m_Length[2];
		ValueCircular(&g_RailPier, 0.0f, m_PierModel->m_Interval);
		if(m_Pier<=m_Length[2]){
			m_PierNum = 1+(int)((m_Length[2]-m_Pier)/m_PierModel->m_Interval);
			m_PHigh = new float[m_PierNum];
			for(i = 0; i<m_PierNum; i++){
				m_PHigh[i] = -1.0f;
				if(g_SurfaceObject.Pick(pp =
					m_Pos[0]+(m_Pier+i*m_PierModel->m_Interval)*m_Dir[2], -V3UP, &pick, NULL)
					&& (pp.y-pick.y)>RAIL_PIER_TSD) m_PHigh[i] = pick.y;
			}
		}
	}else{
		g_RailPier = m_Pier = 0.0f;
	}
	m_VLine = LINE_VERT_INTERVAL-g_RailLine;
	while(m_VLine<0.0f) m_VLine += LINE_VERT_INTERVAL;
	g_RailLine += m_Length[2];
	ValueCircular(&g_RailLine, 0.0f, LINE_VERT_INTERVAL);
	return &m_Next[1][0];
}

/*
 *	[擾
 */
float CRail::GetRailHeight(){
	return m_RailModel ? m_RailModel->m_Height : 0.0f;
}

/*
 *	J[\W[ւ̐ڑ𔻒
 */
void CRail::TryLink(
	bool conv2d	//	^W 3D WH
){
	int i, j;
	float td, td2, tmin = 1000.0f;
	POINT pm;
	if(conv2d){
		tmin = PTR_2D_SELECT/PointPointDistance(&m_Mid, &GetVPos());
		pm = WorldToScreen2(&m_Mid);
		if((td = FlatPointDistance(&pm, &g_Pointer))>=g_LinkMin) return;
	}else{
		tmin = CUS_3D_SELECT;
		if((td = PointPointDistance(&m_Mid, &g_ArrowPost))>=g_LinkMin) return;
	}
	for(i = 0; i<2; i++){
		if(conv2d){
			pm = WorldToScreen2(&m_Pos[i]);
			if((td2 = FlatPointDistance(&pm, &g_Pointer))>=tmin) continue;
		}else{
			if((td2 = PointPointDistance(&m_Pos[i], &g_ArrowPost))>=tmin) continue;
		}
		for(j = 0; j<2; j++){
			if(!m_Next[i][j]){
				tmin = td2;
				g_LinkMin = td;
				g_LinkPos = m_Pos[i];
				g_LinkNormal = i ? m_Normal[i] : -m_Normal[i];
				g_LinkUp = m_Up[i];
				g_RailOptionLinkFrom = &m_Next[i][j];
				g_RailOptionLinkMaster = this;
				if(m_TieModel){
					if(i) g_RailTie = m_Length[2]-m_Tie; else g_RailTie = m_Tie;
					while(g_RailTie<0.0f) g_RailTie += m_TieModel->m_Interval;
				}else{
					g_RailTie = -1.0f;
				}
				if(m_PierModel){
					if(i) g_RailPier = m_Length[2]-m_Pier; else g_RailPier = m_Pier;
					while(g_RailPier<0.0f) g_RailPier += m_PierModel->m_Interval;
				}else{
					g_RailPier = -1.0f;
				}
				if(i) g_RailLine = m_Length[2]-m_VLine; else g_RailLine = m_VLine;
				while(g_RailLine<0.0f) g_RailLine += LINE_VERT_INTERVAL;
				break;
			}
		}
	}
}

/*
 *	郌[̐ڑ
 */
void CRail::UnLink(
	CRail *t	//	郌[
){
	int i, j;
	for(i = 0; i<2; i++) for(j = 0; j<2; j++) if(m_Next[i][j]==t) m_Next[i][j] = NULL;
}

/*
 *	|Cgʂ̂߂̒T
 *
 *	߂l:	苗Ti߂n_̍W
 */
VEC3 CRail::ReadNext(
	CRail *s,	//	ǂĂ[
	VEC3 *o		//	TW
){
	int t = 0, j;
	float ttt;
	if((ttt = V3Len(&(*o-m_Mid)))<POINT_CHECK_DIST){
		for(j = 0; j<2; j++) if(m_Next[0][j]==s) t = 1;
		for(j = 0; j<2; j++) if(m_Next[t][j]) return m_Next[t][j]->ReadNext(this, o);
	}
	return m_Mid;
}

/*
 *	I
 */
void CRail::Select(){
	float td, dist;
	POINT scr;
	if(V3Dot(&(m_Mid-GetVPos()), &GetVDir())<0) return;
	if(g_RailSelectFlag&2){
		scr = WorldToScreen2(&m_Mid);
		if(CheckValueArea(scr.x, g_AreaPos1.x, g_AreaPos2.x) && CheckValueArea(scr.y, g_AreaPos1.y, g_AreaPos2.y)) m_Selected = true;
	}
	if(g_RailSelectFlag&1){
		scr = WorldToScreen2(&m_Mid);
		td = PTR_2D_SELECT/PointPointDistance(&m_Mid, &GetVPos());
		if((dist = sqrtf(Squ(scr.x-g_AreaPos1.x)+Squ(scr.y-g_AreaPos1.y)))<td){
			if(!g_RailOptionNearest2 || g_RailOptionNearestDist>dist){
				g_RailOptionNearestDist = dist;
				g_RailOptionNearest2 = this;
			}
		}
	}
}

/*
 *	I
 */
void CRail::Release(){
	m_Selected = false;
}

/*
 *	IĂ΍폜
 *
 *	폜ɐ true Ԃ
 */
bool CRail::Delete(){
	int i, j;
	if(m_User>=0) return false;
	if(m_Selected){
		for(i = 0; i<2; i++) for(j = 0; j<2; j++) if(m_Next[i][j]) m_Next[i][j]->UnLink(this);
		delete this;
		return true;
	}
	return false;
}

/*
 *	_O
 */
void CRail::Show(){
	static D3DMATERIAL8 col2 = {{1.0f, 0.5f, 0.0f, 1.0f}, {1.0f, 0.5f, 0.0f, 1.0f}};
	static D3DMATERIAL8 col3 = {{1.0f, 0.0f, 0.0f, 1.0f}, {1.0f, 0.0f, 0.0f, 1.0f}};
	int i;
	float ttmp, ta, td, dist, height, gauge;
	if(m_RailModel){
		height = m_RailModel->m_Height;
		gauge = m_RailModel->m_Gauge;
	}else{
		height = gauge = 0.0f;
	}
	POINT scr;
	D3DMATERIAL8 *pcol = NULL;
	VEC3 n, u, r;
	m_SUpdate = m_Update;
	m_Update = -1;
	if(g_RailSelectFlag&8){
		if(g_RailOptionLinkMaster==this && !g_AltSwitch){
			g_LinkObject.SetPos(g_LinkPos+RAIL_HEIGHT*g_LinkUp);
			g_LinkObject.SetDir(g_LinkUp, -g_LinkNormal);
			g_LinkObject.Render();
			pcol = &col2;
		}
	}
	if((g_RailSelectFlag&4) && m_Selected) pcol = &col3;
	if(g_RailSelectFlag&2){
		scr = WorldToScreen2(&m_Mid);
		if(CheckValueArea(scr.x, g_AreaPos1.x, g_AreaPos2.x)
			&& CheckValueArea(scr.y, g_AreaPos1.y, g_AreaPos2.y)) pcol = &col2;
	}
	if(g_RailSelectFlag&1){
		scr = WorldToScreen2(&m_Mid);
		td = PTR_2D_SELECT/PointPointDistance(&m_Mid, &GetVPos());
		if((dist = sqrtf(Squ(scr.x-g_AreaPos1.x)+Squ(scr.y-g_AreaPos1.y)))<td){
			if(!g_RailOptionNearest2 || g_RailOptionNearestDist>dist){
				g_RailOptionNearestDist = dist;
				g_RailOptionNearest2 = this;
			}
		}
		if(g_RailOptionNearest1==this) pcol = &col2;
	}
	if(g_MiscOptionLineFlag && m_LineFlag){
		ta = g_MiscOptionRailMode ? 1.0f : GetFarAlpha(&m_Mid, g_LineFarDraw, g_LineFarHide);
		if(ta>0.0f){
			D3DCOLOR lcol = (((int)(ta*255))<<24)|g_LineColor;
			VEC3 lip1 = m_Pos[0]+(height+LINE_POS_LOW)*m_Up[0];
			VEC3 lip2 = m_Pos[1]+(height+LINE_POS_LOW)*m_Up[1];
			ResetMatrix();
			devResetMaterial();
			devSetTexture(0, NULL);
			devSetLighting(false);
			Draw3DLine(lip1, lip2, lcol, lcol);
			Draw3DLine(lip1+LINE_POS_HIGH, lip2+LINE_POS_HIGH, lcol, lcol);
			if(m_VLine<=m_Length[2]){
				float tr2 = m_VLine/m_Length[2], tr1 = 1.0f-tr2;
				VEC3 lipm = tr1*lip1+tr2*lip2;
				Draw3DLine(lipm, lipm+LINE_POS_HIGH, lcol, lcol);
			}
			devSetLighting(true);
		}
	}
	if(g_MiscOptionRailMode){
		ta = 1.0f;
	}else{
		ta = GetFarAlpha(&m_Mid, g_RailFarDraw, g_RailFarHide);
		if(ta==0.0f) return;
	}
	if(m_RailModel){
		float scale = m_RailModel->m_Scale;
		CObject *robj = m_RailModel->GetObject();
		for(i = 0; i<2; i++){
			robj->SetPos(m_Pos[0]+gauge*(i ? -0.5f : 0.5f)*m_Right[0]+m_Start[i]*m_Dir[2]);
			robj->SetDir(m_Dir[i], m_Up[2]);
			robj->SetScale2(scale, scale, m_Length[i]*scale);
			if(g_MiscOptionShadowFlag) RenderShadow2(robj, ta);
			Render3(robj, ta, pcol);
			robj++;
		}
	}
	if(m_PierModel){
		float scale = m_PierModel->m_Scale;
		CObject *pobj = m_PierModel->GetObject();
		for(i = 0; i<m_PierNum; i++){
			if(m_PHigh[i]>=0.0f){
				float pos = m_Pier+i*m_PierModel->m_Interval;
				r = m_Pos[0]+pos*m_Dir[2];
				ta = g_MiscOptionRailMode ? 1.0f : GetFarAlpha(&r, g_PierFarDraw, g_PierFarHide);
				pobj->SetPos(VEC3(r.x, m_PHigh[i]-RAIL_PIER_GROUND
					+(ttmp = r.y-m_PHigh[i]+RAIL_PIER_GROUND-RAIL_PIER_RACK), r.z));
				pobj->SetDir(VEC3(m_Dir[2].x, 0.0f, m_Dir[2].z), -V3UP);
				pobj->SetScale2(scale, ttmp*scale, scale);
				if(g_MiscOptionShadowFlag) RenderShadow2(pobj, ta);
				Render3(pobj, ta, pcol);
				pobj++;
				pobj->SetPos(VEC3(r.x, r.y, r.z));
				pobj->SetDir(m_Dir[2], (m_Up[0]*(m_Length[2]-pos)+m_Up[1]*pos)/m_Length[2]);
	 			if(g_MiscOptionShadowFlag) RenderShadow2(pobj, ta);
				Render3(pobj, ta, pcol);
			}
		}
	}
	CObject *tobj = m_TieModel ? m_TieModel->GetObject() : NULL;
	if(tobj && g_MiscOptionTieFlag){
		ta = g_MiscOptionRailMode ? 1.0f : GetFarAlpha(&m_Mid, g_TieFarDraw, g_TieFarHide);
		if(ta>0.0f){
			for(ttmp = m_Tie; ttmp<=m_Length[2]; ttmp += m_TieModel->m_Interval){
				tobj->SetPos(m_Pos[0]+ttmp*m_Dir[2]);
				tobj->SetDir(m_Dir[2], (m_Up[0]*(m_Length[2]-ttmp)+m_Up[1]*ttmp)/m_Length[2]);
				if(g_MiscOptionShadowFlag) RenderShadow2(tobj, ta);
				Render3(tobj, ta, pcol);
			}
		}
	}
	if(m_HomeAnchor && !g_AltSwitch){
		g_AnchorObject.SetPos(m_Mid);
		g_AnchorObject.SetDir(m_Up[2], m_Dir[2]);
		Render2(&g_AnchorObject, ta);
	}
}

/*
 *	gpq̃Zbg
 */
void CRail::EraseUser(
	int u	//	ZbgqCfbNX
){
	if(m_User==u) m_User = -1;
}

/*
 *	q̐ݒuWvZ (O̎ԗ֍WɁA̎ԗ֍WZo)
 *
 *	߂l:	qݒu郌[
 */
CRail *CRail::GetTrainPos(
	CRail *src,	//	ǂĂ[
	VEC3 *d,	//	
	VEC3 *p1,	//	Oԗ֍W
	VEC3 *p2,	//	ԗ֍W (ʊi[)
	VEC3 *u,	//	up xNg
	float l,	//	Oԗ֊Ԋu
	int f1,		//	vZptO (ȉڍ)
				//	0x01: TJntO (Oԗ֍Ws)
				//	0x02: TJntO (Oԗ֍W)
				//	0x04: zuԂ̔zutO
				//	0x08: [U[L^tO
				//	0x10: qƂ̏Փ˔tO
				//	0x20: ǂ݃|Cg\tO
				//	0x40: s~܂Ȃ NULL ԂtO
	int usrc	//	gpqCfbNX
){
	static VEC3 su;
	int d1, d2, i;
	double beta, gamma, rm, rn;
	VEC3 tdir, tp1, tp2, dd;
	CRail *np = NULL;
	if(V3Dot(d, &(m_Pos[0]-m_Mid))<0){
		d1 = 1;
		d2 = 0;
	}else{
		d1 = 0;
		d2 = 1;
	}
	if(f1&0x10 && m_User>=0 && m_User!=usrc) return NULL;
	if(f1&0x08) m_User = usrc;
	if(src && f1&0x04){
		if(m_Next[d1][0]==src) m_Point[d1] = 0;
		else if(m_Next[d1][1]==src) m_Point[d1] = 1;
	}
	switch(f1&0x03){
	case 0x02:
		*p1 = m_Pos[d1];
	case 0x01:
		g_RailOptionTrainCheck = this;
		V3Norm(&su, &((V3Len(&(m_Pos[d1]-*p1))*m_Up[d2]+V3Len(&(m_Pos[d2]-*p1))*m_Up[d1])/m_Length[2]));
		break;
	default:
		if(g_RailOptionTrainCheck==this) return NULL;
	}
	V3Norm(&tdir, &(m_Pos[d1]-m_Pos[d2]));
	tp1 = m_Pos[d1]-m_Mid;
	tp2 = *p1-m_Mid;
	beta = 2.0f*(V3Dot(&tdir, &tp1)-V3Dot(&tdir, &tp2));
	gamma = V3Len2(&tp1)+V3Len2(&tp2)-Squ(l)-2.0f*V3Dot(&tp1, &tp2);
	tp2 = tdir*(-beta-sqrt(fabsf(Squ(beta)-4.0f*gamma)))*0.5f+tp1;
	if(V3Len(&tp2)>m_Length[2]*TRAIN_SET_TSD){
		if(m_Next[d2][0] && m_Next[d2][1]){
			//	w|Cg̒ʂɒʉ
			np = m_Next[d2][m_Point[d2]];
		}else{
			//	_^s
			for(i = 0; i<2; i++){
				if(m_Next[d2][i]){
					np = m_Next[d2][i];
					break;
				}
			}
		}
		if(np) return np->GetTrainPos(this, &tdir, p1, p2, u, l, f1&0xfc, usrc);
		if(f1&0x40) return NULL;
		if(f1&0x10) return this;
		return NULL;
	}
	tp2 += m_Mid;
	rn = V3Len(&(m_Pos[d1]-tp2));
	rm = V3Len(&(m_Pos[d2]-tp2));
	if(p2) *p2 = tp2+0.5f*rn*rm*(m_Normal[0]-m_Normal[1])/m_Length[2];
	if(u){
		V3Norm(u, &(rn*m_Up[d2]+rm*m_Up[d1]));
		V3Norm(u, &(*u+su));
	}
	return this;
}

/*
 *	z[AJ[ (wԃ|Cg) ̒T
 *
 *	߂l:	-1: ՓˌoA0: ʏA1: s~܂
 *			2: AJ[oA3: s~܂AJ[o
 */
int CRail::ScanAnchor(
	VEC3 *d,	//	
	float l,	//	T
	float th,	//	TI鋗
	float *get,	//	oi[
	bool st,	//	TJntO
	bool ha,	//	AJ[otO
	int pcnt,	//	|CgTJEg
	int usrc	//	gpqCfbNX
){
	int d1, d2, i;
	VEC3 tdir, dd;
	CRail *np = NULL;
	if(V3Dot(d, &(m_Pos[0]-m_Mid))<0){
		d1 = 1;
		d2 = 0;
	}else{
		d1 = 0;
		d2 = 1;
	}
	if((m_User>=0 && m_User!=usrc) || (m_SUpdate>=0 && m_SUpdate!=usrc)){
		if(l<=POINT_RESERVE_LEN){
			*get = 0.5f*l;
			return -1;
		}
	}
	if(st) g_RailOptionTrainCheck = this;
	else if(g_RailOptionTrainCheck==this) ha ? 2 : 0;
	if(m_HomeAnchor){
		ha = true;
		*get = l+0.3f*m_Length[2];
	}
	tdir = m_Pos[d1]-m_Pos[d2];
	l += m_Length[2];
	if(l<th){
		if(l<=POINT_RESERVE_LEN) m_Update = usrc;
		if(m_Next[d2][0] && m_Next[d2][1]){
			//	2 ̘AA|Cgł
			if(l<=POINT_RESERVE_LEN){
				np = m_Next[d2][m_Point[d2]];
				if(m_SUpdate<0){
					//	܂|Cgm肳ĂȂ
					if(i = g_TrainGroupParent->ReadPoint(-1)){
						//	|CgɂčE
						V3Cross(&dd, &(m_Next[d2][0]->ReadNext(this, &m_Mid)-m_Mid),
							&(m_Next[d2][1]->ReadNext(this, &m_Mid)-m_Mid));
						if(dd.y>0.0f) m_Point[d2] = (i==1 ? 0 : 1);
						else m_Point[d2] = (i==1 ? 1 : 0);
					}else{
						m_Point[d2] = 0;
					}
				}
				np = m_Next[d2][m_Point[d2]];
			}else{
				if(i = g_TrainGroupParent->ReadPoint(pcnt++)){
					//	|CgɂčE
					V3Cross(&dd, &(m_Next[d2][0]->ReadNext(this, &m_Mid)-m_Mid),
						&(m_Next[d2][1]->ReadNext(this, &m_Mid)-m_Mid));
					if(dd.y>0.0f) np = m_Next[d2][i==1 ? 0 : 1];
					else np = m_Next[d2][i==1 ? 1 : 0];
				}else{
					np = m_Next[d2][0];
				}
			}
		}else{
			//	|Cgł͂Ȃ
			for(i = 0; i<2; i++){
				if(m_Next[d2][i]){
					np = m_Next[d2][i];
					break;
				}
			}
		}
		if(np) return np->ScanAnchor(&tdir, l, th, get, false, ha, pcnt, usrc);
		*get = l-0.5f*m_Length[2];
		return ha ? 3 : 1;
	}
	if(!ha) *get = th;
	return ha ? 2 : 0;
}

/*
 *	z[AJ[L̐؂ւ
 */
void CRail::SwitchAnchor(){
	m_HomeAnchor = !m_HomeAnchor;
}

/*
 *	ۑ
 */
void CRail::SaveData(
	FILE *df	//	t@C
){
	int i;
	fprintf(df, "\tRailTip{\n\t\tAddress=%08X\n", this);
	fprintf(df, "\t\tPoint=%d,%d\n", m_Point[0], m_Point[1]);
	fprintf(df, "\t\tUserInfo=%d,%d,%d\n", m_User, m_Update, m_SUpdate);
	fprintf(df, "\t\tHomeAnchor=%d\n", m_HomeAnchor);
	fprintf(df, "\t\tStart=%f,%f\n", m_Start[0], m_Start[1]);
	fprintf(df, "\t\tLength=%f,%f,%f\n", m_Length[0], m_Length[1], m_Length[2]);
	fprintf(df, "\t\tTieOffset=%f\n", m_Tie);
	fprintf(df, "\t\tPierOffset=%f,%d", m_Pier, m_PierNum);
	for(i = 0; i<m_PierNum; i++) fprintf(df, ",%f", m_PHigh[i]);
	fprintf(df, "\n");
	fprintf(df, "\t\tVLineOffset=%f\n", m_VLine);
	fprintf(df, "\t\tRailModel=%s\n", m_RailModel ? m_RailModel->GetIndex() : "*none");
	fprintf(df, "\t\tTieModel=%s\n", m_TieModel ? m_TieModel->GetIndex() : "*none");
	fprintf(df, "\t\tPierModel=%s\n", m_PierModel ? m_PierModel->GetIndex() : "*none");
	fprintf(df, "\t\tLineFlag=%d\n", m_LineFlag);
	fprintf(df, "\t\tPosition=");
	SaveVec3Data(df, m_Pos[0], ",");
	SaveVec3Data(df, m_Pos[1], "\n");
	fprintf(df, "\t\tNormal=");
	SaveVec3Data(df, m_Normal[0], ",");
	SaveVec3Data(df, m_Normal[1], "\n");
	fprintf(df, "\t\tUp=");
	SaveVec3Data(df, m_Up[0], ",");
	SaveVec3Data(df, m_Up[1], ",");
	SaveVec3Data(df, m_Up[2], "\n");
	fprintf(df, "\t\tRight=");
	SaveVec3Data(df, m_Right[0], ",");
	SaveVec3Data(df, m_Right[1], "\n");
	fprintf(df, "\t\tDirection=");
	SaveVec3Data(df, m_Dir[0], ",");
	SaveVec3Data(df, m_Dir[1], ",");
	SaveVec3Data(df, m_Dir[2], "\n");
	fprintf(df, "\t\tMiddle=");
	SaveVec3Data(df, m_Mid, "\n");
	fprintf(df, "\t\tLinkInfo=(%08X,%08X),(%08X,%08X)\n", m_Next[0][0], m_Next[0][1], m_Next[1][0], m_Next[1][1]);
	fprintf(df, "\t}\n");
}

/*
 *	Ǎ
 */
CRail *CRail::LoadData(
	FILE *df	//	t@C
){
	char id_rail[FILE_NAME_MAX], id_tie[FILE_NAME_MAX], id_pier[FILE_NAME_MAX];
	int i;
	VEC3 dummy;
	CRail *atmp;
	fscanf(df, "\tRailTip{\n\t\tAddress=%08X\n", &atmp);
	fscanf(df, "\t\tPoint=%d,%d\n", &m_Point[0], &m_Point[1]);
	fscanf(df, "\t\tUserInfo=%d,%d,%d\n", &m_User, &m_Update, &m_SUpdate);
	if(g_CSVersion>=130) fscanf(df, "\t\tHomeAnchor=%d\n", &m_HomeAnchor);
	fscanf(df, "\t\tStart=%f,%f\n", &m_Start[0], &m_Start[1]);
	fscanf(df, "\t\tLength=%f,%f,%f\n", &m_Length[0], &m_Length[1], &m_Length[2]);
	fscanf(df, "\t\tTieOffset=%f\n", &m_Tie);
	if(g_CSVersion>=140){
		fscanf(df, "\t\tPierOffset=%f,%d", &m_Pier, &m_PierNum);
		if(m_PierNum){
			m_PHigh = new float[m_PierNum];
			for(i = 0; i<m_PierNum; i++) fscanf(df, ",%f", &m_PHigh[i]);
		}
		fscanf(df, "\n");
		fscanf(df, "\t\tVLineOffset=%f\n", &m_VLine);
	}else if(g_CSVersion>=110){
		m_PierNum = 1;
		m_PHigh = new float[1];
		fscanf(df, "\t\tPierOffset=%f,%f\n", &m_Pier, &m_PHigh[0]);
		m_VLine = m_Pier;
	}else{
		m_VLine = m_Pier = 0.0f;
		m_PierNum = 0;
	}
	if(g_CSVersion>=140){
		fscanf(df, "\t\tRailModel=%s\n", id_rail);
		fscanf(df, "\t\tTieModel=%s\n", id_tie);
		fscanf(df, "\t\tPierModel=%s\n", id_pier);
	}else if(g_CSVersion>=130){
		int tie, pier;
		fscanf(df, "\t\tTieType=%d\n", &tie);
		fscanf(df, "\t\tPierType=%d\n", &pier);
		strcpy(id_rail, "RS_Wide");
		strcpy(id_tie, g_TieReplace[tie]);
		strcpy(id_pier, g_PierReplace[pier]);
	}else{
		strcpy(id_rail, "RS_Wide");
		strcpy(id_tie, "RSW_SimpleWood");
		strcpy(id_pier, "SimpleConcrete");
	}
	if(g_CSVersion>=130) fscanf(df, "\t\tLineFlag=%d\n", &m_LineFlag);
	else m_LineFlag = true;
	fscanf(df, "\t\tPosition=");
	LoadVec3Data(df, &m_Pos[0], ",");
	LoadVec3Data(df, &m_Pos[1], "\n");
	fscanf(df, "\t\tNormal=");
	LoadVec3Data(df, &m_Normal[0], ",");
	LoadVec3Data(df, &m_Normal[1], "\n");
	fscanf(df, "\t\tUp=");
	LoadVec3Data(df, &m_Up[0], ",");
	LoadVec3Data(df, &m_Up[1], ",");
	LoadVec3Data(df, &m_Up[2], "\n");
	fscanf(df, "\t\tRight=");
	LoadVec3Data(df, &m_Right[0], ",");
	LoadVec3Data(df, &m_Right[1], "\n");
	fscanf(df, "\t\tDirection=");
	LoadVec3Data(df, &m_Dir[0], ",");
	LoadVec3Data(df, &m_Dir[1], ",");
	LoadVec3Data(df, &m_Dir[2], "\n");
	fscanf(df, "\t\tMiddle=");
	LoadVec3Data(df, &m_Mid, "\n");
	if(g_CSVersion<=100){
		fscanf(df, "\t\tTieUp=");
		LoadVec3Data(df, &dummy, "\n");
	}
	fscanf(df, "\t\tLinkInfo=(%08X,%08X),(%08X,%08X)\n", &m_Next[0][0], &m_Next[0][1], &m_Next[1][0], &m_Next[1][1]);
	fscanf(df, "\t}\n");
	if(id_rail[0]!='*' && !(m_RailModel = g_RailOptionModelSeed->Find(id_rail))){
		fclose(df);
		ShowCursor(true);
		Dialog("[vOC \"%s\" sĂ܂!", id_rail);
		ExitProcess(0);
	}
	if(id_tie[0]!='*' && !(m_TieModel = g_TieOptionModelSeed->Find(id_tie))){
		fclose(df);
		ShowCursor(true);
		Dialog("؃vOC \"%s\" sĂ܂!", id_tie);
		ExitProcess(0);
	}
	if(id_pier[0]!='*' && !(m_PierModel = g_PierOptionModelSeed->Find(id_pier))){
		fclose(df);
		ShowCursor(true);
		Dialog("rvOC \"%s\" sĂ܂!", id_pier);
		ExitProcess(0);
	}
	return atmp;
}
