//	Cu
#include "lib\udx.h"

//	萔E}N
#include "Const.h"
#include "Macro.h"

extern const float CUS_3D_SELECT;

extern const float RAIL_DIV_MIN = 2.0f;		//	_ԍŏ
extern const float RAIL_TIE_HEIGHT = 0.05f;	//	؂ɂ郌[グ

const float RAIL_BUILD_ACCUTE = 0.0f;	//	_ԍőpx (Kϒl)
const float RAIL_LINK_ACCUTE = 0.5f;	//	ڑőpx (Kϒl)
const float RAIL_BANK_TAIL = 0.2f;		//	JgW (I[)
const float RAIL_BANK_RATE = 0.5f;		//	JgW ()
const float RAIL_TIE_WIDTH = 0.75f;		//	؂̕
const float RAIL_DIV_INTERVAL = 0.5f;	//	J[uł̍ő啪
const float RAIL_DIV_MAX = 5.0f;		//	ł̍ő啪
const float RAIL_STRAIGHT_TSD = 0.15f;	//	Ƃ݂Ȃpx
const float RAIL_LINK_FIX_TSD = 0.25f;	//	Ԑ_̕Cl

//	c[֐
#include "SystemCover.h"
#include "SaveData.h"

//	NX
#include "CLogger.h"
#include "CRail.h"
#include "CRailList.h"

//	OO[o
extern CRail **g_RailOptionLinkFrom;
extern CRail *g_RailOptionLinkMaster;
extern CRail *g_RailOptionLastInstalled;
extern CRail *g_RailOptionNearest1;
extern CRail *g_RailOptionNearest2;
extern int g_RailSelectFlag;
extern int g_KantSwitch;
extern float g_RailTie;
extern float g_RailPier;
extern float g_RailLine;
extern float g_LinkMin;
extern VEC3 g_LinkPos;
extern VEC3 g_LinkUp;
extern VEC3 g_LinkNormal;
extern CLogger g_GeneralLog;
extern CLogger g_CornerLog;

//	O[o
int g_SimAlpha = 128;	//	\̓_ŃAt@l

bool g_CreationLog = true;	//	H쐬bZ[W̕\ ON/OFF (wɃz[ݒu OFF)

/*
 *	RXgN^
 */
CRailList::CRailList(){
	int i;
	m_Number = 0;
	for(i = 0; i<RAIL_TIP_MAX; i++) m_Tip[i] = NULL;
	for(i = 0; i<2; i++) m_LinkFrom2[i] = NULL;
}

/*
 *	fXgN^
 */
CRailList::~CRailList(){
	int i;
	for(i = 0; i<RAIL_TIP_MAX; i++) if(m_Tip[i]) delete m_Tip[i];
}

/*
 *	_̒ǉ
 *
 *	߂l: ǉł true Ԃ
 */
bool CRailList::Push(
	VEC3 p,	//	W
	float b	//	n\x
){
	if(m_Number>=CORNER_MAX){
		if(g_CreationLog) g_GeneralLog.Add("_܂!");
		return false;
	}
	if(g_RailOptionLinkFrom) p = g_LinkPos;
	m_Corner[m_Number] = p;
	m_Base[m_Number] = b;
	if(m_Number){
		if(V3Len(&(p-m_Corner[m_Number-1]))<RAIL_DIV_MIN){
			if(g_CreationLog) g_GeneralLog.Add("_߂܂!");
			return false;
		}
		if(m_Number>1){
			if(V3Dot2(&(p-m_Corner[m_Number-1]), &(m_Corner[m_Number-1]-m_Corner[m_Number-2]))<RAIL_BUILD_ACCUTE){
				if(g_CreationLog) g_GeneralLog.Add("px傫܂!");
				return false;
			}
		}else if(m_LinkFrom2[0]){
			if(V3Dot2(&(p-m_Corner[m_Number-1]), &m_LinkNormal2[0])<RAIL_LINK_ACCUTE){
				if(g_CreationLog) g_GeneralLog.Add("px傫܂!");
				return false;
			}
		}
		if(g_RailOptionLinkFrom){
			if(V3Dot2(&(p-m_Corner[m_Number-1]), &(-g_LinkNormal))<RAIL_LINK_ACCUTE){
				if(g_CreationLog) g_GeneralLog.Add("ڑł܂!");
				return false;
			}
			m_LinkFrom2[1] = g_RailOptionLinkFrom;
			m_LinkMaster2[1] = g_RailOptionLinkMaster;
			m_LinkPos2[1] = g_LinkPos;
			m_LinkNormal2[1] = -g_LinkNormal;
			m_LinkUp2[1] = g_LinkUp;
			if(!m_LinkFrom2[0]){
				m_TieSpace = g_RailTie;
				m_PierSpace = g_RailPier;
				m_LineSpace = g_RailLine;
			}
			if(g_CreationLog){
				m_Number++;
				Finish(false);
				return true;
			}
		}
		if(g_CreationLog) g_GeneralLog.Add("_ǉ܂B");
	}else{
		if(g_RailOptionLinkFrom){
			m_LinkFrom2[0] = g_RailOptionLinkFrom;
			m_LinkMaster2[0] = g_RailOptionLinkMaster;
			m_LinkPos2[0] = g_LinkPos;
			m_LinkNormal2[0] = g_LinkNormal;
			m_LinkUp2[0] = g_LinkUp;
			m_TieSpace = g_RailTie;
			m_PierSpace = g_RailPier;
			m_LineSpace = g_RailLine;
		}else{
			m_TieSpace = -1.0f;
			m_PierSpace = -1.0f;
		}
		if(g_CreationLog) g_GeneralLog.Add("[쐬Jn܂B");
	}
	if(g_CreationLog) g_CornerLog.AddF("%2d: (%.1f, %.1f, %.1f)", m_Number, p.x, p.y, p.z);
	m_Number++;
	return true;
}

/*
 *	_ 1 폜
 */
void CRailList::Pop(){
	int i;
	if(!m_Number) return;
	m_Number--;
	g_CornerLog.Clear();
	m_LinkFrom2[1] = NULL;
	if(m_Number){
		for(i = 0; i<m_Number; i++) g_CornerLog.AddF("%2d: (%.1f, %.1f, %.1f)", i, m_Corner[i].x, m_Corner[i].y, m_Corner[i].z);
		if(g_CreationLog) g_GeneralLog.Add("_܂B");
	}else{
		m_LinkFrom2[0] = NULL;
		if(g_CreationLog) g_GeneralLog.Add("[쐬𒆒f܂B");
	}
}

/*
 *	J[\W[ւ̐ڑ𔻒
 */
void CRailList::TryLink(
	bool conv2d	//	^W 3D WH
){
	int i;
	g_LinkMin = conv2d ? PTR_2D_SELECT : CUS_3D_SELECT;
	g_RailOptionLinkFrom = NULL;
	g_RailOptionLinkMaster = NULL;
	for(i = 0; i<RAIL_TIP_MAX; i++) if(m_Tip[i]) m_Tip[i]->TryLink(conv2d);
}

/*
 *	[`bvI
 */
void CRailList::Select(){
	int i;
	g_RailOptionNearest2 = NULL;
	for(i = 0; i<RAIL_TIP_MAX; i++) if(m_Tip[i]) m_Tip[i]->Select();
	if(g_RailSelectFlag&1 && g_RailOptionNearest2) g_RailOptionNearest2->m_Selected = true;
}

/*
 *	[`bvI
 */
void CRailList::Release(){
	int i;
	for(i = 0; i<RAIL_TIP_MAX; i++) if(m_Tip[i]) m_Tip[i]->Release();
}

/*
 *	I[`bṽz[؂ւ
 */
void CRailList::SwitchAnchor(){
	int i;
	g_RailOptionNearest2 = NULL;
	for(i = 0; i<RAIL_TIP_MAX; i++) if(m_Tip[i]) m_Tip[i]->Select();
	if(g_RailOptionNearest2) g_RailOptionNearest2->SwitchAnchor();
	Release();
}

/*
 *	Iꂽ[`bv̍폜
 */
void CRailList::Delete(){
	int i;
	bool push = false, flag = false;
	for(i = 0; i<RAIL_TIP_MAX; i++){
		if(m_Tip[i]){
			if(!push && m_Tip[i]->m_User<0 && m_Tip[i]->m_Selected){
				push = true;
				FilePushUndo();
			}
			if(m_Tip[i]->Delete()){
				flag = true;
				m_Tip[i] = NULL;
			}
		}
	}
	if(flag && g_CreationLog) g_GeneralLog.Add("[P܂B");
}

/*
 *	`bvXg̋󂫂
 *
 *	߂l: JXbg̃AhX
 */
CRail **CRailList::FindSlot(){
	int i;
	for(i = 0; i<RAIL_TIP_MAX; i++) if(!m_Tip[i]) return &m_Tip[i];
	return NULL;
}

/*
 *	S[̃_O
 */
void CRailList::ShowRail(){
	int i;
	g_RailOptionNearest2 = NULL;
	for(i = 0; i<RAIL_TIP_MAX; i++) if(m_Tip[i]) m_Tip[i]->Show();
	g_RailOptionNearest1 = g_RailOptionNearest2;
}

/*
 *	[ݒu\̕\
 */
void CRailList::ShowLog(
	VEC3 last,	//	J[\W
	float lb,	//	J[\n_̒n\x
	bool ls		//	ŏI_̍x\tO
){
	int i;
	bool f, crold;
	if(!m_Number) return;
	devSetState(D3DRS_ZFUNC, D3DCMP_ALWAYS);
	for(i = 0; i<(m_Number-1); i++){
		Draw3DLine(m_Corner[i], m_Corner[i+1], MAKE_AC(g_SimAlpha, 255, 0, 0), 0);
		Draw3DLine(VEC3(m_Corner[i].x, m_Base[i], m_Corner[i].z), m_Corner[i], MAKE_AC(g_SimAlpha, 255, 0, 0), 0);
	}
	Draw3DLine(m_Corner[m_Number-1], last, MAKE_AC(g_SimAlpha, 255, 0, 0), 0);
	Draw3DLine(VEC3(m_Corner[m_Number-1].x, m_Base[m_Number-1], m_Corner[m_Number-1].z), m_Corner[m_Number-1], MAKE_AC(g_SimAlpha, 255, 0, 0), 0);
	if(ls) Draw3DLine(VEC3(last.x, lb, last.z), last, MAKE_AC(g_SimAlpha, 255, 0, 0), 0);
	crold = g_CreationLog;
	g_CreationLog = false;
	f = Push(last, lb);
	Finish(true);
	if(f) Pop();
	g_CreationLog = crold;
	devSetState(D3DRS_ZFUNC, D3DCMP_LESSEQUAL);
}

/*
 *	gpq̃Zbg
 */
void CRailList::EraseUser(
	int u	//	ZbgqCfbNX
){
	int i;
	for(i = 0; i<RAIL_TIP_MAX; i++) if(m_Tip[i]) m_Tip[i]->EraseUser(u);
}

/*
 *	S_̍폜
 */
void CRailList::Cancel(){
	while(m_Number) Pop();
}

/*
 *	[̃XvCvZ
 */
void CRailList::Finish(
	bool sim	//	\\̂߂̌vZH
){
	int i, max;
	float tbank;
	VEC3 p1, p2, n1, n2, u1, u2, r, b, d1, d2;
	CRail **p = NULL;
	if(m_Number<2){
		if(!sim && g_CreationLog) g_GeneralLog.Add("_܂!");
		return;
	}
	if(!sim && g_CreationLog) FilePushUndo();
	if(!sim && !m_LinkFrom2[0] && m_LinkFrom2[1]){
		for(i = 0; i<(m_Number/2); i++){
			p1 = m_Corner[m_Number-i-1];
			m_Corner[m_Number-i-1] = m_Corner[i];
			m_Corner[i] = p1;
		}
		m_LinkFrom2[0] = m_LinkFrom2[1];
		m_LinkMaster2[0] = m_LinkMaster2[1];
		m_LinkPos2[0] = m_LinkPos2[1];
		m_LinkNormal2[0] = -m_LinkNormal2[1];
		m_LinkUp2[0] = m_LinkUp2[1];
		m_LinkFrom2[1] = NULL;
	}
	g_RailTie = m_TieSpace;
	g_RailPier = m_PierSpace;
	g_RailLine = m_LineSpace;
	if(m_LinkFrom2[0]){
		p = m_LinkFrom2[0];
		g_RailOptionLastInstalled = m_LinkMaster2[0];
	}else{
		p = NULL;
		g_RailOptionLastInstalled = NULL;
	}
	max = m_Number-2;
	max += !max;
	for(i = 0; i<max; i++){
		if(i){
			p1 = p2;
			n1 = n2;
			u1 = u2;
		}else{
			p1 = m_Corner[0];
			if(m_LinkFrom2[0]){
				n1 = m_LinkNormal2[0];
				u1 = m_LinkUp2[0];
			}else{
				if(m_Number<3){
					if(m_LinkFrom2[1]) V3Norm(&n1, &((m_LinkPos2[1]-m_LinkNormal2[1]*0.5f*V3Len(&(m_LinkPos2[1]-p1)))-p1));
					else V3Norm(&n1, &(m_Corner[1]-p1));
					V3Norm(&u1, V3Cross(&u1, V3Cross(&r, &n1, &V3UP), &n1));
				}else{
					V3Norm(&n1, &(m_Corner[1]-p1));
					V3Norm(&r, V3Cross(&r, &n1, &V3UP));
					tbank = PointPointDistance(&m_Corner[2], &m_Corner[0]);
					b = (m_Corner[2]-m_Corner[0])*(PointPointDistance(&m_Corner[2], &m_Corner[1])
						+PointPointDistance(&m_Corner[1], &m_Corner[0]))/Squ(tbank);
					tbank = RAIL_BANK_TAIL*V3Dot(&b, &r);
					V3Norm(&u1, &(*V3Cross(&u1, &r, &n1)+tbank*r));
					if(!g_KantSwitch) p1 += fabsf(tbank)*RAIL_TIE_WIDTH*0.5f*V3UP;
				}
			}
		}
		switch(m_Number-i){
		case 2:
			p2 = m_Corner[m_Number-1];
			if(m_LinkFrom2[1]){
				n2 = m_LinkNormal2[1];
				u2 = m_LinkUp2[1];
			}else{
				if(m_LinkFrom2[0]) V3Norm(&n2, &(p2-(p1+n1*0.5f*V3Len(&(p2-p1)))));
				else V3Norm(&n2, &(p2-m_Corner[m_Number-2]));
				V3Norm(&u2, V3Cross(&u2, V3Cross(&r, &n2, &V3UP), &n2));
			}
			break;
		case 3:
			p2 = m_Corner[m_Number-1];
			if(m_LinkFrom2[1]){
				n2 = m_LinkNormal2[1];
				u2 = m_LinkUp2[1];
			}else{
				V3Norm(&n2, &(p2-m_Corner[m_Number-2]));
				V3Norm(&r, V3Cross(&r, &n2, &V3UP));
				tbank = PointPointDistance(&m_Corner[m_Number-1], &m_Corner[m_Number-3]);
				b = (m_Corner[m_Number-1]-m_Corner[m_Number-3])
					*(PointPointDistance(&m_Corner[m_Number-1], &m_Corner[m_Number-2])
					+PointPointDistance(&m_Corner[m_Number-2], &m_Corner[m_Number-3]))/Squ(tbank);
				tbank = RAIL_BANK_TAIL*V3Dot(&b, &r);
				V3Norm(&u2, &(*V3Cross(&u2, &r, &n2)-tbank*r));
				if(!g_KantSwitch) p2 += fabsf(tbank)*RAIL_TIE_WIDTH*0.5f*V3UP;
			}
			break;
		default:
			p2 = (m_Corner[i+1]+m_Corner[i+2])*0.5f;
			V3Norm(&n2, &(m_Corner[i+2]-m_Corner[i+1]));
			d1 = m_Corner[i+1]-m_Corner[i];
			d2 = m_Corner[i+3]-m_Corner[i+2];
			V3Norm(&r, V3Cross(&r, &n2, &V3UP));
			if(V3Dot(&d1, &r)*V3Dot(&d2, &r)<0.0f){
				b = (d2-d1)/(PointPointDistance(&m_Corner[i+3], &m_Corner[i+2])
					+PointPointDistance(&m_Corner[i+2], &m_Corner[i+1])
					+PointPointDistance(&m_Corner[i+1], &m_Corner[i]));
				tbank = RAIL_BANK_RATE*V3Dot(&b, &r);
				V3Norm(&u2, &(*V3Cross(&u2, &r, &n2)+r*tbank));
				if(!g_KantSwitch) p2 += fabsf(tbank)*RAIL_TIE_WIDTH*0.5f*V3UP;
			}else{
				V3Norm(&u2, V3Cross(&u2, &r, &n2));
			}
		}
		if(sim) CurveLine(&p1, &p2, &n1, &n2, &u1, &u2);
		else p = Curve(p, &p1, &p2, &n1, &n2, &u1, &u2);
	}
	if(sim) return;
	if(m_LinkFrom2[1]){
		*p = m_LinkMaster2[1];
		*m_LinkFrom2[1] = g_RailOptionLastInstalled;
	}
	m_Number = 0;
	for(i = 0; i<2; i++) m_LinkFrom2[i] = NULL;
	g_CornerLog.Clear();
	if(g_CreationLog) g_GeneralLog.Add("[쐬܂B");
}

/*
 *	XvCċA֐ (ݒup)
 *
 *	߂l:	Aڑp|C^
 */
CRail **CRailList::Curve(
	CRail **dest,	//	ڑ|C^
	VEC3 *p1,		//	Jnn_W
	VEC3 *p2,		//	In_W
	VEC3 *n1,		//	Jnn_
	VEC3 *n2,		//	In_
	VEC3 *u1,		//	Jnn_ up xNg
	VEC3 *u2		//	In_ up xNg
){
	float d, a, b, t, n12;
	bool flag = false;
	VEC3 r, t1, t2, mp, mn, mu;
	CRail **p;
	r = *p2-*p1;
	d = V3Len(&r);
	if(d<=RAIL_DIV_INTERVAL || (d<RAIL_DIV_MAX && V3Len(&(*n1-*n2))*d<RAIL_STRAIGHT_TSD)){
		if(p = FindSlot()){
			*p = new CRail;
			if(dest) *dest = *p;
			return (*p)->Install(p1, p2, n1, n2, u1, u2);
		}else{
			if(g_CreationLog) g_GeneralLog.Add("[Eł!");
			return NULL;
		}
	}
	n12 = V3Dot(n1, n2);
	t = 1.0f-n12*n12;
	if(t>0.0001f){
		a = V3Dot(n1, &(r-*n2*V3Dot(n2, &r)))/t;
		b = V3Dot(n2, &(*n1*V3Dot(n1, &r)-r))/t;
		mp = ((*p1+*p2)+(*n1*a+*n2*b)*0.5f)*0.5f;
	}else{
		flag = true;
	}
	if(flag || (V3Len(&(mp-*p1))>d) || (V3Len(&(*p2-mp))>d)
		|| (V3Len(&(mp-*p1))<(d*RAIL_LINK_FIX_TSD)) || (V3Len(&(*p2-mp))<(d*RAIL_LINK_FIX_TSD))){
		t1 = *p1+*n1*d*0.4f;
		t2 = *p2-*n2*d*0.4f;
		mp = (t1+t2)*0.5f;
		V3Norm(&mn, &(t2-t1));
	}else{
		V3Norm(&mn, &r);
	}
	V3Norm(&mu, V3Cross(&mu, V3Cross(&mu, &r, &(*u1+*u2)), &r));
	if(p = Curve(dest, p1, &mp, n1, &mn, u1, &mu)) if(p = Curve(p, &mp, p2, &mn, n2, &mu, u2)) return p;
	return NULL;
}

/*
 *	XvCċA֐ (\\p)
 */
void CRailList::CurveLine(
	VEC3 *p1,	//	Jnn_W
	VEC3 *p2,	//	In_W
	VEC3 *n1,	//	Jnn_
	VEC3 *n2,	//	In_
	VEC3 *u1,	//	Jnn_ up xNg
	VEC3 *u2	//	In_ up xNg
){
	float d, a, b, t, n12;
	bool flag = false;
	VEC3 r, t1, t2, mp, mn, mu;
	r = *p2-*p1;
	d = V3Len(&r);
	if(d<=RAIL_DIV_INTERVAL){
		Draw3DLine(*p1, *p2, MAKE_AC(g_SimAlpha, 255, 0, 255), 0);
		return;
	}
	n12 = V3Dot(n1, n2);
	t = 1.0f-n12*n12;
	if(t>0.0001f){
		a = V3Dot(n1, &(r-*n2*V3Dot(n2, &r)))/t;
		b = V3Dot(n2, &(*n1*V3Dot(n1, &r)-r))/t;
		mp = ((*p1+*p2)+(*n1*a+*n2*b)*0.5f)*0.5f;
	}else{
		flag = true;
	}
	if(flag || (V3Len(&(mp-*p1))>d) || (V3Len(&(*p2-mp))>d)
		|| (V3Len(&(mp-*p1))<(d*RAIL_LINK_FIX_TSD)) || (V3Len(&(*p2-mp))<(d*RAIL_LINK_FIX_TSD))){
		t1 = *p1+*n1*d*0.4f;
		t2 = *p2-*n2*d*0.4f;
		mp = (t1+t2)*0.5f;
		V3Norm(&mn, &(t2-t1));
	}else{
		V3Norm(&mn, &r);
	}
	V3Norm(&mu, V3Cross(&mu, V3Cross(&mu, &r, &(*u1+*u2)), &r));
	CurveLine(p1, &mp, n1, &mn, u1, &mu);
	CurveLine(&mp, p2, &mn, n2, &mu, u2);
}

/*
 *	S[̊J
 */
void CRailList::Destroy(){
	int i;
	for(i = 0; i<RAIL_TIP_MAX; i++){
		if(m_Tip[i]){
			delete m_Tip[i];
			m_Tip[i] = NULL;
		}
	}
	m_Number = 0;
	for(i = 0; i<2; i++) m_LinkFrom2[i] = NULL;
}

/*
 *	ۑ
 */
void CRailList::SaveData(
	FILE *df	//	t@C
){
	int i, n = 0;
	for(i = 0; i<RAIL_TIP_MAX; i++) if(m_Tip[i]) n++;
	fprintf(df, "RailClass{\n\tRailTips=%d\n", n);
	for(i = 0; i<RAIL_TIP_MAX; i++) if(m_Tip[i]) m_Tip[i]->SaveData(df);
	fprintf(df, "}\n\n");
}

/*
 *	Ǎ
 */
void CRailList::LoadData(
	FILE *df	//	t@C
){
	int i, j, k;
	fscanf(df, "RailClass{\n\tRailTips=%d\n", &m_Oldies);
	for(i = 0; i<m_Oldies; i++){
		m_LinkTable[i][1] = m_Tip[i] = new CRail;
		m_LinkTable[i][0] = m_Tip[i]->LoadData(df);
	}
	for(i = 0; i<m_Oldies; i++) for(j = 0; j<2; j++) for(k = 0; k<2; k++) ReLink(&m_Tip[i]->m_Next[j][k]);
	fscanf(df, "}\n\n");
}

/*
 *	Ǎ̃AhXu
 */
void CRailList::ReLink(
	CRail **pp	//	Ώۃ|C^
){
	int i;
	if(!*pp) return;
	for(i = 0; i<m_Oldies; i++){
		if(*pp==m_LinkTable[i][0]){
			*pp = m_LinkTable[i][1];
			return;
		}
	}
}
