//	Cu
#include "lib\udx.h"

//	萔E}N
#include "Const.h"
#include "Macro.h"

//	c[֐
#include "SystemCover.h"
#include "CameraControl.h"

//	NX
#include "CPlugin.h"
#include "CStructModel.h"
#include "CStationModel.h"
#include "CStruct.h"
#include "CStation.h"

//	OO[o
extern int g_MiscOptionShadowFlag;
extern int g_MiscOptionStationMode;
extern int g_ObjectSelectFlag;
extern float g_Blink;
extern float g_StationFarDraw;
extern float g_StationFarHide;
extern CStationModel *g_StationOptionModelSeed;

/*
 *	RXgN^
 */
CStation::CStation(
	CStationModel *m,	//	wɃf
	VEC3 *p,			//	W
	VEC3 *d,			//	dir xNg
	VEC3 *u,			//	up xNg
	bool ha				//	AJ[ݒutO
):
	CStruct(m, p, d, u)	//	{NX
{
	m->BuildHome(p, d, u, ha);
}

/*
 *	_O
 */
void CStation::Show(){
	float ta;
	if(g_MiscOptionStationMode){
		ta = 1.0f;
	}else{
		ta = GetFarAlpha(&m_Object.GetPos(), g_StationFarDraw, g_StationFarHide);
		if(ta==0.0f) return;
	}
	if(g_MiscOptionShadowFlag) RenderShadow2(&m_Object, ta);
	if((g_ObjectSelectFlag&4) && m_Selected) Render2(&m_Object, BlinkToAlpha(g_Blink));
	else Render2(&m_Object, ta);
}

/*
 *	ۑ
 */
void CStation::SaveData(
	FILE *df	//	t@C
){
	fprintf(df, "\tStation{\n\t\tModel=%s\n", ((CStationModel *)(m_Model))->m_Index);
	fprintf(df, "\t\tPos=");
	SaveVec3Data(df, m_Object.GetPos(), "\n");
	fprintf(df, "\t\tDir=");
	SaveVec3Data(df, m_Object.GetDir(), "\n");
	fprintf(df, "\t\tUp=");
	SaveVec3Data(df, m_Object.GetUp(), "\n");
	fprintf(df, "\t}\n");
}

/*
 *	Ǎ
 */
void CStation::LoadData(
	FILE *df	//	t@C
){
	char m_Index[FILE_NAME_MAX];
	VEC3 tp, td, tu;
	fscanf(df, "\tStation{\n\t\tModel=%s\n", m_Index);
	fscanf(df, "\t\tPos=");
	LoadVec3Data(df, &tp, "\n");
	fscanf(df, "\t\tDir=");
	LoadVec3Data(df, &td, "\n");
	fscanf(df, "\t\tUp=");
	LoadVec3Data(df, &tu, "\n");
	fscanf(df, "\t}\n");
	if(!(m_Model = g_StationOptionModelSeed->Find(m_Index))){
		fclose(df);
		ShowCursor(true);
		Dialog("wɃvOC \"%s\" sĂ܂!", m_Index);
		ExitProcess(0);
	}
	m_Object.SetMesh(((CStationModel *)(m_Model))->GetMesh(), V3ZERO, ((CStationModel *)(m_Model))->m_Scale);
	m_Object.SetPos(tp);
	m_Object.SetDir(td, tu);
}
