//	Cu
#include <direct.h>
#include "lib\udx.h"

//	萔E}N
#include "Const.h"
#include "Macro.h"

extern const int STATION_LOG_MAX;
extern const float RAIL_TIE_HEIGHT;
extern const float RAIL_DIV_MIN;

//	NX
#include "CLogger.h"
#include "CRail.h"
#include "CRailList.h"
#include "CPlugin.h"
#include "CStructModel.h"
#include "CStationModel.h"

//	OO[o
extern char g_BaseDir[];
extern CRail **g_RailOptionLinkFrom;
extern CRail *g_RailOptionLinkMaster;
extern CRailList g_RailOptionList;
extern int g_SimAlpha;
extern int g_HomePreview;
extern float g_Blink;
extern float g_RailLength;
extern bool g_CreationLog;
extern bool g_PierCreate;
extern CLogger g_StationLog;
extern CLogger g_StationSpecLog;
extern CRail *g_HomeMiddle;

//	O[o
int g_StationOptionModels = 0;						//	wɃvOCo^
int g_StationOptionSelect = 0;						//	Iꂽwɂ̃Xgԍ
int g_StationOptionListID = 0;						//	Xg\̃XN[
CStationModel *g_StationOptionModelSeed = NULL;		//	Xg̐擪
CStationModel *g_StationOptionModelSelect = NULL;	//	Iꂽw
CStationModel **g_StationOptionModelNext = &g_StationOptionModelSeed;
													//	Ō|C^

CObject g_StationDisplayObject;	//	Tv\pIuWFNg

/*
 *	RXgN^
 */
CStationModel::CStationModel(
	char *str,	//	fBNg
	FILE *info,	//	`t@C
	bool load	//	[htO
){
	int i;
	strcpy(m_Index, str);
	if(m_Loaded = load) m_Mesh.Load("Model.x");
	fscanf(info, "%s\n%s\n%f\n%d", m_Name, m_Author, &m_TieWidth, &m_HomeNumber);
	m_PracticalHomeNumber = m_HomeNumber;
	m_Scale = RAIL_WIDTH/m_TieWidth;
	m_HomePos = new VEC3 [m_HomeNumber][2];
	for(i = 0; i<m_HomeNumber; i++){
		fscanf(info, "\n(%f,%f,%f),(%f,%f,%f)", &m_HomePos[i][0].x, &m_HomePos[i][0].y, &m_HomePos[i][0].z, &m_HomePos[i][1].x, &m_HomePos[i][1].y, &m_HomePos[i][1].z);
		m_HomePos[i][0] *= m_Scale;
		m_HomePos[i][1] *= m_Scale;
		m_HomePos[i][0] += VEC3(0.0f, RAIL_TIE_HEIGHT, 0.0f);
		m_HomePos[i][1] += VEC3(0.0f, RAIL_TIE_HEIGHT, 0.0f);
		if(V3Len(&(m_HomePos[i][0]-m_HomePos[i][1]))<RAIL_DIV_MIN) m_PracticalHomeNumber--;
	}
	m_Next = NULL;
	*g_StationOptionModelNext = this;
	g_StationOptionModelNext = NextAdr();
	m_Count = g_StationOptionModels;
	g_StationOptionModels++;
}

/*
 *	fXgN^
 */
CStationModel::~CStationModel(){
	delete [] m_HomePos;
	if(m_Next){
		delete m_Next;
		m_Next = NULL;
	}
}

/*
 *	bV擾 ([h̏ꍇ[h)
 *
 *	߂l: bV
 */
CMesh *CStationModel::GetMesh(){
	if(!m_Loaded){
		chdir(g_BaseDir);
		chdir("Station");
		chdir(m_Index);
		m_Mesh.Load("Model.x");
		m_Loaded = true;
	}
	return &m_Mesh;
}

/*
 *	Xg̍쐬
 */
void CStationModel::AddLog(
	int n	//	\JE^
){
	if(n<=0){
		if(m_Count==g_StationOptionSelect){
			g_StationLog.AddF("%s", m_Name);
			g_StationDisplayObject.SetMesh(GetMesh(), V3ZERO, m_Scale);
			g_StationOptionModelSelect = this;
			ViewSpec();
		}else{
			g_StationLog.AddF("%s", m_Name);
		}
	}
	if(n+STATION_LOG_MAX-4){
		if(Next()) Next()->AddLog(n-1);
		else for(; n+STATION_LOG_MAX-4; n--) g_StationLog.Add("");
	}
}

/*
 *	vOC̕\
 */
void CStationModel::ViewSpec(){
	g_StationSpecLog.Clear();
	g_StationSpecLog.AddF("<%s>", m_Index);
	g_StationSpecLog.Add(m_Name);
	g_StationSpecLog.AddF(": %s", m_Author);
	g_StationSpecLog.AddF("z[: %d", m_PracticalHomeNumber);
}

/*
 *	z[\̕\
 */
void CStationModel::ShowHome(
	const VEC3 *p,	//	wɂ̍W
	const VEC3 *d,	//	wɂ dir xNg
	const VEC3 *u	//	wɂ up xNg
){
	if(!g_HomePreview) return;
	int i, alpha = 128+127*sin(g_Blink);
	VEC3 tx, ty, tz, p1, p2;
	V3Norm(&ty, u);
	V3Norm(&tz, d);
	V3Cross(&tx, &ty, &tz);
	devSetState(D3DRS_ZFUNC, D3DCMP_ALWAYS);
	g_CreationLog = false;
	g_RailOptionList.Cancel();
	g_RailOptionLinkFrom = NULL;
	g_RailOptionLinkMaster = NULL;
	g_SimAlpha = alpha;
	for(i = 0; i<m_HomeNumber; i++){
		p1 = *p+tx*m_HomePos[i][0].x+ty*m_HomePos[i][0].y+tz*m_HomePos[i][0].z;
		p2 = *p+tx*m_HomePos[i][1].x+ty*m_HomePos[i][1].y+tz*m_HomePos[i][1].z;
		g_RailOptionList.Push(p1, p->y);
		if(V3Len(&(p2-p1))<RAIL_DIV_MIN) continue;
		g_RailOptionList.ShowLog(p2, p->y, true);
		g_RailOptionList.Cancel();
	}
	g_RailOptionList.Cancel();
	g_CreationLog = true;
	g_SimAlpha = 128;
	devSetState(D3DRS_ZFUNC, D3DCMP_LESSEQUAL);
}

/*
 *	z[ݒu
 */
void CStationModel::BuildHome(
	const VEC3 *p,	//	wɂ̍W
	const VEC3 *d,	//	wɂ dir xNg
	const VEC3 *u,	//	wɂ up xNg
	bool ha			//	AJ[ݒutO
){
	int i;
	VEC3 tx, ty, tz, p1, p2;
	V3Norm(&ty, u);
	V3Norm(&tz, d);
	V3Cross(&tx, &ty, &tz);
	g_CreationLog = false;
	g_RailOptionList.Cancel();
	g_RailOptionLinkFrom = NULL;
	g_RailOptionLinkMaster = NULL;
	g_RailLength = 0.0f;
	g_HomeMiddle = NULL;
	for(i = 0; i<m_HomeNumber; i++){
		p1 = *p+tx*m_HomePos[i][0].x+ty*m_HomePos[i][0].y+tz*m_HomePos[i][0].z;
		p2 = *p+tx*m_HomePos[i][1].x+ty*m_HomePos[i][1].y+tz*m_HomePos[i][1].z;
		g_RailOptionList.Push(p1, 0.0f);
		if(V3Len(&(p2-p1))<RAIL_DIV_MIN) continue;
		g_RailOptionList.Push(p2, 0.0f);
		g_RailOptionList.Finish(false);
		g_RailOptionList.Cancel();
		if(ha && g_HomeMiddle) g_HomeMiddle->SwitchAnchor();
		g_RailLength = 0.0f;
		g_HomeMiddle = NULL;
	}
	g_RailLength = -1.0f;
	g_CreationLog = true;
}
