//	Cu
#include "lib\udx.h"

//	萔E}N
#include "Const.h"
#include "Macro.h"

//	c[֐
#include "ValueArea.h"
#include "SystemCover.h"
#include "CameraControl.h"

//	NX
#include "CPlugin.h"
#include "CStructModel.h"
#include "CStruct.h"

//	OO[o
extern int g_MiscOptionShadowFlag;
extern int g_MiscOptionStructMode;
extern float g_Blink;
extern float g_StructFarDraw;
extern float g_StructFarHide;
extern CStructModel *g_StructOptionModelSeed;
extern POINT g_AreaPos1;
extern POINT g_AreaPos2;

//	O[o
float g_StructOptionNearestDist;		//	Iɔ͈͓ōł߂̂̋
CStruct *g_StructOptionNearest = NULL;	//	ł߂{

int g_ObjectSelectFlag;	//	{ݑIIvV

/*
 *	RXgN^
 */
CStruct::CStruct(
	CStructModel *m,	//	{݃f
	VEC3 *p,			//	W
	VEC3 *d,			//	dir xNg
	VEC3 *u				//	up xNg
){
	VEC3 td;
	m_Selected = false;
	m_Model = m;
	m_Object.SetMesh(m->GetMesh(), V3ZERO, m->m_Scale);
	m_Object.SetPos(*p);
	m_Object.SetDir(*V3Norm(&td, d), *u);
}

/*
 *	I
 */
void CStruct::Select(){
	float td, dist;
	POINT scr;
	VEC3 mid = m_Object.GetPos();
	if(V3Dot(&(mid-GetVPos()), &GetVDir())<0) return;
	if(g_ObjectSelectFlag&2){
		scr = WorldToScreen2(&mid);
		if(CheckValueArea(scr.x, g_AreaPos1.x, g_AreaPos2.x) && CheckValueArea(scr.y, g_AreaPos1.y, g_AreaPos2.y)) m_Selected = true;
	}
	if(g_ObjectSelectFlag&1){
		scr = WorldToScreen2(&mid);
		td = 10.0f*PTR_2D_SELECT/PointPointDistance(&mid, &GetVPos());
		if((dist = sqrtf(Squ(scr.x-g_AreaPos1.x)+Squ(scr.y-g_AreaPos1.y)))<td){
			if(!g_StructOptionNearest || g_StructOptionNearestDist>dist){
				g_StructOptionNearestDist = dist;
				g_StructOptionNearest = this;
			}
		}
	}
}

/*
 *	I
 */
void CStruct::Release(){
	m_Selected = false;
}

/*
 *	IĂ΍폜
 *
 *	폜ɐ true Ԃ
 */
bool CStruct::Delete(){
	if(!m_Selected) return false;
	delete this;
	return true;
}

/*
 *	߂l: IuWFNg
 */
CObject *CStruct::GetObject(){
	return &m_Object;
}

/*
 *	_O
 */
void CStruct::Show(){
	float ta;
	if(g_MiscOptionStructMode){
		ta = 1.0f;
	}else{
		ta = GetFarAlpha(&m_Object.GetPos(), g_StructFarDraw, g_StructFarHide);
		if(ta==0.0f) return;
	}
	if(g_MiscOptionShadowFlag) RenderShadow2(&m_Object, ta);
	if((g_ObjectSelectFlag&8) && m_Selected) Render2(&m_Object, BlinkToAlpha(g_Blink));
	else Render2(&m_Object, ta);
}

/*
 *	ۑ
 */
void CStruct::SaveData(
	FILE *df	//	t@C
){
	fprintf(df, "\tStruct{\n\t\tModel=%s\n", m_Model->m_Index);
	fprintf(df, "\t\tPos=");
	SaveVec3Data(df, m_Object.GetPos(), "\n");
	fprintf(df, "\t\tDir=");
	SaveVec3Data(df, m_Object.GetDir(), "\n");
	fprintf(df, "\t\tUp=");
	SaveVec3Data(df, m_Object.GetUp(), "\n");
	fprintf(df, "\t}\n");
}

/*
 *	Ǎ
 */
void CStruct::LoadData(
	FILE *df	//	t@C
){
	char m_Index[FILE_NAME_MAX];
	VEC3 tp, td, tu;
	fscanf(df, "\tStruct{\n\t\tModel=%s\n", m_Index);
	fscanf(df, "\t\tPos=");
	LoadVec3Data(df, &tp, "\n");
	fscanf(df, "\t\tDir=");
	LoadVec3Data(df, &td, "\n");
	fscanf(df, "\t\tUp=");
	LoadVec3Data(df, &tu, "\n");
	fscanf(df, "\t}\n");
	if(!(m_Model = g_StructOptionModelSeed->Find(m_Index))){
		fclose(df);
		ShowCursor(true);
		Dialog("{݃vOC \"%s\" sĂ܂!", m_Index);
		ExitProcess(0);
	}
	m_Object.SetMesh(m_Model->GetMesh(), V3ZERO, m_Model->m_Scale);
	m_Object.SetPos(tp);
	m_Object.SetDir(td, tu);
}
