//	Cu
#include "lib\udx.h"

//	萔E}N
#include "Const.h"

//	c[֐
#include "SaveData.h"

//	NX
#include "CLogger.h"
#include "CPlugin.h"
#include "CStructModel.h"
#include "CStruct.h"
#include "CStructList.h"

//	OO[o
extern float g_StructOptionNearestDist;
extern CStruct *g_StructOptionNearest;
extern int g_ObjectSelectFlag;
extern CLogger g_GeneralLog;

/*
 *	RXgN^
 */
CStructList::CStructList(
	int n	//	{ݍő吔
){
	int i;
	m_TypeName = "{";
	m_Number = n;
	m_Article = new CStruct *[n];
	for(i = 0; i<m_Number; i++) m_Article[i] = NULL;
}

/*
 *	fXgN^
 */
CStructList::~CStructList(){
	int i;
	for(i = 0; i<m_Number; i++) if(m_Article[i]) delete m_Article[i];
	delete [] m_Article;
}

/*
 *	Xg̋󂫂
 *
 *	߂l:	JXbg
 */
CStruct **CStructList::FindSlot(){
	int i;
	for(i = 0; i<m_Number; i++) if(!m_Article[i]) return &m_Article[i];
	return NULL;
}

/*
 *	Xgɒǉ
 */
void CStructList::Add(
	CStructModel *m,	//	{݃f
	VEC3 *p,			//	W
	VEC3 *d,			//	dir xNg
	VEC3 *u				//	up xNg
){
	CStruct **ptr;
	if(ptr = FindSlot()){
		FilePushUndo();
		*ptr = new CStruct(m, p, d, u);
		g_GeneralLog.AddF("%sݒu܂B", m->m_Name);
	}else{
		g_GeneralLog.AddF("ȏ%sݒuł܂!", m_TypeName);
	}
}

/*
 *	{݂̑I
 */
void CStructList::Select(){
	int i;
	g_StructOptionNearest = NULL;
	for(i = 0; i<m_Number; i++) if(m_Article[i]) m_Article[i]->Select();
	if(g_ObjectSelectFlag&1 && g_StructOptionNearest) g_StructOptionNearest->m_Selected = true;
}

/*
 *	{݂̑I
 */
void CStructList::Release(){
	int i;
	for(i = 0; i<m_Number; i++) if(m_Article[i]) m_Article[i]->Release();
}

/*
 *	J[\ł߂̂I
 *
 *	߂l:	ł߂{
 */
CStruct *CStructList::SearchNearest(
	float *dist	//	擾
){
	int i;
	g_StructOptionNearest = NULL;
	g_ObjectSelectFlag = 1;
	for(i = 0; i<m_Number; i++) if(m_Article[i]) m_Article[i]->Select();
	*dist = g_StructOptionNearestDist;
	return g_StructOptionNearest;
}

/*
 *	I{݂̍폜
 */
void CStructList::Delete(){
	int i;
	bool push = false, flag = false;
	for(i = 0; i<m_Number; i++){
		if(m_Article[i]){
			if(!push && m_Article[i]->m_Selected){
				push = true;
				FilePushUndo();
			}
			if(m_Article[i]->Delete()){
				flag = true;
				m_Article[i] = NULL;
			}
		}
	}
	if(flag) g_GeneralLog.AddF("%sP܂B", m_TypeName);
}

/*
 *	S{݂̃_O
 */
void CStructList::Show(){
	int i;
	for(i = 0; i<m_Number; i++) if(m_Article[i]) m_Article[i]->Show();
}

/*
 *	S{݂̊J
 */
void CStructList::Destroy(){
	int i;
	for(i = 0; i<m_Number; i++){
		if(m_Article[i]){
			delete m_Article[i];
			m_Article[i] = NULL;
		}
	}
}

/*
 *	ۑ
 */
void CStructList::SaveData(
	FILE *df	//	t@C
){
	int i, n = 0;
	for(i = 0; i<m_Number; i++) if(m_Article[i]) n++;
	fprintf(df, "StructClass{\n\tStructs=%d\n", n);
	for(i = 0; i<m_Number; i++) if(m_Article[i]) m_Article[i]->SaveData(df);
	fprintf(df, "}\n\n");
}

/*
 *	Ǎ
 */
void CStructList::LoadData(
	FILE *df	//	t@C
){
	int i, n;
	fscanf(df, "StructClass{\n\tStructs=%d\n", &n);
	for(i = 0; i<n; i++){
		m_Article[i] = new CStruct;
		m_Article[i]->LoadData(df);
	}
	fscanf(df, "}\n\n");
}
