//	Cu
#include <direct.h>
#include "lib\udx.h"

//	萔E}N
#include "Const.h"
#include "Macro.h"

extern const int SURFACE_LOG_MAX;

const float SURFACE_PREVIEW = 0.05f;	//	Tv\XP[

//	NX
#include "CLogger.h"
#include "CPlugin.h"
#include "CSurfaceModel.h"

//	OO[o
extern char g_BaseDir[];
extern CLogger g_SurfaceLog;
extern CLogger g_SurfaceSpecLog;

//	OO[o
int g_SurfaceOptionModels = 0;						//	n`vOCo^
int g_SurfaceOptionSelect = 0;						//	Iꂽn`̃Xgԍ
int g_SurfaceOptionListID = 0;						//	Xg\̃XN[
CSurfaceModel *g_SurfaceOptionModelSeed = NULL;		//	Xg̐擪
CSurfaceModel *g_SurfaceOptionModelSelect = NULL;	//	Iꂽn`
CSurfaceModel **g_SurfaceOptionModelNext = &g_SurfaceOptionModelSeed;
													//	Ō|C^

float g_FWidthX;	//	gpn` x TCY
float g_FWidthZ;	//	gpn` z TCY

CObject g_SurfaceDisplayObject;	//	Tv\pIuWFNg

/*
 *	RXgN^
 */
CSurfaceModel::CSurfaceModel(
	char *str,	//	fBNg
	FILE *info,	//	`t@C
	bool load	//	[htO
){
	strcpy(m_Index, str);
	if(m_Loaded = load) m_Mesh.Load("Model.x");
	fscanf(info, "%s\n%s\n%f\n%f\n%f", m_Name, m_Author, &m_TieWidth, &m_WidthX, &m_WidthZ);
	m_Scale = RAIL_WIDTH/m_TieWidth;
	m_WidthX *= m_Scale;
	m_WidthZ *= m_Scale;
	m_Next = NULL;
	*g_SurfaceOptionModelNext = this;
	g_SurfaceOptionModelNext = NextAdr();
	m_Count = g_SurfaceOptionModels;
	g_SurfaceOptionModels++;
}

/*
 *	bV擾 ([h̏ꍇ[h)
 *
 *	߂l: bV
 */
CMesh *CSurfaceModel::GetMesh(){
	if(!m_Loaded){
		chdir(g_BaseDir);
		chdir("Surface");
		chdir(m_Index);
		m_Mesh.Load("Model.x");
		m_Loaded = true;
	}
	return &m_Mesh;
}

/*
 *	Xg̍쐬
 */
void CSurfaceModel::AddLog(
	int n	//	\JE^ (ŏ̌Ăяoɕ\ԏ̔ԍw)
){
	if(n<=0){
		if(m_Count==g_SurfaceOptionSelect){
			g_SurfaceLog.AddF("%s", m_Name);
			g_SurfaceDisplayObject.SetMesh(GetMesh(), V3ZERO, m_Scale*SURFACE_PREVIEW);
			g_SurfaceOptionModelSelect = this;
			ViewSpec();
		}else{
			g_SurfaceLog.AddF("%s", m_Name);
		}
	}
	if(n+SURFACE_LOG_MAX-4){
		if(Next()) Next()->AddLog(n-1);
		else for(; n+SURFACE_LOG_MAX-4; n--) g_SurfaceLog.Add("");
	}
}

/*
 *	vOC̕\
 */
void CSurfaceModel::ViewSpec(){
	g_SurfaceSpecLog.Clear();
	g_SurfaceSpecLog.AddF("<%s>", m_Index);
	g_SurfaceSpecLog.Add(m_Name);
	g_SurfaceSpecLog.AddF(" : %s", m_Author);
	g_SurfaceSpecLog.AddF("X: %.1f", m_WidthX);
	g_SurfaceSpecLog.AddF("Z: %.1f", m_WidthZ);
}

/*
 *	gpn`IuWFNgɃbVZbg
 */
void CSurfaceModel::SetGround(
	CObject *p	//	IuWFNg
){
	p->SetMesh(GetMesh(), V3ZERO, m_Scale);
	g_FWidthX = m_WidthX*0.5f;
	g_FWidthZ = m_WidthZ*0.5f;
}

/*
 *	J
 */
void CSurfaceModel::Destroy(){
	if(Next()) Next()->Destroy();
	if(this!=g_SurfaceOptionModelSelect) delete this;
}
