//	Cu
#include "lib\udx.h"

//	萔E}N
#include "Const.h"
#include "Macro.h"

extern const int TGROUP_LOG_MAX;
extern const int TDIA_LOG_MAX;
extern const float CAM_MAX_DIST;
extern const float TRAIN_MARCH_TSD;

extern const float TRAIN_INTERVAL = 0.15f;	//	qԊu

const float TRAIN_ACCEL = 0.02f;		//	xW
const float TRAIN_MARCH_SCALE = 30.0f;	//	x\{
const float TRAIN_STOP_TIME = 3.0f;		//	Ԃ܂ł̎ [s]
const float TRAIN_STOP_MARGIN = 1.0f;	//	s~܂Ԏ̒ԗ]T
const float TRAIN_EMG_BREAK = 0.8f;		//	ً}~xW
const float TRAIN_PREV_SPEED = 0.2f;	//	vr[x
const float TRAIN_AVE_HEIGHT = 1.0f;	//	^]Ȏ_

//	c[֐
#include "ValueArea.h"
#include "SystemCover.h"

//	NX
#include "CLogger.h"
#include "CRail.h"
#include "CRailList.h"
#include "CPlugin.h"
#include "CTrainModel.h"
#include "CTrain.h"
#include "CTrainGroup.h"

//	OO[o
extern int g_MiscOptionProjectionMode;
extern int g_CSVersion;
extern unsigned int g_TimeDay;
extern unsigned int g_TimeHour;
extern unsigned int g_TimeMin;
extern float g_OrthoRatio;
extern VEC3 g_TrainLinkPos;
extern VEC3 g_TrainLinkDir;
extern CLogger g_GeneralLog;
extern CLogger g_TrainGroupLog;
extern CLogger g_TrainDiaLog;
extern CRailList g_RailOptionList;

//	O[o
CTrainGroup *g_TrainGroupParent;	//	֐ĂяoҐ

/*
 *	RXgN^
 */
CTrainGroup::CTrainGroup(){
	m_Count = m_Index = m_DiaNumber = m_DiaListID = 0;
	m_DiaSelect = -1;
	m_Mode = 1;
	m_Speed = m_SpeedSet = m_SpeedMax = m_Length = m_ScanDist = 0.0f;
	m_Enabled = m_ClearAnchor = false;
	m_CabinView = true;
	ClearPoint();
}

/*
 *	fXgN^
 */
CTrainGroup::~CTrainGroup(){
	int i;
	for(i = 0; i<m_Count; i++) delete m_Car[i];
}

/*
 *	NbNőI
 */
void CTrainGroup::Select(){
	int i;
	if(!m_Enabled) return;
	for(i = 0; i<m_Count; i++) m_Car[i]->Select();
}

/*
 *	Ґԍ̐ݒ
 */
void CTrainGroup::SetID(
	int i	//	Ґԍ
){
	m_Index = i;
}

/*
 *	q̒ǉ
 */
void CTrainGroup::AddCar(
	CTrainModel *c,	//	qf
	bool t			//	]tO
){
	if(m_Enabled){
		g_GeneralLog.Add("zu͕ҐύXł܂!");
		return;
	}
	if(m_Count<TRAIN_LINK_MAX){
		m_Car[m_Count++] = new CTrain(c, t, m_Index);
		CalcSpec();
		SetLog();
		g_GeneralLog.Add("Ґqǉ܂B");
	}else{
		g_GeneralLog.Add("ȏǉł܂!");
	}
}

/*
 *	Ōq̔]
 */
void CTrainGroup::TurnCar(){
	if(!m_Count) return;
	if(m_Enabled){
		g_GeneralLog.Add("zu͕ҐύXł܂!");
		return;
	}
	m_Car[m_Count-1]->Turn();
	SetLog();
}

/*
 *	Ōq̍폜
 */
void CTrainGroup::PopCar(){
	if(!m_Count) return;
	if(m_Enabled){
		g_GeneralLog.Add("zu͕ҐύXł܂!");
		return;
	}
	delete m_Car[--m_Count];
	CalcSpec();
	SetLog();
	g_GeneralLog.Add("Ґq폜܂B");
}

/*
 *	|Cgݒ擾
 *
 *	߂l:	|Cgݒ (: 1AE: 2)
 */
int CTrainGroup::GetPoint(
	int k	//	ݒԍ
){
	return m_Point[k];
}

/*
 *	߂l: |Cgݒo^
 */
int CTrainGroup::CountPoint(){
	int i;
	for(i = TRAIN_POINT_MAX-1; i>=0; i--) if(m_Point[i]) return i+1;
	return 0;
}

/*
 *	|Cgݒ̒ǉ
 */
void CTrainGroup::AddPoint(
	int p	//	|Cgݒ (: 1AE: 2)
){
	int i;
	for(i = 0; i<TRAIN_POINT_MAX; i++){
		if(m_Point[i]) continue;
		m_Point[i] = p;
		return;
	}
	g_GeneralLog.Add("ȏǉł܂!");
}

/*
 *	|Cgݒ̍폜
 */
void CTrainGroup::PopPoint(){
	int i;
	for(i = TRAIN_POINT_MAX-1; i>=0; i--){
		if(m_Point[i]){
			m_Point[i] = 0;
			return;
		}
	}
}

/*
 *	|Cgݒǂ
 *
 *	߂l:	|Cgݒ (: 1AE: 2)
 */
int CTrainGroup::ReadPoint(
	int	pcnt	//	ǂ݃JEg (-1 ̏ꍇ̓[v)
){
	int i = 0, t = m_Point[0];
	if(pcnt<0){
		if(t){
			for(i = 1; i<TRAIN_POINT_MAX; i++)
				if(m_Point[i]) m_Point[i-1] = m_Point[i]; else break;
			m_Point[i-1] = t;
		}
		return t;
	}
	if(t){
		while(pcnt){
			pcnt--;
			i++;
			if(!m_Point[i]) i = 0;
		}
		t = m_Point[i];
	}
	return t;
}

/*
 *	|Cgݒ̑S폜
 */
void CTrainGroup::ClearPoint(){
	int i;
	for(i = 0; i<TRAIN_POINT_MAX; i++) m_Point[i] = 0;
}

/*
 *	_Cݒ胊Xg̍쐬
 */
void CTrainGroup::SetDiaLog(){
	static char *ttype[2] = {"Ԏ", "Ԏ"};
	static char *dtype[3] = {" ", "ܕ t", "ʉ "};
	int i = 0, n = m_DiaListID;
	g_TrainDiaLog.AddF("_Cݒ(%d/%d)", m_DiaSelect+1, m_DiaNumber);
	g_TrainDiaLog.Add(m_DiaListID ? "" : "");
	while(true){
		if(!m_DiaNumber){
			g_TrainDiaLog.Add("");
		}else if(n<=0){
			if(m_Dia[i][0]<2){
				g_TrainDiaLog.AddF("%s%s %s %02d:%02d",	TextSw(i, m_DiaSelect),
					dtype[m_Dia[i][0]], ttype[m_Dia[i][1]], m_Dia[i][2], m_Dia[i][3]);
			}else{
				g_TrainDiaLog.AddF("%s%s", TextSw(i, m_DiaSelect), dtype[m_Dia[i][0]]);
			}
		}
		if(n+TDIA_LOG_MAX-4){
			if((++i)<m_DiaNumber){
				n--;
				continue;
			}
			for(; n+TDIA_LOG_MAX-4; n--) g_TrainDiaLog.Add("");
		}
		break;
	}
	g_TrainDiaLog.Add(m_DiaListID+TDIA_LOG_MAX-3<m_DiaNumber ? "" : "");
}

/*
 *	߂l:	_Cݒ萔
 */
int CTrainGroup::GetDiaNumber(){
	return m_DiaNumber;
}

/*
 *	߂l:	_CXgI (ύXp)
 */
int &CTrainGroup::GetDiaSelect(){
	return m_DiaSelect;
}

/*
 *	߂l:	_CXgԍ (ύXp)
 */
int &CTrainGroup::GetDiaListID(){
	return m_DiaListID;
}

/*
 *	߂l:	I𒆃_C (ύXp)
 */
char *CTrainGroup::GetDia(){
	return m_Dia[m_DiaSelect];
}

/*
 *	_Cݒ̒ǉ
 */
void CTrainGroup::AddDia(){
	if(m_DiaNumber==TRAIN_DIA_MAX) return;
	int i, j;
	for(i = m_DiaNumber; i>m_DiaSelect+1; i--)
		for(j = 0; j<4; j++) m_Dia[i][j] = m_Dia[i-1][j];
	m_DiaNumber++;
	m_DiaSelect++;
	m_Dia[m_DiaSelect][0] = m_Dia[m_DiaSelect][1] = m_Dia[m_DiaSelect][2] = 0;
	m_Dia[m_DiaSelect][3] = 10;
}

/*
 *	_Cݒ̍폜
 */
void CTrainGroup::DeleteDia(){
	if(!m_DiaNumber) return;
	int i, j;
	for(i = m_DiaSelect; i<m_DiaNumber-1; i++)
		for(j = 0; j<4; j++) m_Dia[i][j] = m_Dia[i+1][j];
	m_DiaNumber--;
	if(m_DiaSelect==m_DiaNumber) m_DiaSelect--;
}

/*
 *	_Cݒ̓ւ
 */
void CTrainGroup::MoveDia(
	bool upset	//	Ɉړꍇ true
){
	int i, t;
	if(upset){
		if(m_DiaSelect<=0) return;
		for(i = 0; i<4; i++){
			t = m_Dia[m_DiaSelect][i];
			m_Dia[m_DiaSelect][i] = m_Dia[m_DiaSelect-1][i];
			m_Dia[m_DiaSelect-1][i] = t;
		}
		m_DiaSelect--;
	}else{
		if(m_DiaSelect>=m_DiaNumber-1) return;
		for(i = 0; i<4; i++){
			t = m_Dia[m_DiaSelect][i];
			m_Dia[m_DiaSelect][i] = m_Dia[m_DiaSelect+1][i];
			m_Dia[m_DiaSelect+1][i] = t;
		}
		m_DiaSelect++;
	}
}

/*
 *	_Cݒ̃[v
 */
void CTrainGroup::LoopDia(){
	if(!m_DiaNumber) return;
	int i, j, t[4];
	for(i = 0; i<4; i++) t[i] = m_Dia[0][i];
	for(j = 1; j<m_DiaNumber; j++) for(i = 0; i<4; i++) m_Dia[j-1][i] = m_Dia[j][i];
	for(i = 0; i<4; i++) m_Dia[m_DiaNumber-1][i] = t[i];
}

/*
 *	Ԏ̐ݒ
 */
void CTrainGroup::Schedule(){
	if(m_Dia[0][1]){
		m_DepartDay = g_TimeDay;
		m_DepartHour = m_Dia[0][2];
		m_DepartMin = m_Dia[0][3];
		if(m_DepartHour<g_TimeHour
			|| (m_DepartHour==g_TimeHour && m_DepartMin<g_TimeMin)) m_DepartDay++;
	}else{
		m_DepartDay = g_TimeDay;
		m_DepartHour = g_TimeHour+m_Dia[0][2];
		m_DepartMin = g_TimeMin+m_Dia[0][3];
		m_DepartHour += m_DepartMin/60;
		m_DepartMin %= 60;
		m_DepartDay += m_DepartHour/24;
		m_DepartHour %= 24;
	}
}

/*
 *	_Cݒ̏
 */
void CTrainGroup::ClearDia(){
	m_DiaNumber = m_DiaListID = 0;
	m_DiaSelect = -1;
}

/*
 *	擪ԗ̍WvZɎc̍WvZ
 *
 *	߂l:	zuɐ true Ԃ
 */
bool CTrainGroup::Pull(
	CRail *p,	//	擪ԗ̌ԗ֔zu[
	bool c,		//	qƂ̏Փ˔tO
	bool r		//	ރtO
){
	int i;
	if(r){
		for(i = m_Count-2; i>=0; i--) if(!(p = m_Car[i]->Set2(p, &g_TrainLinkDir, &g_TrainLinkPos, c, true))) return false;
	}else{
		for(i = 1; i<m_Count; i++) if(!(p = m_Car[i]->Set2(p, &g_TrainLinkDir, &g_TrainLinkPos, c, false))) return false;
	}
	return true;
}

/*
 *	zu
 *
 *	߂l:	zuɐ true Ԃ
 */
bool CTrainGroup::Set(
	CRail *dest,	//	擪ԗOԗւ̔zu[
	VEC3 *d,		//	
	bool turn		//	zuɋtɑ点tO
){
	CRail *p;
	if(m_Enabled){
		g_GeneralLog.Add("ɔzuĂ܂!");
		return false;
	}
	if(!m_Count){
		g_GeneralLog.Add("qҐĂ܂!");
		return false;
	}
	if(p = m_Car[0]->Set(dest, d)){
		if(Pull(p, true, false)){
			m_Speed = 0.0f;
			if(m_DiaNumber){
				m_SpeedSet = turn ? -m_SpeedMax : m_SpeedMax;
				m_Mode = 1;
			}else{
				m_SpeedSet = 0.0f;
				m_Mode = 0;
			}
			m_ClearAnchor = false;
			g_GeneralLog.Add("qzu܂B");
			return m_Enabled = true;
		}
	}
	g_RailOptionList.EraseUser(m_Index);
	g_GeneralLog.Add("ꏊKĂ܂!");
	return false;
}

/*
 *	P
 */
void CTrainGroup::Remove(){
	if(!m_Enabled) return;
	m_Enabled = false;
	g_RailOptionList.EraseUser(m_Index);
	g_GeneralLog.Add("qP܂B");
}

/*
 *	_O
 */
void CTrainGroup::Show(){
	int i, test;
	float tsp, sth, get;
	bool ret;
	CRail *p;
	CTrain *tp;
	if(!m_Count) return;
	for(i = 0; i<m_Count; i++) m_Car[i]->Show();
	g_RailOptionList.EraseUser(m_Index);
	tsp = m_Speed/TRAIN_MARCH_SCALE;
	if(fabsf(tsp)<TRAIN_MARCH_TSD) tsp = (m_SpeedSet<0.0f ? -0.5f : 0.5f)*TRAIN_MARCH_TSD;
	ret = m_Speed==0.0f ? m_SpeedSet<0.0f : tsp<0.0f;
	if(ret) tp = m_Car[m_Count-1]; else tp = m_Car[0];
	m_Speed = (1.0f-TRAIN_ACCEL)*m_Speed+TRAIN_ACCEL*m_SpeedSet;
	g_TrainGroupParent = this;
	if(p = tp->March(tsp, m_ScanDist, &get, &test)){
		Pull(p, false, ret);
		if(m_StopPoint>0.0f) m_StopPoint -= fabsf(tsp);
		if(m_StopPoint<0.0f) m_StopPoint = 0.0f;
		if(m_StopPoint>m_ScanDist) sth = 1.0f;
		else sth = sqrtf(m_StopPoint/m_ScanDist);
		if(m_DiaNumber){
			if(m_Mode<1) m_Mode = 1;
		}else{
			if(m_Mode>0) m_Mode = 0;
		}
		switch(m_Mode){
		case -1:	//	蓮^]Eً}~
			switch(test){
			case 0:
			case 2:
				m_Mode = 0;
				break;
			default:
				if(m_Speed<0.0f){
					if(m_Speed<-m_SpeedMax*sth) m_Speed = -m_SpeedMax*sth;
				}else{
					if(m_Speed>m_SpeedMax*sth) m_Speed = m_SpeedMax*sth;
				}
			}
			if(fabsf(m_Speed)<TRAIN_MARCH_TSD){
				m_SpeedSet = -m_SpeedSet;
				m_Mode = 0;
			}
			break;
		case 0:	//	蓮^]Eʏ^s
			switch(test){
			case -1:
			case 1:
			case 3:
				m_Mode = -1;
				m_StopPoint = get-TRAIN_STOP_MARGIN;
				break;
			}
			break;
		case 1:	//	^]Eʏ^s
			if(test>0 && test&2){
				if(!m_ClearAnchor && m_Dia[0][0]==2){
					m_ClearAnchor = true;
					LoopDia();
				}
				if(m_ClearAnchor) test &= ~2;
			}else{
				m_ClearAnchor = false;
			}
			switch(test){
			case -1:
			case 1:
				m_Mode = 2;
				m_StopPoint = get-TRAIN_STOP_MARGIN;
				break;
			case 2:
				m_Mode = 3;
				m_StopPoint = get+0.5f*m_Length;
				break;
			case 3:
				m_Mode = 4;
				m_StopPoint = get-TRAIN_STOP_MARGIN;
				break;
			}
			break;
		case 2:	//	^]Eً}~
			if(m_StopPoint>get-TRAIN_STOP_MARGIN) m_StopPoint = get-TRAIN_STOP_MARGIN;
			if(m_Speed<0.0f){
				if(m_Speed<-m_SpeedMax*sth) m_Speed = -m_SpeedMax*sth;
			}else{
				if(m_Speed>m_SpeedMax*sth) m_Speed = m_SpeedMax*sth;
			}
			if(fabsf(m_Speed)<TRAIN_MARCH_TSD){
				m_SpeedSet = m_SpeedSet>0.0f ? -m_SpeedMax : m_SpeedMax;
				m_Mode = 1;
			}
			break;
		case 3:	//	^]Eʏ
			switch(test){
			case -1:
			case 1:
			case 3:
				m_Mode = 4;
				if(m_StopPoint>get-TRAIN_STOP_MARGIN) m_StopPoint = get-TRAIN_STOP_MARGIN;
				break;
			default:
				if(m_Speed<0.0f){
					if(m_Speed<-m_SpeedMax*sth) m_Speed = -m_SpeedMax*sth;
				}else{
					if(m_Speed>m_SpeedMax*sth) m_Speed = m_SpeedMax*sth;
				}
				break;
			}
			if(fabsf(m_Speed)<TRAIN_MARCH_TSD){
				if(m_ClearAnchor){
					if(g_TimeDay>m_DepartDay || (g_TimeDay==m_DepartDay && g_TimeHour>m_DepartHour)
						|| (g_TimeDay==m_DepartDay && g_TimeHour==m_DepartHour && g_TimeMin>=m_DepartMin)) m_Mode = 1;
				}else{
					m_ClearAnchor = true;
					if(m_Dia[0][0]) m_SpeedSet = m_SpeedSet>0.0f ? -m_SpeedMax : m_SpeedMax;
					Schedule();
					LoopDia();
				}
			}
			break;
		case 4:	//	^]Es~܂
			if(m_Speed<0.0f){
				if(m_Speed<-m_SpeedMax*sth) m_Speed = -m_SpeedMax*sth;
			}else{
				if(m_Speed>m_SpeedMax*sth) m_Speed = m_SpeedMax*sth;
			}
			if(fabsf(m_Speed)<TRAIN_MARCH_TSD){
				if(m_ClearAnchor){
					if(g_TimeDay>m_DepartDay || (g_TimeDay==m_DepartDay && g_TimeHour>m_DepartHour)
						|| (g_TimeDay==m_DepartDay && g_TimeHour==m_DepartHour && g_TimeMin>=m_DepartMin)) m_Mode = 1;
				}else{
					m_ClearAnchor = true;
					m_SpeedSet = m_SpeedSet>0.0f ? -m_SpeedMax : m_SpeedMax;
					Schedule();
					LoopDia();
				}
			}
			break;
		}
		return;
	}
	if(m_Mode>0){
		m_Speed = m_StopPoint = 0.0f;
		m_SpeedSet = m_SpeedSet>0.0f ? -m_SpeedMax : m_SpeedMax;
		m_Mode = 1;
	}else{
		m_Speed = 0.0f;
		m_SpeedSet = -m_SpeedSet;
	}
}

/*
 *	Ґvr[̕\
 */
void CTrainGroup::Preview(){
	int i;
	float m_Length = -TRAIN_INTERVAL, lc;
	VEC3 cp = GetVPos(), cd = GetVDir(), cr = GetVRight(), cu = GetVUp(), sp;
	if(!m_Count) return;
	for(i = 0; i<m_Count; i++) m_Length += m_Car[i]->m_Model->m_CarLength+TRAIN_INTERVAL;
	lc = 6.0f-m_PreviewCount;
	m_PreviewCount += TRAIN_PREV_SPEED;
	ValueCircular(&m_PreviewCount, 0.0f, 12.0f+m_Length);
	sp = cp+cd*9.5f-cu*3.8f;
	for(i = 0; i<m_Count; i++){
		lc += m_Car[i]->m_Model->m_CarLength*0.5f;
		m_Car[i]->Preview(&(sp+cr*lc), &(-cr), &cu);
		lc += m_Car[i]->m_Model->m_CarLength*0.5f+TRAIN_INTERVAL;
	}
}

/*
 *	x̕\
 */
void CTrainGroup::ShowSpeed(){
	if(m_Enabled) TextF(5, 475-FONT_HEIGHT*3, "%s\nݑx: %.1f\nݒ葬x: %.1f",
		m_Mode<1 ? "蓮^s" : "^s", m_Speed, m_SpeedSet);
	else TextF(5, 475-FONT_HEIGHT*3, "zu\n-\n-");

}

/*
 *	x̕\ mini
 */
void CTrainGroup::ShowSpeed2(){
	if(m_Enabled) TextF(5, 475-FONT_HEIGHT*2, "[%d/%d]\n%.1f / %.1f",
		m_Index+1, TRAIN_GROUP_MAX, m_Speed, m_SpeedSet);
	else TextF(5, 475-FONT_HEIGHT*2, "[%d/%d]\n- / -", m_Index+1, TRAIN_GROUP_MAX);

}

/*
 *	x̐ݒ
 */
void CTrainGroup::SetSpeed(
	float s,	//	xω
	int f		//	ݒtO
){
	if(!m_Enabled || m_Mode>0) return;
	if(f&1) m_SpeedSet += s; else m_SpeedSet -= s;
	ValueArea(&m_SpeedSet, f&2 ? -m_SpeedMax : 0.0f, (f&4)?m_SpeedMax:0.0f);
}

/*
 *	߂l: ݒ葬x
 */
float CTrainGroup::GetSpset(){
	return m_SpeedSet;
}

/*
 *	ōx̌vZ
 */
void CTrainGroup::CalcSpec(){
	int i;
	m_SpeedMax = m_Length = 0.0f;
	for(i = 0; i<m_Count; i++){
		if(i) m_Length += TRAIN_INTERVAL;
		m_Length += m_Car[i]->m_Model->m_CarLength;
		if(m_SpeedMax<m_Car[i]->m_Model->m_SpeedMax) m_SpeedMax = m_Car[i]->m_Model->m_SpeedMax;
	}
	m_ScanDist = TRAIN_STOP_TIME*m_SpeedMax;
}

/*
 *	Ґ̕\
 */
void CTrainGroup::SetLog(){
	int i = m_Count-TGROUP_LOG_MAX+4;
	g_TrainGroupLog.Clear();
	g_TrainGroupLog.AddF("@@Ґ: %d/%d", m_Index+1, TRAIN_GROUP_MAX);
	g_TrainGroupLog.AddF("@q: %d", m_Count);
	g_TrainGroupLog.AddF("ōx: %.2f", m_SpeedMax);
	g_TrainGroupLog.AddF("ԑ̒: %.2f", m_Length);
	if(i<0) i = 0;
	for(; i<m_Count; i++) g_TrainGroupLog.AddF("%2d: %s%s", i+1, m_Car[i]->m_Model->m_Name, m_Car[i]->m_TurnFlag ? " (])" : "");
	for(i = 0; i<TGROUP_LOG_MAX-m_Count-4; i++) g_TrainGroupLog.Add("");
}

/*
 *	߂l: zuĂ true Ԃ
 */
bool CTrainGroup::IsEnable(){
	return m_Enabled;
}

/*
 *	ҐɎ_킹
 *
 *	߂l:	_̒SW
 */
VEC3 CTrainGroup::SetCam(
	float d,	//	
	float b,	//	px
	float dis	//	
){
	VEC3 p1 = m_Car[0]->m_Pos[1], p2 = m_Car[m_Count-1]->m_Pos[0], r, cp;
	r = p1-p2;
	r.y = 0.0f;
	cp = (p1+p2)*0.5f+VEC3(0.0f, TRAIN_AVE_HEIGHT, 0.0f);
	V3Norm(&r, &r);
	SetView(V3ZERO, r, V3UP);
	RotVY(-d);
	RotVX(b);
	if(g_MiscOptionProjectionMode){
		g_OrthoRatio = 0.5f*dis/CAM_MAX_DIST;
		D3DXMatrixOrthoLH(&sv3.mtxProj, g_OrthoRatio*sv3.width, g_OrthoRatio*sv3.height, CLIP_PLANE_NEAR, CLIP_PLANE_FAR);
		sv3.pDev->SetTransform(D3DTS_PROJECTION, &sv3.mtxProj);
		SetVPos(-(dis+30.0f)*GetVDir());
	}else{
		SetVPos(-dis*GetVDir());
	}
	MoveVW(cp);
	return cp;
}

/*
 *	^]Ȏ_̓Kp
 *
 *	߂l:	_W
 */
VEC3 CTrainGroup::SetCab(){
	VEC3 p, d;
	if(m_Speed>0.0f || (m_Speed==0.0f && m_CabinView)){
		m_CabinView = true;
		p = m_Car[0]->m_Pos[0]+m_Car[0]->m_Model->m_Fix*(d = m_Car[0]->m_Dir)+VEC3(0.0f, TRAIN_AVE_HEIGHT*0.8f, 0.0f);
		SetView(p, p+d, m_Car[0]->m_Up);
	}else{
		m_CabinView = false;
		p = m_Car[m_Count-1]->m_Pos[1]-m_Car[m_Count-1]->m_Model->m_Fix*(d = m_Car[m_Count-1]->m_Dir)+VEC3(0.0f, TRAIN_AVE_HEIGHT*0.8f, 0.0f);
		SetView(p, p-d, m_Car[m_Count-1]->m_Up);
	}
	return p;
}

/*
 *	SҐq̊J
 */
void CTrainGroup::Destroy(){
	int i;
	for(i = 0; i<m_Count; i++) delete m_Car[i];
	m_Count = 0;
	m_Speed = m_SpeedSet = m_SpeedMax = m_Length = 0.0f;
	m_Enabled = false;
	ClearPoint();
	ClearDia();
}

/*
 *	ۑ
 */
void CTrainGroup::SaveData(
	FILE *df	//	t@C
){
	int i, n;
	fprintf(df, "\tTrainGroup{\n\t\tTrains=%d\n", m_Count);
	fprintf(df, "\t\tSpeedInfo=%f,%f,%f\n", m_Speed, m_SpeedSet, m_SpeedMax);
	fprintf(df, "\t\tLength=%f\n", m_Length);
	fprintf(df, "\t\tEnable=%d\n", m_Enabled);
	fprintf(df, "\t\tMode=%d\n", m_Mode);
	fprintf(df, "\t\tStopPoint=%f\n", m_StopPoint);
	fprintf(df, "\t\tClearAnchor=%d\n", m_ClearAnchor);
	fprintf(df, "\t\tPointInfo=%d,", n = CountPoint());
	for(i = 0; i<n; i++) fprintf(df, m_Point[i]==1 ? "L" : "R");
	fprintf(df, "\n");
	fprintf(df, "\t\tDiaInfo=%d,", m_DiaNumber);
	for(i = 0; i<m_DiaNumber; i++) fprintf(df, "(%d,%d,%d,%d),",
		m_Dia[i][0], m_Dia[i][1], m_Dia[i][2], m_Dia[i][3]);
	fprintf(df, "\n");
	fprintf(df, "\t\tDeparture=%d,%d,%d\n", m_DepartDay, m_DepartHour, m_DepartMin);
	for(i = 0; i<m_Count; i++) m_Car[i]->SaveData(df);
	fprintf(df, "\t}\n");
}

/*
 *	Ǎ
 */
void CTrainGroup::LoadData(
	FILE *df	//	t@C
){
	char c;
	int i, n;
	fscanf(df, "\tTrainGroup{\n\t\tTrains=%d\n", &m_Count);
	fscanf(df, "\t\tSpeedInfo=%f,%f,%f\n", &m_Speed, &m_SpeedSet, &m_SpeedMax);
	fscanf(df, "\t\tLength=%f\n", &m_Length);
	fscanf(df, "\t\tEnable=%d\n", &m_Enabled);
	if(g_CSVersion>=130){
		fscanf(df, "\t\tMode=%d\n", &m_Mode);
		fscanf(df, "\t\tStopPoint=%f\n", &m_StopPoint);
		fscanf(df, "\t\tClearAnchor=%d\n", &m_ClearAnchor);
	}
	ClearPoint();
	if(g_CSVersion>=110){
		fscanf(df, "\t\tPointInfo=%d,", &n);
		for(i = 0; i<n; i++){
			fscanf(df, "%c", &c);
			m_Point[i] = (c=='L' ? 1 : 2);
		}
		fscanf(df, "\n");
	}
	ClearDia();
	if(g_CSVersion>=130){
		fscanf(df, "\t\tDiaInfo=%d,", &m_DiaNumber);
		for(i = 0; i<m_DiaNumber; i++) fscanf(df, "(%d,%d,%d,%d),",
			&m_Dia[i][0], &m_Dia[i][1], &m_Dia[i][2], &m_Dia[i][3]);
		fscanf(df, "\n");
		fscanf(df, "\t\tDeparture=%d,%d,%d\n", &m_DepartDay, &m_DepartHour, &m_DepartMin);
		m_DiaSelect = m_DiaNumber ? 0 : -1;
	}
	m_DiaListID = 0;
	for(i = 0; i<m_Count; i++){
		m_Car[i] = new CTrain(m_Index);
		m_Car[i]->LoadData(df);
	}
	CalcSpec();
	fscanf(df, "\t}\n");
}
