//	Cu
#include "lib\udx.h"

//	萔E}N
#include "Const.h"
#include "Macro.h"

extern const float ARROW_ROTATE;
extern const float CAM_ZOM_RATE;
extern const int PANEL_WIDTH;
extern const int PANEL_UNIT;

extern const float CAM_MAX_DIST = 400.0f;	//	Jő勗

const int GRID_RADIUS = 10;				//	Obha (`)
const float CAM_MOV_KEY = 0.1f;			//	L[ɂJړx
const float PTR_MOV_RATE = 10.0f;		//	}EXɂJړx
const float PTR_2D_WIDTH = 8.0f;		//	OJ[\ړ͈͂̕
const float PTR_2D_HEIGHT = 6.0f;		//	OJ[\ړ͈͂̍
const float CAM_ROT_RATE = 0.5f;		//	J]x
const float CAM_MIN_DIST = 1.0f;		//	Jŏ
const float PTR_2D_DISTANCE = 14.5f;	//	J[\IuWFNg\
const float EARTH_SPIN = 0.01f;			//	n]x
const float EARTH_AXIS = D3DX_PI*0.4f;	//	n]p

//	c[֐
#include "ValueArea.h"
#include "SystemCover.h"

//	OO[o
extern int g_MiscOptionProjectionMode;
extern int g_MiscOptionEarthSpinFlag;
extern int g_ShowGrid;
extern float g_FWidthX;
extern float g_FWidthZ;
extern float g_Angle;
extern CObject g_ArrowObject;
extern CObject g_MagnetObject;
extern CObject g_DirectionObject;
extern CObject g_SurfaceObject;
extern CTexture g_InterfaceTexture;

//	O[o
int g_LengthSwitch = 2;	//	Q[x̐ݒ
unsigned int g_LengthTable[10] = {
	900, 1800, 5400, 9000, 18000, 36000, 54000, 108000, 432000, 2592000};
									//	Q[ 1 ̃t[e[u
unsigned int g_DayLength = 2880;	//	Q[ 1 ̃t[
unsigned int g_GameCounter = 0;		//	ԃt[JE^
unsigned int g_TimeDay;				//	
unsigned int g_TimeHour;			//	
unsigned int g_TimeMin;				//	

float g_CameraDir = D3DX_PI*1.5f;	//	px
float g_CameraBank = D3DX_PI/3.0f;	//	px
float g_CameraDist = 30.0f;			//	񒆐S̋
float g_OrthoRatio;					//	sẽY[
float g_ShadowAlpha = 1.0f;			//	ẽAt@l

bool g_RenderMode = false;	//	se[htO

VEC3 g_LightDir;	//	Cg

D3DCOLOR g_SkyColor;	//	wiF

/*
 *	J]
 */
void CameraRotate(
	POINT *p,	//	VXeJ[\W
	float *d,	//	px
	float *b	//	px
){
	*d -= CAM_ROT_RATE*((float)(p->x)-svw.winW/2)/svw.winW;
	*b += CAM_ROT_RATE*((float)(p->y)-svw.winH/2)/svw.winH;
	ValueCircular(d, 0.0f, D3DX_PI*2.0f);
	ValueArea(b, -D3DX_PI*0.45f, D3DX_PI*0.45f);
}

/*
 *	J[\̈ړ
 */
void CursorMove(
	POINT *p,	//	VXeJ[\W
	VEC3 *pp,	//	J[\W
	VEC3 *cp,	//	JSW
	bool updown	//	㉺ړtO
){
	float mtmp3 = FAST_MOV_RATE*CAM_MOV_KEY;
	VEC3 tgpick;
	pp->x -= PTR_MOV_RATE*((float)(p->x)-svw.winW/2)/svw.winW;
	pp->y -= PTR_MOV_RATE*((float)(p->y)-svw.winH/2)/svw.winH;
	ValueArea(&pp->x, -PTR_2D_WIDTH, PTR_2D_WIDTH);
	ValueArea(&pp->y, -PTR_2D_HEIGHT, PTR_2D_HEIGHT);
	if(updown){
		if(SDK_GetKey(VK_UP)>=S_PUSH) cp->y += mtmp3;
		if(SDK_GetKey(VK_DOWN)>=S_PUSH) cp->y -= mtmp3;
		g_SurfaceObject.Pick(VEC3(cp->x, FIELD_HEIGHT, cp->z), -V3UP, &tgpick, NULL);
		ValueArea(&tgpick.y, CAM_MIN_HIGH, FIELD_HEIGHT);
		ValueArea(&cp->y, tgpick.y, FIELD_HEIGHT);
	}
}

/*
 *	Jړ
 *
 *	߂l:	SW̒n`W
 */
float CameraSlide(
	POINT *p,	//	VXeJ[\W
	VEC3 *pp	//	JSW
){
	float mtmp2, mtmp3, gndalt = 0.0f;
	VEC3 tgpick;
	mtmp2 = FAST_MOV_RATE*CUS_MOV_RATE;
	mtmp3 = FAST_MOV_RATE*CAM_MOV_KEY;
	pp->x += mtmp2*(((float)(p->x)-svw.winW/2)/svw.winW*sin(-g_CameraDir)+((float)(p->y)-svw.winH/2)/svw.winH*cos(g_CameraDir));
	pp->z += mtmp2*(((float)(p->x)-svw.winW/2)/svw.winW*cos(g_CameraDir)+((float)(p->y)-svw.winH/2)/svw.winH*sin(g_CameraDir));
	ValueArea(&pp->x, -g_FWidthX, g_FWidthX);
	ValueArea(&pp->z, -g_FWidthZ, g_FWidthZ);  
	if(SDK_GetKey(VK_UP)>=S_PUSH) pp->y += mtmp3;
	if(SDK_GetKey(VK_DOWN)>=S_PUSH) pp->y -= mtmp3;
	if(g_SurfaceObject.Pick(VEC3(pp->x, FIELD_HEIGHT, pp->z), -V3UP, &tgpick, NULL)) gndalt = tgpick.y;
	ValueArea(&tgpick.y, CAM_MIN_HIGH, FIELD_HEIGHT);
	ValueArea(&pp->y, tgpick.y, FIELD_HEIGHT);
	return gndalt;
}

/*
 *	J
 */
void CameraDistance(
	float *d	//	
){
	float mtmp;
	if(CheckCtrl()) mtmp = FAST_MOV_RATE*CAM_ZOM_RATE; else mtmp = CAM_ZOM_RATE;
	*d -= mtmp*GetWheel();
	if(SDK_GetKey(VK_PRIOR)>=S_PUSH) *d -= mtmp*120;
	if(SDK_GetKey(VK_NEXT)>=S_PUSH) *d += mtmp*120;
	ValueArea(d, CAM_MIN_DIST, CAM_MAX_DIST);
}

/*
 *	J[\IuWFNg̈ʒuݒ
 *
 *	߂l:	J[\IuWFNg 3D W
 */
VEC3 ArrowSet(
	const VEC3 *cp,	//	JW
	const VEC3 *p	//	J[\W
){
	VEC3 cd = GetVDir(), cr = GetVRight(), cu = GetVUp(), pp, mp;
	if(g_MiscOptionProjectionMode){
		float ratio = 0.5f*g_OrthoRatio*sv3.width/PTR_2D_WIDTH;
		if(p){
			g_Angle += ARROW_ROTATE;
			ValueCircular(&g_Angle, 0.0f, D3DX_PI*2.0f);
			g_ArrowObject.SetPos(pp = *cp+PTR_2D_DISTANCE*cd+ratio*(-cr*p->x+cu*p->y));
			g_ArrowObject.SetDir(cd, -cu+cr);
			g_ArrowObject.SetScale(20.0f*g_OrthoRatio);
			g_ArrowObject.RotY(g_Angle);
		}
		g_MagnetObject.SetPos(mp = *cp+PTR_2D_DISTANCE*cd-g_OrthoRatio*cu*180.0);
		g_MagnetObject.SetScale(40.0f*g_OrthoRatio);
		cd.y = 0.0f;
		g_DirectionObject.SetPos(mp);
		g_DirectionObject.SetDir(cd, V3UP);
		g_DirectionObject.SetScale(40.0f*g_OrthoRatio);
		return pp;
	}else{
		if(p){
			g_Angle += ARROW_ROTATE;
			ValueCircular(&g_Angle, 0.0f, D3DX_PI*2.0f);
			g_ArrowObject.SetPos(pp = *cp+PTR_2D_DISTANCE*cd-cr*p->x+cu*p->y);
			g_ArrowObject.SetDir(cd, -cu+cr);
			g_ArrowObject.SetScale(0.5f);
			g_ArrowObject.RotY(g_Angle);
		}
		g_MagnetObject.SetPos(mp = *cp+PTR_2D_DISTANCE*cd-cu*4.5f);
		g_MagnetObject.SetScale(1.0f);
		cd.y = 0.0f;
		g_DirectionObject.SetPos(mp);
		g_DirectionObject.SetDir(cd, V3UP);
		g_DirectionObject.SetScale(1.0f);
		return pp;
	}
}

/*
 *	Jݒ̓KpƃJ[\̐ݒ
 *
 *	߂l:	J[\IuWFNg 3D W
 */
VEC3 CameraSet(
	float d,		//	px
	float b,		//	px
	float dis,		//	
	const VEC3 *c,	//	JSW
	const VEC3 *p	//	J[\W
){
	VEC3 cp, cd, cr, cu, pp;
	if(g_MiscOptionProjectionMode){
		g_OrthoRatio = 0.5f*dis/CAM_MAX_DIST;
		D3DXMatrixOrthoLH(&sv3.mtxProj, g_OrthoRatio*sv3.width, g_OrthoRatio*sv3.height, CLIP_PLANE_NEAR, CLIP_PLANE_FAR);
		sv3.pDev->SetTransform(D3DTS_PROJECTION, &sv3.mtxProj);
		cd = VEC3(cos(d)*cos(b), sin(b), sin(d)*cos(b));
		SetVPos(cp = (dis+30.0f)*cd);
	}else{
		cd = VEC3(cos(d)*cos(b), sin(b), sin(d)*cos(b));
		SetVPos(cp = dis*cd);
	}
	LookAtV(V3ZERO);
	SetVPos(cp += *c);
	return ArrowSet(&cp, p);
}

/*
 *	n_̐ (y W) vZ
 *
 *	߂l:	
 */
float GetFarDistance(
	const VEC3 *p	//	W
){
	VEC3 tv;
	tv = GetVPos();
	tv.y = 0.0f;
	return V3Len(&(tv-VEC3(p->x, 0.0f, p->z)));
}

/*
 *	IuWFNg̃tF[hAEgAt@lvZ
 *
 *	߂l:	At@l
 */
float GetFarAlpha(
	const VEC3 *p,	//	W
	float tsd1,		//	tF[hAEgJnW
	float tsd2		//	tF[hAEgԋ
){
	float alpha;
	alpha = (tsd1+tsd2-GetFarDistance(p))/tsd2;
	ValueArea(&alpha, 0.0f, 1.0f);
	return alpha;
}

/*
 *	3Obh`
 */
void DrawGrid(
	VEC3 pos	//	SW
){
	if(!g_ShowGrid) return;
	int x = pos.x, z = pos.z, tx, tz, ta;
	D3DCOLOR col;
	devSetState(D3DRS_ZFUNC, D3DCMP_ALWAYS);
	for(tx = x-GRID_RADIUS; tx<=x+GRID_RADIUS; tx++){
		ta = 255*cos((tx-x)*0.5f*D3DX_PI/(GRID_RADIUS+1));
		col = tx%5 ? MAKE_AC(ta, 192, 192, 255) : MAKE_AC(ta, 0, 0, 255);
		Draw3DLine(VEC3(tx, pos.y, z), VEC3(tx, pos.y, z-GRID_RADIUS-1), col, col&0x00ffffff);
		Draw3DLine(VEC3(tx, pos.y, z), VEC3(tx, pos.y, z+GRID_RADIUS+1), col, col&0x00ffffff);
	}
	for(tz = z-GRID_RADIUS; tz<=z+GRID_RADIUS; tz++){
		ta = 255*cos((tz-z)*0.5f*D3DX_PI/(GRID_RADIUS+1));
		col = tz%5 ? MAKE_AC(ta, 192, 192, 255) : MAKE_AC(ta, 0, 0, 255);
		Draw3DLine(VEC3(x, pos.y, tz), VEC3(x-GRID_RADIUS-1, pos.y, tz), col, col&0x00ffffff);
		Draw3DLine(VEC3(x, pos.y, tz), VEC3(x+GRID_RADIUS+1, pos.y, tz), col, col&0x00ffffff);
	}
	devSetState(D3DRS_ZFUNC, D3DCMP_LESSEQUAL);
}

/*
 *	IuWFNg̃At@lmFt_O
 */
void Render2(
	CObject *o,	//	IuWFNg
	float alpha	//	At@l
){
	if(alpha<1.0f){
		o->SetAlphaAlt(alpha);
		o->RenderA();
	}else{
		o->Render();
	}
}

/*
 *	IuWFNg̃At@lA}eAmFt_O
 */
void Render3(
	CObject *o,			//	IuWFNg
	float alpha,		//	At@l
	D3DMATERIAL8 *mat	//	}eA
){
	if(alpha<1.0f){
		if(mat){
			float t = mat->Diffuse.a;
			mat->Diffuse.a = t*alpha;
			o->RenderSC(mat);
			mat->Diffuse.a = t;
		}else{
			o->SetAlphaAlt(alpha);
			o->RenderA();
		}
	}else{
		if(mat) o->RenderSC(mat); else o->Render();
	}
}

/*
 *	Ǝ]̐
 */
void SpinEarth(){
	static float rot;
	unsigned int mod;
	int r, g, b, amb;
	float s;
	g_TimeDay = g_GameCounter/g_DayLength;
	mod = g_GameCounter%g_DayLength;
	g_TimeHour = mod*24/g_DayLength;
	g_TimeMin = (mod*24*60/g_DayLength)%60;
	g_GameCounter++;
	switch(g_MiscOptionEarthSpinFlag){
	case 0:
		rot = D3DX_PI*0.5f;
		break;
	case 1:
		rot = D3DX_PI*(2.0f*(g_GameCounter%g_DayLength)/g_DayLength-0.5f);
		break;
	case 2:
		rot = D3DX_PI*1.5f;
	}
	s = sin(rot);
	g_RenderMode = s<=0.0f;
	g_LightDir = VEC3(cos(rot), -s*sin(EARTH_AXIS), s*cos(EARTH_AXIS));
	if(s<0.05f) g_ShadowAlpha = 0.0f;
	else if(s<0.25f) g_ShadowAlpha = 5.0f*(s-0.05f);
	else g_ShadowAlpha = 1.0f;
	s = sin(rot)+0.25f;
	r = 1023*s;
	ValueArea(&r, 0, 192);
	g = 255*s;
	ValueArea(&g, 0, 64);
	g += 383*s;
	ValueArea(&g, 0, 255);
	b = 512*s;
	ValueArea(&b, 0, 255);
	amb = 512*s;
	ValueArea(&amb, 32, 128);
	devSetAmbient(MAKE_XC(amb, amb, amb));
	g_SkyColor = MAKE_XC(r, g, b);
	SetDirLight(g_LightDir, MAKE_CV(r/192.0f, g/255.0f, b/255.0f, 1.0f));
}

/*
 *	ẽ_O
 */
void RenderShadow2(
	CObject *o,	//	IuWFNg
	float alpha	//	ZAt@l
){
	devSetState(D3DRS_STENCILENABLE, TRUE);
	VEC3 spos, sdir, tri[3];
	CObject::matShadow.Diffuse.a = 0.5f*alpha*g_ShadowAlpha;
	if(g_SurfaceObject.Pick(o->GetPos()-g_LightDir, g_LightDir, &spos, tri)){
		CalcNormal(tri, &sdir);
		o->RenderShadow(&GetShadowMtx(spos+0.01f*sdir, sdir));
	}
	devSetState(D3DRS_STENCILENABLE, FALSE);
}

/*
 *	FPS Ǝ̕\
 */
void ShowFPS2(){
	ShowFPS(5, 5);
	TextF(5+13*FONT_WIDTH, 5, "%d%02d%02d", g_TimeDay, g_TimeHour, g_TimeMin);
}

/*
 *	ȈՃXe[^X\
 */
void MiniStatus(){
	ResetMatrix();
	devResetMaterial();
	devSetTexture(0, NULL);
	devSetLighting(false);
	ShowFPS2();
	devSetLighting(true);
	devSetState(D3DRS_ZFUNC, D3DCMP_ALWAYS);
	RenderMagnet();
}
