//	Cu
#include <direct.h>
#include "lib\udx.h"
#include "Pixelbit.h"

//	萔E}N
#include "Const.h"
#include "Macro.h"

extern const int SAVE_MAX;
extern const int RAILSIM_VERSION;
extern const int MODE_NUMBER;
extern const int SUBMODE_NUMBER;
extern const int PANEL_WIDTH;
extern const int PANEL_UNIT;

extern const int MAIN_LOG_MAX = 5;		//	ʃOs
extern const int TRAIN_LOG_MAX = 11;	//	qvOCXgs
extern const int TGROUP_LOG_MAX = 10;	//	ҐqXgs
extern const int TDIA_LOG_MAX = 11;		//	_Cݒ胊Xgs
extern const int STRUCT_LOG_MAX = 11;	//	{݃vOCXgs
extern const int STATION_LOG_MAX = 11;	//	wɃvOCXgs
extern const int SURFACE_LOG_MAX = 11;	//	n`vOCXgs

extern const float CAM_ZOM_RATE = 0.01f;	//	JY[x

const int CORNER_LOG_MAX = 5;	//	H_Xgs
const int NTL_EXP_MAX = 4;		//	j[g[hs
const int RAIL_EXP_MAX = 4;		//	H쐬[hs
const int RAILEDIT_EXP_MAX = 4;	//	HҏW[hs
const int TEXP_LOG_MAX = 5;		//	qҐ[hs
const int TSPEC_LOG_MAX = 5;	//	qXybNs
const int TPOINT_EXP_MAX = 1;	//	|Cgݒs
const int TDIA_EXP_MAX = 3;		//	_Cݒs
const int TSET_EXP_MAX = 5;		//	qzus
const int TVIEW_EXP_MAX = 3;	//	qn_s
const int BEXP_LOG_MAX = 1;		//	{ݑIs
const int BSPEC_LOG_MAX = 3;	//	{݃XybNs
const int SEXP_LOG_MAX = 1;		//	wɑIs
const int SSPEC_LOG_MAX = 4;	//	wɃXybNs
const int GEXP_LOG_MAX = 1;		//	n`Is
const int GSPEC_LOG_MAX = 5;	//	n`XybNs
const int DEF_EXP2_MAX = 3;		//	{ݓݒus
const int DEF_EXP3_MAX = 3;		//	{ݓPs

//	c[֐
#include "SystemCover.h"
#include "SwitchMode.h"

//	NX
#include "CLogger.h"
#include "CPlugin.h"
#include "CTrainModel.h"
#include "CStructModel.h"
#include "CStationModel.h"
#include "CSurfaceModel.h"
#include "CRailModel.h"
#include "CTieModel.h"
#include "CPierModel.h"

//	OO[o
extern int g_RailCreate;
extern int g_MiscOptionTexFilter;
extern CTrainModel *g_TrainOptionModelSeed;
extern CStructModel *g_StructOptionModelSeed;
extern CStationModel *g_StationOptionModelSeed;
extern CRailModel *g_RailOptionModelSeed;
extern CRailModel *g_RailOptionModelSelect;
extern CTieModel *g_TieOptionModelSeed;
extern CPierModel *g_PierOptionModelSeed;
extern int g_SurfaceOptionModels;
extern CSurfaceModel *g_SurfaceOptionModelSeed;
extern CSurfaceModel *g_SurfaceOptionModelSelect;
extern int g_ModePMode;
extern bool g_ModeChanged;
extern VEC3 g_LightDir;
extern CObject g_SurfaceObject;
extern CPixelbit g_ScreenShot;

//	O[o
char g_BaseDir[FILE_NAME_MAX];	//	AvP[VfBNg

CMesh g_OpeningMesh[10];	//	SbV

CObject g_OpeningObject[10];	//	SIuWFNg

CLogger g_GeneralLog;		//	ʃO
CLogger g_CornerLog;		//	H_Xg
CLogger g_NeutralExpLog;	//	j[g[h
CLogger g_RailExpLog;		//	H쐬[h
CLogger g_RailEditExpLog;	//	HҏW[h
CLogger g_TrainLog;			//	qvOCXg
CLogger g_TrainGroupLog;	//	ҐqXg
CLogger g_TrainExpLog;		//	qҐ[h
CLogger g_TrainSpecLog;		//	qXybN
CLogger g_TrainDiaLog;		//	_Cݒ胊Xg
CLogger g_TrainPointExpLog;	//	|Cgݒ
CLogger g_TrainDiaExpLog;	//	_Cݒ
CLogger g_TrainSetExpLog;	//	qzu
CLogger g_TrainViewExpLog;	//	qn_
CLogger g_StructLog;		//	{݃vOCXg
CLogger g_StructExpLog;		//	{ݑI
CLogger g_StructSpecLog;	//	{݃XybN
CLogger g_StationLog;		//	wɃvOCXg
CLogger g_StationExpLog;	//	wɑI
CLogger g_StationSpecLog;	//	wɃXybN
CLogger g_SurfaceLog;		//	n`vOCXg
CLogger g_SurfaceExpLog;	//	n`I
CLogger g_SurfaceSpecLog;	//	n`XybN
CLogger g_DefaultExp2Log;	//	{ݓݒu
CLogger g_DefaultExp3Log;	//	{ݓP
CLogger g_FileLog;			//	t@CXg
CLogger g_ModeLog;			//	[hXg

//	֐錾
void LoadTrain();
void LoadModel();
void Starting();
void CountPicture();
void LoadSurface(char *);
void SurfaceEdit();
void SaveOption();

/*
 *	S\̏
 */
void StartUp(){
	char fname[32];
	int i;
	SetCaption("RailSim");
	ShowCursor(false);
	V3Norm(&g_LightDir, &g_LightDir);
	SetDirLight(g_LightDir, MAKE_CV(1.0f, 1.0f, 1.0f, 1.0f));
	devSetNormalize(true);
	if(g_MiscOptionTexFilter) devTEX_LINEAR(); else devTEX_POINT();
	chdir(g_BaseDir);
	chdir("Misc");
	for(i = 0; i<10; i++){
		sprintf(fname, "op_%02d.x", i<7 ? i : i+3);
		g_OpeningMesh[i].Load(fname);
		g_OpeningObject[i].SetMesh(&g_OpeningMesh[i], V3ZERO, 0.1f);
	}
	SetExitKey(NULL);
	g_ScreenShot.Clear(DISP_WIDTH, DISP_HEIGHT);
	SetLoopFunc(MainLoop);
	devSetState(D3DRS_STENCILFUNC, D3DCMP_NOTEQUAL);
	devSetState(D3DRS_STENCILFAIL, D3DSTENCILOP_KEEP);
	devSetState(D3DRS_STENCILZFAIL, D3DSTENCILOP_KEEP);
	devSetState(D3DRS_STENCILPASS, D3DSTENCILOP_REPLACE);
	devSetState(D3DRS_STENCILREF, 1);
	devSetState(D3DRS_STENCILENABLE, FALSE);
}

/*
 *	S\t[
 */
void LogoFrame(
	int t	//	^CJEg
){
	int i, x;
	float e;
	SetView(VEC3(0.0f, -10.0f, -30.0f), VEC3(0.0f, -2.0f, 0.0f), V3UP);
	SetDirLight(LIGHT_DEF_DIR, MAKE_CV(1.0f, 1.0f, 1.0f, 1.0f));
	devSetState(D3DRS_ZFUNC, D3DCMP_LESSEQUAL);
	devSetLighting(true);
	for(i = 0; i<10; i++){
		x = t-i*3;
		if(x<0) break;
		e = 1.0f-exp(-x*x*0.005f);
		if(i<7) g_OpeningObject[i].SetPos(VEC3(4.5f*(i-3), 3.0f, 0.0f)*e);
		else g_OpeningObject[i].SetPos(VEC3(6.5f*(i-8), -3.0f, 0.0f)*e);
		g_OpeningObject[i].SetDir(V3UP, VEC3(0.0f, 0.0f, -1.0f));
		g_OpeningObject[i].SetAlphaAlt(e);
		g_OpeningObject[i].RenderA();
	}
}

/*
 *	S\Aj
 */
void MainLoop(){
	static int t = 0;
	BeginScene();
	LogoFrame(t);
	EndScene();
	if((t++)==90) SetLoopFunc(Starting);
}

/*
 *	e탍O
 */
void Starting(){
	g_GeneralLog.Init(MAIN_LOG_MAX, 30, 5, 10+FONT_HEIGHT);
	g_CornerLog.Init(CORNER_LOG_MAX, 0, 5, 20+(15+MAIN_LOG_MAX)*FONT_HEIGHT);
	g_NeutralExpLog.Init(NTL_EXP_MAX, 0, DISP_WIDTH-5-20*FONT_WIDTH, DISP_HEIGHT-5-NTL_EXP_MAX*FONT_HEIGHT);
	g_RailExpLog.Init(RAIL_EXP_MAX, 0, DISP_WIDTH-5-20*FONT_WIDTH, DISP_HEIGHT-5-RAIL_EXP_MAX*FONT_HEIGHT);
	g_RailEditExpLog.Init(RAILEDIT_EXP_MAX, 0, DISP_WIDTH-5-20*FONT_WIDTH, DISP_HEIGHT-5-RAILEDIT_EXP_MAX*FONT_HEIGHT);
	g_TrainLog.Init(TRAIN_LOG_MAX, 0, 5, 15+(1+MAIN_LOG_MAX)*FONT_HEIGHT);
	g_TrainGroupLog.Init(TGROUP_LOG_MAX, 0, 5, 20+(1+MAIN_LOG_MAX+TRAIN_LOG_MAX)*FONT_HEIGHT);
	g_TrainExpLog.Init(TEXP_LOG_MAX, 0, DISP_WIDTH-5-20*FONT_WIDTH, DISP_HEIGHT/1.2f-TEXP_LOG_MAX*FONT_HEIGHT);
	g_TrainSpecLog.Init(TSPEC_LOG_MAX, 0, DISP_WIDTH-5-20*FONT_WIDTH, DISP_HEIGHT/1.2f-5-(TEXP_LOG_MAX+TSPEC_LOG_MAX)*FONT_HEIGHT);
	g_TrainDiaLog.Init(TDIA_LOG_MAX, 0, 220, 15+(1+MAIN_LOG_MAX)*FONT_HEIGHT);
	g_TrainPointExpLog.Init(TPOINT_EXP_MAX, 0, DISP_WIDTH-5-20*FONT_WIDTH, DISP_HEIGHT/1.2f-TPOINT_EXP_MAX*FONT_HEIGHT);
	g_TrainDiaExpLog.Init(TDIA_EXP_MAX, 0, DISP_WIDTH-5-20*FONT_WIDTH, DISP_HEIGHT/1.2f-TDIA_EXP_MAX*FONT_HEIGHT);
	g_TrainSetExpLog.Init(TSET_EXP_MAX, 0, DISP_WIDTH-5-20*FONT_WIDTH, DISP_HEIGHT-5-TSET_EXP_MAX*FONT_HEIGHT);
	g_TrainViewExpLog.Init(TVIEW_EXP_MAX, 0, DISP_WIDTH-5-20*FONT_WIDTH, DISP_HEIGHT-5-TVIEW_EXP_MAX*FONT_HEIGHT);
	g_StructLog.Init(STRUCT_LOG_MAX, 0, 5, 15+(1+MAIN_LOG_MAX)*FONT_HEIGHT);
	g_StructExpLog.Init(BEXP_LOG_MAX, 0, DISP_WIDTH-5-20*FONT_WIDTH, DISP_HEIGHT-5-BEXP_LOG_MAX*FONT_HEIGHT);
	g_StructSpecLog.Init(BSPEC_LOG_MAX, 0, DISP_WIDTH-5-20*FONT_WIDTH, DISP_HEIGHT-10-(BEXP_LOG_MAX+BSPEC_LOG_MAX)*FONT_HEIGHT);
	g_StationLog.Init(STATION_LOG_MAX, 0, 5, 15+(1+MAIN_LOG_MAX)*FONT_HEIGHT);
	g_StationExpLog.Init(SEXP_LOG_MAX, 0, DISP_WIDTH-5-20*FONT_WIDTH, DISP_HEIGHT-5-SEXP_LOG_MAX*FONT_HEIGHT);
	g_StationSpecLog.Init(SSPEC_LOG_MAX, 0, DISP_WIDTH-5-20*FONT_WIDTH, DISP_HEIGHT-10-(SEXP_LOG_MAX+SSPEC_LOG_MAX)*FONT_HEIGHT);
	g_SurfaceLog.Init(SURFACE_LOG_MAX, 0, 5, 15+(1+MAIN_LOG_MAX)*FONT_HEIGHT);
	g_SurfaceExpLog.Init(GEXP_LOG_MAX, 0, DISP_WIDTH-5-20*FONT_WIDTH, DISP_HEIGHT-5-GEXP_LOG_MAX*FONT_HEIGHT);
	g_SurfaceSpecLog.Init(GSPEC_LOG_MAX, 0, DISP_WIDTH-5-20*FONT_WIDTH, DISP_HEIGHT-10-(GEXP_LOG_MAX+GSPEC_LOG_MAX)*FONT_HEIGHT);
	g_DefaultExp2Log.Init(DEF_EXP2_MAX, 0, DISP_WIDTH-5-20*FONT_WIDTH, DISP_HEIGHT-5-DEF_EXP2_MAX*FONT_HEIGHT);
	g_DefaultExp3Log.Init(DEF_EXP3_MAX, 0, DISP_WIDTH-5-20*FONT_WIDTH, DISP_HEIGHT-5-DEF_EXP3_MAX*FONT_HEIGHT);
	g_FileLog.Init(SAVE_MAX, 0, 50+2*FONT_WIDTH, 25+(8+MAIN_LOG_MAX)*FONT_HEIGHT);
	g_ModeLog.Init(MODE_NUMBER+SUBMODE_NUMBER+1, 0, DISP_WIDTH-105, 6);
	g_ModeLog.SetInterval(PANEL_UNIT);
	BeginScene();
	LogoFrame(90);
	Text(5, DISP_HEIGHT-5-FONT_HEIGHT, "Train ... Loading");
	EndScene();
	SetLoopFunc(LoadTrain);
}

/*
 *	̑̏
 */
void Starting2(){
	int i;
	g_TrainOptionModelSeed->MergeSort((CPlugin **)&g_TrainOptionModelSeed, NULL, 0);
	g_StructOptionModelSeed->MergeSort((CPlugin **)&g_StructOptionModelSeed, NULL, 0);
	g_StationOptionModelSeed->MergeSort((CPlugin **)&g_StationOptionModelSeed, NULL, 0);
	g_RailOptionModelSeed->MergeSort((CPlugin **)&g_RailOptionModelSeed, NULL, 0);
	g_TieOptionModelSeed->MergeSort((CPlugin **)&g_TieOptionModelSeed, NULL, 0);
	g_PierOptionModelSeed->MergeSort((CPlugin **)&g_PierOptionModelSeed, NULL, 0);
	CRailModel *rail = g_RailOptionModelSeed;
	for(i = 1; rail; i++){
		if(!_mbsicmp((PUCHAR)rail->GetIndex(), (PUCHAR)"RS_Wide")){
			g_RailCreate = i;
			g_RailOptionModelSelect = rail;
		}
		rail = rail->Next();
	}
	LoadModel();
	CountPicture();
	g_NeutralExpLog.Add("      : ㉺ړ");
	g_NeutralExpLog.Add(" SPACE(MM): ړ");
	g_NeutralExpLog.Add("   ESC(MR): ډ");
	g_NeutralExpLog.Add("      HOME: ǐ");
	g_RailExpLog.Add("     SHIFT: ㉺ړ");
	g_RailExpLog.Add("      CTRL: ړ");
	g_RailExpLog.Add("      : ݒI");
	g_RailExpLog.Add(" SPACE: ݒύX");
	g_RailEditExpLog.Add("      : ㉺ړ");
	g_RailEditExpLog.Add(" SPACE(MM): ړ");
	g_RailEditExpLog.Add("  DEL(MR2): P");
	g_RailEditExpLog.Add("      HOME: AJ[");
	g_TrainExpLog.Add("       TAB: ҐI");
	g_TrainExpLog.Add("      : ԎI");
	g_TrainExpLog.Add("   (MR2): q폜");
	g_TrainExpLog.Add("   (ML2): qǉ");
	g_TrainExpLog.Add(" SPACE(MR): q]");
	g_TrainSetExpLog.Add("       TAB: ҐI");
	g_TrainSetExpLog.Add("      : xݒ");
	g_TrainSetExpLog.Add("      : ㉺ړ");
	g_TrainSetExpLog.Add(" SPACE(MM): ړ");
	g_TrainSetExpLog.Add("  DEL(MR2): P");
	g_TrainPointExpLog.Add("       TAB: ҐI");
	g_TrainDiaExpLog.Add("       TAB: ҐI");
	g_TrainDiaExpLog.Add("     SPACE: ҏWؑ");
	g_TrainDiaExpLog.Add("      : lݒ");
	g_TrainViewExpLog.Add("       TAB: ҐI");
	g_TrainViewExpLog.Add("      : xݒ");
	g_TrainViewExpLog.Add("     SPACE: _ؑ");
	g_StructExpLog.Add("      : {ݑI");
	g_StationExpLog.Add("      : wɑI");
	g_SurfaceExpLog.Add("      : n`I");
	g_DefaultExp2Log.Add("      CTRL: ړ");
	g_DefaultExp2Log.Add("      : ݒI");
	g_DefaultExp2Log.Add(" SPACE: ݒύX");
	g_DefaultExp3Log.Add("      : ㉺ړ");
	g_DefaultExp3Log.Add(" SPACE(MM): ړ");
	g_DefaultExp3Log.Add("  DEL(MR2): P");
	LoadSurface("Default");
	for(i = 0; i<10; i++) g_OpeningMesh[i].Free();
	if(g_SurfaceOptionModels){
		g_SurfaceOptionModelSelect = g_SurfaceOptionModelSeed;
		g_SurfaceOptionModelSelect->SetGround(&g_SurfaceObject);
		g_SurfaceOptionModelSeed = NULL;
		g_ModePMode = 4;
		RegisterMode(0, true);
	}else{
		g_ModeChanged = true;
		SetLoopFunc(SurfaceEdit);
	}
	g_GeneralLog.Add("");
	g_GeneralLog.Add("");
	g_GeneralLog.AddF("RailSim Version %4.2f", RAILSIM_VERSION*0.01f);
	g_GeneralLog.Add("Copyright (c) 2003-2006");
	g_GeneralLog.Add("C^[lbg◯");
}

/*
 *	J
 */
void CleanUp(){
	if(g_TrainOptionModelSeed) delete g_TrainOptionModelSeed;
	if(g_StructOptionModelSeed) delete g_StructOptionModelSeed;
	if(g_StationOptionModelSeed) delete g_StationOptionModelSeed;
	if(g_SurfaceOptionModelSeed){
		g_SurfaceOptionModelSelect = NULL;
		g_SurfaceOptionModelSeed->Destroy();
	}else{
		if(g_SurfaceOptionModelSelect) delete g_SurfaceOptionModelSelect;
	}
	SaveOption();
}
