//	Cu
#include <direct.h>
#include "lib\udx.h"

//	萔E}N
#include "Const.h"
#include "Macro.h"

extern const int RAIL_TIE_TYPES = 16;			//	؂̎ސ
extern const int RAIL_PIER_TYPES = 16;			//	r̎ސ
//extern const float RAIL_MODEL_SCALE = 0.05f;	//	[bV̕\XP[
//extern const float RAIL_PIER_SCALE = 0.125f;	//	rbV̕\XP[

const float RAIL_TIE_SCALE = 0.125f;	//	؃bV̕\XP[

//	OO[o
extern char g_BaseDir[];
extern D3DCOLOR g_LineColor;

//	O[o
char g_TieReplace[RAIL_TIE_TYPES+1][FILE_NAME_MAX];		//	؃vOCu
char g_PierReplace[RAIL_TIE_TYPES+1][FILE_NAME_MAX];	//	rvOCu

float g_TrainFarDraw = 80.0;
float g_TrainFarHide = 40.0;
float g_StationFarDraw = 80.0;
float g_StationFarHide = 40.0;
float g_StructFarDraw = 80.0;
float g_StructFarHide = 40.0;
float g_RailFarDraw = 80.0;
float g_RailFarHide = 40.0;
float g_TieFarDraw = 40.0;
float g_TieFarHide = 40.0;
float g_PierFarDraw = 80.0;
float g_PierFarHide = 40.0;
float g_LineFarDraw = 40.0;
float g_LineFarHide = 40.0;

CMesh g_ArrowMesh;		//	J[\bV
CMesh g_CompassMesh;	//	_SbV
CMesh g_MagnetMesh;		//	΃bV
CMesh g_DirectionMesh;	//	ʃbV
CMesh g_LinkMesh;		//	AV{bV
CMesh g_AnchorMesh;		//	AJ[bV

CObject g_ArrowObject;		//	J[\IuWFNg
CObject g_CompassObject;	//	_SIuWFNg
CObject g_MagnetObject;		//	΃V{IuWFNg
CObject g_DirectionObject;	//	ʃV{IuWFNg
CObject g_LinkObject;		//	AV{IuWFNg
CObject g_AnchorObject;		//	AJ[IuWFNg

CTexture g_InterfaceTexture;	//	C^[tFCXeNX`

/*
 *	e탁bṼ[h
 */
void LoadModel(){
	int i;
	FILE *file;
	chdir(g_BaseDir);
	chdir("Misc");
	g_ArrowMesh.Load("Arrow.x");
	g_CompassMesh.Load("Compass.x");
	g_MagnetMesh.Load("Magnet.x");
	g_DirectionMesh.Load("Direction.x");
	g_LinkMesh.Load("Link.x");
	g_AnchorMesh.Load("Anchor.x");
	strcpy(g_TieReplace[0], "*none");
	if(file = fopen("TieReplace.txt", "rt")){
		for(i = 0; i<RAIL_TIE_TYPES; i++) fscanf(file, "%s\n", g_TieReplace[i+1]);
		fclose(file);
	}
	strcpy(g_PierReplace[0], "*none");
	if(file = fopen("PierReplace.txt", "rt")){
		for(i = 0; i<RAIL_PIER_TYPES; i++) fscanf(file, "%s\n", g_PierReplace[i+1]);
		fclose(file);
	}
	file = fopen("LineCustomize.txt", "rt");
	if(file){
		int r, g, b;
		fscanf(file, "Color=%d,%d,%d\n", &r, &g, &b);
		g_LineColor = MAKE_XC(r, g, b)&0x00ffffff;
		fclose(file);
	}
	file = fopen("FadeCustomize.txt", "rt");
	if(file){
		fscanf(file, "Train=%f,%f\n", &g_TrainFarDraw, &g_TrainFarHide);
		fscanf(file, "Station=%f,%f\n", &g_StationFarDraw, &g_StationFarHide);
		fscanf(file, "Struct=%f,%f\n", &g_StructFarDraw, &g_StructFarHide);
		fscanf(file, "Rail=%f,%f\n", &g_RailFarDraw, &g_RailFarHide);
		fscanf(file, "Tie=%f,%f\n", &g_TieFarDraw, &g_TieFarHide);
		fscanf(file, "Pier=%f,%f\n", &g_PierFarDraw, &g_PierFarHide);
		fscanf(file, "Line=%f,%f\n", &g_LineFarDraw, &g_LineFarHide);
		fclose(file);
	}
	g_InterfaceTexture.Load("Interface.png", 0, 0);
	chdir(g_BaseDir);
	g_ArrowObject.SetMesh(&g_ArrowMesh, V3ZERO, 0.5f);
	g_CompassObject.SetMesh(&g_CompassMesh, V3ZERO, 1.0f);
	g_MagnetObject.SetMesh(&g_MagnetMesh, V3ZERO, 1.0f);
	g_DirectionObject.SetMesh(&g_DirectionMesh, V3ZERO, 1.0f);
	g_LinkObject.SetMesh(&g_LinkMesh, V3ZERO, 0.5f);
	g_AnchorObject.SetMesh(&g_AnchorMesh, V3ZERO, 0.1f);
}
