//	Cu
#include "lib\udx.h"

//	萔E}N
#include "Const.h"
#include "Macro.h"

extern const int MAIN_LOG_MAX;

const int STRUCT_MAX = 2048;	//	{ݍő吔
const int STATION_MAX = 512;	//	wɍő吔

//	c[֐
#include "ValueArea.h"
#include "SystemCover.h"
#include "CameraControl.h"
#include "SwitchMode.h"
#include "SaveData.h"

//	NX
#include "CLogger.h"
#include "CRailList.h"
#include "CTrain.h"
#include "CTrainGroup.h"
#include "CTrainGroupList.h"
#include "CStruct.h"
#include "CStructList.h"
#include "CStation.h"
#include "CStationList.h"

//	OO[o
extern int g_RailSelectFlag;
extern int g_ObjectSelectFlag;
extern float g_CameraDir;
extern float g_CameraBank;
extern float g_CameraDist;
extern bool g_ModeChanged;
extern D3DCOLOR g_SkyColor;
extern CLogger g_GeneralLog;
extern CLogger g_NeutralExpLog;
extern CLogger g_ModeLog;

//	O[o
float g_Angle = 0.0f;	//	J[\]p
float g_Blink = 0.0f;	//	TvIuWFNg̓_ŃAt@

POINT g_Pointer;			//	J[\W
POINT g_AreaPos1 = {0, 0};	//	͈͑IW
POINT g_AreaPos2 = {0, 0};	//	͈͑IEW

VEC3 g_ArrowPos(0.0f, 0.0f, 0.0f);			//	OJ[\W
VEC3 g_ArrowPost(0.0f, 0.0f, 0.0f);			//	OJ[\ObhۂߍW
VEC3 g_Pick(0.0f, 0.0f, 0.0f);				//	n`̕W`FbNW
VEC3 g_PointPos(0.0f, 0.0f, 0.0f);			//	񎟌J[\W
VEC3 g_CameraPos(0.0f, CAM_MIN_HIGH, 0.0f);	//	J񒆐SW

CObject g_SurfaceObject;	//	n`IuWFNg

CRailList g_RailOptionList;	//	[`bvXg

CTrainGroupList g_TrainOptionList;	//	ҐXg

CStructList g_StructOptionList(STRUCT_MAX);	//	{݃Xg

CStationList g_StationOptionList(STATION_MAX);	//	wɃXg

//	֐錾
void VideoCapture(bool);

/*
 *	`揇
 */
void RenderOrder(){
	g_SurfaceObject.Render();
	g_RailOptionList.ShowRail();
	g_TrainOptionList.Show();
	g_StructOptionList.Show();
	g_StationOptionList.Show();
}

/*
 *	j[g[h
 */
void Neutral(){
	static int rk, lk, follow;
	static CObject *glance = NULL;
	float gndalt = 0.0f;
	bool drawcompass = false;
	VEC3 pp, tgpick;
	BOX8 tbox;
	POINT pos;
	if(g_ModeChanged) glance = NULL;
	pos = GetCursorXY();
	if((pos.x!=(svw.winW/2)) || (pos.y!=(svw.winH/2))) rk = lk = 0;
	switch(SDK_GetKey(VK_LBUTTON)){
	case S_PUSH:
		lk = 1;
		break;
	case S_HOLD:
		break;
	case S_PULL:
		if(lk){
			if(ClickMode()){
				if(g_ModeChanged) return;
			}else{
				float dist1, dist2;
				CStruct *st1 = NULL, *st2;
				CTrain *tr = NULL;
				g_AreaPos1 = g_Pointer;
				st1 = g_StructOptionList.SearchNearest(&dist1);
				if(st2 = g_StationOptionList.SearchNearest(&dist2)){
					if(!st1 || dist1>dist2){
						st1 = st2; dist1 = dist2;
					}
				}
				if(tr = g_TrainOptionList.SearchNearest(&dist2)){
					if(!st1 || dist1>dist2) glance = tr->GetObject();
					else glance = st1->GetObject();
				}else if(st1){
					glance = st1->GetObject();
				}
			}
		}
	default:
		lk = 0;
		break;
	}
	switch(SDK_GetKey(VK_RBUTTON)){
	case S_PULL:
		if(rk){
			glance = NULL;
		}
		break;
	case S_PUSH:
		rk = 1;
		break;
	case S_HOLD:
		drawcompass = true;
		if(g_SurfaceObject.Pick(VEC3(g_CameraPos.x, FIELD_HEIGHT, g_CameraPos.z), -V3UP, &tgpick, NULL)) gndalt = tgpick.y;
		ValueArea(&tgpick.y, CAM_MIN_HIGH, FIELD_HEIGHT);
		CameraRotate(&pos, &g_CameraDir, &g_CameraBank);
		break;
	default:
		SwitchMode();
		if(CheckSlide()){
			drawcompass = true;
			gndalt = CameraSlide(&pos, &g_CameraPos);
			glance = NULL;
		}else{
			CursorMove(&pos, &g_PointPos, &g_CameraPos, true);
			if(SDK_GetKey(VK_UP)>=S_PUSH || SDK_GetKey(VK_DOWN)>=S_PUSH) glance = NULL;
			if(SDK_GetKey(VK_HOME)==S_PUSH) follow = !follow;
		}
		ScanUndoRedo();
	}
	SetCursor(svw.winW/2, svw.winH/2);
	if(follow && glance){
		SetView(GetVPos(), glance->GetPos(), V3UP);
		tbox = glance->GetBox();
		pp = ArrowSet(&GetVPos(), &g_PointPos);
	}else{
		if(glance){
			g_CameraPos = glance->GetPos();
			tbox = glance->GetBox();
		}
		CameraDistance(&g_CameraDist);
		pp = CameraSet(g_CameraDir, g_CameraBank, g_CameraDist, &g_CameraPos, &g_PointPos);
	}
	Blink(&g_Blink);
	BeginScene(g_SkyColor);
	devSetState(D3DRS_ZFUNC, D3DCMP_LESSEQUAL);
	SpinEarth();
	g_RailSelectFlag = 0;
	g_ObjectSelectFlag = 0;
	g_Pointer = WorldToScreen2(&pp);
	devSetLighting(true);
	RenderOrder();
	switch(SwitchAlt()){
	case 0:
		ResetMatrix();
		devResetMaterial();
		devSetTexture(0, NULL);
		devSetLighting(false);
		TextF(5, 15+(1+MAIN_LOG_MAX)*FONT_HEIGHT, "J[\: (%d, %d)", g_Pointer.x, g_Pointer.y);
		TextF(5, 15+(2+MAIN_LOG_MAX)*FONT_HEIGHT, "_S: (%.2f, %.2f, %.2f)", g_CameraPos.x, g_CameraPos.y, g_CameraPos.z);
		g_GeneralLog.Show();
		g_NeutralExpLog.Show();
		if(glance){
			devResetMaterial();
			devSetTexture(0, NULL);
			devSetState(D3DRS_ZFUNC, D3DCMP_ALWAYS);
			DrawBox(&tbox, MAKE_AC((int)(255.0f*BlinkToAlpha(g_Blink)), 255, 0, 0));
			devSetState(D3DRS_ZFUNC, D3DCMP_LESSEQUAL);
		}
		RenderMode(true);
		g_ModeLog.Show();
		ShowFPS2();
		devSetLighting(true);
		devSetState(D3DRS_ZFUNC, D3DCMP_ALWAYS);
		RenderMagnet();
		RenderArrow(drawcompass, gndalt);
		break;
	case 1:
		MiniStatus();
		break;
	}
	EndScene();
	VideoCapture(true);
}
