//	Cu
#include <direct.h>
#include "..\lib\udx.h"

//	萔E}N
#include "..\Const.h"
#include "..\Macro.h"

//	c[֐
#include "..\SystemCover.h"
#include "..\SwitchMode.h"

extern const int MAIN_LOG_MAX = 5;				//	ʃOs
extern const int TRAIN_LOG_MAX = 11;			//	qvOCXgs
extern const int TGROUP_LOG_MAX = 10;			//	ҐqXgs
extern const int TDIA_LOG_MAX = 11;				//	_Cݒ胊Xgs
extern const int STRUCT_LOG_MAX = 11;			//	{݃vOCXgs
extern const int STATION_LOG_MAX = 11;			//	wɃvOCXgs
extern const int SURFACE_LOG_MAX = 11;			//	n`vOCXgs
extern const int RAIL_TIE_TYPES = 16;			//	؂̎ސ
extern const int RAIL_PIER_TYPES = 16;			//	r̎ސ
extern const float RAIL_MODEL_SCALE = 0.05f;	//	[bV̕\XP[
extern const float RAIL_PIER_SCALE = 0.125f;	//	rbV̕\XP[
extern const float ARROW_ROTATE = 0.3f;			//	J[\]x
extern const float CAM_ZOM_RATE = 0.002f;		//	JY[x

const int CORNER_LOG_MAX = 5;	//	H_Xgs
const int NTL_EXP_MAX = 3;		//	j[g[hs
const int RAIL_EXP_MAX = 4;		//	H쐬[hs
const int TEXP_LOG_MAX = 5;		//	qҐ[hs
const int TSPEC_LOG_MAX = 5;	//	qXybNs
const int TPOINT_EXP_MAX = 1;	//	|Cgݒs
const int TDIA_EXP_MAX = 3;		//	_Cݒs
const int TSET_EXP_MAX = 5;		//	qzus
const int TVIEW_EXP_MAX = 3;	//	qn_s
const int BEXP_LOG_MAX = 1;		//	{ݑIs
const int BSPEC_LOG_MAX = 3;	//	{݃XybNs
const int SEXP_LOG_MAX = 1;		//	wɑIs
const int SSPEC_LOG_MAX = 4;	//	wɃXybNs
const int GEXP_LOG_MAX = 1;		//	n`Is
const int GSPEC_LOG_MAX = 5;	//	n`XybNs
const int DEF_EXP2_MAX = 3;		//	{ݓݒus

//	NX
#include "..\CLogger.h"
#include "..\CPlugin.h"
#include "..\CTrainModel.h"
#include "..\CStructModel.h"
#include "..\CStationModel.h"
#include "..\CSurfaceModel.h"
#include "..\CRailList.h"

//	OO[o
extern CTrainModel *g_TrainOptionModelSeed;
extern CStructModel *g_StructOptionModelSeed;
extern CStationModel *g_StationOptionModelSeed;
extern CSurfaceModel *g_SurfaceOptionModelSeed;
extern VEC3 g_LightDir;

//	O[o
int g_DisplayOptionWidth;			//	𑜓x x
int g_DisplayOptionHeight;			//	𑜓x y
int g_MiscOptionShadowFlag = 1;		//	e_Oݒ
int g_MiscOptionTieFlag = 1;		//	؃_Oݒ
int g_MiscOptionLineFlag = 0;		//	ː_Oݒ
int g_MiscOptionRailMode = 0;		//	[_Oݒ
int g_MiscOptionTrainMode = 0;		//	q_Oݒ
int g_MiscOptionStationMode = 1;	//	wɃ_Oݒ
int g_MiscOptionStructMode = 0;		//	{݃_Oݒ
int g_MiscOptionTexFilter = 0;		//	eNX`tB^ݒ
int g_MiscOptionProjectionMode = 0;	//	e@ݒ
int g_MiscOptionEarthSpinFlag = 1;	//	Ԍoߐݒ
int g_MiscOptionFontShadowFlag = 1;	//	Ԍoߐݒ
int g_MiscOptionMagnetFlag = 1;		//	ʎjݒ
int g_MiscOptionWindowFlag = 1;		//	EBhE[hݒ
int g_MiscOptionDispSize = 0;		//	𑜓xݒ
int g_MiscOptionPluginSort = 0;		//	vOC\[hݒ

int g_CSVersion;
int g_ShowGrid = 0;
int g_KantSwitch = 0;
int g_HomePreview = 1;

char g_BaseDir[FILE_NAME_MAX];							//	AvP[VfBNg
char g_TieReplace[RAIL_TIE_TYPES+1][FILE_NAME_MAX];		//	؃vOCu
char g_PierReplace[RAIL_TIE_TYPES+1][FILE_NAME_MAX];	//	rvOCu

float g_Angle = 0.0f;	//	J[\]p
float g_Blink = 0.0f;	//	TvIuWFNg̓_ŃAt@
float g_TrainFarDraw = 80.0;
float g_TrainFarHide = 40.0;
float g_StationFarDraw = 80.0;
float g_StationFarHide = 40.0;
float g_StructFarDraw = 80.0;
float g_StructFarHide = 40.0;
float g_RailFarDraw = 80.0;
float g_RailFarHide = 40.0;
float g_TieFarDraw = 40.0;
float g_TieFarHide = 40.0;
float g_PierFarDraw = 80.0;
float g_PierFarHide = 40.0;
float g_LineFarDraw = 40.0;
float g_LineFarHide = 40.0;

POINT g_Pointer;			//	J[\W
POINT g_AreaPos1 = {0, 0};	//	͈͑IW
POINT g_AreaPos2 = {0, 0};	//	͈͑IEW

VEC3 g_ArrowPost(0.0f, 0.0f, 0.0f);			//	OJ[\ObhۂߍW
VEC3 g_CameraPos(0.0f, CAM_MIN_HIGH, 0.0f);	//	J񒆐SW

CObject g_ArrowObject;					//	J[\IuWFNg
CObject g_CompassObject;				//	AV{IuWFNg
CObject g_MagnetObject;					//	΃V{IuWFNg
CObject g_DirectionObject;				//	ʃV{IuWFNg
CObject g_LinkObject;					//	_SIuWFNg
CObject g_AnchorObject;					//	AJ[IuWFNg
CObject g_RailObject;					//	[IuWFNg
CObject g_TieObject[RAIL_TIE_TYPES];	//	؃IuWFNg
CObject g_Pier1Object[RAIL_PIER_TYPES];	//	rIuWFNg (x)
CObject g_Pier2Object[RAIL_PIER_TYPES];	//	rIuWFNg (x)
CObject g_SurfaceObject;				//	n`IuWFNg

CLogger g_GeneralLog;		//	ʃO
CLogger g_CornerLog;		//	H_Xg
CLogger g_NeutralExpLog;	//	j[g[h
CLogger g_RailExpLog;		//	H쐬[h
CLogger g_TrainLog;			//	qvOCXg
CLogger g_TrainGroupLog;	//	ҐqXg
CLogger g_TrainExpLog;		//	qҐ[h
CLogger g_TrainSpecLog;		//	qXybN
CLogger g_TrainDiaLog;		//	_Cݒ胊Xg
CLogger g_TrainPointExpLog;	//	|Cgݒ
CLogger g_TrainDiaExpLog;	//	_Cݒ
CLogger g_TrainSetExpLog;	//	qzu
CLogger g_TrainViewExpLog;	//	qn_
CLogger g_StructLog;		//	{݃vOCXg
CLogger g_StructExpLog;		//	{ݑI
CLogger g_StructSpecLog;	//	{݃XybN
CLogger g_StationLog;		//	wɃvOCXg
CLogger g_StationExpLog;	//	wɑI
CLogger g_StationSpecLog;	//	wɃXybN
CLogger g_SurfaceLog;		//	n`vOCXg
CLogger g_SurfaceExpLog;	//	n`I
CLogger g_SurfaceSpecLog;	//	n`XybN
CLogger g_DefaultExp2Log;	//	{ݓݒu
CLogger g_DefaultExp3Log;	//	{ݓP
CLogger g_FileLog;			//	t@CXg
CLogger g_ModeLog;			//	[hXg

CRailList g_RailOptionList;	//	[`bvXg

//	֐錾
void TrainEdit();
void StructEdit();
void StationEdit();
void SurfaceEdit();

/*
 *	t@CtpXfBNĝݎo
 */
void CutPath(
	char *path	//	pXi[
){
	char *ptr = path+strlen(path);
	for(; ptr>path && *ptr!='\\'; ptr = CharPrev(path, ptr)) *ptr = 0;
}

void StartUp(){
	char *types[4] = {"Train.txt", "Struct.txt", "Station.txt", "Surface.txt"}, tmp[1024];
	int i;
	FILE *fname;
	SetCaption("RailSim Plugin Viewer");
	V3Norm(&g_LightDir, &g_LightDir);
	SetDirLight(g_LightDir, MAKE_CV(1.0f, 1.0f, 1.0f, 1.0f));
	sv3.pDev->SetRenderState(D3DRS_NORMALIZENORMALS, true);
	if(__argc<2){
		Dialog("PƂŋNĂg܂̂");
		ExitProcess(0);
	}
	ShowCursor(false);
	g_GeneralLog.Init(MAIN_LOG_MAX, 30, 5, 10+FONT_HEIGHT);
	g_CornerLog.Init(CORNER_LOG_MAX, 0, 5, 10+FONT_HEIGHT);
	g_TrainLog.Init(TRAIN_LOG_MAX, 0, 5, 10+FONT_HEIGHT);
	g_TrainSpecLog.Init(TSPEC_LOG_MAX, 0, 5, DISP_HEIGHT-5-TSPEC_LOG_MAX*FONT_HEIGHT);
	g_StructLog.Init(STRUCT_LOG_MAX, 0, 5, 10+FONT_HEIGHT);
	g_StructSpecLog.Init(BSPEC_LOG_MAX, 0, 5, DISP_HEIGHT-5-BSPEC_LOG_MAX*FONT_HEIGHT);
	g_StationLog.Init(STATION_LOG_MAX, 0, 5, 10+FONT_HEIGHT);
	g_StationSpecLog.Init(SSPEC_LOG_MAX, 0, 5, DISP_HEIGHT-5-SSPEC_LOG_MAX*FONT_HEIGHT);
	g_SurfaceLog.Init(SURFACE_LOG_MAX, 0, 5, 10+FONT_HEIGHT);
	g_SurfaceSpecLog.Init(GSPEC_LOG_MAX, 0, 5, DISP_HEIGHT-5-GSPEC_LOG_MAX*FONT_HEIGHT);
	for(i = 0; i<8; i++){
		if(i<4){
			if(_mbsicmp((PUCHAR)(__argv[1]+strlen(__argv[1])-strlen(types[i])),
				(PUCHAR)(types[i]))) continue;
			strcpy(tmp, __argv[1]);
			tmp[strlen(tmp)-strlen(types[i])] = 0;
			chdir(tmp);
		}else{
			chdir(__argv[1]);
		}
		switch(i%4){
		case 0:
			if(!(fname = fopen("Model.x", "r"))) continue;
			fclose(fname);
			if(!(fname = fopen("Train.txt", "r"))) continue;
			g_TrainLog.Clear();
			(new CTrainModel("PLUGIN", fname, true))->AddLog(0);
			fclose(fname);
			SetLoopFunc(TrainEdit);
			return;
		case 1:
			if(!(fname = fopen("Model.x", "r"))) continue;
			fclose(fname);
			if(!(fname = fopen("Struct.txt", "r"))) continue;
			(new CStructModel("PLUGIN", fname, true))->AddLog(0);
			fclose(fname);
			SetLoopFunc(StructEdit);
			return;
		case 2:
			if(!(fname = fopen("Model.x", "r"))) continue;
			fclose(fname);
			if(!(fname = fopen("Station.txt", "r"))) continue;
			(new CStationModel("PLUGIN", fname, true))->AddLog(0);
			fclose(fname);
			SetLoopFunc(StationEdit);
			return;
		case 3:
			if(!(fname = fopen("Model.x", "r"))) continue;
			fclose(fname);
			if(!(fname = fopen("Surface.txt", "r"))) continue;
			(new CSurfaceModel("PLUGIN", fname, true))->AddLog(0);
			fclose(fname);
			SetLoopFunc(SurfaceEdit);
			return;
		}
	}
	if(!_mbsicmp((PUCHAR)(__argv[1]+strlen(__argv[1])-2), (PUCHAR)".x")){
		strcpy(tmp, __argv[1]);
		CutPath(tmp);
		chdir(tmp);
		(new CStructModel(__argv[1]))->AddLog(0);
		SetLoopFunc(StructEdit);
		return;
	}
	ExitProcess(0);
}

void MainLoop(){}

void CleanUp(){
	if(g_TrainOptionModelSeed) delete g_TrainOptionModelSeed;
	if(g_StructOptionModelSeed) delete g_StructOptionModelSeed;
	if(g_StationOptionModelSeed) delete g_StationOptionModelSeed;
	if(g_SurfaceOptionModelSeed) delete g_SurfaceOptionModelSeed;
}

void LoadOption(){
	static const int wtable[3] = {640, 800, 1024};
	static const int htable[3] = {480, 600, 768};
	g_DisplayOptionWidth = wtable[g_MiscOptionDispSize];
	g_DisplayOptionHeight = htable[g_MiscOptionDispSize];
}

void FilePushUndo(){}

/*
 *	pxɂ郉Cgw
 */
void LightSetByAngle(
	float d,		//	px
	float b,		//	px
	D3DCOLORVALUE c	//	F
){
	SetDirLight(VEC3(cos(d)*cos(b), sin(b), sin(d)*cos(b)), c);
}

/*
 *	Cg\
 */
void LightShowDir(){
	float d = 0.2f*V3Len(&GetVPos());
	VEC3 dir = svl.dir.Direction, up, right, fdir;
	V3Norm(&up, V3Cross(&up, &dir, V3Cross(&right, &VEC3(V3UP), &dir)));
	V3Norm(&fdir, &VEC3(dir.x, 0.0f, dir.z));
	Draw3DLine(V3ZERO, 2.5f*d*V3RIGHT, 0xffff0000, 0xffff0000);
	Draw3DLine(V3ZERO, 2.5f*d*V3UP, 0xff00ff00, 0xff00ff00);
	Draw3DLine(V3ZERO, 2.5f*d*V3DIR, 0xff0000ff, 0xff0000ff);
	Draw3DLine(-d*dir, -1.5f*d*dir+0.2f*d*up, 0xffffffff, 0xffffc080);
	Draw3DLine(-1.5f*d*dir+0.2f*d*up, -1.5f*d*dir+0.1f*d*up, 0xffffc080, 0xffffc080);
	Draw3DLine(-1.5f*d*dir+0.1f*d*up, -2.0f*d*dir+0.1f*d*up, 0xffffc080, 0xffff8000);
	Draw3DLine(-d*dir, -1.5f*d*dir-0.2f*d*up, 0xffffffff, 0xffffc080);
	Draw3DLine(-1.5f*d*dir-0.2f*d*up, -1.5f*d*dir-0.1f*d*up, 0xffffc080, 0xffffc080);
	Draw3DLine(-1.5f*d*dir-0.1f*d*up, -2.0f*d*dir-0.1f*d*up, 0xffffc080, 0xffff8000);
	Draw3DLine(-2.0f*d*dir+0.1f*d*up, -2.0f*d*dir-0.1f*d*up, 0xffff8000, 0xffff8000);
	Draw3DLine(V3ZERO, -2.5f*d*dir, 0xffffffff, 0xff00ffff);
	Draw3DLine(V3ZERO, -2.5f*d*fdir, 0xffffffff, 0xff00ffff);
}
