//	Cu
#include "..\lib\udx.h"

//	萔E}N
#include "..\Const.h"
#include "..\Macro.h"

extern const int MAIN_LOG_MAX;
extern const int STATION_LOG_MAX;
extern const int RAIL_TIE_TYPES;
extern const int RAIL_PIER_TYPES;
extern const float ARROW_ROTATE;
extern const float PTR_FOLLOW_RATE;
extern const float GRID_SNAP_Y;

//	c[֐
#include "..\ValueArea.h"
#include "..\SystemCover.h"
#include "..\CameraControl.h"
#include "..\SwitchMode.h"

//	NX
#include "..\CLogger.h"
#include "..\CRailList.h"
#include "..\CTrainGroup.h"
#include "..\CTrainGroupList.h"
#include "..\CPlugin.h"
#include "..\CStructModel.h"
#include "..\CStationModel.h"
#include "..\CStructList.h"
#include "..\CStationList.h"

//	OO[o
extern int g_MiscOptionTexFilter;
extern int g_StationOptionModels;
extern int g_StationOptionSelect;
extern int g_StationOptionListID;
extern CStationModel *g_StationOptionModelSeed;
extern CStationModel *g_StationOptionModelSelect;
extern char g_TieName[][PLUGIN_NAME_MAX];
extern char g_PierName[][PLUGIN_NAME_MAX];
extern int g_ModePMode;
extern int g_RailSelectFlag;
extern int g_ObjectSelectFlag;
extern int g_StructDir;
extern int g_SnapSwitch;
extern int g_TieCreate;
extern int g_PierCreate;
extern float g_GridSnap;
extern float g_SnapTable[];
extern float g_CameraDir;
extern float g_CameraBank;
extern float g_CameraDist;
extern float g_FWidthX;
extern float g_FWidthZ;
extern float g_Angle;
extern float g_Blink;
extern bool g_LineCreate;
extern bool g_ModeChanged;
extern bool g_RenderMode;
extern POINT g_Pointer;
extern POINT g_AreaPos1;
extern POINT g_AreaPos2;
extern D3DCOLOR g_SkyColor;
extern VEC3 g_ArrowPos;
extern VEC3 g_ArrowPost;
extern VEC3 g_CameraPos;
extern VEC3 g_Pick;
extern VEC3 g_PointPos;
extern CObject g_SurfaceObject;
extern CObject g_StationDisplayObject;
extern CLogger g_StationSpecLog;

//	֐錾
void VideoCapture(bool);
void LightSetByAngle(float, float, D3DCOLORVALUE);
void LightShowDir();

/*
 *	wɑI[h
 */
void StationEdit(){
	static float se_dir = D3DX_PI*1.75f, se_bank = D3DX_PI/6.0f, se_dist = 30.0f;
	static float l_dir = -D3DX_PI*0.25f, l_bank = -D3DXToRadian(54.7356f), l_dist = 10.0f;
	static VEC3 center = V3ZERO;
	bool updatelog = false;
	VEC3 pp;
	POINT pos;
	pos = GetCursorXY();
	if(GetButton(DIM_LEFT)>=S_PUSH){
		center += -0.01f*(pos.x-svw.winW/2)*GetVRight()+0.01f*(pos.y-svw.winH/2)*GetVUp();
	}else if(GetButton(DIM_RIGHT)>=S_PUSH){
		if(CheckShift()) CameraRotate(&pos, &l_dir, &l_bank);
		else CameraRotate(&pos, &se_dir, &se_bank);
	}
	SetCursor(svw.winW/2, svw.winH/2);
	CameraDistance(&se_dist);
	CameraSet(se_dir, se_bank, se_dist, &center, &V3ZERO);
	Blink(&g_Blink);
	BeginScene();
	if(GetKey(DIK_HOME)==S_PUSH) center = V3ZERO;
	if(GetKey(DIK_TAB)==S_PUSH) g_RenderMode = !g_RenderMode;
	if(g_RenderMode){
		LightSetByAngle(-l_dir, l_bank, MAKE_CV(0.0f, 0.0f, 0.0f, 1.0f));
		devSetAmbient(0xff202020);
	}else{
		LightSetByAngle(-l_dir, l_bank, MAKE_CV(1.0f, 1.0f, 1.0f, 1.0f));
		devSetAmbient(0xff808080);
	}
	if(GetKey(DIK_SPACE)==S_PUSH) g_MiscOptionTexFilter = 1-g_MiscOptionTexFilter;
	if(g_MiscOptionTexFilter) devTEX_LINEAR(); else devTEX_POINT();
	devSetState(D3DRS_ZFUNC, D3DCMP_LESSEQUAL);
	devSetLighting(true);
	g_StationDisplayObject.SetPos(V3ZERO);
	g_StationDisplayObject.SetDir(V3DIR);
	g_StationDisplayObject.Render();
	ResetMatrix();
	devResetMaterial();
	devSetTexture(0, NULL);
	devSetLighting(false);
	if(CheckShift()) LightShowDir();
	g_StationOptionModelSelect->ShowHome(&V3ZERO, &VEC3(0.0f, 0.0f, 1.0f), &V3UP);
	g_StationSpecLog.Show();
	TextF(DISP_WIDTH-180, 5, "ԑ(TAB)    : %s", g_RenderMode ? "" : "");
	TextF(DISP_WIDTH-180, 5+FONT_HEIGHT, "tB^(SPACE): %s", g_MiscOptionTexFilter ? "`⊮" : "ŋߕ⊮");
	ShowFPS(5, 5);
	EndScene();
}
