//	Cu
#include <io.h>
#include <direct.h>
#include "..\lib\udx.h"

//	萔E}N
#include "..\Const.h"
#include "..\Macro.h"

extern const int MAIN_LOG_MAX;
extern const int SURFACE_LOG_MAX;

//	c[֐
#include "..\ValueArea.h"
#include "..\SystemCover.h"
#include "..\CameraControl.h"
#include "..\SwitchMode.h"

//	NX
#include "..\CLogger.h"
#include "..\CPlugin.h"
#include "..\CSurfaceModel.h"

//	OO[o
extern int g_MiscOptionTexFilter;
extern int g_SurfaceOptionModels;
extern int g_SurfaceOptionSelect;
extern int g_SurfaceOptionListID;
extern CSurfaceModel *g_SurfaceOptionModelSeed;
extern CSurfaceModel *g_SurfaceOptionModelSelect;
extern CSurfaceModel **g_SurfaceOptionModelNext;
extern char g_BaseDir[];
extern int g_ModePMode;
extern float g_Angle;
extern float g_Blink;
extern bool g_ModeChanged;
extern bool g_RenderMode;
extern POINT g_Pointer;
extern VEC3 g_CameraPos;
extern VEC3 g_PointPos;
extern CObject g_SurfaceDisplayObject;
extern CObject g_SurfaceObject;
extern CLogger g_SurfaceSpecLog;

//	֐錾
void LoadSurface(char *);
void VideoCapture(bool);
void LightSetByAngle(float, float, D3DCOLORVALUE);
void LightShowDir();

/*
 *	VKn`I[h
 */
void SurfaceEdit(){
	static float ge_dir = D3DX_PI*1.75f, ge_bank = D3DX_PI/6.0f, ge_dist = 50.0f;
	static float l_dir = -D3DX_PI*0.25f, l_bank = -D3DXToRadian(54.7356f), l_dist = 10.0f;
	static VEC3 center = V3ZERO;
	bool updatelog = false;
	VEC3 pp;
	POINT pos;
	pos = GetCursorXY();
	if(GetButton(DIM_LEFT)>=S_PUSH){
		center += -0.01f*(pos.x-svw.winW/2)*GetVRight()+0.01f*(pos.y-svw.winH/2)*GetVUp();
	}else if(GetButton(DIM_RIGHT)>=S_PUSH){
		if(CheckShift()) CameraRotate(&pos, &l_dir, &l_bank);
		else CameraRotate(&pos, &ge_dir, &ge_bank);
	}
	SetCursor(svw.winW/2, svw.winH/2);
	CameraDistance(&ge_dist);
	CameraSet(ge_dir, ge_bank, ge_dist, &center, &V3ZERO);
	Blink(&g_Blink);
	BeginScene();
	if(GetKey(DIK_HOME)==S_PUSH) center = V3ZERO;
	if(GetKey(DIK_TAB)==S_PUSH) g_RenderMode = !g_RenderMode;
	if(g_RenderMode){
		LightSetByAngle(-l_dir, l_bank, MAKE_CV(0.0f, 0.0f, 0.0f, 1.0f));
		devSetAmbient(0xff202020);
	}else{
		LightSetByAngle(-l_dir, l_bank, MAKE_CV(1.0f, 1.0f, 1.0f, 1.0f));
		devSetAmbient(0xff808080);
	}
	if(GetKey(DIK_SPACE)==S_PUSH) g_MiscOptionTexFilter = 1-g_MiscOptionTexFilter;
	if(g_MiscOptionTexFilter) devTEX_LINEAR(); else devTEX_POINT();
	devSetState(D3DRS_ZFUNC, D3DCMP_LESSEQUAL);
	devSetLighting(true);
	g_SurfaceDisplayObject.SetPos(V3ZERO);
	g_SurfaceDisplayObject.SetDir(V3DIR);
	g_SurfaceDisplayObject.Render();
	ResetMatrix();
	devResetMaterial();
	devSetTexture(0, NULL);
	devSetLighting(false);
	if(CheckShift()) LightShowDir();
	g_SurfaceSpecLog.Show();
	TextF(DISP_WIDTH-180, 5, "ԑ(TAB)    : %s", g_RenderMode ? "" : "");
	TextF(DISP_WIDTH-180, 5+FONT_HEIGHT, "tB^(SPACE): %s", g_MiscOptionTexFilter ? "`⊮" : "ŋߕ⊮");
	ShowFPS(5, 5);
	EndScene();
}
