//	Cu
#include "lib\udx.h"
#include "Pixelbit.h"

//	萔E}N
#include "Macro.h"

extern const float RIVER_SWITCH_TH;

//	c[֐
#include "Rand.h"
#include "SystemCover.h"

//	NX
#include "CInterface.h"
#include "CInterfaceSlider.h"
#include "CInterfaceCheck.h"
#include "CInterfaceColorMixer.h"
#include "CSurfaceLayer.h"
#include "CMoldLayer.h"
#include "CCoastLayer.h"

//	OO[o
extern bool g_SettingSwitch;
extern CInterfaceSlider g_GroundRatioSlider;
extern CInterfaceCheck g_WaterCheck1;
extern CInterfaceColorMixer g_FieldColor;
extern CInterfaceColorMixer g_BeachColor;
extern CInterfaceColorMixer g_OceanColor;

/*
 *	RXgN^
 */
CCoastLayer::CCoastLayer(){
	m_Beach = 2.7f;
	m_Gap = 0.15f;
}

/*
 *	Cݐ̐
 */
void CCoastLayer::Generate(
	CSurfaceLayer *dest,	//	ʏo͐惌C[
	bool redraw				//	eNX`ĕ`̂݃tO
){
	int x, y;
	CPixelbit *tex = &dest->m_Texture;
	if(!redraw){
		SetCaption("Cݐ n`vZc");
		if(g_SettingSwitch){
			int pc = 100-g_GroundRatioSlider.GetValue();
			m_GroundSwitch = g_WaterCheck1.GetValue() ? false : true;
			m_Threshold = m_GroundSwitch ? ms_Number*(10000-pc*pc)/10000 : ms_Number*pc*pc/10000;
		}else{
			m_GroundSwitch = Rand(2) ? true : false;
			for(x = 0; x<2; x++){
				m_Threshold = m_GroundSwitch ? Rand2(0, ms_Number*3/2) : Rand2(-ms_Number/2, ms_Number);
				if(m_GroundSwitch ? m_Threshold>ms_Number*RIVER_SWITCH_TH : m_Threshold<ms_Number*(1.0f-RIVER_SWITCH_TH)) break;
			}
		}
		if(m_GroundSwitch ? m_Threshold<ms_Number : 0<m_Threshold){
			int seed = Rand2(1, 5+20*m_Threshold/ms_Number);
			for(x = 0; x<seed; x++) if(GetMold(Rand(ms_Width+1), Rand(ms_Height+1))->Molden(FRand2(m_MinRatio, m_MaxRatio))) m_MoldNumber++;
			while(m_MoldNumber<m_Threshold) Step();
			ms_StaticSwitch = this;
			CSurfaceScanner scanner(ms_Width, ms_Height, GetPos2, StaticIsMoldy);
			for(y = 0; y<=ms_Height; y++){
				for(x = 0; x<=ms_Width; x++){
					if(IsMoldy(x, y)==m_GroundSwitch){
						float dist = scanner.Scan(x, y, m_Beach, !m_GroundSwitch, NULL);
						SetAlt(x, y, 0.5f*m_Gap*(1.0f-cos(D3DX_PI*dist/m_Beach)));
					}else{
						SetAlt(x, y, 0.0f);
					}
				}
			}
		}else{
			for(y = 0; y<=ms_Height; y++){
				for(x = 0; x<=ms_Width; x++){
					GetMold(x, y)->Molden(m_GroundSwitch ? 0.0f : -1.0f);
					SetAlt(x, y, m_Gap);
				}
			}
			m_MoldNumber = m_GroundSwitch ? ms_Number : 0;
		}
		for(y = 0; y<=ms_Height; y++) for(x = 0; x<=ms_Width; x++) dest->SetAlt(x, y, GetAlt(x, y));
	}
	SetCaption("Cݐ eNX``撆c");
	int r1, g1, b1, r2, g2, b2, r3, g3, b3;
	if(g_SettingSwitch){
		SplitColor(NULL, &r1, &g1, &b1, g_FieldColor.GetValue());
		SplitColor(NULL, &r2, &g2, &b2, g_BeachColor.GetValue());
		SplitColor(NULL, &r3, &g3, &b3, g_OceanColor.GetValue());
	}else{
		SplitColor(NULL, &r1, &g1, &b1, 0xff80c040);
		SplitColor(NULL, &r2, &g2, &b2, 0xffffe0c0);
		SplitColor(NULL, &r3, &g3, &b3, 0xff0080c0);
	}
	for(y = 0; y<ms_TexHeight; y++){
		for(x = 0; x<ms_TexWidth; x++){
			int ty = ms_TexHeight-y-1;
			float h = 2.0f*GetTexAlt(x, y)/m_Gap, k, l = 0.0f;
			if(h>1.0f){
				h = h-1.0f;
				k = 1.0f-h;
			}else{
				k = h;
				l = 1.0f-k;
				h = 0.0f;
			}
			tex->SetR(x, ty, h*r1+k*r2+l*r3+Rand2(-16, 17)*Rand2(-16, 17)/16);
			tex->SetG(x, ty, h*g1+k*g2+l*g3+Rand2(-16, 17)*Rand2(-16, 17)/16);
			tex->SetB(x, ty, h*b1+k*b2+l*b3+Rand2(-16, 17)*Rand2(-16, 17)/16);
		}
	}
}
