//	Cu
#include "lib\udx.h"

//	萔E}N
#include "Const.h"
#include "Macro.h"

extern const float CAM_DEF_DIR;
extern const float CAM_DEF_BANK;
extern const float CAM_DEF_DIST;

//	c[֐
#include "ValueArea.h"
#include "SystemCover.h"
#include "CameraControl.h"

//	NX
#include "CInterface.h"
#include "CInterfaceButton.h"
#include "CInterfaceCheck.h"
#include "CInterfaceText.h"
#include "CInterfaceColorMixer.h"

//	OO[o
extern float g_Angle;
extern POINT g_Pointer;
extern VEC3 g_PointPos;
extern VEC3 g_LightDir;
extern CObject g_ArrowObject;

//	static o
CInterfaceColorMixer *CInterfaceColorMixer::ms_StaticSwitch = NULL;

/*
 *	[static]
 *	F_CAO[`
 */
void CInterfaceColorMixer::MixerRoutine(){
	static int color_r, color_g, color_b;
	static bool routine_flag = false;
	static CInterfaceColorMixer before_color("ύXO", 5, 25, 100, 125, 125, 20, 0xff808080);
	static CInterfaceColorMixer after_color("ύX", 5, 45, 100, 125, 125, 20, 0xff808080);
	static CInterfaceText rgb_text("RGB@F", 5, 70, 100, 20, 0xffffffff, 5, -1);
	static CInterfaceText r_text("R", 5, 90, 45, 20, 0xffff8080, -1, -1);
	static CInterfaceText g_text("G", 5, 110, 45, 20, 0xff80ff80, -1, -1);
	static CInterfaceText b_text("B", 5, 130, 45, 20, 0xff8080ff, -1, -1);
	static CInterfaceText cmy_text("CMY@F", 5, 155, 100, 20, 0xffffffff, 5, -1);
	static CInterfaceText c_text("C", 5, 175, 45, 20, 0xff80ffff, -1, -1);
	static CInterfaceText m_text("M", 5, 195, 45, 20, 0xffff80ff, -1, -1);
	static CInterfaceText y_text("Y", 5, 215, 45, 20, 0xffffff80, -1, -1);
	static CInterfaceText palette_text("pbg", 340, 70, 100, 20, 0xffffffff, 5, -1);
	static CInterfaceButton apply_button("쐬", 5, DISP_HEIGHT-25, 100, 20, 0xc0c0c0c0);
	static CInterfaceButton cancel_button("LZ", 110, DISP_HEIGHT-25, 100, 20, 0xc0c0c0c0);
	static CInterfaceCheck gb_check("GB", 355, 360, 80, 20, 0xff800000, NULL);
	static CInterfaceCheck br_check("BR", 355+80, 360, 80, 20, 0xff008000, &gb_check);
	static CInterfaceCheck rg_check("RG", 355+160, 360, 80, 20, 0xff000080, &gb_check);
	static CInterfaceCheck my_check("MY", 355, 380, 80, 20, 0xff008080, &gb_check);
	static CInterfaceCheck yc_check("YC", 355+80, 380, 80, 20, 0xff800080, &gb_check);
	static CInterfaceCheck cm_check("CM", 355+160, 380, 80, 20, 0xff808000, &gb_check);
	char str[16];
	int px1, py1, px2, py2;
	VEC3 pp;
	POINT pos = GetCursorXY();
	D3DCOLOR pc0, pc1, pc2, pc3;
	CursorMove(&pos, &g_PointPos);
	SetCursor(svw.winW/2, svw.winH/2);
	pp = CameraSet(CAM_DEF_DIR, CAM_DEF_BANK, CAM_DEF_DIST, &V3ZERO, &g_PointPos);
	BeginScene();
	SetDirLight(g_LightDir, MAKE_CV(1.0f, 1.0f, 1.0f, 1.0f));
	devSetState(D3DRS_ZFUNC, D3DCMP_LESSEQUAL);
	g_Pointer = WorldToScreen2(&pp);
	devSetLighting(false);
	ResetMatrix();
	devResetMaterial();
	devSetTexture(0, NULL);
	if(!routine_flag){
		routine_flag = true;
		SplitColor(NULL, &color_r, &color_g, &color_b, ms_StaticSwitch->m_Color);
		before_color.Enable(false);
		after_color.Enable(false);
		before_color.SetValue(ms_StaticSwitch->m_Color);
	}
	after_color.SetValue(MAKE_AC(255, color_r, color_g, color_b));
	before_color.Render();
	after_color.Render();
	rgb_text.Render();
	sprintf(str, "R %3d", color_r); r_text.SetCaption(str); r_text.Render();
	sprintf(str, "G %3d", color_g); g_text.SetCaption(str); g_text.Render();
	sprintf(str, "B %3d", color_b); b_text.SetCaption(str); b_text.Render();
	cmy_text.Render();
	sprintf(str, "C %3d", 255-color_r); c_text.SetCaption(str); c_text.Render();
	sprintf(str, "M %3d", 255-color_g); m_text.SetCaption(str); m_text.Render();
	sprintf(str, "Y %3d", 255-color_b); y_text.SetCaption(str); y_text.Render();
	Fill2DRect(49+color_r, 90+1, 52+color_r, 90+19, 0xffff0000);
	Fill2DRect(49+color_g, 110+1, 52+color_g, 110+19, 0xff00ff00);
	Fill2DRect(49+color_b, 130+1, 52+color_b, 130+19, 0xff0000ff);
	Fill2DRect(49+255-color_r, 175+1, 52+255-color_r, 175+19, 0xff00ffff);
	Fill2DRect(49+255-color_g, 195+1, 52+255-color_g, 195+19, 0xffff00ff);
	Fill2DRect(49+255-color_b, 215+1, 52+255-color_b, 215+19, 0xffffff00);
	Grad2DRect(50, 95, 50+256, 95+3, 0xff000000, 0xff000000, 0xffff0000, 0xffff0000);
	Grad2DRect(50, 95+4, 50+256, 95+10, MAKE_XC(0, color_g, color_b), MAKE_XC(0, color_g, color_b), MAKE_XC(255, color_g, color_b), MAKE_XC(255, color_g, color_b));
	Grad2DRect(50, 115, 50+256, 115+3, 0xff000000, 0xff000000, 0xff00ff00, 0xff00ff00);
	Grad2DRect(50, 115+4, 50+256, 115+10, MAKE_XC(color_r, 0, color_b), MAKE_XC(color_r, 0, color_b), MAKE_XC(color_r, 255, color_b), MAKE_XC(color_r, 255, color_b));
	Grad2DRect(50, 135, 50+256, 135+3, 0xff000000, 0xff000000, 0xff0000ff, 0xff0000ff);
	Grad2DRect(50, 135+4, 50+256, 135+10, MAKE_XC(color_r, color_g, 0), MAKE_XC(color_r, color_g, 0), MAKE_XC(color_r, color_g, 255), MAKE_XC(color_r, color_g, 255));
	Grad2DRect(50, 180, 50+256, 180+3, 0xffffffff, 0xffffffff, 0xff00ffff, 0xff00ffff);
	Grad2DRect(50, 180+4, 50+256, 180+10, MAKE_XC(255, color_g, color_b), MAKE_XC(255, color_g, color_b), MAKE_XC(0, color_g, color_b), MAKE_XC(0, color_g, color_b));
	Grad2DRect(50, 200, 50+256, 200+3, 0xffffffff, 0xffffffff, 0xffff00ff, 0xffff00ff);
	Grad2DRect(50, 200+4, 50+256, 200+10, MAKE_XC(color_r, 255, color_b), MAKE_XC(color_r, 255, color_b), MAKE_XC(color_r, 0, color_b), MAKE_XC(color_r, 0, color_b));
	Grad2DRect(50, 220, 50+256, 220+3, 0xffffffff, 0xffffffff, 0xffffff00, 0xffffff00);
	Grad2DRect(50, 220+4, 50+256, 220+10, MAKE_XC(color_r, color_g, 255), MAKE_XC(color_r, color_g, 255), MAKE_XC(color_r, color_g, 0), MAKE_XC(color_r, color_g, 0));
	palette_text.Render();
	switch(gb_check.GetValue()){
	case 0:
		pc0 = 0xff000000; pc1 = 0xff00ff00; pc2 = 0xff0000ff; pc3 = pc1|pc2; px1 = color_g; py1 = color_b;
		Grad2DRect(347, 97, 347+256, 97+256, MAKE_XC(color_r, 0, 255), MAKE_XC(color_r, 0, 0), MAKE_XC(color_r, 255, 0), MAKE_XC(color_r, 255, 255));
		break;
	case 1:
		pc0 = 0xff000000; pc1 = 0xff0000ff; pc2 = 0xffff0000; pc3 = pc1|pc2; px1 = color_b; py1 = color_r;
		Grad2DRect(347, 97, 347+256, 97+256, MAKE_XC(255, color_g, 0), MAKE_XC(0, color_g, 0), MAKE_XC(0, color_g, 255), MAKE_XC(255, color_g, 255));
		break;
	case 2:
		pc0 = 0xff000000; pc1 = 0xffff0000; pc2 = 0xff00ff00; pc3 = pc1|pc2; px1 = color_r; py1 = color_g;
		Grad2DRect(347, 97, 347+256, 97+256, MAKE_XC(0, 255, color_b), MAKE_XC(0, 0, color_b), MAKE_XC(255, 0, color_b), MAKE_XC(255, 255, color_b));
		break;
	case 3:
		pc0 = 0xffffffff; pc1 = 0xffff00ff; pc2 = 0xffffff00; pc3 = pc1&pc2; px1 = 255-color_g; py1 = 255-color_b;
		Grad2DRect(347, 97, 347+256, 97+256, MAKE_XC(color_r, 255, 0), MAKE_XC(color_r, 255, 255), MAKE_XC(color_r, 0, 255), MAKE_XC(color_r, 0, 0));
		break;
	case 4:
		pc0 = 0xffffffff; pc1 = 0xffffff00; pc2 = 0xff00ffff; pc3 = pc1&pc2; px1 = 255-color_b; py1 = 255-color_r;
		Grad2DRect(347, 97, 347+256, 97+256, MAKE_XC(0, color_g, 255), MAKE_XC(255, color_g, 255), MAKE_XC(255, color_g, 0), MAKE_XC(0, color_g, 0));
		break;
	case 5:
		pc0 = 0xffffffff; pc1 = 0xff00ffff; pc2 = 0xffff00ff; pc3 = pc1&pc2; px1 = 255-color_r; py1 = 255-color_g;
		Grad2DRect(347, 97, 347+256, 97+256, MAKE_XC(255, 0, color_b), MAKE_XC(255, 255, color_b), MAKE_XC(0, 255, color_b), MAKE_XC(0, 0, color_b));
		break;
	}
	px1 += 345; py1 += 95; px2 = px1+5; py2 = py1+5;
	ValueArea(&px1, 347, 347+256); ValueArea(&py1, 97, 97+256);
	ValueArea(&px2, 347, 347+256); ValueArea(&py2, 97, 97+256);
	Fill2DRect(px1, py1, px2, py2, color_r+color_g+color_b>384 ? 0xff000000 : 0xffffffff);
	Grad2DRect(347, 97-4, 347+256, 97-1, pc0, pc0, pc1, pc1);
	Grad2DRect(347, 97+256+1, 347+256, 97+256+4, pc2, pc2, pc3, pc3);
	Grad2DRect(347-4, 97, 347-1, 97+256, pc2, pc0, pc0, pc2);
	Grad2DRect(347+256+1, 97, 347+256+4, 97+256, pc3, pc1, pc1, pc3);
	gb_check.Render();
	br_check.Render();
	rg_check.Render();
	my_check.Render();
	yc_check.Render();
	cm_check.Render();
	if(GetButton(DIM_LEFT)>=S_PUSH){
		if(CheckRect(g_Pointer.x, g_Pointer.y, 45, 95, 266, 10)) color_r = g_Pointer.x-50;
		if(CheckRect(g_Pointer.x, g_Pointer.y, 45, 115, 266, 10)) color_g = g_Pointer.x-50;
		if(CheckRect(g_Pointer.x, g_Pointer.y, 45, 135, 266, 10)) color_b = g_Pointer.x-50;
		if(CheckRect(g_Pointer.x, g_Pointer.y, 45, 180, 266, 10)) color_r = 255-(g_Pointer.x-50);
		if(CheckRect(g_Pointer.x, g_Pointer.y, 45, 200, 266, 10)) color_g = 255-(g_Pointer.x-50);
		if(CheckRect(g_Pointer.x, g_Pointer.y, 45, 220, 266, 10)) color_b = 255-(g_Pointer.x-50);
		if(CheckRect(g_Pointer.x, g_Pointer.y, 342, 92, 266, 266)){
			int tx = g_Pointer.x-347, ty = g_Pointer.y-97;
			switch(gb_check.GetValue()){
			case 0: color_g = tx; color_b = ty; break;
			case 1: color_b = tx; color_r = ty; break;
			case 2: color_r = tx; color_g = ty; break;
			case 3: color_g = 255-tx; color_b = 255-ty; break;
			case 4: color_b = 255-tx; color_r = 255-ty; break;
			case 5: color_r = 255-tx; color_g = 255-ty; break;
			}
		}
		ValueArea(&color_r, 0, 255);
		ValueArea(&color_g, 0, 255);
		ValueArea(&color_b, 0, 255);
	}
	if(apply_button.Render()){
		routine_flag = false;
		ms_StaticSwitch->SetValue(MAKE_XC(color_r, color_g, color_b));
		SetLoopFunc(MainLoop);
	}
	if(cancel_button.Render()){
		routine_flag = false;
		SetLoopFunc(MainLoop);
	}
	ShowFPS(5, 5);
	devSetLighting(true);
	devSetState(D3DRS_ZFUNC, D3DCMP_ALWAYS);
	g_ArrowObject.Render();
	EndScene();
}

/*
 *	RXgN^
 */
CInterfaceColorMixer::CInterfaceColorMixer(
	char *s,	//	x
	int x,		//	x W
	int y,		//	y W
	int w1,		//	x̕
	int w2,		//	F\̕
	int w3,		//	RGB l\̕
	int h,		//	
	D3DCOLOR c	//	ݒl
):
	CInterface(x, y, 0, h, c)	//	{NX
{
	m_Width1 = w1; m_Width2 = w2; m_Width3 = w3;
	m_Width = m_Width1+m_Width2+m_Width3;
	SetCaptionArea(0, 0, m_Width1, m_Height);
	SetCaption(s);
	SetValue(m_Init = c);
	m_LastDown = false;
}

/*
 *	_O
 */
void CInterfaceColorMixer::Render(){
	D3DCOLOR lc1, lc2, lc3;
	if(m_Enabled && CheckRect(g_Pointer.x, g_Pointer.y, m_PosX, m_PosY, m_Width, m_Height)){
		if(GetButton(DIM_LEFT)==S_PUSH) m_LastDown = true;
		if(m_LastDown){
			lc1 = 0x00ffffff; lc2 = 0xffffffff, lc3 = m_ShadowColor;
			if(GetButton(DIM_LEFT)==S_PULL){
				ms_StaticSwitch = this;
				SetLoopFunc(MixerRoutine);
			}
		}else{
			lc1 = 0x00c0c0c0; lc2 = 0xffc0c0c0, lc3 = m_DarkColor;
		}
	}else{
		if(m_LastDown){
			lc1 = 0x00ffffff; lc2 = 0xffffffff, lc3 = m_DarkColor;
		}else{
			lc1 = 0x00808080; lc2 = 0xff808080, lc3 = m_DarkShadow;
		}
	}
	if(GetButton(DIM_LEFT)<=S_PULL) m_LastDown = false;
	Fill2DRect(m_PosX, m_PosY, m_PosX+m_Width, m_PosY+m_Height, 0xc0000000);
	Draw2DLine(m_PosX+m_Width1, m_PosY+m_Height-2, m_PosX, m_PosY+m_Height-2, lc2, lc1);
	Draw2DLine(m_PosX+m_Width1+m_Width2-1, m_PosY+m_Height-2, m_PosX+m_Width, m_PosY+m_Height-2, lc2, lc1);
	Fill2DRect(m_PosX+m_Width1+1, m_PosY+1, m_PosX+m_Width1+m_Width2-1, m_PosY+m_Height-1, lc2);
	Grad2DRect(m_PosX+m_Width1+2, m_PosY+2, m_PosX+m_Width1+m_Width2/2, m_PosY+m_Height-2, m_Color, lc3, m_Color, m_Color);
	Grad2DRect(m_PosX+m_Width1+m_Width2/2, m_PosY+2, m_PosX+m_Width1+m_Width2-2, m_PosY+m_Height-2, m_Color, m_Color, m_Color, lc3);
	Text(m_CapPosX, m_CapPosY, m_Caption);
	Text(m_ValCapPosX, m_CapPosY, m_ValueCaption);
}

/*
 *	Zbg
 */
void CInterfaceColorMixer::Reset(){
	SetValue(m_Init);
}

/*
 *	F̐ݒ RGB lx̏
 */
void CInterfaceColorMixer::SetValue(
	D3DCOLOR c	//	F
){
	int r0, g0, b0;
	SplitColor(NULL, &r0, &g0, &b0, c);
	SetColor(c);
	sprintf(m_ValueCaption, "%3d, %3d, %3d", r0, g0, b0);
	m_ValCapPosX = m_PosX+m_Width1+m_Width2+(m_Width3-FONT_WIDTH*strlen(m_ValueCaption))/2;
}

/*
 *	߂l: F
 */
D3DCOLOR CInterfaceColorMixer::GetValue(){
	return m_Color;
}
