//	Cu
#include "lib\udx.h"
#include "Pixelbit.h"

//	萔E}N
#include "Macro.h"

//	c[֐
#include "Rand.h"

//	NX
#include "CSurfaceLayer.h"
#include "CMoldLayer.h"

/*
 *	JrRXgN^
 */
CMoldLayer::CMold::CMold(){
	m_Ratio = -1.0f;
}

/*
 *	߂l: JrĂ true Ԃ
 */
bool CMoldLayer::CMold::IsMoldy(){
	return m_Ratio>=0.0f;
}

/*
 *	Jr
 *
 *	߂l: łɃJrĂ false Ԃ
 */
bool CMoldLayer::CMold::Molden(
	float ratio	//	ɐBW
){
	if(!IsMoldy()){
		m_Ratio = ratio;
		return true;
	}
	return false;
}

/*
 *	Jr̔ɐB
 *
 *	߂l: Jr true Ԃ
 */
bool CMoldLayer::CMold::Infect(
	CMold *m1,	//	אڃJr 1
	CMold *m2,	//	אڃJr 2
	CMold *m3,	//	אڃJr 3
	CMold *m4	//	אڃJr 4
){
	int i;
	float ratio = 0.0f, min = 1.0f, max = 0.0f;
	CMold *list[4] = {m1, m2, m3, m4};
	for(i = 0; i<4; i++){
		CMold *mold = list[i];
		if(mold && mold->IsMoldy()){
			ratio += mold->m_Ratio;
			if(mold->m_Ratio<min) min = mold->m_Ratio;
			if(mold->m_Ratio>max) max = mold->m_Ratio;
		}
	}
	if(FRand(1.0f)<ratio && !IsMoldy()){
		m_Ratio = FRand2(min, max);
		return true;
	}
	return false;
}

/*
 *	[static]
 *	߂l: wWJrĂ true Ԃ
 */
bool CMoldLayer::StaticIsMoldy(
	int x,	//	x W
	int y	//	y W
){
	return ((CMoldLayer *)ms_StaticSwitch)->GetMold(x, y)->IsMoldy();
}

/*
 *	RXgN^
 */
CMoldLayer::CMoldLayer(){
	m_MoldNumber = 0;
	m_MinRatio = 0.05f; m_MaxRatio = 0.5f;
	m_Mold = new CMold[ms_Number];
}

/*
 *	fXgN^
 */
CMoldLayer::~CMoldLayer(){
	DELETE_A(m_Mold);
}

/*
 *	߂l: wWJrĂ true Ԃ
 */
bool CMoldLayer::IsMoldy(
	int x,	//	x W
	int y	//	y W
){
	return GetMold(x, y)->IsMoldy();
}

/*
 *	JrɐB̃V~[g
 */
void CMoldLayer::Step(){
	int x, y;
	CMold *next = new CMold[ms_Number], *m;
	for(y = 0; y<=ms_Height; y++){
		for(x = 0; x<=ms_Width; x++){
			if((m = GetMold(x, y))->IsMoldy()) next[ArrayIndex(x, y)] = *m;
			else if(next[ArrayIndex(x, y)].Infect(GetMold(x-1, y), GetMold(x+1, y),
				GetMold(x, y-1), GetMold(x, y+1))) m_MoldNumber++;
		}
	}
	DELETE_A(m_Mold);
	m_Mold = next;
}
