//	Cu
#include "lib\udx.h"
#include "Pixelbit.h"

//	萔E}N
#include "Macro.h"

extern const int EXT_ACC;

//	c[֐
#include "Rand.h"
#include "ValueArea.h"
#include "SystemCover.h"

//	NX
#include "CInterface.h"
#include "CInterfaceSlider.h"
#include "CInterfaceColorMixer.h"
#include "CSurfaceLayer.h"
#include "CMoldLayer.h"
#include "CCoastLayer.h"
#include "CRiverLayer.h"
#include "CMountainLayer.h"

//OO[o
extern float g_TempDist;
extern bool g_SettingSwitch;
extern CInterfaceSlider g_MountainNumberSlider;
extern CInterfaceColorMixer g_MountainColor;
extern CInterfaceColorMixer g_BeachColor;
extern CInterfaceColorMixer g_SideColor;

/*
 *	[static]
 *	R̐_𗲋N
 *
 *	߂l:  true
 */
bool CMountainLayer::StaticProtrude(
	int x,	//	x W
	int y	//	y W
){
	((CMountainLayer *)ms_StaticSwitch)->Protrude(x, y);
	return true;
}

/*
 *	RXgN^
 */
CMountainLayer::CMountainLayer(){
	m_Gap = 0.15f;
}

/*
 *	R̐
 */
void CMountainLayer::Generate(
	CSurfaceLayer *dest,	//	ʏo͐惌C
	CCoastLayer *coast,		//	CݐC
	CRiverLayer *river,		//	͐샌C
	bool redraw				//	eNX`ĕ`̂݃tO
){
	int x, y, k;
	CPixelbit *tex = &dest->m_Texture;
	if(!redraw){
		SetCaption("R n`vZc");
		m_MountainNumber = g_SettingSwitch ? g_MountainNumberSlider.GetValue() : FRand2(-5.0f, 5.0f)*FRand2(-5.0f, 5.0f)/5.0f+0.4f;
		if(m_MountainNumber<=0) return;
		Flatten(0.0f);
		ms_StaticSwitch = this;
		CSurfaceScanner scanner(ms_Width, ms_Height, GetPos2, StaticProtrude);
		for(k = 0; k<m_MountainNumber; k++){
			VEC3 ps(FRand2(-0.25f*ms_Width, 1.25f*ms_Width), 0.0f, FRand2(-0.25f*ms_Height, 1.25f*ms_Width));
			VEC3 pd(FRand2(-0.25f*ms_Width, 1.25f*ms_Width), 0.0f, FRand2(-0.25f*ms_Height, 1.25f*ms_Width));
			ps += VEC3(FRand2(-0.25f*ms_Width, 0.25f*ms_Width), 0.0f, FRand2(-0.25f*ms_Width, 0.25f*ms_Width));
			pd += VEC3(FRand2(-0.25f*ms_Width, 0.25f*ms_Width), 0.0f, FRand2(-0.25f*ms_Width, 0.25f*ms_Width));
			ValueArea(&ps.x, 0.0f, ms_Width); ValueArea(&ps.z, 0.0f, ms_Height);
			ValueArea(&pd.x, 0.0f, ms_Width); ValueArea(&pd.z, 0.0f, ms_Height);
			m_Radius = FRand2(2.0f, 6.0f);
			m_Peak = m_Radius*FRand2(0.2f, 1.0)/cosf(m_Sharpness = FRand(D3DX_PI/4.0f));
			m_Curve = FRand2(0.05f, 0.3f);
			Split(ps, pd, FRand2(0.1f, 0.9f), 1.0f, FRand2(0.1f, 0.9f), &scanner);
		}
		for(y = 0; y<=ms_Height; y++){
			for(x = 0; x<=ms_Width; x++){
				float oa = dest->GetAlt(x, y), na = GetAlt(x, y);
				float comratio = 0.5f*(1.0f-cosf(D3DX_PI*oa/m_Gap));
				dest->SetAlt(x, y, oa+comratio*na);
			}
		}
	}
	if(m_MountainNumber<=0) return;
	SetCaption("R eNX``撆c");
	int r2, g2, b2, r3, g3, b3, r4, g4, b4;
	if(g_SettingSwitch){
		SplitColor(NULL, &r2, &g2, &b2, g_MountainColor.GetValue());
		SplitColor(NULL, &r3, &g3, &b3, g_BeachColor.GetValue());
		SplitColor(NULL, &r4, &g4, &b4, g_SideColor.GetValue());
	}else{
		SplitColor(NULL, &r2, &g2, &b2, 0xff408020);
		SplitColor(NULL, &r3, &g3, &b3, 0xffe0d070);
		SplitColor(NULL, &r4, &g4, &b4, 0xffc0e0a0);
	}
	for(y = 0; y<ms_TexHeight; y++){
		for(x = 0; x<ms_TexWidth; x++){
			int ty = ms_TexHeight-y-1;
			float dalt = dest->GetTexAlt(x, y)/m_Gap, malt = GetTexAlt(x, y)/m_Gap;
			float calt = (m_Gap-coast->GetTexAlt(x, y))/m_Gap, ralt = (m_Gap-river->GetTexAlt(x, y))/m_Gap;
			float h, k, p = 1.0f, q = 0.0f, s, t;
			if(dalt>=2.0f){
				h = 0.0f;
			}else if(dalt>1.0f){
				h = malt>=1.0f ? 0.0f : (1.0f-malt)*(2.0f-dalt);
			}else{
				h = malt>=1.0f ? 1.0f-dalt : 1.0f-malt*dalt;
				q = 1.0f-(p = dalt>0.5f ? (dalt-0.5f)/0.5f : 0.0f);
			}
			t = 1.0-(s = calt+ralt>0.0f ? calt/(calt+ralt) : 0.0f);
			k = 1.0f-h;
			int r1 = tex->GetR(x, ty), g1 = tex->GetG(x, ty), b1 = tex->GetB(x, ty);
			tex->SetR(x, ty, h*r1+k*(p*r2+q*(s*r3+t*r4)+Rand2(-16, 17)*Rand2(-16, 17)/16));
			tex->SetG(x, ty, h*g1+k*(p*g2+q*(s*g3+t*g4)+Rand2(-16, 17)*Rand2(-16, 17)/16));
			tex->SetB(x, ty, h*b1+k*(p*b2+q*(s*b3+t*b4)+Rand2(-16, 17)*Rand2(-16, 17)/16));
		}
	}
}

/*
 *	XvCvZ֐
 */
void CMountainLayer::Split(
	VEC3 ps,					//	JnW
	VEC3 pd,					//	IW
	float rs,					//	Jna
	float rc,					//	Ԕa
	float rd,					//	Ia
	CSurfaceScanner *scanner	//	NƗpXLi
){
	float len = V3Len(&(pd-ps));
	VEC3 center = 0.5f*(ps+pd), hit;
	if(len<1.0f){
		float opeak = m_Peak, orad = m_Radius;
		m_Peak *= rc; m_Radius *= rc;
		scanner->Scan(center.x, center.z, m_Radius, false, NULL);
		m_Peak = opeak; m_Radius = orad;
		return;
	}
	center += m_Curve*len*V3Rand2();
	ValueArea(&center.x, 0.0f, ms_Width);
	ValueArea(&center.z, 0.0f, ms_Height);
	Split(ps, center, rs, FRand2(0.75*rs+0.25*rc, 0.25*rs+0.75*rc), rc, scanner);
	Split(center, pd, rc, FRand2(0.75*rc+0.25*rd, 0.25*rc+0.75*rd), rd, scanner);
}

/*
 *	R̐_𗲋N
 */
void CMountainLayer::Protrude(
	int x,	//	x W
	int y	//	y W
){
	float talt = 0.5f*m_Peak*(cosf(m_Sharpness+(D3DX_PI-m_Sharpness)*g_TempDist/m_Radius)+1.0f);
	float nr = talt*0.3f;
	ValueArea(&nr, 0.0f, 0.05f*m_Peak);
	talt += FRand(nr);
	if(GetAlt(x, y)<talt) SetAlt(x, y, talt);
}
