//	Cu
#include "lib\udx.h"
#include "Pixelbit.h"

//	萔E}N
#include "Macro.h"

extern const float RIVER_SWITCH_TH = 0.6f;	//	͐𐶐̂ɕKvȗn̊

//	c[֐
#include "Rand.h"
#include "ValueArea.h"
#include "SystemCover.h"

//	NX
#include "CInterface.h"
#include "CInterfaceSlider.h"
#include "CInterfaceColorMixer.h"
#include "CSurfaceLayer.h"
#include "CMoldLayer.h"
#include "CCoastLayer.h"
#include "CRiverLayer.h"

//	OO[o
extern bool g_SettingSwitch;
extern CInterfaceSlider g_RiverNumberSlider;
extern CInterfaceColorMixer g_SideColor;
extern CInterfaceColorMixer g_RiverColor;

/*
 *	[static]
 *	̐̕ǂׂ
 *
 *	߂l: Ȃ true Ԃ
 */
bool CRiverLayer::StaticIsRiver(
	int x,	//	x W
	int y	//	y W
){
	return ((CRiverLayer *)ms_StaticSwitch)->GetAlt(x, y)==0.0f;
}

/*
 *	RXgN^
 */
CRiverLayer::CRiverLayer(){
	m_Gap = 0.15f;
	m_Side = 1.7f;
	m_Margin = 5.2f;
	m_Estuary = 10.2f;
	m_Curve = 0.0f;
	m_WidthRatio = 0.1f;
	m_SideRatio = 1.0f;
}

/*
 *	͐̐
 */
void CRiverLayer::Generate(
	CSurfaceLayer *dest,	//	ʏo͐惌C
	CCoastLayer *coast,		//	C݃C
	bool redraw				//	eNX`ĕ`̂݃tO
){
	int x, y, k, sx, sy, dx, dy, srcdir, trial;
	CPixelbit *tex = &dest->m_Texture;
	if(!redraw){
		SetCaption("͐쐶 n`vZc");
		m_RiverNumber = g_SettingSwitch ? g_RiverNumberSlider.GetValue() : FRand2(-5.0f, 5.0f)*FRand2(-5.0f, 5.0f)/5.0f+0.4f;
		if(m_RiverNumber<=0) return;
		if(!g_SettingSwitch){
			if(coast->m_GroundSwitch){
				if(coast->m_MoldNumber<ms_Number*RIVER_SWITCH_TH) return;
			}else{
				if(coast->m_MoldNumber>ms_Number*(1.0f-RIVER_SWITCH_TH)) return;
			}
		}
		m_Check = new bool[ms_Number];
		for(x = 0; x<ms_Number; x++) m_Check[x] = false;
		Flatten(m_Gap);
		ms_StaticSwitch = coast;
		CSurfaceScanner scanner(ms_Width, ms_Height, GetPos2, CCoastLayer::StaticIsMoldy);
		for(k = 0; k<m_RiverNumber; k++){
			m_Curve = FRand(0.3f);
			for(trial = 0; trial<64; trial++){
				switch(srcdir = Rand(4)){
				case 0: sx = 0; sy = Rand(ms_Height+1); dx = ms_Width; dy = Rand(ms_Height+1); break;
				case 1: sx = ms_Width; sy = Rand(ms_Height+1); dx = 0; dy = Rand(ms_Height+1); break;
				case 2: sx = Rand(ms_Width+1); sy = 0; dx = Rand(ms_Width+1); dy = ms_Height; break;
				case 3: sx = Rand(ms_Width+1); sy = ms_Height; dx = Rand(ms_Width+1); dy = 0; break;
				}
				if(scanner.Scan(sx, sy, m_Margin, !coast->m_GroundSwitch, NULL)==m_Margin){
				}else if(scanner.Scan(dx, dy, m_Margin, !coast->m_GroundSwitch, NULL)==m_Margin){
					x = dx; y = dy;
					dx = sx; dy = sy;
					sx = x; sy = y;
				}else{
					continue;
				}
				Split(VEC3(sx, 0.0f, sy), VEC3(dx, 0.0f, dy), &scanner, coast, false);
				break;
			}
			for(y = 0; y<=ms_Height; y++) for(x = 0; x<=ms_Width; x++)
				if(GetAlt(x, y)==0.0f) m_Check[ArrayIndex(x, y)] = true;
		}
		DELETE_A(m_Check);
		ms_StaticSwitch = this;
		scanner.ChangeFunc(GetPos2, StaticIsRiver);
		for(y = 0; y<=ms_Height; y++){
			for(x = 0; x<=ms_Width; x++){
				if(GetAlt(x, y)>0.0f){
					float dist = scanner.Scan(x, y, m_Side, true, NULL);
					SetAlt(x, y, 0.5f*m_Gap*(1.0f-cos(D3DX_PI*dist/m_Side)));
				}else{
					SetAlt(x, y, 0.0f);
				}
			}
		}
		for(y = 0; y<=ms_Height; y++){
			for(x = 0; x<=ms_Width; x++){
				float oa = dest->GetAlt(x, y), na = GetAlt(x, y);
				dest->SetAlt(x, y, oa<na ? oa : na);
			}
		}
	}
	if(m_RiverNumber<=0) return;
	SetCaption("͐쐶 eNX``撆c");
	int r2, g2, b2, r3, g3, b3;
	if(g_SettingSwitch){
		SplitColor(NULL, &r2, &g2, &b2, g_SideColor.GetValue());
		SplitColor(NULL, &r3, &g3, &b3, g_RiverColor.GetValue());
	}else{
		SplitColor(NULL, &r2, &g2, &b2, 0xffc0e0a0);
		SplitColor(NULL, &r3, &g3, &b3, 0xff0080c0);
	}
	for(y = 0; y<ms_TexHeight; y++){
		for(x = 0; x<ms_TexWidth; x++){
			int ty = ms_TexHeight-y-1;
			float h = 2.0f*GetTexAlt(x, y)/m_Gap, k, l = 0.0, p = coast->GetTexAlt(x, y)/m_Gap, q = 1.0f-p;
			float wr = p*m_WidthRatio+q*2.0f, sr = p*m_SideRatio+q*2.0f, r;
			if(h>wr){
				k = 1.0f-(h = h>sr ? (h-sr)/(2.0-sr) : 0.0f);
			}else{
				l = 1.0f-(k = h/wr);
				h = 0.0f;
			}
			r = 1.0f-(h+k*q);
			int r1 = tex->GetR(x, ty), g1 = tex->GetG(x, ty), b1 = tex->GetB(x, ty);
			tex->SetR(x, ty, h*r1+k*(p*r2+q*r1)+l*r3+r*Rand2(-16, 17)*Rand2(-16, 17)/16);
			tex->SetG(x, ty, h*g1+k*(p*g2+q*g1)+l*g3+r*Rand2(-16, 17)*Rand2(-16, 17)/16);
			tex->SetB(x, ty, h*b1+k*(p*b2+q*b1)+l*b3+r*Rand2(-16, 17)*Rand2(-16, 17)/16);
		}
	}
}

/*
 *	XvCvZ֐
 */
bool CRiverLayer::Split(
	VEC3 ps,					//	n_W
	VEC3 pd,					//	I_W
	CSurfaceScanner *scanner,	//	CݐTpXLi
	CCoastLayer *coast,			//	CݐC
	bool force					//	͐쉻tO
){
	float len = V3Len(&(pd-ps));
	VEC3 center = 0.5f*(ps+pd), hit;
	if(len<1.0f){
		if(!force && scanner->Scan(center.x, center.z, m_Margin, !coast->m_GroundSwitch, &hit)<m_Margin){
			int i, n = Rand2(1, 4);
			hit.x = (hit.x-ms_OffsetX)/ms_Scale;
			hit.z = (hit.z-ms_OffsetY)/ms_Scale;
			for(i = 0; i<n; i++){
				while(true){
					VEC3 tmp = hit+FRand2(1.0f, m_Estuary)*V3Rand2();
					ValueArea(&tmp.x, 0.0f, ms_Width);
					ValueArea(&tmp.z, 0.0f, ms_Height);
					if(coast->IsMoldy(tmp.x, tmp.z)==coast->m_GroundSwitch) continue;
					Split(ps, tmp, scanner, coast, true);
					break;
				}
			}
			return false;
		}
		if(m_Check[ArrayIndex(ps.x, ps.z)]) return false;
		SetAlt(ps.x, ps.z, 0.0f);
		if(m_Check[ArrayIndex(center.x, center.z)]) return false;
		SetAlt(center.x, center.z, 0.0f);
		if(m_Check[ArrayIndex(pd.x, pd.z)]) return false;
		SetAlt(pd.x, pd.z, 0.0f);
		return true;
	}
	center += m_Curve*len*V3Rand2();
	ValueArea(&center.x, 0.0f, ms_Width);
	ValueArea(&center.z, 0.0f, ms_Height);
	if(Split(ps, center, scanner, coast, force) && Split(center, pd, scanner, coast, force)) return true;
	return false;
}
