//	Cu
#include <direct.h>
#include "lib\udx.h"
#include "Pixelbit.h"

//	萔E}N
#include "Const.h"
#include "Macro.h"

extern const int EXT_ACC;

//	c[֐
#include "Rand.h"
#include "SystemCover.h"

//	NX
#include "CSurfaceLayer.h"
#include "CMoldLayer.h"
#include "CCoastLayer.h"
#include "CRiverLayer.h"
#include "CMountainLayer.h"
#include "CSurfaceGenerator.h"

//	OO[o
extern char g_BaseDir[];
extern CTexture g_SurfaceTexture;

//	O[o
unsigned int g_GenerateSeed[4];	//	ID pn

/*
 *	RXgN^
 */
CSurfaceGenerator::CSurfaceGenerator(
	int w,		//	Obh x TCY
	int h,		//	Obh y TCY
	float s,	//	_ԋ
	int tw,		//	eNX` x TCY
	int th		//	eNX` y TCY
){
	m_Width = w;
	m_Height = h;
	m_Number = (m_Width+1)*(m_Height+1);
	m_TriangleNumber = 2*w*h;
	m_TexWidth = tw;
	m_TexHeight = th;
	m_Scale = s;
	m_Table = new float[m_Number];
	m_Normal = new VEC3[m_Number];
	m_Saved = false;
	m_FaceVertex = NULL;
	m_NormalVertex = NULL;
}

/*
 *	fXgN^
 */
CSurfaceGenerator::~CSurfaceGenerator(){
	DELETE_A(m_Table);
	DELETE_A(m_Normal);
	DELETE_V(m_FaceVertex);
	DELETE_V(m_NormalVertex);
}

/*
 *	n`
 */
void CSurfaceGenerator::Generate(){
	int x, y, c = 0, n = 3*m_TriangleNumber;
	VTX_NX *v = new VTX_NX[n];
	VTX_L *nv = new VTX_L[2*m_Number];
	_chdir(g_BaseDir);
	m_FaceVertex = new CVertex;
	m_NormalVertex = new CVertex;
	m_MainLayer.Flatten(0.0f);
	m_MainLayer.m_Texture.Clear(m_TexWidth, m_TexHeight);
	g_GenerateSeed[0] = Randomize();
	m_CoastLayer.Generate(&m_MainLayer, false);
	g_GenerateSeed[1] = Randomize();
	m_RiverLayer.Generate(&m_MainLayer, &m_CoastLayer, false);
	g_GenerateSeed[2] = Randomize();
	m_MountainLayer.Generate(&m_MainLayer, &m_CoastLayer, &m_RiverLayer, false);
	g_GenerateSeed[3] = Randomize();
	SetCaption("d㏈c");
	m_MainLayer.m_Texture.Save("Surface.bmp");
	for(y = 0; y<=m_Height; y++){
		for(x = 0; x<=m_Width; x++){
			int cnt = 0, i0 = 2*(x+y*(m_Width+1)), i1 = i0+1;
			VEC3 v1, v2, v3, v4, tmp, p0 = m_MainLayer.GetPos3(EXT_ACC*x, EXT_ACC*y), p1;
			VEC3 *norm = &m_Normal[x+y*(m_Width+1)];
			*norm = V3ZERO;
			if(0<x) v1 = m_MainLayer.GetPos3(EXT_ACC*(x-1), EXT_ACC*y)-p0;
			if(x<m_Width) v2 = m_MainLayer.GetPos3(EXT_ACC*(x+1), EXT_ACC*y)-p0;
			if(0<y) v3 = m_MainLayer.GetPos3(EXT_ACC*x, EXT_ACC*(y-1))-p0;
			if(y<m_Height) v4 = m_MainLayer.GetPos3(EXT_ACC*x, EXT_ACC*(y+1))-p0;
			if(0<x && 0<y) *norm += *V3Norm(&tmp, V3Cross(&tmp, &v3, &v1));
			if(x<m_Width && 0<y) *norm += *V3Norm(&tmp, V3Cross(&tmp, &v2, &v3));
			if(0<x && y<m_Height) *norm += *V3Norm(&tmp, V3Cross(&tmp, &v1, &v4));
			if(x<m_Width && y<m_Height) *norm += *V3Norm(&tmp, V3Cross(&tmp, &v4, &v2));
			p1 = p0+*V3Norm(norm, norm);
			nv[i0].x = p0.x; nv[i0].y = p0.y; nv[i0].z = p0.z; nv[i0].d = 0xff0000ff;
			nv[i1].x = p1.x; nv[i1].y = p1.y; nv[i1].z = p1.z; nv[i1].d = 0xff0000ff;
		}
	}
	for(y = 0; y<m_Height; y++){
		for(x = 0; x<m_Width; x++){
			VEC3 p1 = m_MainLayer.GetPos3(EXT_ACC*x, EXT_ACC*y), p2 = m_MainLayer.GetPos3(EXT_ACC*(x+1), EXT_ACC*y);
			VEC3 p3 = m_MainLayer.GetPos3(EXT_ACC*x, EXT_ACC*(y+1)), p4 = m_MainLayer.GetPos3(EXT_ACC*(x+1), EXT_ACC*(y+1));
			VEC3 &n1 = m_Normal[x+y*(m_Width+1)], &n2 = m_Normal[x+1+y*(m_Width+1)];
			VEC3 &n3 = m_Normal[x+(y+1)*(m_Width+1)], &n4 = m_Normal[x+1+(y+1)*(m_Width+1)];
			float u1 = ((float)x)/m_Width, v1 = ((float)(m_Height-y))/m_Height;
			float u2 = ((float)(x+1))/m_Width, v2 = v1;
			float u3 = u1, v3 = ((float)(m_Height-(y+1)))/m_Height;
			float u4 = u2, v4 = v3;
			v[c].x = p1.x; v[c].y = p1.y; v[c].z = p1.z; v[c].n = n1;
			v[c].d = 0xffffffff; v[c].u = u1, v[c].v = v1; c++;
			v[c].x = p4.x; v[c].y = p4.y; v[c].z = p4.z; v[c].n = n4;
			v[c].d = 0xffffffff; v[c].u = u4, v[c].v = v4; c++;
			v[c].x = p2.x; v[c].y = p2.y; v[c].z = p2.z; v[c].n = n2;
			v[c].d = 0xffffffff; v[c].u = u2, v[c].v = v2; c++;
			v[c].x = p4.x; v[c].y = p4.y; v[c].z = p4.z; v[c].n = n4;
			v[c].d = 0xffffffff; v[c].u = u4, v[c].v = v4; c++;
			v[c].x = p1.x; v[c].y = p1.y; v[c].z = p1.z; v[c].n = n1;
			v[c].d = 0xffffffff; v[c].u = u1, v[c].v = v1; c++;
			v[c].x = p1.x; v[c].y = p3.y; v[c].z = p3.z; v[c].n = n3;
			v[c].d = 0xffffffff; v[c].u = u3, v[c].v = v3; c++;
		}
	}
	m_FaceVertex->Create(v, FVF_NX, n*sizeof(VTX_NX));
	m_NormalVertex->Create(nv, FVF_L, 2*m_Number*sizeof(VTX_L));
	delete [] v;
	g_SurfaceTexture.Load("Surface.bmp", 0, 1);
	SetCaption("RailSim Surface Generator");
	sprintf(m_Name, "RSSG_%08X%08X%08X%08X", g_GenerateSeed[0], g_GenerateSeed[1], g_GenerateSeed[2], g_GenerateSeed[3]);
}

/*
 *	eNX`ĕ`
 */
void CSurfaceGenerator::RedrawTexture(
	int tw,		//	eNX` x TCY
	int th		//	eNX` y TCY
){
	m_Saved = false;
	m_TexWidth = tw;
	m_TexHeight = th;
	Randomize();
	m_MainLayer.m_Texture.Clear(m_TexWidth, m_TexHeight);
	g_GenerateSeed[3] = Randomize();
	m_CoastLayer.Generate(&m_MainLayer, true);
	m_RiverLayer.Generate(&m_MainLayer, &m_CoastLayer, true);
	m_MountainLayer.Generate(&m_MainLayer, &m_CoastLayer, &m_RiverLayer, true);
	SetCaption("d㏈c");
	m_MainLayer.m_Texture.Save("Surface.bmp");
	g_SurfaceTexture.Load("Surface.bmp", 0, 1);
	SetCaption("RailSim Surface Generator");
	sprintf(m_Name, "RSSG_%08X%08X%08X%08X", g_GenerateSeed[0], g_GenerateSeed[1], g_GenerateSeed[2], g_GenerateSeed[3]);
}

/*
 *	_O
 */
void CSurfaceGenerator::Render(){
	ResetMatrix();
	devResetMaterial();
	if(m_FaceVertex){
		devSetTexture(0, g_SurfaceTexture.GetObject());
		devSetLighting(true);
		m_FaceVertex->RenderTL();
	}
	if(m_NormalVertex){
		devSetTexture(0, NULL);
		devSetLighting(false);
		//m_NormalVertex->RenderLL();
	}
}

/*
 *	ID ̕\
 */
void CSurfaceGenerator::PrintName(){
	TextF(5, 475-FONT_HEIGHT, "%s (%s)", m_Name, m_Saved ? "ۑ" : "ۑ");
}

/*
 *	vOCƂĕۑ
 */
void CSurfaceGenerator::Save(){
	static char *head[21] = {
		"xof 0302txt 0064\n",
		"template Header {\n <3D82AB43-62DA-11cf-AB39-0020AF71E433>\n WORD major;\n WORD minor;\n DWORD flags;\n}\n\n",
		"template Vector {\n <3D82AB5E-62DA-11cf-AB39-0020AF71E433>\n FLOAT x;\n FLOAT y;\n FLOAT z;\n}\n\n",
		"template Coords2d {\n <F6F23F44-7686-11cf-8F52-0040333594A3>\n FLOAT u;\n FLOAT v;\n}\n\n",
		"template Matrix4x4 {\n <F6F23F45-7686-11cf-8F52-0040333594A3>\n array FLOAT matrix[16];\n}\n\n",
		"template ColorRGBA {\n <35FF44E0-6C7C-11cf-8F52-0040333594A3>\n FLOAT red;\n FLOAT green;\n FLOAT blue;\n FLOAT alpha;\n}\n\n",
		"template ColorRGB {\n <D3E16E81-7835-11cf-8F52-0040333594A3>\n FLOAT red;\n FLOAT green;\n FLOAT blue;\n}\n\n",
		"template IndexedColor {\n <1630B820-7842-11cf-8F52-0040333594A3>\n DWORD index;\n ColorRGBA indexColor;\n}\n\n",
		"template Boolean {\n <4885AE61-78E8-11cf-8F52-0040333594A3>\n WORD truefalse;\n}\n\n",
		"template Boolean2d {\n <4885AE63-78E8-11cf-8F52-0040333594A3>\n Boolean u;\n Boolean v;\n}\n\n",
		"template MaterialWrap {\n <4885AE60-78E8-11cf-8F52-0040333594A3>\n Boolean u;\n Boolean v;\n}\n\n",
		"template TextureFilename {\n <A42790E1-7810-11cf-8F52-0040333594A3>\n STRING filename;\n}\n\n",
		"template Material {\n <3D82AB4D-62DA-11cf-AB39-0020AF71E433>\n ColorRGBA faceColor;\n FLOAT power;\n ColorRGB specularColor;\n ColorRGB emissiveColor;\n [...]\n}\n\n",
		"template MeshFace {\n <3D82AB5F-62DA-11cf-AB39-0020AF71E433>\n DWORD nFaceVertexIndices;\n array DWORD faceVertexIndices[nFaceVertexIndices];\n}\n\n",
		"template MeshFaceWraps {\n <4885AE62-78E8-11cf-8F52-0040333594A3>\n DWORD nFaceWrapValues;\n Boolean2d faceWrapValues;\n}\n\n",
		"template MeshTextureCoords {\n <F6F23F40-7686-11cf-8F52-0040333594A3>\n DWORD nTextureCoords;\n array Coords2d textureCoords[nTextureCoords];\n}\n\n",
		"template MeshMaterialList {\n <F6F23F42-7686-11cf-8F52-0040333594A3>\n DWORD nMaterials;\n DWORD nFaceIndexes;\n array DWORD faceIndexes[nFaceIndexes];\n [Material]\n}\n\n",
		"template MeshNormals {\n <F6F23F43-7686-11cf-8F52-0040333594A3>\n DWORD nNormals;\n array Vector normals[nNormals];\n DWORD nFaceNormals;\n array MeshFace faceNormals[nFaceNormals];\n}\n\n",
		"template MeshVertexColors {\n <1630B821-7842-11cf-8F52-0040333594A3>\n DWORD nVertexColors;\n array IndexedColor vertexColors[nVertexColors];\n}\n\n",
		"template Mesh {\n <3D82AB44-62DA-11cf-AB39-0020AF71E433>\n DWORD nVertices;\n array Vector vertices[nVertices];\n DWORD nFaces;\n array MeshFace faces[nFaces];\n [...]\n}\n\n",
		"Header{\n1;\n0;\n1;\n}\n\n"};
	char tex[256];
	int x, y;
	FILE *fname;
	sprintf(tex, "%s.bmp", m_Name);
	_chdir(g_BaseDir);
	mkdir(m_Name);
	_chdir(m_Name);
	m_MainLayer.m_Texture.Save(tex);
	if(!(fname = fopen("Model.x", "wt"))) return;
	for(x = 0; x<21; x++) fprintf(fname, head[x]);
	fprintf(fname, "Mesh {\n %d;\n", m_Number);
	for(y = 0; y<=m_Height; y++){
		for(x = 0; x<=m_Width; x++){
			VEC3 p = m_MainLayer.GetPos3(EXT_ACC*x, EXT_ACC*y);
			fprintf(fname, " %.5f;%.5f;%.5f;%c\n", p.x, p.y, p.z, (y==m_Height && x==m_Height) ? ';' : ',');
		}
	}
	fprintf(fname, " \n %d;\n", m_TriangleNumber);
	for(y = 0; y<m_Height; y++){
		for(x = 0; x<m_Width; x++){
			int p1 = x+y*(m_Width+1), p2 = x+1+y*(m_Width+1);
			int p3 = x+(y+1)*(m_Width+1), p4 = x+1+(y+1)*(m_Width+1);
			fprintf(fname, " 3;%d,%d,%d;,\n", p1, p4, p2);
			fprintf(fname, " 3;%d,%d,%d;%s\n", p4, p1, p3, (y==m_Height-1 && x==m_Height-1) ? ";;" : ",");
		}
	}
	fprintf(fname, " \n MeshMaterialList {\n  1;\n  %d;\n", m_TriangleNumber);
	for(x = 0; x<m_TriangleNumber; x++) fprintf(fname, "  0%s\n", x==m_TriangleNumber-1 ? ";;" : ",");
	fprintf(fname, "  Material {\n   0.800000;0.800000;0.800000;1.000000;;\n   5.000000;\n   0.000000;0.000000;0.000000;;\n   0.000000;0.000000;0.000000;;\n   TextureFilename {\n    \"%s\";\n   }\n  }\n }\n", tex);
	fprintf(fname, " MeshNormals {\n  %d;\n", m_Number);
	for(y = 0; y<=m_Height; y++){
		for(x = 0; x<=m_Width; x++){
			VEC3 n = m_Normal[x+y*(m_Width+1)];
			fprintf(fname, "  %.6f;%.6f;%.6f;%c\n", n.x, n.y, n.z, (y==m_Height && x==m_Height) ? ';' : ',');
		}
	}
	fprintf(fname, "  %d;\n", m_TriangleNumber);
	for(y = 0; y<m_Height; y++){
		for(x = 0; x<m_Width; x++){
			int n1 = x+y*(m_Width+1), n2 = x+1+y*(m_Width+1);
			int n3 = x+(y+1)*(m_Width+1), n4 = x+1+(y+1)*(m_Width+1);
			fprintf(fname, "  3;%d,%d,%d;,\n", n1, n4, n2);
			fprintf(fname, "  3;%d,%d,%d;%s\n", n4, n1, n3, (y==m_Height-1 && x==m_Height-1) ? ";;" : ",");
		}
	}
	fprintf(fname, " }\n MeshTextureCoords {\n  %d;\n", m_Number);
	for(y = 0; y<=m_Height; y++){
		for(x = 0; x<=m_Width; x++){
			float u1 = ((float)x)/m_Width, v1 = ((float)(m_Height-y))/m_Height;
			fprintf(fname, "  %6f;%.6f;%s\n", u1, v1, (y==m_Height && x==m_Height) ? ";" : "");
		}
	}
	fprintf(fname, " }\n}\n");
	fclose(fname);
	if(!(fname = fopen("Surface.txt", "wt"))) return;
	fprintf(fname, "%s\n", m_Name);
	fprintf(fname, "RSSG\n");
	fprintf(fname, "%f\n", 0.01f/m_Scale);
	fprintf(fname, "%f\n", m_Width*m_Scale);
	fprintf(fname, "%f\n", m_Height*m_Scale);
	fclose(fname);
	m_Saved = true;
}
