//	Cu
#include "lib\udx.h"
#include "Pixelbit.h"

//	萔E}N
#include "Macro.h"

extern const int EXT_ACC = 3;	//	.x `t@Co͂̐_Ԋuɑ΂
								//	vZɎgp鐸x̔{

//	NX
#include "CSurfaceLayer.h"

//	O[o
float g_TempDist;	//	֐ŒTJnW̋gpꍇ̎󂯓nϐ

//	static o
int CSurfaceLayer::ms_Width, CSurfaceLayer::ms_Height, CSurfaceLayer::ms_Number;
int CSurfaceLayer::ms_TexWidth, CSurfaceLayer::ms_TexHeight;
float CSurfaceLayer::ms_Scale, CSurfaceLayer::ms_OffsetX, CSurfaceLayer::ms_OffsetY;
CSurfaceLayer *CSurfaceLayer::ms_StaticSwitch = NULL;

/*
 *	L[ACeRXgN^
 */
CSurfaceLayer::CSurfaceScanner::CScannerToken::CScannerToken(
	int x,	//	x W
	int y	//	y W
){
	m_PosX = x;
	m_PosY = y;
	m_Next = NULL;
}

/*
 *	L[ACefXgN^
 */
CSurfaceLayer::CSurfaceScanner::CScannerToken::~CScannerToken(){
	DELETE_V(m_Next);
}

/*
 *	XLiRXgN^
 */
CSurfaceLayer::CSurfaceScanner::CSurfaceScanner(
	int w,					//	Obh x TCY
	int h,					//	Obh y TCY
	VEC3 (*df)(int, int),	//	ObhvZpW擾֐
	bool (*ff)(int, int)	//	Ώۊ֐
){
	int i;
	m_Seed = NULL;
	m_Link = &m_Seed;
	m_Width = w;
	m_Height = h;
	m_Number = (m_Width+1)*(m_Height+1);
	m_Phase = 0;
	m_Table = new unsigned int[m_Number];
	for(i = 0; i<m_Number; i++) m_Table[i] = 0;
	m_DistFunc = df;
	m_FlagFunc = ff;
}

/*
 *	XLifXgN^
 */
CSurfaceLayer::CSurfaceScanner::~CSurfaceScanner(){
	DELETE_V(m_Seed);
	DELETE_A(m_Table);
}

/*
 *	L[ACȇ}
 */
void CSurfaceLayer::CSurfaceScanner::Enqueue(
	int x,	//	x W
	int y	//	y W
){
	if(x<0 || m_Width<x || y<0 || m_Height<y) return;
	if(GetCount(x, y)<m_Phase){
		SetCount(x, y, m_Phase);
		m_Link = &(*m_Link = new CScannerToken(x, y))->m_Next;
	}
}

/*
 *	ǂXL
 *
 *	߂l: ŋߓ_܂ł̋ (Ȃꍇ͔a)
 */
float CSurfaceLayer::CSurfaceScanner::Scan(
	int x,		//	x W
	int y,		//	y W
	float max,	//	{͈͔a
	bool flag,	//	Ώۃu[l
	VEC3 *loc	//	ŋߓ_̍W
){
	float min = max;
	VEC3 origin = m_DistFunc(x, y);
	CScannerToken *token;
	m_Phase++;
	Enqueue(x, y);
	while(token = m_Seed){
		int tx = token->m_PosX, ty = token->m_PosY;
		VEC3 sp = m_DistFunc(tx, ty);
		float len = g_TempDist = V3Len(&(origin-sp));
		m_Seed = token->m_Next;
		if(m_Link==&token->m_Next) m_Link = &m_Seed;
		token->m_Next = NULL;
		if(len<max){
			if(len<min && m_FlagFunc(tx, ty)==flag){
				min = len;
				if(loc) *loc = sp;
			}
			Enqueue(tx-1, ty);
			Enqueue(tx+1, ty);
			Enqueue(tx, ty-1);
			Enqueue(tx, ty+1);
		}
		delete token;
	}
	m_Seed = NULL;
	return min;
}

/*
 *	e֐̕ύX
 */
void CSurfaceLayer::CSurfaceScanner::ChangeFunc(
	VEC3 (*df)(int, int),
	bool (*ff)(int, int)
){
	m_DistFunc = df;
	m_FlagFunc = ff;
}

/*
 *	[static]
 *	TCY̊{ݒ
 */
void CSurfaceLayer::SetStatus(
	int w,		//	Obh x TCY
	int h,		//	Obh y TCY
	float s,	//	XP[
	int tw,		//	eNX`
	int th		//	eNX`
){
	if(w){
		ms_Width = EXT_ACC*w;
		ms_Height = EXT_ACC*h;
		ms_Number = (ms_Width+1)*(ms_Height+1);
		ms_Scale = s/EXT_ACC;
		ms_OffsetX = -0.5f*ms_Width*ms_Scale;
		ms_OffsetY = -0.5f*ms_Height*ms_Scale;
	}
	ms_TexWidth = tw;
	ms_TexHeight = th;
}

/*
 *	RXgN^
 */
CSurfaceLayer::CSurfaceLayer(){
	m_Table = new float[ms_Number];
}

/*
 *	fXgN^
 */
CSurfaceLayer::~CSurfaceLayer(){
	DELETE_A(m_Table);
}

/*
 *	eNX`WPʂ̍xvZ
 */
float CSurfaceLayer::GetTexAlt(
	int x,	//	x W
	int y	//	y W
){
	float tx = (x+0.45f)*ms_Width/ms_TexWidth, ty = (y+0.45f)*ms_Height/ms_TexHeight;
	int nx = tx, ny = ty;
	float sx = tx-(float)((int)tx), sy = ty-(float)((int)ty);
	return (1.0f-sy)*((1.0f-sx)*GetAlt(nx, ny)+sx*GetAlt(nx+1, ny))+sy*((1.0f-sx)*GetAlt(nx, ny+1)+sx*GetAlt(nx+1, ny+1));
}

/*
 *	Obh荂xŏ
 */
void CSurfaceLayer::Flatten(
	float h	//	x
){
	int i;
	for(i = 0; i<ms_Number; i++) m_Table[i] = h;
}
