/*
 *	n`C[{NX
 *
 *	n`vZɎgpeC[̊{NX
 *	Obh_Ɋւ{@\
 */
class CSurfaceLayer{
	friend class CCoastLayer;
	friend class CRiverLayer;
	friend class CMountainLayer;
	friend class CSurfaceGenerator;
protected:
	static int ms_Width, ms_Height;			//	ObhTCY
	static int ms_Number;					//	Obh_
	static int ms_TexWidth, ms_TexHeight;	//	eNX`TCY
	static float ms_Scale;					//	Obh 1 }X̃TCY
	static float ms_OffsetX, ms_OffsetY;	//	Z^OpItZbgW
	static CSurfaceLayer *ms_StaticSwitch;	//	static ʃ|C^
	/*
	 *	ObhXLi
	 *
	 *	_𒆐SƂ͈͂𑖍
	 *	^֐ true ƂȂł߂_Ƃ̋擾
	 */
	class CSurfaceScanner{
	private:
		/*
		 *	XLƃL[ACe
		 *
		 *	͈͓ɂ鐧_̍WL^
		 */
		class CScannerToken{
		public:
			int m_PosX, m_PosY;		//	W
			CScannerToken *m_Next;	//	AXg|C^
		public:
			CScannerToken(int, int);
			~CScannerToken();
		};
		CScannerToken *m_Seed;			//	AXg̃[g
		CScannerToken **m_Link;			//	AXg̎i[ꏊ
		int m_Width, m_Height;			//	ObhTCY
		int m_Number;					//	Obh_
		unsigned int m_Phase;			//	XL
		unsigned int *m_Table;			//	XLς݃tOe[u
		VEC3 (*m_DistFunc)(int, int);	//	ObhvZpW擾֐
		bool (*m_FlagFunc)(int, int);	//	Ώۊ֐
	public:
		CSurfaceScanner(int, int, VEC3 (*)(int, int), bool (*)(int, int));
		~CSurfaceScanner();
		void SetCount(int, int, int);
		int GetCount(int, int);
		void Enqueue(int, int);
		float Scan(int, int, float, bool, VEC3 *);
		void ChangeFunc(VEC3 (*)(int, int), bool (*)(int, int));
	};
	float *m_Table;			//	_̕We[u
	CPixelbit m_Texture;	//	eNX`
public:
	static void SetStatus(int, int, float, int, int);
	static int ArrayIndex(int, int);
	static VEC3 GetPos2(int, int);
	CSurfaceLayer();
	virtual ~CSurfaceLayer();
	void SetAlt(int, int, float);
	float GetAlt(int, int);
	float GetTexAlt(int, int);
	VEC3 GetPos3(int, int);
	VEC3 GetTexPos3(int, int);
	void Flatten(float);
};

/*
 *	XLς݃tO̐ݒ
 */
inline void CSurfaceLayer::CSurfaceScanner::SetCount(
	int x,	//	x W
	int y,	//	y W
	int v	//	XL
){
	m_Table[x+y*(m_Width+1)] = v;
}

/*
 *	߂l: XLς݃tO
 */
inline int CSurfaceLayer::CSurfaceScanner::GetCount(
	int x,	//	x W
	int y	//	y W
){
	return m_Table[x+y*(m_Width+1)];
}

/*
 *	[static]
 *	߂l: WvZe[uCfbNX
 */
inline int CSurfaceLayer::ArrayIndex(
	int x,	//	x W
	int y	//	y W
){
	return x+y*(ms_Width+1);
}

/*
 *	[static]
 *	߂l: _̕ʍW
 */
inline VEC3 CSurfaceLayer::GetPos2(
	int x,	//	x W
	int y	//	y W
){
	return VEC3(ms_OffsetX+x*ms_Scale, 0.0f, ms_OffsetY+y*ms_Scale);
}

/*
 *	_x̐ݒ
 */
inline void CSurfaceLayer::SetAlt(
	int x,	//	x W
	int y,	//	y W
	float v	//	_x
){
	m_Table[ArrayIndex(x, y)] = v;
}

/*
 *	߂l: _x
 */
inline float CSurfaceLayer::GetAlt(
	int x,	//	x W
	int y	//	y W
){
	return m_Table[ArrayIndex(x, y)];
}

/*
 *		߂l: _ 3D W
 */
inline VEC3 CSurfaceLayer::GetPos3(
	int x,	//	x W
	int y	//	y W
){
	return VEC3(ms_OffsetX+x*ms_Scale, m_Table[ArrayIndex(x, y)], ms_OffsetY+y*ms_Scale);
}
