//	Cu
#include "lib\udx.h"

//	萔E}N
#include "Const.h"

extern const float CAM_DEF_DIR = D3DX_PI*1.5f;	//	ftHgpx
extern const float CAM_DEF_BANK = D3DX_PI/3.0f;	//	ftHgpx
extern const float CAM_DEF_DIST = 30.0f;		//	ftHg

const float CAM_ROT_RATE = 0.5f;		//	]x
const float CAM_ZOM_RATE = 0.01f;		//	Y[x
const float CAM_MIN_DIST = 1.0f;		//	ŏ
const float CAM_MAX_DIST = 400.0f;		//	ő勗
const float PTR_MOV_RATE = 10.0f;		//	J[\ړ
const float PTR_2D_DISTANCE = 14.5f;	//	J[\_O
const float PTR_2D_WIDTH = 8.0f;		//	J[\ړ͈͕
const float PTR_2D_HEIGHT = 6.0f;		//	J[\ړ͈͍

//	c[֐
#include "ValueArea.h"

//	OO[o
extern float g_Angle;
extern CObject g_ArrowObject;

/*
 *	J]
 */
void CameraRotate(
	POINT *p,	//	VXeJ[\W
	float *d,	//	px
	float *b	//	px
){
	*d -= CAM_ROT_RATE*((float)(p->x)-svw.winW/2)/svw.winW;
	*b += CAM_ROT_RATE*((float)(p->y)-svw.winH/2)/svw.winH;
	ValueCircular(d, 0.0f, D3DX_PI*2.0f);
	ValueArea(b, -D3DX_PI*0.45f, D3DX_PI*0.45f);
}

/*
 *	J[\̈ړ
 */
void CursorMove(
	POINT *p,	//	VXeJ[\W
	VEC3 *pp	//	J[\W
){
	pp->x -= PTR_MOV_RATE*((float)(p->x)-svw.winW/2)/svw.winW;
	pp->y -= PTR_MOV_RATE*((float)(p->y)-svw.winH/2)/svw.winH;
	ValueArea(&pp->x, -PTR_2D_WIDTH, PTR_2D_WIDTH);
	ValueArea(&pp->y, -PTR_2D_HEIGHT, PTR_2D_HEIGHT);
}

/*
 *	J
 */
void CameraDistance(
	float *d	//	
){
	*d -= CAM_ZOM_RATE*GetWheel();
	if(GetKey(DIK_PGUP)>=S_PUSH) *d -= CAM_ZOM_RATE*120;
	if(GetKey(DIK_PGDN)>=S_PUSH) *d += CAM_ZOM_RATE*120;
	ValueArea(d, CAM_MIN_DIST, CAM_MAX_DIST);
}

/*
 *	J[\IuWFNg̈ʒuݒ
 *
 *	߂l:	J[\IuWFNg 3D W
 */
VEC3 ArrowSet(
	const VEC3 *cp,	//	JSW
	const VEC3 *p	//	J[\W
){
	VEC3 cd = GetVDir(), cr = GetVRight(), cu = GetVUp(), pp;
	g_Angle += 0.3f;
	ValueCircular(&g_Angle, 0.0f, D3DX_PI*2.0f);
	g_ArrowObject.SetPos(pp = *cp+PTR_2D_DISTANCE*cd-cr*p->x+cu*p->y);
	g_ArrowObject.SetDir(cd, -cu+cr);
	g_ArrowObject.SetScale(0.5f);
	g_ArrowObject.RotY(g_Angle);
	return pp;
}

/*
 *	Jݒ̓KpƃJ[\̐ݒ
 *
 *	߂l:	J[\IuWFNg 3D W
 */
VEC3 CameraSet(
	float d,		//	px
	float b,		//	px
	float dis,		//	
	const VEC3 *c,	//	JSW
	const VEC3 *p	//	J[\W
){
	VEC3 cp, cd, cr, cu, pp;
	cd = VEC3(cos(d)*cos(b), sin(b), sin(d)*cos(b));
	SetVPos(cp = dis*cd);
	LookAtV(V3ZERO);
	SetVPos(cp += *c);
	return ArrowSet(&cp, p);
}
