//	Cu
#include "lib\udx.h"
#include "Pixelbit.h"

//	萔E}N
#include "Const.h"
#include "Macro.h"

extern const float CAM_DEF_DIR;
extern const float CAM_DEF_BANK;
extern const float CAM_DEF_DIST;

//	c[֐
#include "SystemCover.h"
#include "CameraControl.h"

//	NX
#include "CInterface.h"
#include "CInterfaceButton.h"
#include "CInterfaceCheck.h"
#include "CInterfaceText.h"
#include "CInterfaceSlider.h"
#include "CInterfaceColorMixer.h"
#include "CSurfaceLayer.h"
#include "CMoldLayer.h"
#include "CCoastLayer.h"
#include "CRiverLayer.h"
#include "CMountainLayer.h"
#include "CSurfaceGenerator.h"

//	O[o
char g_BaseDir[FILE_NAME_MAX];	//	fBNg

int g_GenerateFlag = 0;	//	n`R}h (1: n`A2: ĕ`)
int g_TexResolution[6] = {64, 128, 256, 512, 1024, 2048};
						//	eNX`𑜓xXg

float g_CameraDir = CAM_DEF_DIR;	//	Jpx
float g_CameraBank = CAM_DEF_BANK;	//	Jpx
float g_CameraDist = CAM_DEF_DIST;	//	J
float g_Angle = 0.0f;				//	J[\]px

bool g_SettingSwitch = false;	//	ݒLtO
bool g_MenuHidden = false;		//	j[BtO

VEC3 g_PointPos(0.0f, 0.0f, 0.0f);	//	񎟌J[\W
VEC3 g_LightDir(1.0f, -2.0f, 1.0f);	//	CeBOpx

POINT g_Pointer;	//	J[\W

CTexture g_SurfaceTexture;	//	n`eNX`
CTexture g_WaitTexture;		//	ƒʃeNX`

CSprite g_WaitSprite;	//	ƒʃXvCg

CMesh g_ArrowMesh;	//	J[\bV

CObject g_ArrowObject;	//	J[\IuWFNg

CSurfaceGenerator *g_Generator = NULL;	//	n`WFl[^

//	eÓI
CInterfaceText g_SizeText("n`TCY", 5, 25, 100, 20, 0xffffffff, 5, -1);
CInterfaceText g_TexResText("eNX`𑜓x", 360, 25, 150, 20, 0xffffffff, 5, -1);
CInterfaceText g_TerrainText("n`ݒ", 5, 90, 100, 20, 0xffffffff, 5, -1);
CInterfaceText g_WaterText("", 5, 175, 100, 20, 0xffffffff, 5, -1);
CInterfaceText g_ColorText("Fݒ", 5, 200, 100, 20, 0xffffffff, 5, -1);

//	e{^
CInterfaceButton g_HideButton("B", DISP_WIDTH-25, 5, 20, 20, 0xc0c0c0c0);
CInterfaceButton g_RedrawButton("eNX`ĕ`", 5, 345, 150, 20, 0xc0c0c0c0);
CInterfaceButton g_SettingButton("ݒI", DISP_WIDTH-105, DISP_HEIGHT-150, 100, 20, 0xc0ff0000);
CInterfaceButton g_DefaultButton("Kl", DISP_WIDTH-105, DISP_HEIGHT-125, 100, 20, 0xc0ffff00);
CInterfaceButton g_GenerateButton("n`쐬", DISP_WIDTH-105, DISP_HEIGHT-100, 100, 20, 0xc000ff00);
CInterfaceButton g_SaveButton("n`ۑ", DISP_WIDTH-105, DISP_HEIGHT-75, 100, 20, 0xc000ffff);
CInterfaceButton g_DeleteButton("n`j", DISP_WIDTH-105, DISP_HEIGHT-50, 100, 20, 0xc00000ff);
CInterfaceButton g_QuitButton("I", DISP_WIDTH-105, DISP_HEIGHT-25, 100, 20, 0xc0ff00ff);

//	eXC_
CInterfaceSlider g_XSizeSlider("XTCY", 5, 45, 100, 200, 50, 20, 0xff808080, 100, 2000, NULL, 20, 4);
CInterfaceSlider g_ZSizeSlider("ZTCY", 5, 65, 100, 200, 50, 20, 0xff808080, 100, 2000, NULL, 20, 4);
CInterfaceSlider g_TexWidthSlider("X", 360, 45, 50, 150, 50, 20, 0xff808080, 0, 0, g_TexResolution, 6, 3);
CInterfaceSlider g_TexHeightSlider("Z", 360, 65, 50, 150, 50, 20, 0xff808080, 0, 0, g_TexResolution, 6, 3);
CInterfaceSlider g_GroundRatioSlider("nʐ", 5, 110, 100, 200, 50, 20, 0xffff8000, 0, 100, NULL, 21, 15);
CInterfaceSlider g_RiverNumberSlider("͐쐔", 5, 130, 100, 200, 50, 20, 0xff0080ff, 0, 10, NULL, 11, 1);
CInterfaceSlider g_MountainNumberSlider("R", 5, 150, 100, 200, 50, 20, 0xff80ff00, 0, 10, NULL, 11, 2);

//	e`FbN{bNX
CInterfaceCheck g_WaterCheck1("Cm", 105, 175, 125, 20, 0xff0080c0, NULL);
CInterfaceCheck g_WaterCheck2("Ώ", 230, 175, 125, 20, 0xff00c080, &g_WaterCheck1);

//	eF~LT[
CInterfaceColorMixer g_FieldColor("n", 5, 220, 100, 125, 125, 20, 0xff80c040);
CInterfaceColorMixer g_BeachColor("l", 5, 240, 100, 125, 125, 20, 0xffffe0c0);
CInterfaceColorMixer g_OceanColor("", 5, 260, 100, 125, 125, 20, 0xff0080c0);
CInterfaceColorMixer g_SideColor("͌", 5, 280, 100, 125, 125, 20, 0xffc0e0a0);
CInterfaceColorMixer g_RiverColor("͐", 5, 300, 100, 125, 125, 20, 0xff0080c0);
CInterfaceColorMixer g_MountainColor("R", 5, 320, 100, 125, 125, 20, 0xff408020);

/*
 *	
 */
void StartUp(){
	GetAppPath(g_BaseDir);
	ShowCursor(false);
	V3Norm(&g_LightDir, &g_LightDir);
	SetDirLight(g_LightDir, MAKE_CV(1.0f, 1.0f, 1.0f, 1.0f));
	//devSetTexFilter(0, D3DTEXF_LINEAR);
	g_WaitTexture.LoadResource("WAIT", 0, 1);
	g_WaitSprite.SetTexture(&g_WaitTexture);
	g_WaitSprite.SetRect(0, 0, 512, 320);
	g_WaitSprite.SetPos(VEC2(0.5f*(DISP_WIDTH-512), 0.5f*(DISP_HEIGHT-320)));
	g_ArrowMesh.LoadResource("ARROW");
	g_ArrowObject.SetMesh(&g_ArrowMesh, V3ZERO, 0.5f);
}

/*
 *	C[`
 */
void MainLoop(){
	int tmpw, tmph;
	VEC3 pp;
	POINT pos = GetCursorXY();
	switch(g_GenerateFlag){
	case 1:
		g_GenerateFlag = 0;
		tmpw = g_XSizeSlider.GetValue()*40/500;
		tmph = g_ZSizeSlider.GetValue()*40/500;
		BeginScene();
		devSetLighting(false);
		g_WaitSprite.Render();
		EndScene();
		DELETE_V(g_Generator);
		CSurfaceLayer::SetStatus(tmpw, tmph, 0.5f, g_TexWidthSlider.GetValue(), g_TexHeightSlider.GetValue());
		g_Generator = new CSurfaceGenerator(tmpw, tmph, 0.5f, g_TexWidthSlider.GetValue(), g_TexHeightSlider.GetValue());
		g_Generator->Generate();
		return;
	case 2:
		g_GenerateFlag = 0;
		if(g_Generator){
			BeginScene();
			devSetLighting(false);
			g_WaitSprite.Render();
			EndScene();
			CSurfaceLayer::SetStatus(0, 0, 0.0f, g_TexWidthSlider.GetValue(), g_TexHeightSlider.GetValue());
			g_Generator->RedrawTexture(g_TexWidthSlider.GetValue(), g_TexHeightSlider.GetValue());
			return;
		}
	}
	if(GetButton(DIM_RIGHT)>=S_PUSH) CameraRotate(&pos, &g_CameraDir, &g_CameraBank);
	else CursorMove(&pos, &g_PointPos);
	SetCursor(svw.winW/2, svw.winH/2);
	CameraDistance(&g_CameraDist);
	pp = CameraSet(g_CameraDir, g_CameraBank, g_CameraDist, &V3ZERO, &g_PointPos);
	BeginScene();
	SetDirLight(g_LightDir, MAKE_CV(1.0f, 1.0f, 1.0f, 1.0f));
	devSetState(D3DRS_ZFUNC, D3DCMP_LESSEQUAL);
	g_Pointer = WorldToScreen2(&pp);
	if(g_Generator) g_Generator->Render();
	devSetLighting(false);
	ResetMatrix();
	devResetMaterial();
	devSetTexture(0, NULL);
	if(g_MenuHidden){
		if(g_HideButton.Render()){
			g_MenuHidden = false;
			g_HideButton.SetCaption("B");
		}
	}else{
		if(g_Generator) g_Generator->PrintName();
		if(g_HideButton.Render()){
			g_MenuHidden = true;
			g_HideButton.SetCaption("");
		}
		g_SizeText.Render();
		g_XSizeSlider.Render();
		g_ZSizeSlider.Render();
		g_TexResText.Render();
		g_TexWidthSlider.Render();
		g_TexHeightSlider.Render();
		if(g_SettingSwitch){
			if(g_SettingButton.Render()){
				g_SettingSwitch = false;
				g_SettingButton.SetCaption("ݒI");
			}
			g_TerrainText.Render();
			g_GroundRatioSlider.Render();
			g_RiverNumberSlider.Render();
			g_MountainNumberSlider.Render();
			g_WaterText.Render();
			g_WaterCheck1.Render();
			g_WaterCheck2.Render();
			g_ColorText.Render();
			g_FieldColor.Render();
			g_BeachColor.Render();
			g_OceanColor.Render();
			g_SideColor.Render();
			g_RiverColor.Render();
			g_MountainColor.Render();
			if(g_RedrawButton.Render() && g_Generator) g_GenerateFlag = 2;
		}else{
			if(g_SettingButton.Render()){
				g_SettingSwitch = true;
				g_SettingButton.SetCaption("ݒIt");
			}
		}
		if(g_DefaultButton.Render()){
			g_XSizeSlider.Reset();
			g_ZSizeSlider.Reset();
			g_TexWidthSlider.Reset();
			g_TexHeightSlider.Reset();
			g_GroundRatioSlider.Reset();
			g_RiverNumberSlider.Reset();
			g_MountainNumberSlider.Reset();
			g_WaterCheck1.Reset();
			g_FieldColor.Reset();
			g_BeachColor.Reset();
			g_OceanColor.Reset();
			g_SideColor.Reset();
			g_RiverColor.Reset();
			g_MountainColor.Reset();
		}
		if(g_GenerateButton.Render()) g_GenerateFlag = 1;
		if(g_SaveButton.Render() && g_Generator) g_Generator->Save();
		if(g_DeleteButton.Render()) DELETE_V(g_Generator);
		if(g_QuitButton.Render()) SendWM_CLOSE();
		ShowFPS(5, 5);
	}
	devSetLighting(true);
	devSetState(D3DRS_ZFUNC, D3DCMP_ALWAYS);
	g_ArrowObject.Render();
	EndScene();
}

/*
 *	J
 */
void CleanUp(){
	DELETE_V(g_Generator);
}
