//@@@@@@@@@@@@@@@@@@@@@@Copyright (c) 2002 Midikyou
#include"headers.h"
#include"debug.h"
#include"frame.h"
#include"window.h"
#include"graphic.h"
#include"texture.h"
#include"font.h"
#include"input.h"
#include"editbox.h"

/*============================================================================
  RXgN^
============================================================================*/
CEditBox::CEditBox()
{
	m_hImc = NULL;
//	m_pList = NULL;
	m_str = "";
	m_x = 0;
	m_y = 0;
	m_pos = 0;
	m_max = 80;
}
/*============================================================================
  fXgN^
============================================================================*/
CEditBox::~CEditBox()
{
	Release();
}
/*============================================================================
  GfBbg{bNX쐬

  x		:\JnwW
  y		:\JnxW
  max	:ő啶
============================================================================*/
void CEditBox::Create(int x,int y,int max,std::string pre)
{
	Release();

	m_hImc = ImmGetContext(svw.hWnd);
	m_x = x;
	m_y = y;
	m_pos = 0;
	m_max = max;
	m_str = m_show = pre;
}
/*============================================================================
  GfBbg{bNX
============================================================================*/
void CEditBox::Release()
{
	if(m_hImc)
	{
		ImmReleaseContext(svw.hWnd,m_hImc);
		m_hImc = 0;
	}
}
/*============================================================================
  ̓͂ƕ`

  ϊ̌A͈͂̕\͖B
============================================================================*/
int CEditBox::Update()
{
	//\
	Text(m_x,m_y,m_show.c_str());

	//Lbg\
	DrawCaret();

	//L[ĂȂȂXLbv
	if(CheckKeyDown() == -1) return 0;

	//G^[L[
	ON_PUSH(DIK_RETURN)
	{
		//ϊ̊mŖꍇ͓͏IƌȂ
		if(!IsComp()) return EDIT_OK;

		//m肵A
		CompEnd();
		return 0;
	}
	//GXP[vL[
	ON_PUSH(DIK_ESCAPE)
	{
		//ϊ̎Ŗꍇ͓͏IƌȂ
		if(!IsComp()) return EDIT_CANNCEL;
		else return 0;
	}
	//FEPNȂϊ̕擾
	if(IsFEPOpen()) GetCompStr(m_comp);

	//ϊȂ
	if(IsComp())
	{
		m_show = m_str;
		m_show.insert(m_pos,m_comp);
	}
	//ϊłȂȂiFEP̋N̗Lɂ炸j
	else
	{
		ON_PUSH(DIK_BACKSPACE)	DelChar();	//BS
		ON_PUSH(DIK_DELETE)		DelChar2();	//DEL
		ON_PUSH(DIK_LEFT)		MoveLeft(); //
		ON_PUSH(DIK_RIGHT)		MoveRight(); //

		//L[
		int c = GetChar();

		//p
		if((IsPrintChar(c)) && m_str.size() < m_max) AddChar(c);
	}
	return 0;
}
/*============================================================================
  Lbg\
============================================================================*/
void CEditBox::DrawCaret()
{
	static int frame; //t[JEg

	frame = (frame+1)%MAXFPS;

	if(frame < MAXFPS/2)
		Text(m_x+(m_pos*svf.size/2), m_y, "_");
}
/*============================================================================
  Lbgʒu1O
============================================================================*/
void CEditBox::DelChar()
{
	//݈ʒuQڈȍ~
	if(m_pos > 1)
	{
		//Sp
		if(Is2ByteChar(m_str[m_pos-2]))
		{
			m_str.erase(m_pos-2,2);
			m_pos-=2;
		}
		//p
		else
		{
			m_str.erase(m_pos-1,1);
			m_pos--;
		}
	}
	//Pڈȍ~
	else if(m_pos > 0)
	{
		m_str.erase(m_pos-1,1);
		m_pos--;
	}
	m_show = m_str;
}
/*============================================================================
  Lbgʒu̕
============================================================================*/
void CEditBox::DelChar2()
{
	int size = m_str.size();

	//݈ʒuŌォQڈȑO
	if(m_pos < size-1)
	{
		//Sp
		if(Is2ByteChar(m_str[m_pos]))
			m_str.erase(m_pos,2);
		//p
		else
			m_str.erase(m_pos,1);
	}
	//ŌォPڈȑO
	else if(m_pos < size)
		m_str.erase(m_pos,1);

	m_show = m_str;
}
/*============================================================================
  Lbgʒuɕǉ
  
  c		:
============================================================================*/
void CEditBox::AddChar(char c)
{
	m_str += c;
	m_pos++;
	m_show = m_str;
}
/*============================================================================
  LbgɈړ
============================================================================*/
void CEditBox::MoveLeft()
{
	//݈ʒuQڈȍ~
	if(m_pos > 1)
	{
		if(Is2ByteChar(m_str[m_pos-2])) m_pos-=2;
		else m_pos--;
	}
	//Pڈȍ~
	else if(m_pos > 0) m_pos--;
}
/*============================================================================
  LbgEɈړ
============================================================================*/
void CEditBox::MoveRight()
{
	//݈ʒuŌォQڈȑO
	if(m_pos+1 < m_str.size())
	{
		if(Is2ByteChar(m_str[m_pos])) m_pos+=2;
		else m_pos++;
	}
	//ŌォPڈȑO
	else if(m_pos < m_str.size()) m_pos++;
}
/*============================================================================
  ϊm
============================================================================*/
void CEditBox::CompEnd()
{
	GetResultStr(m_comp);
	m_str = m_str.insert(m_pos,m_comp);
	m_pos += m_comp.size();
	Clip();			//ő啶ŃNbv
	m_show = m_str;	//\XV
	m_comp = "";		//ϊ̃NA
}
/*============================================================================
  
============================================================================*/
void CEditBox::Clip()
{
	int size = m_str.size();

	if(size <= m_max) return;

	//Sp̐`FbNȂĂ
	for(int i = size; i > m_max;)
	{
		if(Is2ByteChar(m_str[i-2]))
		{
			m_str.erase(i-2,2);
			i-=2;
		}
		else
		{
			m_str.erase(i-1,1);
			i--;
		}
	}
	size = m_str.size();
	if(m_pos > size) m_pos = size;
}
/*============================================================================
  ϊ̕擾
  
  str	:̊i[
============================================================================*/
void CEditBox::GetCompStr(std::string& str)
{
    LONG size = ImmGetCompositionString(m_hImc,GCS_COMPSTR,NULL,0);
    char* pBuf = new char[size+1];

    ImmGetCompositionString(m_hImc,GCS_COMPSTR,pBuf,size);

    pBuf[size] = '\0';
    str = pBuf;
    delete pBuf;
}
/*============================================================================
  ϊm肵擾
  
  str	:̊i[
============================================================================*/
void CEditBox::GetResultStr(std::string& str)
{
    LONG size = ImmGetCompositionString(m_hImc,GCS_RESULTSTR,NULL,0);
    char* pBuf = new char[size+1];

    ImmGetCompositionString(m_hImc,GCS_RESULTSTR,pBuf,size);

    pBuf[size] = '\0';
    str = pBuf;
    delete pBuf;
}

/*============================================================================
  t@CI_CAO
  
  file	:t@Ci[
  len	:t@C̍ő啶
@def	:`("text file" ACӁj
@ext	:gq
@flag	:TRUE=݁AFALSE=Ǎ

  ߂l:TRUE=I𐬌,FALSE=LZAs
============================================================================*/
BOOL SelectFile(char* file,int len,const char* def,const char* ext,int flag)
{
	OPENFILENAME ofn;
	char filter[256];
	
	memset(&ofn,0,sizeof(OPENFILENAME));
	memset(file,0,sizeof(file));
	wsprintf(filter,"%s (*.%s)\t*.%s\t\t",def,ext,ext);
	
	for(int i=0;i<256;i++)
	{
		if(filter[i] == '\t') filter[i] = '\0';
	}
	ofn.lStructSize  = sizeof(OPENFILENAME);
	ofn.hwndOwner    = svw.hWnd;
	ofn.lpstrFilter  = filter;
	ofn.nFilterIndex = 0;
	ofn.lpstrDefExt  = ext;
	ofn.nMaxFile     = len;
	ofn.lpstrFile    = file;

	BOOL ret;

	if(flag)
	{
		ofn.Flags = OFN_OVERWRITEPROMPT|OFN_HIDEREADONLY;
		ret = GetSaveFileName(&ofn);
	}
	else
	{
		ofn.Flags = OFN_FILEMUSTEXIST|OFN_HIDEREADONLY;
		ret = GetOpenFileName(&ofn);
	}
	return ret;
}