//@@@@@@@@@@@@@@@@@@@@@@Copyright (c) 2002 Midikyou
#include"headers.h"
#include"debug.h"
#include"graphic.h"
#include"view.h"
#include"texture.h"
#include"mesh.h"
#include"object.h"

D3DMATERIAL8 CObject::matShadow = {{0,0,0,0.5f},};

/*============================================================================
  RXgN^
============================================================================*/
CObject::CObject()
{
	m_pMesh     = NULL;
	m_pParent   = NULL;
	m_mtx       = MTX4(1,0,0,0, 0,1,0,0, 0,0,1,0, 0,0,0,1);
	m_scale     = 1.0f;
	m_alphaAlt  = 0.5f;
	m_alphaPlus = 0.0f;
	m_pTexAlt   = NULL;
	m_fRender	= FALSE;
}
/*============================================================================
  fXgN^
============================================================================*/
CObject::~CObject()
{
}
/*============================================================================
  bṼA^b`

  pM	:bV
  p		:ʒu
@s		:XP[
============================================================================*/
void CObject::SetMesh(CMesh* pM,VEC3 p,float s)
{
	m_pMesh = pM;
	m_mtx   = MTX4(s,0,0,0, 0,s,0,0, 0,0,s,0, 0,0,0,1);
	m_scale = s;
	SetPos(p);
	EnableRender(TRUE);
	SetBoxMinMax(&m_box,pM->m_min,pM->m_max);
}
/*============================================================================
  e̐FݒiSIuWFNgʁj

  cv	:F
============================================================================*/
void CObject::SetShadowColor(D3DCOLORVALUE cv)
{
	matShadow.Diffuse = cv;
}
/*============================================================================
@XP[̐ݒi΁j
============================================================================*/
void CObject::SetScale(float s)
{
	float sr = s/m_scale;

	m_mtxOld = m_mtx;
	D3DXMatrixScaling( &m_mtxTmp, sr, sr, sr);
	m_mtx    = m_mtxTmp * m_mtxOld;
	m_scale  = s;
}
/*============================================================================
@XP[̐ݒi΁j
============================================================================*/
void CObject::Scale(float s)
{
	m_mtxOld = m_mtx;
	D3DXMatrixScaling( &m_mtxTmp, s, s, s);
	m_mtx    = m_mtxTmp * m_mtxOld;
	m_scale  *= s;
}
/*============================================================================
  ʒuwieXP[𖳎j

  v		:3DW
============================================================================*/
void CObject::SetPosS(VEC3 v)
{
	if(m_pParent) v /= m_pParent->GetWScale();
	SetPos( v );
}
/*============================================================================
  ړ

  v		:ړ
============================================================================*/
void CObject::Move(VEC3 v)
{
	v /= m_scale; //XP[Ỏe

	m_mtxOld = m_mtx;
	D3DXMatrixTranslation( &m_mtxTmp, v.x, v.y, v.z );
	m_mtx    = m_mtxTmp * m_mtxOld;
}
//_S
void CObject::Move2(VEC3 v)
{
	v /= m_scale; //XP[Ỏe

	m_mtxOld = m_mtx;
	D3DXMatrixTranslation( &m_mtxTmp, v.x, v.y, v.z );
	m_mtx    = m_mtxOld * m_mtxTmp;
}
/*============================================================================
  ړieXP[𖳎j

  v		:ړ
============================================================================*/
void CObject::MoveS(VEC3 v)
{
	v /= GetWScale(); //XP[Ỏe

	m_mtxOld = m_mtx;
	D3DXMatrixTranslation( &m_mtxTmp, v.x, v.y, v.z );
	m_mtx    = m_mtxTmp * m_mtxOld;
}
/*============================================================================
  X̉]

  v		:]piradj

  ]́̕{ɍew̐lw̕
============================================================================*/
void CObject::RotX(float v)
{
	m_mtxOld = m_mtx;
	D3DXMatrixRotationX( &m_mtxTmp, v );
	m_mtx    = m_mtxTmp * m_mtxOld;
}
//_S
void CObject::RotX2(float v)
{
	m_mtxOld = m_mtx;
	D3DXMatrixRotationX( &m_mtxTmp, v );
	m_mtx    = m_mtxOld * m_mtxTmp;
}
/*============================================================================
  Ỷ]

  v		:]piradj
============================================================================*/
void CObject::RotY(float v)
{
	m_mtxOld = m_mtx;
	D3DXMatrixRotationY( &m_mtxTmp, v );
	m_mtx    = m_mtxTmp * m_mtxOld;
}
//_S
void CObject::RotY2(float v)
{
	m_mtxOld = m_mtx;
	D3DXMatrixRotationY( &m_mtxTmp, v );
	m_mtx    = m_mtxOld * m_mtxTmp;
}
/*============================================================================
  Z̉]

  v		:]piradj
============================================================================*/
void CObject::RotZ(float v)
{
	m_mtxOld = m_mtx;
	D3DXMatrixRotationZ( &m_mtxTmp, v );
	m_mtx    = m_mtxTmp * m_mtxOld;
}
//_S
void CObject::RotZ2(float v)
{
	m_mtxOld = m_mtx;
	D3DXMatrixRotationZ( &m_mtxTmp, v );
	m_mtx    = m_mtxOld * m_mtxTmp;
}
/*============================================================================
  Cӎ̉]

  ax	:xNg
  v		:]piradj
============================================================================*/
void CObject::RotAxis(VEC3 ax,float v)
{
	m_mtxOld = m_mtx;
	D3DXMatrixRotationAxis( &m_mtxTmp, &ax, v );
	m_mtx    = m_mtxTmp * m_mtxOld;
}
/*============================================================================
  r{[h]iX,Z]Œj
============================================================================*/
void CObject::Billboard()
{
	//IuWFNgJւ̃xNg𓾂
	VEC3 v = GetVPos() - GetWPos();

	m_mtxOld = m_mtx;

	//]s𓾂
	if( v.x > 0.0f )
		D3DXMatrixRotationY( &m_mtx, -atanf(v.z/v.x)+D3DX_PI/2 );
	else
		D3DXMatrixRotationY( &m_mtx, -atanf(v.z/v.x)-D3DX_PI/2 );

	m_mtx._41 = m_mtxOld._41;
	m_mtx._42 = m_mtxOld._42;
	m_mtx._43 = m_mtxOld._43;
	m_mtx._44 = 1;

	float s = m_scale; m_scale = 1;
	SetScale(s);
}
/*============================================================================
  r{[h]iX,Y]Œj
============================================================================*/
void CObject::Billboard2()
{
	//IuWFNgJւ̃xNg𓾂
	VEC3 v = GetVPos() - GetWPos();

	m_mtxOld = m_mtx;

	//]s𓾂
	if( v.x > 0.0f )
		D3DXMatrixRotationZ( &m_mtx, atanf(v.y/v.x)-D3DX_PI/2 );
	else
		D3DXMatrixRotationZ( &m_mtx, atanf(v.y/v.x)+D3DX_PI/2 );

	m_mtx._41 = m_mtxOld._41;
	m_mtx._42 = m_mtxOld._42;
	m_mtx._43 = m_mtxOld._43;
	m_mtx._44 = 1;

	float s = m_scale; m_scale = 1;
	SetScale(s);
}
/*============================================================================
  w_̕

  at	:ʒu
============================================================================*/
void CObject::LookAt(VEC3 at)
{
	VEC3 dir,up(0,1,0),right;

	dir = at - GetWPos();
	D3DXVec3Normalize( &dir, &dir );
	D3DXVec3Cross( &right, &up, &dir );
	D3DXVec3Normalize( &right, &right );
	D3DXVec3Cross( &up, &dir, &right );
	D3DXVec3Normalize( &up, &up );

	m_mtx._11 = right.x; m_mtx._12 = right.y; m_mtx._13 = right.z;
	m_mtx._21 = up.x;    m_mtx._22 = up.y;    m_mtx._23 = up.z;
	m_mtx._31 = dir.x;   m_mtx._32 = dir.y;   m_mtx._33 = dir.z;
	m_mtx._44 = 1;
	
	float s = m_scale; m_scale = 1;
	SetScale(s);
}
/*============================================================================
  w_̕iX,Z]Œj

  at	:ʒu
============================================================================*/
void CObject::LookAt2(VEC3 at)
{
	//IuWFNgw_ւ̃xNg𓾂
	VEC3 v = at - GetWPos();
	float rx=0,ry,rz = 0;

	//]p𓾂
	if     (v.x >  0.0f)	ry = -atanf(v.z/v.x)+D3DX_PI/2;
	else if(v.x <  0.0f)	ry = -atanf(v.z/v.x)-D3DX_PI/2;
	else if(v.z >= 0.0f)	ry = 0;
	else if(v.z <  0.0f)	ry = -D3DX_PI;

	//]svZ
	m_mtxOld = m_mtx;

	D3DXMatrixRotationYawPitchRoll( &m_mtx, ry, rx, rz);

	m_mtx._41 = m_mtxOld._41;
	m_mtx._42 = m_mtxOld._42;
	m_mtx._43 = m_mtxOld._43;
	m_mtx._44 = 1;

	float s = m_scale; m_scale = 1;
	SetScale(s);
}
/*============================================================================
  w

  dir	:
============================================================================*/
void CObject::SetDir(VEC3 dir,VEC3 up)
{
	VEC3 right;

	D3DXVec3Normalize( &dir, &dir );
	D3DXVec3Cross( &right, &up, &dir );
	D3DXVec3Normalize( &right, &right );
	D3DXVec3Cross( &up, &dir, &right );
	D3DXVec3Normalize( &up, &up );

	m_mtx._11 = right.x; m_mtx._12 = right.y; m_mtx._13 = right.z;
	m_mtx._21 = up.x;    m_mtx._22 = up.y;    m_mtx._23 = up.z;
	m_mtx._31 = dir.x;   m_mtx._32 = dir.y;   m_mtx._33 = dir.z;
	m_mtx._44 = 1;
	
	float s = m_scale; m_scale = 1;
	SetScale(s);
}
/*============================================================================
@ʒu擾(eXP[l)
============================================================================*/
VEC3 CObject::GetPosS()
{
	if(m_pParent)
		return m_pParent->GetWScale() * GetPos();
	else
		return GetPos();
}
/*============================================================================
@ʒu擾([hWn)
============================================================================*/
VEC3 CObject::GetWPos()
{
	if(m_pParent)
	{
		m_mtxTmp = GetWMatrix();
		return VEC3(m_mtxTmp._41, m_mtxTmp._42, m_mtxTmp._43);
	}
	else
		return GetPos();
}
/*============================================================================
@RightxNg擾([hWn)
============================================================================*/
VEC3 CObject::GetWRight()
{
	if(m_pParent)
	{
		m_mtxTmp = GetWMatrix();
		return VEC3(m_mtxTmp._11, m_mtxTmp._12, m_mtxTmp._13);
	}
	else
		return GetRight();
}
/*============================================================================
@UpxNg擾([hWn)
============================================================================*/
VEC3 CObject::GetWUp()
{
	if(m_pParent)
	{
		m_mtxTmp = GetWMatrix();
		return VEC3(m_mtxTmp._21, m_mtxTmp._22, m_mtxTmp._23);
	}
	else
		return GetUp();
}
/*============================================================================
@DirxNg擾([hWn)
============================================================================*/
VEC3 CObject::GetWDir()
{
	if(m_pParent)
	{
		m_mtxTmp = GetWMatrix();
		return VEC3(m_mtxTmp._31, m_mtxTmp._32, m_mtxTmp._33);
	}
	else
		return GetDir();
}
/*============================================================================
  ϊs̎擾([hWn)
============================================================================*/
MTX4 CObject::GetWMatrix()
{
	if(m_pParent)
		return m_mtx * m_pParent->GetWMatrix();
	else
		return m_mtx;
}
/*============================================================================
  XP[̎擾(eXP[lA[hWñXP[Ƃl)
============================================================================*/
float CObject::GetWScale()
{
	if(m_pParent)
		return m_scale * m_pParent->GetWScale();
	else
		return m_scale;
}
/*============================================================================
  _O

@XVfoCXp[^	:[h}gNXA}eAAeNX`
============================================================================*/
void CObject::Render()
{
	if(m_pMesh && m_fRender)
	{
		if(m_pParent)
			m_pMesh->Render(&GetWMatrix());
		else
			m_pMesh->Render(&m_mtx);
	}
}
/*============================================================================
  eNX`w背_O

@XVfoCXp[^	:[h}gNXA}eAAeNX`
============================================================================*/
void CObject::RenderT()
{
	if(m_pMesh && m_fRender)
	{
		if(m_pParent)
			m_pMesh->RenderT(&GetWMatrix(), m_pTexAlt->GetObject());
		else
			m_pMesh->RenderT(&m_mtx, m_pTexAlt->GetObject());
	}
}
/*============================================================================
  lw背_O

@XVfoCXp[^	:[h}gNXA}eAAeNX`
============================================================================*/
void CObject::RenderA()
{
	if(m_pMesh && m_fRender)
	{
		if(m_pParent)
			m_pMesh->RenderA(&GetWMatrix(), m_alphaAlt);
		else
			m_pMesh->RenderA(&m_mtx, m_alphaAlt);
	}
}
/*============================================================================
  Z_O

@XVfoCXp[^	:[h}gNXA}eAAeNX`
============================================================================*/
void CObject::RenderAP()
{
	if(m_pMesh && m_fRender)
	{
		if(m_pParent)
			m_pMesh->RenderAP(&GetWMatrix(), m_alphaPlus);
		else
			m_pMesh->RenderAP(&m_mtx, m_alphaPlus);
	}
}
/*============================================================================
  ẽ_O

  pMtx	:esiGetShadowMtx()Ŏ擾j

@XVfoCXp[^	:[h}gNXA}eAAeNX`
============================================================================*/
void CObject::RenderShadow(MTX4* pMtx)
{
	if(m_pMesh && m_fRender)
	{
		if(m_pParent)
			m_pMesh->RenderSC(&(GetWMatrix() * (*pMtx)), &matShadow);
		else
			m_pMesh->RenderSC(&(m_mtx * (*pMtx)), &matShadow);
	}
}
/*============================================================================
  E{bNX̎擾
============================================================================*/
BOX8 CObject::GetBox()
{
	if(m_pParent) m_mtxTmp = GetWMatrix();
	else          m_mtxTmp = m_mtx;

	BOX8 box;
	VEC3 vTmp;

	for(int i=0;i<8;i++)
	{
		D3DXVec3TransformCoord(&vTmp,&m_box.v[i],&m_mtxTmp);
		box.v[i] = VEC3(vTmp.x, vTmp.y, vTmp.z);
	}
	return box;
}
/*============================================================================
  E̎擾

  c		:S
  r		:a
============================================================================*/
void CObject::GetSphere(VEC3* c,float* r)
{
	*c = m_pMesh->m_center + GetWPos();
	*r = m_pMesh->m_radius  * m_scale;
}
/*============================================================================
  iE{bNXƁj

  pos	:̎n_
  dir	:̕

  J
============================================================================*/
BOOL CObject::IntersectB(VEC3 pos,VEC3 dir)
{
	VEC3 min = m_pMesh->m_min * m_scale;
	VEC3 max = m_pMesh->m_max * m_scale;

	//{ ̍WnIuWFNgɍ킹
	pos -= GetWPos();
	dir -= GetWPos();

	VEC3 vx = GetWRight();
	VEC3 vy = GetWUp();
	VEC3 vz = GetWDir();

	VEC3 pos2;
	pos2.x = D3DXVec3Dot(&pos,&vx);
	pos2.y = D3DXVec3Dot(&pos,&vy);
	pos2.z = D3DXVec3Dot(&pos,&vz);

	VEC3 dir2;
	dir2.x = D3DXVec3Dot(&dir,&vx);
	dir2.y = D3DXVec3Dot(&dir,&vy);
	dir2.z = D3DXVec3Dot(&dir,&vz);
	//}
	//TextF(0,16,"%.1f %.1f %.1f\n",pos2.x,pos2.y,pos2.z);
	//TextF(0,32,"%.1f %.1f %.1f\n",dir2.x,dir2.y,dir2.z);
	return D3DXBoxBoundProbe(&min,&max,&pos2,&dir2);
}
/*============================================================================
  iEƁj

  pos	:̎n_
  dir	:̕
============================================================================*/
BOOL CObject::IntersectS(VEC3 pos,VEC3 dir)
{
	VEC3 center = m_pMesh->m_center + GetWPos();

	return D3DXSphereBoundProbe(
		&center,
		m_pMesh->m_radius  * m_scale,
		&pos,
		&dir
	);
}
/*============================================================================
  ibVƂ̏ڍׂȔj

  pos	:̎n_
  dir	:̕
  hit	:ŏ̌_
  tri	:Op`([JWn)̒_̊i[

  R̂̕𔻒肷ꍇ͂܂IntersectS()őe肷ǂłB
============================================================================*/
BOOL CObject::Pick(VEC3 pos,VEC3 dir,VEC3* hit,VEC3 tri[3])
{
	if(m_pMesh == NULL) return FALSE;

	//pos,dir[JWnɕϊ
	MTX4 mw,mi;
	VEC3 lpos,pos2,dir2;

	mw   = GetWMatrix();
	lpos = GetWPos();
    D3DXMatrixInverse( &mi, NULL, &mw );
	D3DXVec3TransformNormal( &pos2, &pos, &mi ); 
	D3DXVec3TransformNormal( &dir2, &dir, &mi );
	D3DXVec3TransformNormal( &pos, &lpos, &mi );
	pos2 -= pos;

	//bVbNă|SPʂŔ
	LPD3DXMESH pMesh = m_pMesh->GetObject();

	LPDIRECT3DVERTEXBUFFER8 pVB;
	LPDIRECT3DINDEXBUFFER8 pIB;

    pMesh->GetVertexBuffer( &pVB );
    pMesh->GetIndexBuffer( &pIB );

    WORD*	pInd;
    BYTE*	pVtx;

	pIB->Lock( 0,0,(BYTE**)&pInd, D3DLOCK_READONLY );
	pVB->Lock( 0,0,(BYTE**)&pVtx, D3DLOCK_READONLY );

	UINT  fvfSize = D3DXGetFVFVertexSize( pMesh->GetFVF() );
    DWORD dwNumFaces = pMesh->GetNumFaces();
	DWORD dwCount = 0;

	VEC3  v0,v1,v2,tmp;
	float t,u,v;
	*hit = D3DXVECTOR3(1000,1000,1000); //_ɃZbg

    for( DWORD i=0; i<dwNumFaces; i++ )
    {
        v0 = *(VEC3*)( pVtx + fvfSize * pInd[3*i+0] );
        v1 = *(VEC3*)( pVtx + fvfSize * pInd[3*i+1] );
        v2 = *(VEC3*)( pVtx + fvfSize * pInd[3*i+2] );

        if( IntersectTriangle( pos2, dir2, v0, v1, v2, &t, &u, &v ) )
        {
			tmp = (v1 - v0)*u + (v2 - v0)*v + v0;

			//is̍ŋߓ_I
			if( D3DXVec3Dot( &dir2, &(tmp-pos2) ) >= 0 &&
				D3DXVec3Length( &(tmp-pos2) ) < D3DXVec3Length( &(*hit-pos2) ) )
			{
				*hit = tmp;
				if(tri != NULL)	tri[0] = v0, tri[1] = v1, tri[2] = v2;
				dwCount++;
			}
        }
    }
    pVB->Unlock();
    pIB->Unlock();
    pVB->Release();
    pIB->Release();

	if(dwCount > 0)
	{
		D3DXVec3TransformNormal( &tmp, hit, &mw );
		*hit = tmp + lpos;
		return TRUE;
	}
	else
	{
		*hit = VEC3(0,0,0);
		return FALSE;
	}
}
/*============================================================================
@

  ߂l	:TRUE=AFALSE=s
  
@s|S̃NbvDirect3DɂĂݒɂĂ̂ŁA
@܂oԂ͂ȂEEE
@iłsɕ`XLbvƎ኱̃ptH[}XAbvj
============================================================================*/
BOOL CObject::IsVisible()
{
	//SW画f
	VEC3 pos = WorldToScreen(GetWPos());

	if(pos.z >= 0
	&& 0 <= pos.y && pos.y <= 480
	&& 0 <= pos.x && pos.x <= 640) return TRUE;

	//E{bNX画f
	BOX8 box = GetBox();
	
	for(int i = 0; i < 8; i++)
	{
		pos = WorldToScreen(box.v[i]);

		if(pos.z >= 0
		&& 0 <= pos.y && pos.y <= 480
		&& 0 <= pos.x && pos.x <= 640) return TRUE;
	}
	return FALSE;
}

/*============================================================================
  E{bNXeXg

  pDst	:E{bNXA
  pSrc	:E{bNXB

  SphereTest͌łAx኱܂B
  ӂƕӂŐڐGĂꍇ͌oł܂B
============================================================================*/
BOOL BoxTest(BOX8* pDst,BOX8* pSrc)
{
	//Åeʂ쐬
	D3DXPLANE p[6];

	D3DXPlaneFromPoints(&p[0],&pDst->v[0],&pDst->v[1],&pDst->v[2]); //right
	D3DXPlaneFromPoints(&p[1],&pDst->v[2],&pDst->v[3],&pDst->v[7]); //bottom
	D3DXPlaneFromPoints(&p[2],&pDst->v[4],&pDst->v[6],&pDst->v[7]); //left
	D3DXPlaneFromPoints(&p[3],&pDst->v[0],&pDst->v[4],&pDst->v[5]); //top
	D3DXPlaneFromPoints(&p[4],&pDst->v[0],&pDst->v[2],&pDst->v[6]); //back
	D3DXPlaneFromPoints(&p[5],&pDst->v[1],&pDst->v[5],&pDst->v[7]); //front

	//B̒_Pł
	for(int j=0;j<8;j++)
	{
		BOOL f = TRUE;

		//ȂSĂ̖ʂ̓ɂ邩H
		for(int i=0;i<6;i++)
		{
			//Oɂʂ̒_𒲂ׂ
			if(D3DXPlaneDotCoord(&p[i],&pSrc->v[j]) < 0)
			{
				f = FALSE;
				break;
			}
		}
		if(f) return TRUE;
	}
	return FALSE;
}
/*============================================================================
  Op`Ɛ̌
============================================================================*/
BOOL IntersectTriangle(
	const VEC3& orig, const VEC3& dir,
	VEC3& v0, VEC3& v1, VEC3& v2,
	FLOAT* t, FLOAT* u, FLOAT* v )
{
	//SDKTv̂܂(^^;
	
	// Find vectors for two edges sharing vert0
    D3DXVECTOR3 edge1 = v1 - v0;
    D3DXVECTOR3 edge2 = v2 - v0;

    // Begin calculating determinant - also used to calculate U parameter
    D3DXVECTOR3 pvec;
    D3DXVec3Cross( &pvec, &dir, &edge2 );

    // If determinant is near zero, ray lies in plane of triangle
    FLOAT det = D3DXVec3Dot( &edge1, &pvec );
    if( det < 0.0001f )
        return FALSE;

    // Calculate distance from vert0 to ray origin
    D3DXVECTOR3 tvec = orig - v0;

    // Calculate U parameter and test bounds
    *u = D3DXVec3Dot( &tvec, &pvec );
    if( *u < 0.0f || *u > det )
        return FALSE;

    // Prepare to test V parameter
    D3DXVECTOR3 qvec;
    D3DXVec3Cross( &qvec, &tvec, &edge1 );

    // Calculate V parameter and test bounds
    *v = D3DXVec3Dot( &dir, &qvec );
    if( *v < 0.0f || *u + *v > det )
        return FALSE;

    // Calculate t, scale parameters, ray intersects triangle
    *t = D3DXVec3Dot( &edge2, &qvec );
    FLOAT fInvDet = 1.0f / det;
    *t *= fInvDet;
    *u *= fInvDet;
    *v *= fInvDet;

    return TRUE;
}
