//@@@@@@@@@@@@@@@@@@@@@@Copyright (c) 2002 Midikyou
#include"headers.h"
#include"debug.h"
#include"graphic.h"
#include"vertex.h"
#include"draw.h"
#include"texture.h"

/*============================================================================
  RXgN^
============================================================================*/
CTexture::CTexture()
{
	m_pTex = NULL;
}
/*============================================================================
  fXgN^
============================================================================*/
CTexture::~CTexture()
{
	Free();
}
/*============================================================================
  Ǎ

  strFile	:t@CiBMP,PNGȂǁj
  cTrans	:ߐF
  nMipLv	:~bv}bvku
============================================================================*/
BOOL CTexture::Load(LPCSTR strFile,D3DCOLOR cTrans,int nMipLv)
{
	Free(); //Ȃ

	Debug("load(%s) ... ",strFile);
	m_strName = strFile;

	if(FAILED( LOAD_TEXTURE(&m_pTex,strFile,cTrans,nMipLv) ))
	{
		Debug("failed.\n");
		return FALSE;
	}
	m_pTex->GetLevelDesc(0,&m_desc);

	Debug("ok.\n");
	return TRUE;
}
//\[Xirbg}bv̂݁j
BOOL CTexture::LoadResource(LPCSTR strRes,D3DCOLOR cTrans,int nMipLv)
{
	Free(); //Ȃ

	Debug("load(%s) ... ",strRes);
	m_strName = strRes;

	if(FAILED( LOAD_TEXTURE_RES(&m_pTex,strRes,cTrans,nMipLv) ))
	{
		Debug("failed.\n");
		return FALSE;
	}
	m_pTex->GetLevelDesc(0,&m_desc);

	Debug("ok.\n");
	return TRUE;
}
/*============================================================================
  
============================================================================*/
void CTexture::Free()
{
	if(m_strName != "")
	{
		Debug("release(%s)\n",m_strName.c_str());
		m_strName = "";
	}
	RELEASE(m_pTex);
}
/*============================================================================
  eNX`̍쐬
  
  str	:iTABj
  size	:̃TCY
  c		:̐F
  weight:̑(FW_NORMAL,FW_BOLD,FW_HEAVY...)
  font	:tHg

  `łs̕As̓foCXT|[gĂeNX`[
  őTCYɈˑ܂B
============================================================================*/
BOOL CTexture::CreateText(LPCSTR str,int size,D3DCOLOR c,int weight,LPCSTR font)
{
	Free(); //Ȃ
	m_strName = "text";

	//tHg̍쐬
	HDC hDC = CreateCompatibleDC(NULL);

    HFONT hFont = CreateFont(
		size, 0, 0, 0, weight,
		FALSE, FALSE, FALSE,
		SHIFTJIS_CHARSET,
		OUT_DEFAULT_PRECIS,
		CLIP_DEFAULT_PRECIS,
		DEFAULT_QUALITY,
		DEFAULT_PITCH | FF_DONTCARE,
		font
	);
    HFONT hOldFont = (HFONT)SelectObject(hDC, hFont);

	WORD b = LOBYTE(LOWORD(c));
	WORD r = LOBYTE(HIWORD(c));
	WORD g = HIBYTE(LOWORD(c));
	WORD a = HIBYTE(HIWORD(c));

	SetMapMode  (hDC, MM_TEXT);
	SetBkMode   (hDC, TRANSPARENT);
    SetTextColor(hDC, RGB(r,g,b));

	//`̈̎擾
	RECT drawRect={0,0,1,1};

	DrawText(hDC, str, -1, &drawRect, DT_CALCRECT|DT_LEFT|DT_EXPANDTABS|DT_NOPREFIX);

	int drawW = drawRect.right;
	int drawH = drawRect.bottom;

	//DIB̍쐬
    BITMAPINFO bmi;

    ZeroMemory( &bmi.bmiHeader, sizeof(BITMAPINFOHEADER) );
    bmi.bmiHeader.biSize        = sizeof(BITMAPINFOHEADER);
    bmi.bmiHeader.biWidth       = drawW;
    bmi.bmiHeader.biHeight      = -drawH;
    bmi.bmiHeader.biPlanes      = 1;
    bmi.bmiHeader.biCompression = BI_RGB;
    bmi.bmiHeader.biBitCount    = 32;

	BYTE* pDIB;
	DWORD dibSize = 4/* 32bit */ * drawW * drawH;
	RECT rect = {0, 0, drawW, drawH};

    HBITMAP hBM = CreateDIBSection(
		hDC, &bmi, DIB_RGB_COLORS,
		(VOID**)&pDIB, NULL, 0
	);
	if(pDIB == NULL) return FALSE;

	//DIBɕ`
    HBITMAP hOldBM = (HBITMAP)SelectObject(hDC, hBM);
	memset(pDIB, 0, dibSize);
	DrawText(hDC, str, -1, &rect, DT_LEFT|DT_EXPANDTABS|DT_NOCLIP|DT_NOPREFIX);

	//eNX`̍쐬
	HRESULT hr;
	int texW = min(drawW, sv3.capsTexWidth);
	int texH = min(drawH, sv3.capsTexHeight);
	texW = (int)pow( 2, ceil(log(texW)/log(2)) );
	texH = (int)pow( 2, ceil(log(texH)/log(2)) );

	hr = sv3.pDev->CreateTexture(
		texW, texH, 1, 0, D3DFMT_A4R4G4B4,
		D3DPOOL_MANAGED, &m_pTex
	);
	if( FAILED(hr) ) goto error;

	m_pTex->GetLevelDesc(0,&m_desc); //ۂ̃eNX`TCY擾
#if 0
	Debug("Allocated Texture %d x %d.\n", m_desc.Width, m_desc.Height);
#endif

	//DIB(32bit)eNX`(16bit)֓]
	D3DLOCKED_RECT lockRect;

	hr = m_pTex->LockRect(0, &lockRect, NULL, 0); //bN

	if( SUCCEEDED(hr) )
	{
		WORD*  pDst;
		DWORD* pSrc = (DWORD*)pDIB;
		WORD   color = ((a&0xf0)<<8) | ((r&0xf0)<<4) | (g&0xf0) | ((b&0xf0)>>4); //16bit

		for(int i = 0; i < drawH; i++)
		{
			pDst = (WORD*)lockRect.pBits + (lockRect.Pitch/2) * i; //bit炷

			for(int j = 0; j < drawW; j++)
			{
				*pDst = (*pSrc == 0) ? 0/*ȍ*/: color;
				pDst++;
				pSrc++;
			}
		}
		m_pTex->UnlockRect(0); //bN
	}
error: //n
	SelectObject(hDC, hOldBM);
	SelectObject(hDC, hOldFont);
    DeleteObject(hBM);
    DeleteDC(hDC);
	DeleteObject(hFont);

	return SUCCEEDED(hr);
}
/*============================================================================
  2D摜Ƃă_O

  x,y	:`ʒu
@XVfoCXp[^	:eNX`

  OɃCeBOOFFɂ邱ƁB
============================================================================*/
void CTexture::Render(int x,int y)
{
	if(m_pTex != NULL)
	{
		devSetTexture(0,m_pTex);
		TexMap2DRect(x, y, x+m_desc.Width, y+m_desc.Height);
	}
}


/*============================================================================
@RXgN^

  CMeshNXRelease()Ă΂̂ŃfXgN^͕sv
============================================================================*/
CTexList::CTexList()
{
	m_pList = NULL;
}
/*============================================================================
@eNX`Xg猟AȂ΃[h
============================================================================*/
LPTEX8 CTexList::Get(BOOL fRes,LPCSTR strName,D3DCOLOR cTrans,int nMipLv)
{
	//XgeNX`[
	TEXINFO* p = m_pList;

	while(p != NULL)
	{
		//ΎQƃJE^𑝂₵AeNX`Ԃ
		if(p->strName.compare(strName) == 0)
		{
			//Debug("[%s] is in texture-list.\n",strName); /*fobO*/
			p->nRef++;
			return p->pTex;
		}
		p = p->pNext;
	}
	//Ȃ΃[h
	Debug("load(%s) ... ",strName);

	p = new TEXINFO;
	p->pTex = NULL;

	if(fRes == FALSE
		? FAILED( LOAD_TEXTURE(&p->pTex, strName, cTrans, nMipLv) )
		: FAILED( LOAD_TEXTURE_RES(&p->pTex, strName, cTrans, nMipLv) )
	){
		Debug("failed.\n");
		return NULL;
	}
	Debug("ok.\n");

	//Xg̐擪ɒǉAQƃJE^ݒ肷
	if(m_pList == NULL) //Xg
	{
		m_pList  = p;
		p->pNext = NULL;
	}
	else //
	{
		TEXINFO* q = m_pList->pNext;
		m_pList->pNext = p;
		p->pNext       = q;
	}
	p->strName = strName;
	p->nRef = 1;

	return p->pTex;
}
/*============================================================================
@\ȂeNX`
============================================================================*/
void CTexList::Release(LPTEX8 pTex)
{
	//eNX`
	TEXINFO* p = m_pList;
	TEXINFO* q = NULL;

	while(p != NULL)
	{
		//ΎQƃJE^炷
		if(p->pTex == pTex)
		{
			p->nRef--;

			//QƂȂȂ΃eNX`AXgO
			if(p->nRef == 0)
			{
				Debug("release(%s)\n",p->strName.c_str());
				RELEASE(p->pTex);
				
				if(p == m_pList) //Xg̐擪
				{
					m_pList = p->pNext;
					delete p;
				}
				else //r
				{
					q->pNext = p->pNext;
					delete p;
				}
			}
			break;
		}
		q = p;
		p = p->pNext;
	}
}
