//	Cu
#include "lib\udx.h"

//	萔E}N
#include "Const.h"
#include "Macro.h"

extern const int MAIN_LOG_MAX;
extern const int RAIL_PIER_TYPES;
extern const float RAIL_TIE_HEIGHT;

extern const float ARROW_ROTATE = 0.3f;		//	J[\]x
extern const float PTR_FOLLOW_RATE = 0.2f;	//	J̃J[\ǐՑx
extern const float GRID_SNAP_Y = 100.0f;	//	y pXibvݒ

//	c[֐
#include "ValueArea.h"
#include "SystemCover.h"
#include "CameraControl.h"
#include "SwitchMode.h"
#include "SaveData.h"

//	NX
#include "CLogger.h"
#include "CPlugin.h"
#include "CRailModel.h"
#include "CTieModel.h"
#include "CPierModel.h"
#include "CRailList.h"
#include "CTrainGroup.h"
#include "CTrainGroupList.h"
#include "CStructList.h"
#include "CStationList.h"

//	OO[o
extern int g_RailSelectFlag;
extern int g_ObjectSelectFlag;
extern int g_RailOptionModels;
extern int g_TieOptionModels;
extern int g_PierOptionModels;
extern int g_RailCreate;
extern int g_TieCreate;
extern int g_PierCreate;
extern int g_LineCreate;
extern float g_GridSnap;
extern float g_CameraDir;
extern float g_CameraBank;
extern float g_CameraDist;
extern float g_FWidthX;
extern float g_FWidthZ;
extern float g_Angle;
extern bool g_ModeChanged;
extern POINT g_Pointer;
extern POINT g_AreaPos1;
extern POINT g_AreaPos2;
extern D3DCOLOR g_SkyColor;
extern VEC3 g_ArrowPos;
extern VEC3 g_ArrowPost;
extern VEC3 g_CameraPos;
extern VEC3 g_Pick;
extern VEC3 g_PointPos;
extern CObject g_ArrowObject;
extern CObject g_SurfaceObject;
extern CLogger g_GeneralLog;
extern CLogger g_CornerLog;
extern CLogger g_RailExpLog;
extern CLogger g_RailEditExpLog;
extern CLogger g_ModeLog;
extern CRailModel *g_RailOptionModelSeed;
extern CRailModel *g_RailOptionModelSelect;
extern CTieModel *g_TieOptionModelSeed;
extern CTieModel *g_TieOptionModelSelect;
extern CPierModel *g_PierOptionModelSeed;
extern CPierModel *g_PierOptionModelSelect;
extern CRailList g_RailOptionList;
extern CTrainGroupList g_TrainOptionList;
extern CStructList g_StructOptionList;
extern CStationList g_StationOptionList;

//	O[o
int g_SnapSwitch = 0;	//	ObhXibvݒ
int g_KantSwitch = 0;	//	Jg
int g_ShowGrid = 1;		//	Obh\
int g_HeightSnap = 0;	//	xXibv

float g_GridSnap = 100.0f;						//	gpXibv
float g_SnapTable[3] = {100.0f, 10.0f, 1.0f};	//	XibvXg


//	֐錾
void RenderOrder();
void VideoCapture(bool);

/*
 *	Hݒu[h
 */
void RailCreate(){
	static char *bmstr[3] = {"n\", "n\E", "n\EˁEn"};
	static char *kant[2] = {"", "S"};
	static int rk, lk, smode, buildmode = 1;
	float mtmp;
	POINT pos;
	pos = GetCursorXY();
	if(SDK_GetKey(VK_UP)==S_PUSH) smode--;
	if(SDK_GetKey(VK_DOWN)==S_PUSH) smode++;
	ValueCircular(&smode, 0, 8);
	if((pos.x!=(svw.winW/2)) || (pos.y!=(svw.winH/2))) rk = lk = 0;
	switch(SDK_GetKey(VK_LBUTTON)){
	case S_PULL:
		if(lk>1){
			lk = 0;
			g_RailOptionList.Finish(false);
		}else if(lk){
			lk = DCLICK_DURATION;
			g_RailOptionList.Push(VEC3(g_ArrowPost.x, g_ArrowPost.y+RAIL_TIE_HEIGHT, g_ArrowPost.z), g_Pick.y);
		}
		break;
	case S_PUSH:
		if(!lk) lk = 1;
		break;
	default:
		if(lk>1) lk--;
		break;
	}
	switch(SDK_GetKey(VK_RBUTTON)){
	case S_PULL:
		if(rk>1){
			rk = 0;
			RegisterMode(-1, true);
		}else if(rk){
			rk = DCLICK_DURATION;
			g_RailOptionList.Pop();
		}
		break;
	case S_PUSH:
		if(!rk) rk = 1;
		break;
	case S_HOLD:
		CameraRotate(&pos, &g_CameraDir, &g_CameraBank);
		break;
	default:
		if(rk>1) rk--;
		if(CheckCtrl()) mtmp = FAST_MOV_RATE*CUS_MOV_RATE; else mtmp = CUS_MOV_RATE;
		SwitchMode();
		switch(smode){
		case 0:
			OptionSwitch(&g_ShowGrid, 0, 1);
			break;
		case 1:
			OptionSwitch(&g_SnapSwitch, 0, 2);
			g_GridSnap = g_SnapTable[g_SnapSwitch];
			break;
		case 2:
			OptionSwitch(&g_HeightSnap, 0, 1);
			break;
		case 3:
			OptionSwitch(&buildmode, 0, 2);
			break;
		case 4:
			OptionSwitch(&g_KantSwitch, 0, 1);
			break;
		case 5:
			if(OptionSwitch(&g_RailCreate, 0, g_RailOptionModels))
				g_RailOptionModelSelect = g_RailOptionModelSeed->Get(g_RailCreate-1);
			break;
		case 6:
			if(OptionSwitch(&g_TieCreate, 0, g_TieOptionModels))
				g_TieOptionModelSelect = g_TieOptionModelSeed->Get(g_TieCreate-1);
			break;
		case 7:
			if(OptionSwitch(&g_PierCreate, 0, g_PierOptionModels))
				g_PierOptionModelSelect = g_PierOptionModelSeed->Get(g_PierCreate-1);
			break;
		case 8:
			OptionSwitch(&g_LineCreate, 0, 1);
			break;
		}
		if(CheckShift()){
			g_ArrowPos.y -= mtmp*((float)(pos.y)-svw.winH/2)/svw.winH;
		}else{
			g_ArrowPos.x += mtmp*(((float)(pos.x)-svw.winW/2)/svw.winW*sin(-g_CameraDir)+((float)(pos.y)-svw.winH/2)/svw.winH*cos(g_CameraDir));
			g_ArrowPos.z += mtmp*(((float)(pos.x)-svw.winW/2)/svw.winW*cos(g_CameraDir)+((float)(pos.y)-svw.winH/2)/svw.winH*sin(g_CameraDir));
			ValueArea(&g_ArrowPos.x, -g_FWidthX, g_FWidthX);
			ValueArea(&g_ArrowPos.z, -g_FWidthZ, g_FWidthZ);
		}
		ScanUndoRedo();
	}
	SetCursor(svw.winW/2, svw.winH/2);
	g_ArrowPost.x = ((int)(g_ArrowPos.x*g_GridSnap))/g_GridSnap;
	g_ArrowPost.y = g_HeightSnap ? ((int)(g_ArrowPos.y*g_GridSnap))/g_GridSnap
		: ((int)(g_ArrowPos.y*GRID_SNAP_Y))/GRID_SNAP_Y;
	g_ArrowPost.z = ((int)(g_ArrowPos.z*g_GridSnap))/g_GridSnap;
	g_SurfaceObject.Pick(VEC3(g_ArrowPos.x, FIELD_HEIGHT, g_ArrowPos.z), -V3UP, &g_Pick, NULL);
	ValueArea(&g_Pick.y, 0.0f, FIELD_HEIGHT);
	switch(buildmode){
	case 0:
		g_ArrowPos.y = g_ArrowPost.y = g_Pick.y;
		break;
	case 1:
		ValueArea(&g_ArrowPos.y, g_Pick.y, FIELD_HEIGHT);
		ValueArea(&g_ArrowPost.y, g_Pick.y, FIELD_HEIGHT);
		break;
	}
	CameraDistance(&g_CameraDist);
	g_Angle += ARROW_ROTATE;
	ValueCircular(&g_Angle, 0.0f, D3DX_PI*2.0f);
	g_CameraPos = g_CameraPos*(1.0f-PTR_FOLLOW_RATE)
		+VEC3(g_ArrowPost.x, g_ArrowPost.y+CAM_MIN_HIGH, g_ArrowPost.z)*PTR_FOLLOW_RATE;
	ValueArea(&g_CameraPos.y, buildmode<2 ? CAM_MIN_HIGH : -FIELD_HEIGHT, FIELD_HEIGHT);
	SetVPos(VEC3(g_CameraDist*cos(g_CameraDir)*cos(g_CameraBank),
		g_CameraDist*sin(g_CameraBank), g_CameraDist*sin(g_CameraDir)*cos(g_CameraBank)));
	LookAtV(V3ZERO);
	MoveVW(g_CameraPos);
	ArrowSet(&GetVPos(), NULL);
	g_ArrowObject.SetPos(g_ArrowPost);
	g_ArrowObject.SetDir(V3DIR, V3UP);
	g_ArrowObject.RotY(g_Angle);
	g_RailOptionList.TryLink(false);
	BeginScene(g_SkyColor);
	devSetState(D3DRS_ZFUNC, D3DCMP_LESSEQUAL);
	SpinEarth();
	g_RailSelectFlag = 8;
	g_ObjectSelectFlag = 0;
	devSetLighting(true);
	RenderOrder();
	switch(SwitchAlt()){
	case 0:
		ResetMatrix();
		devResetMaterial();
		devSetTexture(0, NULL);
		devSetLighting(false);
		DrawGrid(g_ArrowPost);
		devSetLighting(true);
		g_ArrowObject.Render();
		ResetMatrix();
		devResetMaterial();
		devSetLighting(false);
		g_RailOptionList.ShowLog(g_ArrowPost, g_Pick.y, false);
		Draw3DLine(VEC3(g_ArrowPost.x, g_Pick.y, g_ArrowPost.z), g_ArrowPost, 0xff0000ff, 0x800000ff);
		TextF(5, 15+(1+MAIN_LOG_MAX)*FONT_HEIGHT, "J[\: (%.2f, %.2f, %.2f)", g_ArrowPost.x, g_ArrowPost.y, g_ArrowPost.z);
		TextF(5, 15+(2+MAIN_LOG_MAX)*FONT_HEIGHT, "_S: (%.2f, %.2f, %.2f)", g_CameraPos.x, g_CameraPos.y, g_CameraPos.z);
		TextF(5, 15+(3+MAIN_LOG_MAX)*FONT_HEIGHT, "%sObh\: %s", TextSw(smode, 0), g_ShowGrid ? "L" : "");
		TextF(5, 15+(4+MAIN_LOG_MAX)*FONT_HEIGHT, "%sXibvԊu: %.2f", TextSw(smode, 1), 1.0f/g_GridSnap);
		TextF(5, 15+(5+MAIN_LOG_MAX)*FONT_HEIGHT, "%sXibv: %s", TextSw(smode, 2), g_HeightSnap ? "L" : "");
		TextF(5, 15+(6+MAIN_LOG_MAX)*FONT_HEIGHT, "%sݒu@: %s", TextSw(smode, 3), bmstr[buildmode]);
		TextF(5, 15+(7+MAIN_LOG_MAX)*FONT_HEIGHT, "%sJg: %s", TextSw(smode, 4), kant[g_KantSwitch]);
		TextF(5, 15+(8+MAIN_LOG_MAX)*FONT_HEIGHT, "%s[: <%d/%d>%s", TextSw(smode, 5), g_RailCreate, g_RailOptionModels, g_RailOptionModelSelect ? g_RailOptionModelSelect->GetIndex() : "*none");
		if(g_RailOptionModelSelect) TextF(25, 15+(9+MAIN_LOG_MAX)*FONT_HEIGHT, "%s / %s", g_RailOptionModelSelect->GetName(), g_RailOptionModelSelect->GetAuthor());
		else Text(25, 15+(9+MAIN_LOG_MAX)*FONT_HEIGHT, "-");
		TextF(5, 15+(10+MAIN_LOG_MAX)*FONT_HEIGHT, "%s،: <%d/%d>%s", TextSw(smode, 6), g_TieCreate, g_TieOptionModels, g_TieOptionModelSelect ? g_TieOptionModelSelect->GetIndex() : "*none");
		if(g_TieOptionModelSelect) TextF(25, 15+(11+MAIN_LOG_MAX)*FONT_HEIGHT, "%s / %s", g_TieOptionModelSelect->GetName(), g_TieOptionModelSelect->GetAuthor());
		else Text(25, 15+(11+MAIN_LOG_MAX)*FONT_HEIGHT, "-");
		TextF(5, 15+(12+MAIN_LOG_MAX)*FONT_HEIGHT, "%sr: <%d/%d>%s", TextSw(smode, 7), g_PierCreate, g_PierOptionModels, g_PierOptionModelSelect ? g_PierOptionModelSelect->GetIndex() : "*none");
		if(g_PierOptionModelSelect) TextF(25, 15+(13+MAIN_LOG_MAX)*FONT_HEIGHT, "%s / %s", g_PierOptionModelSelect->GetName(), g_PierOptionModelSelect->GetAuthor());
		else Text(25, 15+(13+MAIN_LOG_MAX)*FONT_HEIGHT, "-");
		TextF(5, 15+(14+MAIN_LOG_MAX)*FONT_HEIGHT, "%sː: %s", TextSw(smode, 8), g_LineCreate ? "L" : "");
		g_GeneralLog.Show();
		g_CornerLog.Show();
		g_RailExpLog.Show();
		RenderMode(false);
		g_ModeLog.Show();
		ShowFPS2();
		devSetLighting(true);
		devSetState(D3DRS_ZFUNC, D3DCMP_ALWAYS);
		RenderMagnet();
		break;
	case 1:
		MiniStatus();
		break;
	}
	EndScene();
	VideoCapture(true);
}

/*
 *	HP[h
 */
void RailRemove(){
	static int rk, lk;
	static POINT pstart;
	float gndalt = 0.0f;
	bool drawrect = false, drawcompass = false;
	VEC3 pp, tgpick;
	POINT pos;
	pos = GetCursorXY();
	if((pos.x!=(svw.winW/2)) || (pos.y!=(svw.winH/2))) rk = lk = 0;
	switch(SDK_GetKey(VK_LBUTTON)){
	case S_PULL:
		if(!CheckShift()) g_RailOptionList.Release();
		if(lk){
			if(ClickMode()){
				if(g_ModeChanged) return;
			}else{
				g_RailSelectFlag = 5;
				g_RailOptionList.Select();
			}
		}else{
			g_RailSelectFlag = 6;
			g_RailOptionList.Select();
		}
		lk = 0;
		break;
	case S_PUSH:
		lk = 1;
		pstart = g_AreaPos1 = g_AreaPos2 = g_Pointer;
		break;
	case S_HOLD:
		g_RailSelectFlag = 6;
		g_AreaPos1 = pstart;
		g_AreaPos2 = g_Pointer;
		if(g_AreaPos1.x>g_AreaPos2.x) Exchange((int *)(&g_AreaPos1.x), (int *)(&g_AreaPos2.x));
		if(g_AreaPos1.y>g_AreaPos2.y) Exchange((int *)(&g_AreaPos1.y), (int *)(&g_AreaPos2.y));
		drawrect = true;
		break;
	default:
		lk = 0;
		g_RailSelectFlag = 5;
		g_AreaPos1 = g_Pointer;
	}
	switch(SDK_GetKey(VK_RBUTTON)){
	case S_PULL:
		if(rk>1){
			rk = 0;
			g_RailOptionList.Delete();
		}else if(rk){
			rk = DCLICK_DURATION;
		}
		break;
	case S_PUSH:
		if(!rk) rk = 1;
		break;
	case S_HOLD:
		if(rk>1) rk--;
		drawcompass = true;
		if(g_SurfaceObject.Pick(VEC3(g_CameraPos.x, FIELD_HEIGHT, g_CameraPos.z), -V3UP, &tgpick, NULL)) gndalt = tgpick.y;
		ValueArea(&tgpick.y, CAM_MIN_HIGH, FIELD_HEIGHT);
		CameraRotate(&pos, &g_CameraDir, &g_CameraBank);
		break;
	default:
		if(rk>1) rk--;
		SwitchMode();
		if(CheckSlide()){
			drawcompass = true;
			gndalt = CameraSlide(&pos, &g_CameraPos);
		}else{
			CursorMove(&pos, &g_PointPos, &g_CameraPos, true);
		}
		if(SDK_GetKey(VK_DELETE)==S_PUSH) g_RailOptionList.Delete();
		if(SDK_GetKey(VK_HOME)==S_PUSH) g_RailOptionList.SwitchAnchor();
		ScanUndoRedo();
	}
	SetCursor(svw.winW/2, svw.winH/2);
	CameraDistance(&g_CameraDist);
	pp = CameraSet(g_CameraDir, g_CameraBank, g_CameraDist, &g_CameraPos, &g_PointPos);
	BeginScene(g_SkyColor);
	devSetState(D3DRS_ZFUNC, D3DCMP_LESSEQUAL);
	SpinEarth();
	g_ObjectSelectFlag = 0;
	g_Pointer = WorldToScreen2(&pp);
	devSetLighting(true);
	RenderOrder();
	switch(SwitchAlt()){
	case 0:
		ResetMatrix();
		devResetMaterial();
		devSetTexture(0, NULL);
		devSetLighting(false);
		if(drawrect) Draw2DRect(g_AreaPos1.x, g_AreaPos1.y, g_AreaPos2.x, g_AreaPos2.y, 0xffff0000);
		TextF(5, 15+(1+MAIN_LOG_MAX)*FONT_HEIGHT, "J[\: (%d, %d)", g_Pointer.x, g_Pointer.y);
		TextF(5, 15+(2+MAIN_LOG_MAX)*FONT_HEIGHT, "_S: (%.2f, %.2f, %.2f)", g_CameraPos.x, g_CameraPos.y, g_CameraPos.z);
		g_GeneralLog.Show();
		g_RailEditExpLog.Show();
		RenderMode(true);
		g_ModeLog.Show();
		ShowFPS2();
		devSetLighting(true);
		devSetState(D3DRS_ZFUNC, D3DCMP_ALWAYS);
		RenderMagnet();
		RenderArrow(drawcompass, gndalt);
		break;
	case 1:
		MiniStatus();
		break;
	}
	EndScene();
	VideoCapture(true);
}
