//	Cu
#include <direct.h>
#include "lib\udx.h"

//	萔E}N
#include "Const.h"
#include "Macro.h"

extern const int RAILSIM_VERSION = 142;	//	݂̃o[W
extern const int SAVE_MAX = 16;			//	t@Cő吔

const int UNDO_MAX = 32;	//	AhDő吔

//	c[֐
#include "SystemCover.h"
#include "SwitchMode.h"
#include "SaveData.h"

//	NX
#include "CLogger.h"
#include "CRailList.h"
#include "CPlugin.h"
#include "CSurfaceModel.h"
#include "CTrainGroup.h"
#include "CTrainGroupList.h"
#include "CStructList.h"
#include "CStationList.h"

//	OO[o
extern int g_MiscOptionUseUndo;
extern int g_SurfaceOptionModels;
extern CSurfaceModel *g_SurfaceOptionModelSeed;
extern CSurfaceModel *g_SurfaceOptionModelSelect;
extern char g_BaseDir[];
extern int g_ModePMode;
extern int g_LengthSwitch;
extern unsigned int g_LengthTable[];
extern unsigned int g_DayLength;	//	Q[ 1 ̃t[
extern unsigned int g_GameCounter;
extern float g_CameraDir;
extern float g_CameraBank;
extern float g_CameraDist;
extern bool g_ModeChanged;
extern VEC3 g_ArrowPos;
extern VEC3 g_ArrowPost;
extern VEC3 g_CameraPos;
extern CObject g_SurfaceObject;
extern CLogger g_GeneralLog;
extern CLogger g_FileLog;
extern CRailList g_RailOptionList;
extern CTrainGroupList g_TrainOptionList;
extern CStructList g_StructOptionList;
extern CStationList g_StationOptionList;

//	O[o
int g_CSVersion;	//	Ǎt@C̃o[W
int g_UndoPos;		//	AhDʒu
int g_UndoNum;		//	AhD
int g_RedoNum;		//	hD

//	֐錾
void SurfaceEdit();
void LoadSurface(char *);

/*
 *	t@CXg쐬
 */
void ListData(){
	char fname[FILE_NAME_MAX], sfname[PLUGIN_NAME_MAX];
	int i, ver, year, month, day, hour, min, sec;
	FILE *datafile;
	chdir(g_BaseDir);
	chdir("Save");
	for(i = 1; i<=SAVE_MAX; i++){
		sprintf(fname, "Save%02d.rsd", i);
		if(datafile = fopen(fname, "r")){
			fscanf(datafile, "Version=%04d\n\n", &ver);
			fscanf(datafile, "Date=%04d/%02d/%02d\n", &year, &month, &day);
			fscanf(datafile, "Time=%02d:%02d:%02d\n\n", &hour, &min, &sec);
			fscanf(datafile, "SurfaceID=%s\n", sfname);
			fscanf(datafile, "SurfaceName=%s\n\n", sfname);
			fclose(datafile);
			g_FileLog.AddF("%02d: V%5.2f %04d/%02d/%02d %02d:%02d:%02d %s", i, ver/100.0f, year, month, day, hour, min, sec, sfname);
		}else{
			g_FileLog.AddF("%02d: o^", i);
		}
	}
}

/*
 *	VKt@C쐬
 */
void MakeData(){
	g_RailOptionList.Destroy();
	g_TrainOptionList.Destroy();
	g_StructOptionList.Destroy();
	g_StationOptionList.Destroy();
	g_ArrowPos = g_ArrowPost = g_CameraPos = V3ZERO;
	g_LengthSwitch = 2;
	g_DayLength = g_LengthTable[g_LengthSwitch];
	g_GameCounter = 0;
	g_ModeChanged = true;
	SetLoopFunc(SurfaceEdit);
	g_GeneralLog.Add("f[^܂B");
	FileResetUndo();
}

/*
 *	t@Cۑ
 */
void SaveData(
	int n,		//	ԍ
	bool undo	//	AhD[h
){
	char fname[FILE_NAME_MAX];
	FILE *datafile;
	time_t ttime;
	tm *ttm;
	chdir(g_BaseDir);
	chdir("Save");
	if(undo) sprintf(fname, "Undo%02d.rsd", ++n);
	else sprintf(fname, "Save%02d.rsd", ++n);
	if(datafile = fopen(fname, "w")){
		time(&ttime);
		ttm = localtime(&ttime);
		fprintf(datafile, "Version=%04d\n\n", RAILSIM_VERSION);
		fprintf(datafile, "Date=%04d/%02d/%02d\n", ttm->tm_year+1900, ttm->tm_mon+1, ttm->tm_mday);
		fprintf(datafile, "Time=%02d:%02d:%02d\n\n", ttm->tm_hour, ttm->tm_min, ttm->tm_sec);
		fprintf(datafile, "SurfaceID=%s\n", g_SurfaceOptionModelSelect->GetIndex());
		fprintf(datafile, "SurfaceName=%s\n\n", g_SurfaceOptionModelSelect->GetName());
		fprintf(datafile, "CameraPos=");
		SaveVec3Data(datafile, g_CameraPos, "\n");
		fprintf(datafile, "CameraInfo=%f,%f,%f\n\n", g_CameraDir, g_CameraBank, g_CameraDist);
		fprintf(datafile, "GameCounter=%d\n", g_GameCounter);
		fprintf(datafile, "LengthSwitch=%d\n\n", g_LengthSwitch);
		g_RailOptionList.SaveData(datafile);
		g_TrainOptionList.SaveData(datafile);
		g_StructOptionList.SaveData(datafile);
		g_StationOptionList.SaveData(datafile);
		fclose(datafile);
		if(!undo) g_GeneralLog.Add("f[^ۑ܂B");
	}else{
		g_GeneralLog.Add("ۑɎs܂!");
	}
	if(!undo) ListData();
}

/*
 *	t@CǍ
 */
void LoadData(
	int n,		//	ԍ
	bool undo	//	AhD[h
){
	char fname[FILE_NAME_MAX], sfname[PLUGIN_NAME_MAX], tmp[PLUGIN_NAME_MAX+256];
	int dummy;
	FILE *datafile;
	chdir(g_BaseDir);
	chdir("Save");
	if(undo) sprintf(fname, "Undo%02d.rsd", ++n);
	else sprintf(fname, "Save%02d.rsd", ++n);
	if(datafile = fopen(fname, "r")){
		fscanf(datafile, "Version=%04d\n\n", &g_CSVersion);
		if(g_CSVersion>RAILSIM_VERSION){
			fclose(datafile);
			g_GeneralLog.Add("̃o[W̃f[^͓ǂݍ߂܂B");
			g_GeneralLog.Add("TCgɂčŐVłmFĂB");
			return;
		}
		g_RailOptionList.Destroy();
		g_TrainOptionList.Destroy();
		g_StructOptionList.Destroy();
		g_StationOptionList.Destroy();
		g_ArrowPos = g_ArrowPost = g_CameraPos = V3ZERO;
		fscanf(datafile, "Date=%04d/%02d/%02d\n", &dummy, &dummy, &dummy);
		fscanf(datafile, "Time=%02d:%02d:%02d\n\n", &dummy, &dummy, &dummy);
		fscanf(datafile, "SurfaceID=%s\n", sfname);
		fscanf(datafile, "SurfaceName=%s\n\n", tmp);
		LoadSurface(sfname);
		if(!g_SurfaceOptionModels){
			fclose(datafile);
			ShowCursor(true);
			Dialog("n`vOC \"%s\" sĂ܂!", sfname);
			ExitProcess(0);
		}
		g_SurfaceOptionModelSelect = g_SurfaceOptionModelSeed;
		g_SurfaceOptionModelSelect->SetGround(&g_SurfaceObject);
		g_SurfaceOptionModelSeed = NULL;
		fscanf(datafile, "CameraPos=");
		LoadVec3Data(datafile, &g_CameraPos, "\n");
		fscanf(datafile, "CameraInfo=%f,%f,%f\n\n", &g_CameraDir, &g_CameraBank, &g_CameraDist);
		if(g_CSVersion>=130){
			fscanf(datafile, "GameCounter=%d\n", &g_GameCounter);
			fscanf(datafile, "LengthSwitch=%d\n\n", &g_LengthSwitch);
			g_DayLength = g_LengthTable[g_LengthSwitch];
		}else{
			g_LengthSwitch = 2;
			g_DayLength = g_LengthTable[g_LengthSwitch];
			g_GameCounter = 0;
		}
		g_RailOptionList.LoadData(datafile);
		g_TrainOptionList.LoadData(datafile);
		g_StructOptionList.LoadData(datafile);
		g_StationOptionList.LoadData(datafile);
		fclose(datafile);
		if(!undo){
			FileResetUndo();
			g_ModePMode = 0;
			RegisterMode(-1, true);
			g_GeneralLog.Add("f[^ǂݍ݂܂B");
		}
	}else{
		g_GeneralLog.Add("f[^܂!");
	}
	if(!undo) ListData();
}

/*
 *	AhD
 */
void FileResetUndo(){
	g_RedoNum = g_UndoNum = g_UndoPos = 0;
}

/*
 *	AhDޔ
 */
void FilePushUndo(){
	if(!g_MiscOptionUseUndo) return;
	SaveData(g_UndoPos, true);
	g_RedoNum = 0;
	g_UndoPos++;
	if(g_UndoPos>=UNDO_MAX) g_UndoPos = 0;
	if(g_UndoNum<UNDO_MAX-1) g_UndoNum++;
}

/*
 *	AhDǍ
 */
void FileLoadUndo(){
	if(!g_MiscOptionUseUndo) return;
	if(g_UndoNum){
		if(!g_RedoNum) SaveData(g_UndoPos, true);
		g_UndoNum--;
		g_RedoNum++;
		g_UndoPos--;
		if(g_UndoPos<0) g_UndoPos = UNDO_MAX-1;
		LoadData(g_UndoPos, true);
		g_GeneralLog.Add("AhD܂B");
	}else{
		g_GeneralLog.Add("AhDł܂!");
	}
}

/*
 *	hDǍ
 */
void FileLoadRedo(){
	if(!g_MiscOptionUseUndo) return;
	if(g_RedoNum){
		g_UndoNum++;
		g_RedoNum--;
		g_UndoPos++;
		if(g_UndoPos>=UNDO_MAX) g_UndoPos = 0;
		LoadData(g_UndoPos, true);
		g_GeneralLog.Add("hD܂B");
	}else{
		g_GeneralLog.Add("hDł܂!");
	}
}

/*
 *	AhDEhDo
 */
void ScanUndoRedo(){
	if(!g_MiscOptionUseUndo) return;
	if(CheckCtrl()){
		if(SDK_GetKey('Z')==S_PUSH) FileLoadUndo();
		if(SDK_GetKey('Y')==S_PUSH) FileLoadRedo();
	}
}
