//	Cu
#include "lib\udx.h"

//	萔E}N
#include "Const.h"
#include "Macro.h"

extern const int MAIN_LOG_MAX;
extern const int STATION_LOG_MAX;
extern const int RAIL_PIER_TYPES;
extern const float ARROW_ROTATE;
extern const float PTR_FOLLOW_RATE;
extern const float GRID_SNAP_Y;

//	c[֐
#include "ValueArea.h"
#include "SystemCover.h"
#include "CameraControl.h"
#include "SwitchMode.h"
#include "SaveData.h"

//	NX
#include "CLogger.h"
#include "CRailList.h"
#include "CTrainGroup.h"
#include "CTrainGroupList.h"
#include "CPlugin.h"
#include "CStructModel.h"
#include "CStationModel.h"
#include "CRailModel.h"
#include "CTieModel.h"
#include "CPierModel.h"
#include "CStructList.h"
#include "CStationList.h"

//	OO[o
extern char g_PierName[][PLUGIN_NAME_MAX];
extern int g_StationOptionModels;
extern int g_StationOptionSelect;
extern int g_StationOptionListID;
extern int g_RailOptionModels;
extern int g_TieOptionModels;
extern int g_PierOptionModels;
extern int g_RailCreate;
extern int g_TieCreate;
extern int g_PierCreate;
extern int g_LineCreate;
extern int g_ModePMode;
extern int g_RailSelectFlag;
extern int g_ObjectSelectFlag;
extern int g_StructDir;
extern int g_SnapSwitch;
extern int g_KantSwitch;
extern int g_ShowGrid;
extern int g_HeightSnap;
extern float g_GridSnap;
extern float g_SnapTable[];
extern float g_CameraDir;
extern float g_CameraBank;
extern float g_CameraDist;
extern float g_FWidthX;
extern float g_FWidthZ;
extern float g_Angle;
extern float g_Blink;
extern bool g_ModeChanged;
extern bool g_RenderMode;
extern POINT g_Pointer;
extern POINT g_AreaPos1;
extern POINT g_AreaPos2;
extern D3DCOLOR g_SkyColor;
extern VEC3 g_ArrowPos;
extern VEC3 g_ArrowPost;
extern VEC3 g_CameraPos;
extern VEC3 g_Pick;
extern VEC3 g_PointPos;
extern CObject g_SurfaceObject;
extern CObject g_StationDisplayObject;
extern CLogger g_GeneralLog;
extern CLogger g_StationLog;
extern CLogger g_StationExpLog;
extern CLogger g_StationSpecLog;
extern CLogger g_DefaultExp2Log;
extern CLogger g_DefaultExp3Log;
extern CLogger g_ModeLog;
extern CStationModel *g_StationOptionModelSeed;
extern CStationModel *g_StationOptionModelSelect;
extern CRailModel *g_RailOptionModelSeed;
extern CRailModel *g_RailOptionModelSelect;
extern CTieModel *g_TieOptionModelSeed;
extern CTieModel *g_TieOptionModelSelect;
extern CPierModel *g_PierOptionModelSeed;
extern CPierModel *g_PierOptionModelSelect;
extern CRailList g_RailOptionList;
extern CTrainGroupList g_TrainOptionList;
extern CStructList g_StructOptionList;
extern CStationList g_StationOptionList;

//	O[o
int g_HomePreview = 1;	//	z[\̕\

//	֐錾
void RenderOrder();
void VideoCapture(bool);

/*
 *	wɑI[h
 */
void StationEdit(){
	static int lk, a_up, a_dn;
	static float se_dir = D3DX_PI*1.75f, se_bank = D3DX_PI/6.0f, se_dist = 30.0f;
	int i;
	bool updatelog = false, drawcompass = false, click = false, dclick = false;
	VEC3 pp;
	POINT pos;
	if(g_ModeChanged){
		a_up = a_dn = 0;
		updatelog = true;
	}
	pos = GetCursorXY();
	if((pos.x!=(svw.winW/2)) || (pos.y!=(svw.winH/2))) lk = 0;
	switch(SDK_GetKey(VK_LBUTTON)){
	case S_PULL:
		if(lk>1){
			lk = 0;
			dclick = true;
		}else if(lk){
			lk = DCLICK_DURATION;
			if(ClickMode()){
				if(g_ModeChanged) return;
			}else{
				click = true;
			}
		}
		break;
	case S_PUSH:
		if(!lk) lk = 1;
		break;
	default:
		if(lk>1) lk--;
		break;
	}
	if(SDK_GetKey(VK_RBUTTON)>=S_PUSH){
		drawcompass = true;
		CameraRotate(&pos, &se_dir, &se_bank);
	}else{
		SwitchMode();
		if(SDK_GetKey(VK_UP)>=S_PUSH){
			a_up++;
			if(a_up==1 || a_up>=LONGPUSH){
				g_StationOptionSelect--;
				updatelog = true;
			}
		}else{
			a_up = 0;
		}
		if(SDK_GetKey(VK_DOWN)>=S_PUSH){
			a_dn++;
			if(a_dn==1 || a_dn>=LONGPUSH){
				g_StationOptionSelect++;
				updatelog = true;
			}
		}else{
			a_dn = 0;
		}
		if(updatelog){
			ValueCircular(&g_StationOptionSelect, 0, g_StationOptionModels-1);
			ValueArea(&g_StationOptionListID, g_StationOptionSelect-STATION_LOG_MAX+4, g_StationOptionSelect);
		}
		CursorMove(&pos, &g_PointPos, &g_CameraPos, true);
	}
	SetCursor(svw.winW/2, svw.winH/2);
	CameraDistance(&se_dist);
	pp = CameraSet(se_dir, se_bank, se_dist, &V3ZERO, &g_PointPos);
	Blink(&g_Blink);
	BeginScene();
	g_RenderMode = false;
	SetDirLight(LIGHT_DEF_DIR, MAKE_CV(1.0f, 1.0f, 1.0f, 1.0f));
	devSetAmbient(0xff808080);
	devSetState(D3DRS_ZFUNC, D3DCMP_LESSEQUAL);
	g_Pointer = WorldToScreen2(&pp);
	devSetLighting(true);
	if(g_StationOptionModels){
		g_StationDisplayObject.SetPos(V3ZERO);
		g_StationDisplayObject.SetDir(V3DIR);
		g_StationDisplayObject.Render();
	}
	ResetMatrix();
	devResetMaterial();
	devSetTexture(0, NULL);
	devSetLighting(false);
	if(g_StationOptionModels) g_StationOptionModelSelect->ShowHome(&V3ZERO, &V3DIR, &V3UP);
	g_GeneralLog.Show();
	for(i = 1; i<STATION_LOG_MAX; i++){
		if(CheckRect(g_Pointer.x, g_Pointer.y, 5, 15+(1+MAIN_LOG_MAX+i)*FONT_HEIGHT, 320, FONT_HEIGHT)){
			Grad2DRect(5, 15+(1+MAIN_LOG_MAX+i)*FONT_HEIGHT, 5+320, 15+(2+MAIN_LOG_MAX+i)*FONT_HEIGHT, 0x8000ff00, 0x8000ff00, 0x0000ff00, 0x0000ff00);
			if(i==1){
				if(click){
					if(STATION_LOG_MAX-3<g_StationOptionModels) g_StationOptionListID = g_StationOptionModels-STATION_LOG_MAX+3;
					updatelog = true;
				}else if(SDK_GetKey(VK_LBUTTON)>=S_PUSH && g_StationOptionListID>0){
					g_StationOptionListID--;
					lk = 0;
					updatelog = true;
				}
			}else if(i==STATION_LOG_MAX-1){
				if(click){
					g_StationOptionListID = 0;
					updatelog = true;
				}else if(SDK_GetKey(VK_LBUTTON)>=S_PUSH && g_StationOptionListID<g_StationOptionModels-STATION_LOG_MAX+3){
					g_StationOptionListID++;
					lk = 0;
					updatelog = true;
				}
			}else if(click && g_StationOptionListID+i-2<g_StationOptionModels){
				g_StationOptionSelect = g_StationOptionListID+i-2;
				updatelog = true;
			}else if(dclick && g_StationOptionListID+i-2<g_StationOptionModels){
				g_ModePMode = 2;
				RegisterMode(1, true);
			}
		}
	}
	if(updatelog){
		g_StationLog.Clear();
		g_StationLog.AddF("p\w(%d/%d)", g_StationOptionSelect+1, g_StationOptionModels);
		g_StationLog.Add(g_StationOptionListID ? "" : "");
		g_StationOptionModelSeed->AddLog(g_StationOptionListID);
		g_StationLog.Add(g_StationOptionListID+STATION_LOG_MAX-3<g_StationOptionModels ? "" : "");
	}
	g_StationLog.Show();
	g_StationExpLog.Show();
	g_StationSpecLog.Show();
	RenderMode(true);
	g_ModeLog.Show();
	ShowFPS2();
	devSetLighting(true);
	devSetState(D3DRS_ZFUNC, D3DCMP_ALWAYS);
	if(!drawcompass) RenderArrow(false, 0.0f);
	EndScene();
	VideoCapture(false);
}

/*
 *	wɐݒu[h
 */
void StationCreate(){
	static char *bmstr[3] = {"n\", "ΖʌX", "Rx"};
	static char *kant[2] = {"", "S"};
	static int rk, lk, smode, buildmode;
	static int anchor = 1;
	float mtmp;
	bool click = false;
	POINT pos;
	VEC3 sd, tri[3], norm(V3UP);
	pos = GetCursorXY();
	if(SDK_GetKey(VK_UP)==S_PUSH) smode--;
	if(SDK_GetKey(VK_DOWN)==S_PUSH) smode++;
	ValueCircular(&smode, 0, 11);
	if((pos.x!=(svw.winW/2)) || (pos.y!=(svw.winH/2))) rk = lk = 0;
	switch(SDK_GetKey(VK_LBUTTON)){
	case S_PUSH:
		lk = 1;
		break;
	case S_PULL:
		if(lk) click = true;
	}
	switch(SDK_GetKey(VK_RBUTTON)){
	case S_PULL:
		if(rk>1){
			rk = 0;
			RegisterMode(-1, true);
		}else if(rk){
			rk = DCLICK_DURATION;
		}
		break;
	case S_PUSH:
		if(!rk) rk = 1;
		break;
	case S_HOLD:
		CameraRotate(&pos, &g_CameraDir, &g_CameraBank);
		break;
	default:
		if(rk>1) rk--;
		if(CheckCtrl()) mtmp = FAST_MOV_RATE*CUS_MOV_RATE; else mtmp = CUS_MOV_RATE;
		SwitchMode();
		switch(smode){
		case 0:
			if(CheckShift()){
				g_StructDir &= ~15;
				if(SDK_GetKey(VK_RIGHT)==S_PUSH) g_StructDir -= 16;
				if(SDK_GetKey(VK_LEFT)==S_PUSH) g_StructDir += 16;
			}else{
				if(SDK_GetKey(VK_RIGHT)>=S_PUSH) g_StructDir--;
				if(SDK_GetKey(VK_LEFT)>=S_PUSH) g_StructDir++;
			}
			g_StructDir &= 127;
			break;
		case 1:
			OptionSwitch(&g_ShowGrid, 0, 1);
			break;
		case 2:
			OptionSwitch(&g_SnapSwitch, 0, 2);
			g_GridSnap = g_SnapTable[g_SnapSwitch];
			break;
		case 3:
			OptionSwitch(&g_HeightSnap, 0, 1);
			break;
		case 4:
			OptionSwitch(&buildmode, 0, 2);
			break;
		case 5:
			OptionSwitch(&g_KantSwitch, 0, 1);
			break;
		case 6:
			OptionSwitch(&anchor, 0, 1);
			break;
		case 7:
			if(OptionSwitch(&g_RailCreate, 0, g_RailOptionModels))
				g_RailOptionModelSelect = g_RailOptionModelSeed->Get(g_RailCreate-1);
			break;
		case 8:
			if(OptionSwitch(&g_TieCreate, 0, g_TieOptionModels))
				g_TieOptionModelSelect = g_TieOptionModelSeed->Get(g_TieCreate-1);
			break;
		case 9:
			if(OptionSwitch(&g_PierCreate, 0, g_PierOptionModels))
				g_PierOptionModelSelect = g_PierOptionModelSeed->Get(g_PierCreate-1);
			break;
		case 10:
			OptionSwitch(&g_LineCreate, 0, 1);
			break;
		case 11:
			OptionSwitch(&g_HomePreview, 0, 1);
			break;
		}
		if(buildmode==2 && CheckShift()){
			g_ArrowPos.y -= mtmp*((float)(pos.y)-svw.winH/2)/svw.winH;
		}else{
			g_ArrowPos.x += mtmp*(((float)(pos.x)-svw.winW/2)/svw.winW*sin(-g_CameraDir)+((float)(pos.y)-svw.winH/2)/svw.winH*cos(g_CameraDir));
			g_ArrowPos.z += mtmp*(((float)(pos.x)-svw.winW/2)/svw.winW*cos(g_CameraDir)+((float)(pos.y)-svw.winH/2)/svw.winH*sin(g_CameraDir));
			ValueArea(&g_ArrowPos.x, -g_FWidthX, g_FWidthX);
			ValueArea(&g_ArrowPos.z, -g_FWidthZ, g_FWidthZ);
		}
		ScanUndoRedo();
	}
	SetCursor(svw.winW/2, svw.winH/2);
	g_ArrowPost.x = ((int)(g_ArrowPos.x*g_GridSnap))/g_GridSnap;
	g_ArrowPost.y = g_HeightSnap ? ((int)(g_ArrowPos.y*g_GridSnap))/g_GridSnap
		: ((int)(g_ArrowPos.y*GRID_SNAP_Y))/GRID_SNAP_Y;
	g_ArrowPost.z = ((int)(g_ArrowPos.z*g_GridSnap))/g_GridSnap;
	if(buildmode<2){
		if(g_SurfaceObject.Pick(VEC3(g_ArrowPos.x, FIELD_HEIGHT, g_ArrowPos.z), -V3UP, &g_Pick, tri) && buildmode==1) CalcNormal(tri, &norm);
		ValueArea(&g_Pick.y, 0.0f, FIELD_HEIGHT);
		g_ArrowPos.y = g_ArrowPost.y = g_Pick.y;
	}else{
		if(!g_SurfaceObject.Pick(VEC3(g_ArrowPos.x, FIELD_HEIGHT, g_ArrowPos.z), -V3UP, &g_Pick, tri)) g_Pick = V3ZERO;
	}
	CameraDistance(&g_CameraDist);
	g_Angle += ARROW_ROTATE;
	ValueCircular(&g_Angle, 0.0f, D3DX_PI*2.0f);
	sd = VEC3(cos(g_StructDir*D3DX_PI/64), 0.0f, sin(g_StructDir*D3DX_PI/64));
	if(buildmode==1) sd -= norm*V3Dot(&norm, &sd);
	if(click) g_StationOptionList.Add(g_StationOptionModelSelect, &g_ArrowPost, &sd, &norm, !!anchor);
	g_CameraPos = g_CameraPos*(1.0f-PTR_FOLLOW_RATE)
		+VEC3(g_ArrowPos.x, g_ArrowPos.y+CAM_MIN_HIGH, g_ArrowPos.z)*PTR_FOLLOW_RATE;
	SetVPos(VEC3(g_CameraDist*cos(g_CameraDir)*cos(g_CameraBank),
		g_CameraDist*sin(g_CameraBank), g_CameraDist*sin(g_CameraDir)*cos(g_CameraBank)));
	LookAtV(V3ZERO);
	MoveVW(g_CameraPos);
	ArrowSet(&GetVPos(), NULL);
	Blink(&g_Blink);
	BeginScene(g_SkyColor);
	devSetState(D3DRS_ZFUNC, D3DCMP_LESSEQUAL);
	SpinEarth();
	g_RailSelectFlag = 0;
	g_ObjectSelectFlag = 0;
	devSetLighting(true);
	RenderOrder();
	switch(SwitchAlt()){
	case 0:
		g_StationDisplayObject.SetPos(g_ArrowPost);
		g_StationDisplayObject.SetDir(sd, norm);
		g_StationDisplayObject.SetAlphaAlt(BlinkToAlpha(g_Blink));
		g_StationDisplayObject.RenderA();
		ResetMatrix();
		devResetMaterial();
		devSetTexture(0, NULL);
		devSetLighting(false);
		DrawGrid(g_ArrowPost);
		if(g_StationOptionModels) g_StationOptionModelSelect->ShowHome(&g_ArrowPost, &sd, &norm);
		if(buildmode==2) Draw3DLine(VEC3(g_ArrowPost.x, g_Pick.y, g_ArrowPost.z), g_ArrowPost, 0xff0000ff, 0x800000ff);
		TextF(5, 15+(1+MAIN_LOG_MAX)*FONT_HEIGHT, "J[\: (%.2f, %.2f, %.2f)", g_ArrowPost.x, g_ArrowPost.y, g_ArrowPost.z);
		TextF(5, 15+(2+MAIN_LOG_MAX)*FONT_HEIGHT, "_S: (%.2f, %.2f, %.2f)", g_CameraPos.x, g_CameraPos.y, g_CameraPos.z);
		TextF(5, 15+(3+MAIN_LOG_MAX)*FONT_HEIGHT, "%sݒupx: %d/64[rad]", TextSw(smode, 0), g_StructDir);
		TextF(5, 15+(4+MAIN_LOG_MAX)*FONT_HEIGHT, "%sObh\: %s", TextSw(smode, 1), g_ShowGrid ? "L" : "");
		TextF(5, 15+(5+MAIN_LOG_MAX)*FONT_HEIGHT, "%sXibvԊu: %.2f", TextSw(smode, 2), 1.0f/g_GridSnap);
		TextF(5, 15+(6+MAIN_LOG_MAX)*FONT_HEIGHT, "%sXibv: %s", TextSw(smode, 3), g_HeightSnap ? "L" : "");
		TextF(5, 15+(7+MAIN_LOG_MAX)*FONT_HEIGHT, "%sݒu@: %s", TextSw(smode, 4), bmstr[buildmode]);
		TextF(5, 15+(8+MAIN_LOG_MAX)*FONT_HEIGHT, "%sJg: %s", TextSw(smode, 5), kant[g_KantSwitch]);
		TextF(5, 15+(9+MAIN_LOG_MAX)*FONT_HEIGHT, "%sAJ[: %s", TextSw(smode, 6), anchor ? "L" : "");
		TextF(5, 15+(10+MAIN_LOG_MAX)*FONT_HEIGHT, "%s[: <%d/%d>%s", TextSw(smode, 7), g_RailCreate, g_RailOptionModels, g_RailOptionModelSelect ? g_RailOptionModelSelect->GetIndex() : "*none");
		if(g_RailOptionModelSelect) TextF(25, 15+(11+MAIN_LOG_MAX)*FONT_HEIGHT, "%s / %s", g_RailOptionModelSelect->GetName(), g_RailOptionModelSelect->GetAuthor());
		else Text(25, 15+(11+MAIN_LOG_MAX)*FONT_HEIGHT, "-");
		TextF(5, 15+(12+MAIN_LOG_MAX)*FONT_HEIGHT, "%s،: <%d/%d>%s", TextSw(smode, 8), g_TieCreate, g_TieOptionModels, g_TieOptionModelSelect ? g_TieOptionModelSelect->GetIndex() : "*none");
		if(g_TieOptionModelSelect) TextF(25, 15+(13+MAIN_LOG_MAX)*FONT_HEIGHT, "%s / %s", g_TieOptionModelSelect->GetName(), g_TieOptionModelSelect->GetAuthor());
		else Text(25, 15+(13+MAIN_LOG_MAX)*FONT_HEIGHT, "-");
		TextF(5, 15+(14+MAIN_LOG_MAX)*FONT_HEIGHT, "%sr: <%d/%d>%s", TextSw(smode, 9), g_PierCreate, g_PierOptionModels, g_PierOptionModelSelect ? g_PierOptionModelSelect->GetIndex() : "*none");
		if(g_PierOptionModelSelect) TextF(25, 15+(15+MAIN_LOG_MAX)*FONT_HEIGHT, "%s / %s", g_PierOptionModelSelect->GetName(), g_PierOptionModelSelect->GetAuthor());
		else Text(25, 15+(15+MAIN_LOG_MAX)*FONT_HEIGHT, "-");
		TextF(5, 15+(16+MAIN_LOG_MAX)*FONT_HEIGHT, "%sː: %s", TextSw(smode, 10), g_LineCreate ? "L" : "");
		TextF(5, 15+(17+MAIN_LOG_MAX)*FONT_HEIGHT, "%sz[\: %s", TextSw(smode, 11), g_HomePreview ? "L" : "");
		g_GeneralLog.Show();
		g_DefaultExp2Log.Show();
		RenderMode(false);
		g_ModeLog.Show();
		ShowFPS2();
		devSetLighting(true);
		devSetState(D3DRS_ZFUNC, D3DCMP_ALWAYS);
		RenderMagnet();
		break;
	case 1:
		MiniStatus();
		break;
	}
	EndScene();
	VideoCapture(true);
}

/*
 *	wɓP
 */
void StationRemove(){
	static int rk, lk;
	static POINT pstart;
	float gndalt = 0.0f;
	bool drawrect = false, drawcompass = false;
	VEC3 pp, tgpick;
	POINT pos;
	pos = GetCursorXY();
	if((pos.x!=(svw.winW/2)) || (pos.y!=(svw.winH/2))) rk = lk = 0;
	switch(SDK_GetKey(VK_LBUTTON)){
	case S_PULL:
		if(!CheckShift()) g_StationOptionList.Release();
		if(lk){
			if(ClickMode()){
				if(g_ModeChanged) return;
			}else{
				g_ObjectSelectFlag = 5;
				g_StationOptionList.Select();
			}
		}else{
			g_ObjectSelectFlag = 6;
			g_StationOptionList.Select();
		}
		lk = 0;
		break;
	case S_PUSH:
		lk = 1;
		pstart = g_AreaPos1 = g_AreaPos2 = g_Pointer;
		break;
	case S_HOLD:
		g_ObjectSelectFlag = 6;
		g_AreaPos1 = pstart;
		g_AreaPos2 = g_Pointer;
		if(g_AreaPos1.x>g_AreaPos2.x) Exchange((int *)(&g_AreaPos1.x), (int *)(&g_AreaPos2.x));
		if(g_AreaPos1.y>g_AreaPos2.y) Exchange((int *)(&g_AreaPos1.y), (int *)(&g_AreaPos2.y));
		drawrect = true;
		break;
	default:
		lk = 0;
		g_ObjectSelectFlag = 5;
		g_AreaPos1 = g_Pointer;
	}
	switch(SDK_GetKey(VK_RBUTTON)){
	case S_PULL:
		if(rk>1){
			rk = 0;
			g_StationOptionList.Delete();
		}else if(rk){
			rk = DCLICK_DURATION;
		}
		break;
	case S_PUSH:
		if(!rk) rk = 1;
		break;
	case S_HOLD:
		if(rk>1) rk--;
		drawcompass = true;
		if(g_SurfaceObject.Pick(VEC3(g_CameraPos.x, FIELD_HEIGHT, g_CameraPos.z), -V3UP, &tgpick, NULL)) gndalt = tgpick.y;
		ValueArea(&tgpick.y, CAM_MIN_HIGH, FIELD_HEIGHT);
		CameraRotate(&pos, &g_CameraDir, &g_CameraBank);
		break;
	default:
		if(rk>1) rk--;
		SwitchMode();
		if(CheckSlide()){
			drawcompass = true;
			gndalt = CameraSlide(&pos, &g_CameraPos);
		}else{
			CursorMove(&pos, &g_PointPos, &g_CameraPos, true);
		}
		if(SDK_GetKey(VK_DELETE)==S_PUSH) g_StationOptionList.Delete();
		ScanUndoRedo();
	}
	SetCursor(svw.winW/2, svw.winH/2);
	CameraDistance(&g_CameraDist);
	pp = CameraSet(g_CameraDir, g_CameraBank, g_CameraDist, &g_CameraPos, &g_PointPos);
	Blink(&g_Blink);
	BeginScene(g_SkyColor);
	devSetState(D3DRS_ZFUNC, D3DCMP_LESSEQUAL);
	SpinEarth();
	g_RailSelectFlag = 0;
	g_Pointer = WorldToScreen2(&pp);
	devSetLighting(true);
	RenderOrder();
	switch(SwitchAlt()){
	case 0:
		ResetMatrix();
		devResetMaterial();
		devSetTexture(0, NULL);
		devSetLighting(false);
		if(drawrect) Draw2DRect(g_AreaPos1.x, g_AreaPos1.y, g_AreaPos2.x, g_AreaPos2.y, 0xffff0000);
		TextF(5, 15+(1+MAIN_LOG_MAX)*FONT_HEIGHT, "J[\: (%d, %d)", g_Pointer.x, g_Pointer.y);
		TextF(5, 15+(2+MAIN_LOG_MAX)*FONT_HEIGHT, "_S: (%.2f, %.2f, %.2f)", g_CameraPos.x, g_CameraPos.y, g_CameraPos.z);
		g_GeneralLog.Show();
		g_DefaultExp3Log.Show();
		RenderMode(true);
		g_ModeLog.Show();
		ShowFPS2();
		devSetLighting(true);
		devSetState(D3DRS_ZFUNC, D3DCMP_ALWAYS);
		RenderMagnet();
		RenderArrow(drawcompass, gndalt);
		break;
	case 1:
		MiniStatus();
		break;
	}
	EndScene();
	VideoCapture(true);
}
