//	Cu
#include <io.h>
#include <direct.h>
#include "lib\udx.h"

//	萔E}N
#include "Const.h"
#include "Macro.h"

extern const int MAIN_LOG_MAX;
extern const int SURFACE_LOG_MAX;

//	c[֐
#include "ValueArea.h"
#include "SystemCover.h"
#include "CameraControl.h"
#include "SwitchMode.h"

//	NX
#include "CLogger.h"
#include "CPlugin.h"
#include "CSurfaceModel.h"

//	OO[o
extern int g_SurfaceOptionModels;
extern int g_SurfaceOptionSelect;
extern int g_SurfaceOptionListID;
extern CSurfaceModel *g_SurfaceOptionModelSeed;
extern CSurfaceModel *g_SurfaceOptionModelSelect;
extern CSurfaceModel **g_SurfaceOptionModelNext;
extern char g_BaseDir[];
extern int g_ModePMode;
extern float g_Angle;
extern float g_Blink;
extern bool g_ModeChanged;
extern bool g_RenderMode;
extern POINT g_Pointer;
extern VEC3 g_CameraPos;
extern VEC3 g_PointPos;
extern CObject g_SurfaceDisplayObject;
extern CObject g_SurfaceObject;
extern CLogger g_GeneralLog;
extern CLogger g_SurfaceLog;
extern CLogger g_SurfaceExpLog;
extern CLogger g_SurfaceSpecLog;

//	֐錾
void LoadSurface(char *);
void VideoCapture(bool);

/*
 *	VKn`I[h
 */
void SurfaceEdit(){
	static int lk, a_up, a_dn;
	static float ge_dir = D3DX_PI*1.75f, ge_bank = D3DX_PI/6.0f, ge_dist = 50.0f;
	int i;
	bool updatelog = false, drawcompass = false, click = false, dclick = false;
	VEC3 pp;
	POINT pos;
	if(g_ModeChanged){
		a_up = a_dn = 0;
		g_ModeChanged = false;
		updatelog = true;
		g_SurfaceDisplayObject.SetMesh(NULL);
		LoadSurface(NULL);
	}
	pos = GetCursorXY();
	if((pos.x!=(svw.winW/2)) || (pos.y!=(svw.winH/2))) lk = 0;
	switch(SDK_GetKey(VK_LBUTTON)){
	case S_PULL:
		if(lk>1){
			lk = 0;
			dclick = true;
		}else if(lk){
			lk = DCLICK_DURATION;
			click = true;
		}
		break;
	case S_PUSH:
		if(!lk) lk = 1;
		break;
	default:
		if(lk>1) lk--;
		break;
	}
	if(SDK_GetKey(VK_RBUTTON)>=S_PUSH){
		drawcompass = true;
		CameraRotate(&pos, &ge_dir, &ge_bank);
	}else{
		if(SDK_GetKey(VK_UP)>=S_PUSH){
			a_up++;
			if(a_up==1 || a_up>=LONGPUSH){
				g_SurfaceOptionSelect--;
				updatelog = true;
			}
		}else{
			a_up = 0;
		}
		if(SDK_GetKey(VK_DOWN)>=S_PUSH){
			a_dn++;
			if(a_dn==1 || a_dn>=LONGPUSH){
				g_SurfaceOptionSelect++;
				updatelog = true;
			}
		}else{
			a_dn = 0;
		}
		if(updatelog){
			ValueCircular(&g_SurfaceOptionSelect, 0, g_SurfaceOptionModels-1);
			ValueArea(&g_SurfaceOptionListID, g_SurfaceOptionSelect-SURFACE_LOG_MAX+4, g_SurfaceOptionSelect);
		}
		if(SDK_GetKey(VK_SPACE)==S_PUSH){
			g_SurfaceOptionModelSelect->SetGround(&g_SurfaceObject);
			g_SurfaceOptionModelSeed->Destroy();
			g_SurfaceOptionModelSeed = NULL;
			g_GeneralLog.Add("VK}bv쐬܂B");
			g_ModePMode = 0;
			RegisterMode(-1, true);
			return;
		}
		CursorMove(&pos, &g_PointPos, &g_CameraPos, false);
	}
	SetCursor(svw.winW/2, svw.winH/2);
	CameraDistance(&ge_dist);
	pp = CameraSet(ge_dir, ge_bank, ge_dist, &V3ZERO, &g_PointPos);
	Blink(&g_Blink);
	BeginScene();
	g_RenderMode = false;
	SetDirLight(LIGHT_DEF_DIR, MAKE_CV(1.0f, 1.0f, 1.0f, 1.0f));
	devSetAmbient(0xff808080);
	devSetState(D3DRS_ZFUNC, D3DCMP_LESSEQUAL);
	g_Pointer = WorldToScreen2(&pp);
	devSetLighting(true);
	if(g_SurfaceOptionModels){
		g_SurfaceDisplayObject.SetPos(V3ZERO);
		g_SurfaceDisplayObject.SetDir(V3DIR);
		g_SurfaceDisplayObject.Render();
	}
	ResetMatrix();
	devResetMaterial();
	devSetTexture(0, NULL);
	devSetLighting(false);
	g_GeneralLog.Show();
	for(i = 1; i<SURFACE_LOG_MAX; i++){
		if(CheckRect(g_Pointer.x, g_Pointer.y, 5, 15+(1+MAIN_LOG_MAX+i)*FONT_HEIGHT, 320, FONT_HEIGHT)){
			Grad2DRect(5, 15+(1+MAIN_LOG_MAX+i)*FONT_HEIGHT, 5+320, 15+(2+MAIN_LOG_MAX+i)*FONT_HEIGHT, 0x8000ff00, 0x8000ff00, 0x0000ff00, 0x0000ff00);
			if(i==1){
				if(click){
					if(SURFACE_LOG_MAX-3<g_SurfaceOptionModels) g_SurfaceOptionListID = g_SurfaceOptionModels-SURFACE_LOG_MAX+3;
					updatelog = true;
				}else if(SDK_GetKey(VK_LBUTTON)>=S_PUSH && g_SurfaceOptionListID>0){
					g_SurfaceOptionListID--;
					lk = 0;
					updatelog = true;
				}
			}else if(i==SURFACE_LOG_MAX-1){
				if(click){
					g_SurfaceOptionListID = 0;
					updatelog = true;
				}else if(SDK_GetKey(VK_LBUTTON)>=S_PUSH && g_SurfaceOptionListID<g_SurfaceOptionModels-SURFACE_LOG_MAX+3){
					g_SurfaceOptionListID++;
					lk = 0;
					updatelog = true;
				}
			}else if(click && g_SurfaceOptionListID+i-2<g_SurfaceOptionModels){
				g_SurfaceOptionSelect = g_SurfaceOptionListID+i-2;
				updatelog = true;
			}else if(dclick && g_SurfaceOptionListID+i-2<g_SurfaceOptionModels){
				g_SurfaceOptionModelSelect->SetGround(&g_SurfaceObject);
				g_SurfaceOptionModelSeed->Destroy();
				g_SurfaceOptionModelSeed = NULL;
				g_GeneralLog.Add("VK}bv쐬܂B");
				g_ModePMode = 0;
				RegisterMode(-1, true);
				return;
			}
		}
	}
	if(updatelog){
		g_SurfaceLog.Clear();
		g_SurfaceLog.AddF("p\n`(%d/%d)", g_SurfaceOptionSelect+1, g_SurfaceOptionModels);
		g_SurfaceLog.Add(g_SurfaceOptionListID ? "" : "");
		g_SurfaceOptionModelSeed->AddLog(g_SurfaceOptionListID);
		g_SurfaceLog.Add(g_SurfaceOptionListID+SURFACE_LOG_MAX-3<g_SurfaceOptionModels ? "" : "");
	}
	g_SurfaceLog.Show();
	g_SurfaceExpLog.Show();
	g_SurfaceSpecLog.Show();
	ShowFPS(5, 5);
	devSetLighting(true);
	devSetState(D3DRS_ZFUNC, D3DCMP_ALWAYS);
	if(!drawcompass) RenderArrow(false, 0.0f);
	EndScene();
	VideoCapture(false);
}

/*
 *	Sn`Ǎ
 */
void LoadSurface(
	char *na	//	fBNg
){
	long filelist;
	_finddata_t data;
	FILE *fname;
	if(g_SurfaceOptionModelSelect) delete g_SurfaceOptionModelSelect;
	g_SurfaceOptionModels = 0;
	g_SurfaceOptionSelect = 0;
	g_SurfaceOptionListID = 0;
	g_SurfaceOptionModelSeed = NULL;
	g_SurfaceOptionModelSelect = NULL;
	g_SurfaceOptionModelNext = &g_SurfaceOptionModelSeed;
	chdir(g_BaseDir);
	chdir("Surface");
	if((filelist = _findfirst("*", &data))>=0){
		do{
			chdir(g_BaseDir);
			chdir("Surface");
			if(!(data.attrib&_A_SUBDIR)) continue;
			if(na) if(_mbsicmp((const unsigned char *)data.name, (const unsigned char *)na)) continue;
			chdir(data.name);
			if(!(fname = fopen("Model.x", "r"))) continue;
			fclose(fname);
			if(!(fname = fopen("Surface.txt", "r"))) continue;
			new CSurfaceModel(data.name, fname, false);
			fclose(fname);
			if(na) break;
		} while(!_findnext(filelist, &data));
	}
	_findclose(filelist);
	chdir(g_BaseDir);
	if(!g_SurfaceOptionModels){
		ShowCursor(true);
		Dialog("p\Ȓn`܂!");
		ExitProcess(0);
	}
	g_SurfaceOptionModelSeed->MergeSort((CPlugin **)&g_SurfaceOptionModelSeed, NULL, 0);
}
