//	Cu
#include "lib\udx.h"

//	萔E}N
#include "Const.h"

extern const int MODE_NUMBER = 5;		//	[hO[v
extern const int SUBMODE_NUMBER = 5;	//	O[vő僂[h +1 (NULL ZeBl)
extern const int PANEL_WIDTH = 128;		//	plS̕
extern const int PANEL_UNIT = 16;		//	plPʍ

//	c[֐
#include "ValueArea.h"
#include "SystemCover.h"
#include "SwitchMode.h"

//	NX
#include "CLogger.h"

//	OO[o
extern POINT g_Pointer;
extern VEC3 g_ArrowPos;
extern VEC3 g_CameraPos;
extern CTexture g_InterfaceTexture;
extern CLogger g_GeneralLog;
extern CLogger g_ModeLog;

//	O[o
bool g_ModeChanged = false;	//	[hύXtO

//	֐錾
void Neutral();
void RailCreate();
void RailRemove();
void TrainEdit();
void TrainDia();
void TrainSet();
void TrainView();
void StationEdit();
void StationCreate();
void StationRemove();
void StructEdit();
void StructCreate();
void StructRemove();
void System();
void Settings();
void VideoControl();
void ExitDialog();

int g_ModePMode;				//	ݓWJ\Ă郂[hO[v
int g_ModePPM;					//	݂̃[h郂[hO[v
int g_ModeSMode[MODE_NUMBER+1];	//	e[hO[v̂LɂȂĂ郂[h
int g_ModeMenu[16];				//	\[hXg̃[h
void (*g_ModeFunc[MODE_NUMBER][SUBMODE_NUMBER])() = {
	{	RailCreate,		RailRemove,		NULL,			NULL,		NULL	},
	{	TrainEdit,		TrainDia,		TrainSet,		TrainView,	NULL	},
	{	StationEdit,	StationCreate,	StationRemove,	NULL,		NULL	},
	{	StructEdit,		StructCreate,	StructRemove,	NULL,		NULL	},
	{	System,			Settings,		VideoControl,	ExitDialog,	NULL	}
};								//	[hXg

/*
 *	[h̐ݒ
 */
bool RegisterMode(
	int m,		//	[hO[vԍ
	bool sub	//	[hԍ
){
	static char *keys[MODE_NUMBER] = {
		"F1",	"F2",	"F3",	"F4",	"F5"
	};
	static char *subkeys[SUBMODE_NUMBER] = {
		"1",	"2",	"3",	"4",	"5"
	};
	static char *mode[MODE_NUMBER] = {
		"H",	"q",	"wɑ",	"{ݑ",	"VXe"
	};
	static char *submode[MODE_NUMBER][SUBMODE_NUMBER] = {
		{	"Hݒu",	"HP"	},
		{	"qҐ",	"^sݒ",	"qzu",	"q_"},
		{	"wɑI",	"wɐݒu",	"wɓP"},
		{	"{ݑI",	"{ݐݒu",	"{ݓP"},
		{	"t@C",	"ݒ",	"rfI",	"I"	}
	};
	int i, j, k = 0;
	if(sub){
		if(m<0){
			g_ModePPM = MODE_NUMBER;
			g_ModeSMode[g_ModePMode] = SUBMODE_NUMBER;
		}else{
			if(!g_ModeFunc[g_ModePMode][m]) return false;
			g_ModeSMode[g_ModePMode] = m;
			g_ModePPM = g_ModePMode;
		}
	}else{
		g_ModePMode = m;
	}
	g_ModeLog.Clear();
	g_ArrowPos.x = g_CameraPos.x;
	g_ArrowPos.y = g_CameraPos.y-CAM_MIN_HIGH;
	g_ArrowPos.z = g_CameraPos.z;
	for(i = 0; i<MODE_NUMBER; i++){
		g_ModeLog.AddF("%s: %s", keys[i], mode[i]);
		g_ModeMenu[k++] = 10*(i+1);
		if(i==g_ModePMode){
			for(j = 0; g_ModeFunc[g_ModePMode][j]; j++){
				g_ModeLog.AddF("@%s: %s", subkeys[j], submode[g_ModePMode][j]);
				g_ModeMenu[k++] = 10*(i+1)+j+1;
			}
		}else if(i==g_ModePPM){
			g_ModeLog.AddF("@-: %s", submode[g_ModePPM][g_ModeSMode[g_ModePPM]]);
			g_ModeMenu[k++] = 10*(i+1)+g_ModeSMode[g_ModePPM]+1;
		}
	}
	for(j -= (g_ModePPM==g_ModePMode); j<SUBMODE_NUMBER; j++) g_ModeLog.Add("");
	if(g_ModePPM==MODE_NUMBER) g_ModeLog.Add("");
	g_ModeMenu[k] = 0;
	if(sub){
		if(m<0){
			g_GeneralLog.AddF("[h: j[g");
			SetLoopFunc(Neutral);
		}else{
			g_GeneralLog.AddF("[h: %s@%s", submode[g_ModePMode][g_ModeSMode[g_ModePMode]], mode[g_ModePMode]);
			SetLoopFunc(g_ModeFunc[g_ModePMode][g_ModeSMode[g_ModePMode]]);
		}
		g_ModeChanged = true;

	}
	return true;
}

/*
 *	L[͂ɂ郂[h̕ύX
 */
void SwitchMode(){
	static int keys[MODE_NUMBER] = {
		VK_F1,	VK_F2,	VK_F3,	VK_F4,	VK_F5
	};
	static int subkeys[SUBMODE_NUMBER] = {
		'1',	'2',	'3',	'4',	'5'
	};
	int i;
	for(i = 0; i<MODE_NUMBER; i++)
		if(SDK_GetKey(keys[i])==S_PUSH)
			if(RegisterMode(i, false)) return;
	for(i = 0; i<SUBMODE_NUMBER; i++)
		if(SDK_GetKey(subkeys[i])==S_PUSH)
			if(RegisterMode(i, true)) return;
	if(SDK_GetKey(VK_ESCAPE)==S_PUSH){
		RegisterMode(-1, true);
		return;
	}
	g_ModeChanged = false;
}

/*
 *	}EX͂ɂ郂[h̕ύX
 */
bool ClickMode(){
	int k, ofsx = DISP_WIDTH-PANEL_WIDTH-5, ofsy = 5;
	for(k = 0; g_ModeMenu[k]; k++){
		if(CheckRect(g_Pointer.x, g_Pointer.y, ofsx, ofsy+k*PANEL_UNIT, PANEL_WIDTH, PANEL_UNIT)){
			int main = g_ModeMenu[k]/10-1, sub = g_ModeMenu[k]%10-1;
			if(g_ModePPM==main && g_ModeSMode[g_ModePPM]==sub){
				RegisterMode(-1, true);
			}else{
				if(sub>=0){
					g_ModePMode = main;
					RegisterMode(sub, true);
				}else{
					RegisterMode(main, false);
				}
			}
			return true;
		}
	}
	return false;
}

/*
 *	[hXg̕\
 */
void RenderMode(
	bool focus	//	tH[JX\tO
){
	int i, j, k = 0, ofsx = DISP_WIDTH-PANEL_WIDTH-5, ofsy = 5;
	devSetTexture(0, NULL);
	for(i = 0; i<MODE_NUMBER; i++){
		if(i==g_ModePMode){
			TextureBlt(&g_InterfaceTexture, ofsx, ofsy+k*PANEL_UNIT,
				PANEL_WIDTH, PANEL_UNIT, 0, PANEL_UNIT*2, PANEL_WIDTH, PANEL_UNIT);
			k++;
			for(j = 0; g_ModeFunc[g_ModePMode][j]; j++){
				if(i==g_ModePPM && j==g_ModeSMode[g_ModePPM]){
					TextureBlt(&g_InterfaceTexture, ofsx, ofsy+k*PANEL_UNIT,
						PANEL_WIDTH, PANEL_UNIT, 0, PANEL_UNIT*4, PANEL_WIDTH, PANEL_UNIT);
				}else{
					TextureBlt(&g_InterfaceTexture, ofsx, ofsy+k*PANEL_UNIT,
						PANEL_WIDTH, PANEL_UNIT, 0, PANEL_UNIT*3, PANEL_WIDTH, PANEL_UNIT);
				}
				k++;
			}
		}else{
			TextureBlt(&g_InterfaceTexture, ofsx, ofsy+k*PANEL_UNIT,
				PANEL_WIDTH, PANEL_UNIT, 0, 0, PANEL_WIDTH, PANEL_UNIT);
			k++;
			if(i==g_ModePPM){
				TextureBlt(&g_InterfaceTexture, ofsx, ofsy+k*PANEL_UNIT,
					PANEL_WIDTH, PANEL_UNIT, 0, PANEL_UNIT, PANEL_WIDTH, PANEL_UNIT);
				k++;
			}
		}
	}
	if(!focus) return;
	for(k = 0; g_ModeMenu[k]; k++){
		if(CheckRect(g_Pointer.x, g_Pointer.y, ofsx, ofsy+k*PANEL_UNIT, PANEL_WIDTH, PANEL_UNIT)){
			Draw2DRect(ofsx, ofsy+k*PANEL_UNIT, ofsx+PANEL_WIDTH-1, ofsy+(k+1)*PANEL_UNIT-1, 0xff00ff00);
			return;
		}
	}
}
