//	Cu
#include "lib\udx.h"

//	萔E}N
#include "Const.h"
#include "Macro.h"

//	萔
const int KEY_NUM = 256;

//	c[֐
#include "ValueArea.h"
#include "SystemCover.h"

//	OO[o
extern int g_MiscOptionMagnetFlag;
extern VEC3 g_CameraPos;
extern CObject g_ArrowObject;
extern CObject g_CompassObject;
extern CObject g_MagnetObject;
extern CObject g_DirectionObject;

//	O[o
char g_CurrentKey[KEY_NUM] = {0};	//	݂̃L[
char g_PreviousKey[KEY_NUM] = {0};	//	ÕL[

int g_AltSwitch = 0;	//	ӏ܃[h ON/OFF

/*
 *	2 ľ
 */
void Exchange(
	int *a,	//	l 1
	int *b	//	l 2
){
	int t = *b;
	*b = *a;
	*a = t;
}

/*
 *	XN[Wn (POINT) ւ̕ϊ
 *
 *	߂l: XN[W
 */
POINT WorldToScreen2(
	VEC3 *w	//	[hW
){
	VEC3 st;
	POINT scr;
	st = WorldToScreen(*w);
	scr.x = (int)(st.x);
	scr.y = (int)(st.y);
	return scr;
}

/*
 *	Kς̌vZ
 *
 *	߂l: ϒl
 */
float V3Dot2(
	VEC3 *v1,	//	xNg 1
	VEC3 *v2	//	xNg 2
){
	VEC3 t1, t2;
	V3Norm(&t1, v1);
	V3Norm(&t2, v2);
	return V3Dot(&t1, &t2);
}

/*
 *	Βl 2 ߂
 *
 *	߂l: Βl 2 
 */
float V3Len2(
	VEC3 *v	//	xNg
){
	return Squ(v->x)+Squ(v->y)+Squ(v->z);
}

/*
 *	2 _ԋ߂
 *
 *	߂l: 
 */
float FlatPointDistance(
	POINT *p1,	//	_ 1
	POINT *p2	//	_ 2
){
	return sqrt(Squ(p2->x-p1->x)+Squ(p2->y-p1->y));
}

/*
 *	2 _ԋ߂
 *
 *	߂l: 
 */
float PointPointDistance(
	VEC3 *p1,	//	_ 1
	VEC3 *p2	//	_ 2
){
	return V3Len(&(*p2-*p1));
}

/*
 *	 1 _̋߂
 *
 *	߂l: 
 */
float LinePointDistance(
	VEC3 *p1,	//	ʂ 1 _
	VEC3 *n1,	//	̕xNg
	VEC3 *p2	//	_
){
	return PointPointDistance(p2, &(*p1+*n1*V3Dot(n1, &(*p2-*p1))));
}

/*
 *	2 ̋߂
 *
 *	߂l: 
 */
float LineLineDistance(
	VEC3 *p1,	//	 1 ʂ 1 _
	VEC3 *n1,	//	 1 ̕xNg
	VEC3 *p2,	//	 2 ʂ 1 _
	VEC3 *n2	//	 2 ̕xNg
){
	float d, a, b, t, n12;
	VEC3 r;
	r = *p2-*p1;
	d = V3Len(&r);
	n12 = V3Dot(n1, n2);
	t = 1.0f-n12*n12;
	if(t>0.0001f){
		a = V3Dot(n1, &(r-*n2*V3Dot(n2, &r)))/t;
		b = V3Dot(n2, &(*n1*V3Dot(n1, &r)-r))/t;
		return PointPointDistance(&(*p2+*n2*b), &(*p1+*n1*a));
	}
	return LinePointDistance(p1, n1, p2);
}

/*
 *	_苗ɂ钼̓_ (2 ) ߂
 */
void LinePointPosition(
	VEC3 *d1,	//	 1
	VEC3 *d2,	//	 2
	VEC3 *p1,	//	ʂ 1 _
	VEC3 *n1,	//	̕xNg
	VEC3 *p2,	//	_
	float x		//	
){
	float r, beta, gamma, tx = p1->x-p2->x, ty = p1->y-p2->y, tz = p1->z-p2->z;
	beta = n1->x*tx+n1->y*ty+n1->z*tz;
	gamma = tx*tx+ty*ty+tz*tz-x*x;
	r = sqrt(beta*beta-4*gamma);
	*d1 = *p1+*n1*(-beta+r);
	*d2 = *p1+*n1*(-beta-r);
}

/*
 *	tbZ[WŃ_CAO̕\
 */
void Dialog(
	char *format,	//	
	...				//	Cӈ
){
	char mes[1024];
	va_list	vl;
	va_start(vl,format);
	vsprintf(mes,format,vl);
	va_end(vl);
	CloseWindow(svw.hWnd);
	MessageBox(GetActiveWindow(), mes, "RailSim", MB_APPLMODAL);
}

/*
 *	L[͗pIvVݒ⏕֐
 */
bool OptionSwitch(
	int *v,		//	ݒϐ
	int min,	//	ŏl
	int max		//	ől
){
	bool push = false;
	if(SDK_GetKey(VK_LEFT)==S_PUSH){
		push = true;
		(*v)--;
	}
	if(SDK_GetKey(VK_RIGHT)==S_PUSH){
		push = true;
		(*v)++;
	}
	if(SDK_GetKey(VK_SPACE)==S_PUSH){
		push = true;
		(*v)++;
	}
	ValueCircular(v, min, max);
	return push;
}

/*
 *	IuWFNg_ŗpʑp̌vZ
 */
void Blink(
	float *d	//	ʑp
){
	*d += 2.0f*D3DX_PI/MAXFPS;
	ValueCircular(d, 0.0f, 2.0f*D3DX_PI);
}

/*
 *	ʑpAt@ľvZ
 *
 *	߂l: At@l
 */
float BlinkToAlpha(float v){
	return 0.5f*(1+sin(v));
}

/*
 *	t@CɃxNgl̕ۑ
 */
void SaveVec3Data(
	FILE *df,	//	t@C
	VEC3 v,		//	xNg
	char *e		//	TtBbNX
){
	fprintf(df, "(%f,%f,%f)%s", v.x, v.y, v.z, e);
}

/*
 *	t@CxNgl̓Ǎ
 */
void LoadVec3Data(
	FILE *df,	//	t@C
	VEC3 *v,	//	xNg
	char *e		//	TtBbNX
){
	char targ[32];
	sprintf(targ, "%s%s", "(%f,%f,%f)", e);
	fscanf(df, targ, &v->x, &v->y, &v->z);
}

/*
 *	I
 */
void Quit(){
	CleanUp();
	ExitProcess(0);
}

/*
 *	ӏ܃[h̃XCb` (Alt)
 *
 *	߂l: ӏ܃[h
 */
int SwitchAlt(){
	if(SDK_GetKey(VK_MENU)==S_PUSH){
		g_AltSwitch++;
		ValueCircular(&g_AltSwitch, 0, 2);
	}
	return g_AltSwitch;
}

/*
 *	`Of[V̕`
 */
void Grad2DRect(
	int x1,			//	 x
	int y1,			//	 y
	int x2,			//	E x
	int y2,			//	E y
	D3DCOLOR c1,	//	F
	D3DCOLOR c2,	//	F
	D3DCOLOR c3,	//	EF
	D3DCOLOR c4		//	EF
){
	VTX_TLX vt[] = {
		x1, y2, 0.0, 1.0, c1, 0.0f, 0.0f,
		x1, y1, 0.0, 1.0, c2, 0.0f, 0.0f,
		x2, y1, 0.0, 1.0, c3, 0.0f, 0.0f,
		x2, y2, 0.0, 1.0, c4, 0.0f, 0.0f};
	//CVertex v;
	//v.Create(vt,FVF_TL,sizeof(vt));
	//v.RenderTF(2);
	sv3.pDev->SetVertexShader(FVF_TLX);
	sv3.pDev->DrawPrimitiveUP(D3DPT_TRIANGLEFAN, 2, vt, sizeof(VTX_TLX));
}

/*
 *	eNX`̃C[W]
 */
void TextureBlt(
	CTexture *txt,	//	eNX`
	int dx, int dy,	//	]W
	int dw, int dh,	//	]TCY
	int sx, int sy,	//	]W
	int sw, int sh	//	]TCY
){
	static CSprite spr;
	spr.SetTexture(txt);
	spr.SetRect(sx, sy, sx+sw, sy+sh);
	spr.SetPos(VEC2(dx, dy));
	spr.SetScale(VEC2((float)dw/sw, (float)dh/sh));
	spr.Render();
}

/*
 *	J[\܂͎_SV{̃_O
 */
void RenderArrow(
	bool drawcompass,	//	_SV{\
	float gndalt		//	_S̒n`W
){
	if(drawcompass){
		g_CompassObject.SetPos(g_CameraPos+VEC3(0.0f, 0.4f-CAM_MIN_HIGH, 0.0f));
		g_CompassObject.RotY(0.1f);
		g_CompassObject.Render();
		ResetMatrix();
		devSetLighting(false);
		Draw3DLine(VEC3(g_CameraPos.x, gndalt, g_CameraPos.z), g_CameraPos-VEC3(0.0f, CAM_MIN_HIGH, 0.0f), 0xff0000ff, 0x800000ff);
	}else{
		g_ArrowObject.Render();
	}
}

/*
 *	΂̃_O
 */
void RenderMagnet(){
	if(g_MiscOptionMagnetFlag){
		g_DirectionObject.Render();
		g_MagnetObject.Render();
	}
}

/*
 *	L[Ԃ̍XV
 */
void SDK_ScanInput(){
	int i;
	memcpy(g_PreviousKey, g_CurrentKey, KEY_NUM);
	for(i = 0; i<KEY_NUM; i++) g_CurrentKey[i] = !!(GetAsyncKeyState(i)&0x8001);
}

/*
 *	L[Ԃ̎擾 (0: free, 1: pull, 2: push, 3: hold)
 */
int SDK_GetKey(
	int vkey	//	zL[R[h
){
	return vkey<0 || KEY_NUM<=vkey ? 0 : (g_CurrentKey[vkey]<<1)|g_PreviousKey[vkey];
}
