//	Cu
#include <direct.h>
#include "lib\udx.h"
#include "Pixelbit.h"

//	萔E}N
#include "Const.h"

extern const int MAIN_LOG_MAX;
extern const int SAVE_MAX;

//	c[֐
#include "ValueArea.h"
#include "SystemCover.h"
#include "SwitchMode.h"
#include "CameraControl.h"
#include "SaveData.h"

//	NX
#include "CLogger.h"
#include "CPlugin.h"
#include "CTrainModel.h"
#include "CStructModel.h"
#include "CStationModel.h"
#include "CRailModel.h"
#include "CTieModel.h"
#include "CPierModel.h"

//	OO[o
extern CTrainModel *g_TrainOptionModelSeed;
extern CStructModel *g_StructOptionModelSeed;
extern CStationModel *g_StationOptionModelSeed;
extern CRailModel *g_RailOptionModelSeed;
extern CRailModel *g_RailOptionModelSelect;
extern CTieModel *g_TieOptionModelSeed;
extern CTieModel *g_TieOptionModelSelect;
extern CPierModel *g_PierOptionModelSeed;
extern CPierModel *g_PierOptionModelSelect;
extern char g_BaseDir[];
extern int g_LengthSwitch;
extern int g_RailCreate;
extern int g_TieCreate;
extern int g_PierCreate;
extern unsigned int g_LengthTable[];
extern unsigned int g_DayLength;
extern unsigned int g_GameCounter;
extern unsigned int g_TimeDay;
extern unsigned int g_TimeHour;
extern unsigned int g_TimeMin;
extern float g_CameraDir;
extern float g_CameraBank;
extern float g_CameraDist;
extern float g_Angle;
extern bool g_ModeChanged;
extern POINT g_Pointer;
extern VEC3 g_CameraPos;
extern VEC3 g_PointPos;
extern CLogger g_GeneralLog;
extern CLogger g_ModeLog;
extern CLogger g_GeneralLog;
extern CLogger g_GeneralLog;
extern CLogger g_GeneralLog;
extern CLogger g_FileLog;

//	O[o
int g_MiscOptionShadowFlag = 1;		//	e_Oݒ
int g_MiscOptionTieFlag = 1;		//	؃_Oݒ
int g_MiscOptionLineFlag = 1;		//	ː_Oݒ
int g_MiscOptionRailMode = 0;		//	[_Oݒ
int g_MiscOptionTrainMode = 0;		//	q_Oݒ
int g_MiscOptionStationMode = 1;	//	wɃ_Oݒ
int g_MiscOptionStructMode = 0;		//	{݃_Oݒ
int g_MiscOptionTexFilter = 0;		//	eNX`tB^ݒ
int g_MiscOptionProjectionMode = 0;	//	e@ݒ
int g_MiscOptionEarthSpinFlag = 1;	//	Ԍoߐݒ
int g_MiscOptionFontShadowFlag = 1;	//	tHgAeݒ
int g_MiscOptionMagnetFlag = 1;		//	ʎjݒ
int g_MiscOptionWindowFlag = 0;		//	EBhE[hݒ
int g_MiscOptionDispSize = 0;		//	𑜓xݒ
int g_MiscOptionPluginSort = 0;		//	vOC\[hݒ
int g_MiscOptionUseUndo = 1;		//	AhDݒ

int g_VideoFrame = 0;	//	rfIt[JEg
int g_PictureCount = 0;	//	XN[VbgJEg

bool g_VideoState = false;	//	rfI^tO

CPixelbit g_ScreenShot;	//	XN[Vbgprbg}bv

//	֐錾
void VideoCapture(bool);
void CountPicture();

/*
 *	t@C[h
 */
void System(){
	static char *dlstr[10] = {
		"30b", "1", "3(Kl)", "5", "10",
		"20", "30", "1", "4", "24"};
	static int lswitch, lmode, smode, lk, a_up, a_dn;
	int i;
	bool click = false, rclick = false;
	VEC3 pp;
	POINT pos;
	pos = GetCursorXY();
	if((pos.x!=(svw.winW/2)) || (pos.y!=(svw.winH/2))) lk = 0;
	if(g_ModeChanged){
		ListData();
		a_up = a_dn = 0;
		lmode = 0;
	}
	switch(SDK_GetKey(VK_LBUTTON)){
	case S_PUSH:
		lk = 1;
		break;
	case S_HOLD:
		break;
	case S_PULL:
		if(lk){
			if(ClickMode()){
				if(g_ModeChanged) return;
			}else{
				click = true;
			}
		}
	default:
		lk = 0;
		break;
	}
	SwitchMode();
	if(lmode){
		if(SDK_GetKey(VK_UP)>=S_PUSH){
			a_up++;
			if(a_up==1 || a_up>=LONGPUSH) smode--;
		}else{
			a_up = 0;
		}
		if(SDK_GetKey(VK_DOWN)>=S_PUSH){
			a_dn++;
			if(a_dn==1 || a_dn>=LONGPUSH) smode++;
		}else{
			a_dn = 0;
		}
		ValueCircular(&smode, 0, SAVE_MAX-1);
		if(SDK_GetKey(VK_BACK)==S_PUSH) lmode = 0;
		if(SDK_GetKey(VK_SPACE)==S_PUSH){
			if(lswitch==1) LoadData(smode, false); else SaveData(smode, false);
		}
	}else{
		if(SDK_GetKey(VK_UP)==S_PUSH) lswitch--;
		if(SDK_GetKey(VK_DOWN)==S_PUSH) lswitch++;
		ValueCircular(&lswitch, 0, 3);
		if(SDK_GetKey(VK_SPACE)==S_PUSH){
			switch(lswitch){
			case 0:
				MakeData();
				break;
			case 1:
			case 2:
				lmode = 1;
				break;
			case 3:
				g_LengthSwitch++;
				ValueCircular(&g_LengthSwitch, 0, 9);
				g_DayLength = g_LengthTable[g_LengthSwitch];
				g_GameCounter = g_TimeDay*g_DayLength+g_TimeHour*g_DayLength/24+g_TimeMin*g_DayLength/24/60;
				break;
			}
		}
		if(lswitch==3 && OptionSwitch(&g_LengthSwitch, 0, 9)){
			g_DayLength = g_LengthTable[g_LengthSwitch];
			g_GameCounter = g_TimeDay*g_DayLength+g_TimeHour*g_DayLength/24+g_TimeMin*g_DayLength/24/60;
		}
	}
	CursorMove(&pos, &g_PointPos, &g_CameraPos, false);
	SetCursor(svw.winW/2, svw.winH/2);
	pp = CameraSet(g_CameraDir, g_CameraBank, g_CameraDist, &g_CameraPos, &g_PointPos);
	BeginScene();
	devSetState(D3DRS_ZFUNC, D3DCMP_LESSEQUAL);
	g_Pointer = WorldToScreen2(&pp);
	devSetLighting(true);
	ResetMatrix();
	devResetMaterial();
	devSetTexture(0, NULL);
	devSetLighting(false);
	if(CheckRect(g_Pointer.x, g_Pointer.y, 50, 15+(2+MAIN_LOG_MAX)*FONT_HEIGHT, 320, FONT_HEIGHT)){
		Grad2DRect(50, 15+(2+MAIN_LOG_MAX)*FONT_HEIGHT, 50+320, 15+(3+MAIN_LOG_MAX)*FONT_HEIGHT, 0x8000ff00, 0x8000ff00, 0x0000ff00, 0x0000ff00);
		if(click){
			lmode = lswitch = 0; MakeData();
		}
	}
	if(CheckRect(g_Pointer.x, g_Pointer.y, 50, 15+(3+MAIN_LOG_MAX)*FONT_HEIGHT, 320, FONT_HEIGHT)){
		Grad2DRect(50, 15+(3+MAIN_LOG_MAX)*FONT_HEIGHT, 50+320, 15+(4+MAIN_LOG_MAX)*FONT_HEIGHT, 0x8000ff00, 0x8000ff00, 0x0000ff00, 0x0000ff00);
		if(click){
			if(lmode && lswitch==1){
				lmode = 0;
			}else{
				lswitch = 1; lmode = 1;
			}
		}
	}
	if(CheckRect(g_Pointer.x, g_Pointer.y, 50, 15+(4+MAIN_LOG_MAX)*FONT_HEIGHT, 320, FONT_HEIGHT)){
		Grad2DRect(50, 15+(4+MAIN_LOG_MAX)*FONT_HEIGHT, 50+320, 15+(5+MAIN_LOG_MAX)*FONT_HEIGHT, 0x8000ff00, 0x8000ff00, 0x0000ff00, 0x0000ff00);
		if(click){
			if(lmode && lswitch==2){
				lmode = 0;
			}else{
				lswitch = 2; lmode = 1;
			}
		}
	}
	if(CheckRect(g_Pointer.x, g_Pointer.y, 50, 20+(6+MAIN_LOG_MAX)*FONT_HEIGHT, 320, FONT_HEIGHT)){
		Grad2DRect(50, 20+(6+MAIN_LOG_MAX)*FONT_HEIGHT, 50+320, 20+(7+MAIN_LOG_MAX)*FONT_HEIGHT, 0x8000ff00, 0x8000ff00, 0x0000ff00, 0x0000ff00);
		if(click || rclick){
			lmode = 0; lswitch = 3;
			if(click) g_LengthSwitch++; else g_LengthSwitch--;
			ValueCircular(&g_LengthSwitch, 0, 9);
			g_DayLength = g_LengthTable[g_LengthSwitch];
			g_GameCounter = g_TimeDay*g_DayLength+g_TimeHour*g_DayLength/24+g_TimeMin*g_DayLength/24/60;
		}
	}
	if(lmode){
		for(i = 0; i<SAVE_MAX; i++){
			if(CheckRect(g_Pointer.x, g_Pointer.y, 50, 25+(8+i+MAIN_LOG_MAX)*FONT_HEIGHT, 320, FONT_HEIGHT)){
				Grad2DRect(50, 25+(8+i+MAIN_LOG_MAX)*FONT_HEIGHT, 50+320, 25+(9+i+MAIN_LOG_MAX)*FONT_HEIGHT, 0x8000ff00, 0x8000ff00, 0x0000ff00, 0x0000ff00);
				if(click){
					smode = i;
					if(lswitch==1) LoadData(smode, false); else SaveData(smode, false);
				}
			}
		}
		Text(30, 25+(7+MAIN_LOG_MAX)*FONT_HEIGHT, lswitch==1 ? "}bvǍ" : "}bvۑ");
		for(i = 0; i<SAVE_MAX; i++) Text(50, 25+(8+i+MAIN_LOG_MAX)*FONT_HEIGHT, TextSw(smode, i));
		g_FileLog.Show();
	}
	Text(30, 15+(1+MAIN_LOG_MAX)*FONT_HEIGHT, "t@C");
	TextF(50, 15+(2+MAIN_LOG_MAX)*FONT_HEIGHT, "%sVK}bv", TextSw(lswitch, 0));
	TextF(50, 15+(3+MAIN_LOG_MAX)*FONT_HEIGHT, "%s}bvǍ", TextSw(lswitch, 1));
	TextF(50, 15+(4+MAIN_LOG_MAX)*FONT_HEIGHT, "%s}bvۑ", TextSw(lswitch, 2));
	Text(30, 20+(5+MAIN_LOG_MAX)*FONT_HEIGHT, "t@CƂ̐ݒ");
	TextF(50, 20+(6+MAIN_LOG_MAX)*FONT_HEIGHT, "%s1̒: %s", TextSw(lswitch, 3), dlstr[g_LengthSwitch]);
	g_GeneralLog.Show();
	RenderMode(true);
	g_ModeLog.Show();
	ShowFPS2();
	devSetLighting(true);
	devSetState(D3DRS_ZFUNC, D3DCMP_ALWAYS);
	RenderArrow(false, 0.0f);
	EndScene();
	VideoCapture(false);
}

/*
 *	ݒ胂[h
 */
void Settings(){
	static int smode, lk;
	static char *onoff[2] = {"", "L"};
	static char *allfade[2] = {"tF[hAEg", "ׂ"};
	static char *scrmode[2] = {"tXN[", "EBhE"};
	static char *scrsize[3] = {"640*480", "800*600", "1024*768"};
	static char *spinmode[3] = {"ƒ", "]", "Ɩ"};
	static char *sortmode[3] = {"ID", "̏", "ҏ"};
	bool click = false;
	VEC3 pp;
	POINT pos;
	pos = GetCursorXY();
	if((pos.x!=(svw.winW/2)) || (pos.y!=(svw.winH/2))) lk = 0;
	switch(SDK_GetKey(VK_LBUTTON)){
	case S_PUSH:
		lk = 1;
		break;
	case S_HOLD:
		break;
	case S_PULL:
		if(lk){
			if(ClickMode()){
				if(g_ModeChanged) return;
			}else{
				click = true;
			}
		}
	default:
		lk = 0;
		break;
	}
	SwitchMode();
	if(SDK_GetKey(VK_UP)==S_PUSH) smode--;
	if(SDK_GetKey(VK_DOWN)==S_PUSH) smode++;
	ValueCircular(&smode, 0, 15);
	switch(smode){
	case 0:
		OptionSwitch(&g_MiscOptionShadowFlag, 0, 1);
		break;
	case 1:
		OptionSwitch(&g_MiscOptionTieFlag, 0, 1);
		break;
	case 2:
		OptionSwitch(&g_MiscOptionLineFlag, 0, 1);
		break;
	case 3:
		OptionSwitch(&g_MiscOptionRailMode, 0, 1);
		break;
	case 4:
		OptionSwitch(&g_MiscOptionTrainMode, 0, 1);
		break;
	case 5:
		OptionSwitch(&g_MiscOptionStationMode, 0, 1);
		break;
	case 6:
		OptionSwitch(&g_MiscOptionStructMode, 0, 1);
		break;
	case 7:
		if(OptionSwitch(&g_MiscOptionTexFilter, 0, 1)){
			if(g_MiscOptionTexFilter) devTEX_LINEAR(); else devTEX_POINT();
		}
		break;
	case 8:
		if(OptionSwitch(&g_MiscOptionProjectionMode, 0, 1)){
			D3DXMatrixPerspectiveFovLH(&sv3.mtxProj, D3DX_PI/4,
				(float)sv3.width/sv3.height, CLIP_PLANE_NEAR, CLIP_PLANE_FAR);
			sv3.pDev->SetTransform(D3DTS_PROJECTION, &sv3.mtxProj);
		}
		break;
	case 9:
		OptionSwitch(&g_MiscOptionEarthSpinFlag, 0, 2);
		break;
	case 10:
		OptionSwitch(&g_MiscOptionFontShadowFlag, 0, 1);
		break;
	case 11:
		OptionSwitch(&g_MiscOptionMagnetFlag, 0, 1);
		break;
	case 12:
		OptionSwitch(&g_MiscOptionWindowFlag, 0, 1);
		break;
	case 13:
		OptionSwitch(&g_MiscOptionDispSize, 0, 2);
		break;
	case 14:
		if(OptionSwitch(&g_MiscOptionPluginSort, 0, 2)){
			g_TrainOptionModelSeed->MergeSort((CPlugin **)&g_TrainOptionModelSeed, NULL, 0);
			g_StructOptionModelSeed->MergeSort((CPlugin **)&g_StructOptionModelSeed, NULL, 0);
			g_StationOptionModelSeed->MergeSort((CPlugin **)&g_StationOptionModelSeed, NULL, 0);
			g_RailOptionModelSeed->MergeSort((CPlugin **)&g_RailOptionModelSeed, NULL, 0);
			g_TieOptionModelSeed->MergeSort((CPlugin **)&g_TieOptionModelSeed, NULL, 0);
			g_PierOptionModelSeed->MergeSort((CPlugin **)&g_PierOptionModelSeed, NULL, 0);
			g_RailOptionModelSelect = g_RailOptionModelSeed->Get(g_RailCreate-1);
			g_TieOptionModelSelect = g_TieOptionModelSeed->Get(g_TieCreate-1);
			g_PierOptionModelSelect = g_PierOptionModelSeed->Get(g_PierCreate-1);
			g_GeneralLog.Add("vOCă\[g܂B");
		}
		break;
	case 15:
		if(OptionSwitch(&g_MiscOptionUseUndo, 0, 1)) FileResetUndo();
		break;
	}
	CursorMove(&pos, &g_PointPos, &g_CameraPos, false);
	SetCursor(svw.winW/2, svw.winH/2);
	pp = CameraSet(g_CameraDir, g_CameraBank, g_CameraDist, &g_CameraPos, &g_PointPos);
	BeginScene();
	devSetState(D3DRS_ZFUNC, D3DCMP_LESSEQUAL);
	g_Pointer = WorldToScreen2(&pp);
	devSetLighting(true);
	ResetMatrix();
	devResetMaterial();
	devSetTexture(0, NULL);
	devSetLighting(false);
	if(CheckRect(g_Pointer.x, g_Pointer.y, 50, 15+(2+MAIN_LOG_MAX)*FONT_HEIGHT, 320, FONT_HEIGHT)){
		Grad2DRect(50, 15+(2+MAIN_LOG_MAX)*FONT_HEIGHT, 50+320, 15+(3+MAIN_LOG_MAX)*FONT_HEIGHT, 0x8000ff00, 0x8000ff00, 0x0000ff00, 0x0000ff00);
		if(click){
			smode = 0; g_MiscOptionShadowFlag++;
			ValueCircular(&g_MiscOptionShadowFlag, 0, 1);
		}
	}
	if(CheckRect(g_Pointer.x, g_Pointer.y, 50, 15+(3+MAIN_LOG_MAX)*FONT_HEIGHT, 320, FONT_HEIGHT)){
		Grad2DRect(50, 15+(3+MAIN_LOG_MAX)*FONT_HEIGHT, 50+320, 15+(4+MAIN_LOG_MAX)*FONT_HEIGHT, 0x8000ff00, 0x8000ff00, 0x0000ff00, 0x0000ff00);
		if(click){
			smode = 1; g_MiscOptionTieFlag++;
			ValueCircular(&g_MiscOptionTieFlag, 0, 1);
		}
	}
	if(CheckRect(g_Pointer.x, g_Pointer.y, 50, 15+(4+MAIN_LOG_MAX)*FONT_HEIGHT, 320, FONT_HEIGHT)){
		Grad2DRect(50, 15+(4+MAIN_LOG_MAX)*FONT_HEIGHT, 50+320, 15+(5+MAIN_LOG_MAX)*FONT_HEIGHT, 0x8000ff00, 0x8000ff00, 0x0000ff00, 0x0000ff00);
		if(click){
			smode = 2; g_MiscOptionLineFlag++;
			ValueCircular(&g_MiscOptionLineFlag, 0, 1);
		}
	}
	if(CheckRect(g_Pointer.x, g_Pointer.y, 50, 15+(5+MAIN_LOG_MAX)*FONT_HEIGHT, 320, FONT_HEIGHT)){
		Grad2DRect(50, 15+(5+MAIN_LOG_MAX)*FONT_HEIGHT, 50+320, 15+(6+MAIN_LOG_MAX)*FONT_HEIGHT, 0x8000ff00, 0x8000ff00, 0x0000ff00, 0x0000ff00);
		if(click){
			smode = 3; g_MiscOptionRailMode++;
			ValueCircular(&g_MiscOptionRailMode, 0, 1);
		}
	}
	if(CheckRect(g_Pointer.x, g_Pointer.y, 50, 15+(6+MAIN_LOG_MAX)*FONT_HEIGHT, 320, FONT_HEIGHT)){
		Grad2DRect(50, 15+(6+MAIN_LOG_MAX)*FONT_HEIGHT, 50+320, 15+(7+MAIN_LOG_MAX)*FONT_HEIGHT, 0x8000ff00, 0x8000ff00, 0x0000ff00, 0x0000ff00);
		if(click){
			smode = 4; g_MiscOptionTrainMode++;
			ValueCircular(&g_MiscOptionTrainMode, 0, 1);
		}
	}
	if(CheckRect(g_Pointer.x, g_Pointer.y, 50, 15+(7+MAIN_LOG_MAX)*FONT_HEIGHT, 320, FONT_HEIGHT)){
		Grad2DRect(50, 15+(7+MAIN_LOG_MAX)*FONT_HEIGHT, 50+320, 15+(8+MAIN_LOG_MAX)*FONT_HEIGHT, 0x8000ff00, 0x8000ff00, 0x0000ff00, 0x0000ff00);
		if(click){
			smode = 5; g_MiscOptionStationMode++;
			ValueCircular(&g_MiscOptionStationMode, 0, 1);
		}
	}
	if(CheckRect(g_Pointer.x, g_Pointer.y, 50, 15+(8+MAIN_LOG_MAX)*FONT_HEIGHT, 320, FONT_HEIGHT)){
		Grad2DRect(50, 15+(8+MAIN_LOG_MAX)*FONT_HEIGHT, 50+320, 15+(9+MAIN_LOG_MAX)*FONT_HEIGHT, 0x8000ff00, 0x8000ff00, 0x0000ff00, 0x0000ff00);
		if(click){
			smode = 6; g_MiscOptionStructMode++;
			ValueCircular(&g_MiscOptionStructMode, 0, 1);
		}
	}
	if(CheckRect(g_Pointer.x, g_Pointer.y, 50, 15+(9+MAIN_LOG_MAX)*FONT_HEIGHT, 320, FONT_HEIGHT)){
		Grad2DRect(50, 15+(9+MAIN_LOG_MAX)*FONT_HEIGHT, 50+320, 15+(10+MAIN_LOG_MAX)*FONT_HEIGHT, 0x8000ff00, 0x8000ff00, 0x0000ff00, 0x0000ff00);
		if(click){
			smode = 7; g_MiscOptionTexFilter++;
			ValueCircular(&g_MiscOptionTexFilter, 0, 1);
			if(g_MiscOptionTexFilter) devTEX_LINEAR(); else devTEX_POINT();
		}
	}
	if(CheckRect(g_Pointer.x, g_Pointer.y, 50, 15+(10+MAIN_LOG_MAX)*FONT_HEIGHT, 320, FONT_HEIGHT)){
		Grad2DRect(50, 15+(10+MAIN_LOG_MAX)*FONT_HEIGHT, 50+320, 15+(11+MAIN_LOG_MAX)*FONT_HEIGHT, 0x8000ff00, 0x8000ff00, 0x0000ff00, 0x0000ff00);
		if(click){
			smode = 8; g_MiscOptionProjectionMode++;
			ValueCircular(&g_MiscOptionProjectionMode, 0, 1);
			D3DXMatrixPerspectiveFovLH(&sv3.mtxProj, D3DX_PI/4, (float)sv3.width/sv3.height, CLIP_PLANE_NEAR, CLIP_PLANE_FAR);
			sv3.pDev->SetTransform(D3DTS_PROJECTION, &sv3.mtxProj);
		}
	}
	if(CheckRect(g_Pointer.x, g_Pointer.y, 50, 20+(12+MAIN_LOG_MAX)*FONT_HEIGHT, 320, FONT_HEIGHT)){
		Grad2DRect(50, 20+(12+MAIN_LOG_MAX)*FONT_HEIGHT, 50+320, 20+(13+MAIN_LOG_MAX)*FONT_HEIGHT, 0x8000ff00, 0x8000ff00, 0x0000ff00, 0x0000ff00);
		if(click){
			smode = 9; g_MiscOptionEarthSpinFlag++;
			ValueCircular(&g_MiscOptionEarthSpinFlag, 0, 2);
		}
	}
	if(CheckRect(g_Pointer.x, g_Pointer.y, 50, 20+(13+MAIN_LOG_MAX)*FONT_HEIGHT, 320, FONT_HEIGHT)){
		Grad2DRect(50, 20+(13+MAIN_LOG_MAX)*FONT_HEIGHT, 50+320, 20+(14+MAIN_LOG_MAX)*FONT_HEIGHT, 0x8000ff00, 0x8000ff00, 0x0000ff00, 0x0000ff00);
		if(click){
			smode = 10; g_MiscOptionFontShadowFlag++;
			ValueCircular(&g_MiscOptionFontShadowFlag, 0, 1);
		}
	}
	if(CheckRect(g_Pointer.x, g_Pointer.y, 50, 20+(14+MAIN_LOG_MAX)*FONT_HEIGHT, 320, FONT_HEIGHT)){
		Grad2DRect(50, 20+(14+MAIN_LOG_MAX)*FONT_HEIGHT, 50+320, 20+(15+MAIN_LOG_MAX)*FONT_HEIGHT, 0x8000ff00, 0x8000ff00, 0x0000ff00, 0x0000ff00);
		if(click){
			smode = 11; g_MiscOptionMagnetFlag++;
			ValueCircular(&g_MiscOptionMagnetFlag, 0, 1);
		}
	}
	if(CheckRect(g_Pointer.x, g_Pointer.y, 50, 25+(16+MAIN_LOG_MAX)*FONT_HEIGHT, 320, FONT_HEIGHT)){
		Grad2DRect(50, 25+(16+MAIN_LOG_MAX)*FONT_HEIGHT, 50+320, 25+(17+MAIN_LOG_MAX)*FONT_HEIGHT, 0x8000ff00, 0x8000ff00, 0x0000ff00, 0x0000ff00);
		if(click){
			smode = 12; g_MiscOptionWindowFlag++;
			ValueCircular(&g_MiscOptionWindowFlag, 0, 1);
		}
	}
	if(CheckRect(g_Pointer.x, g_Pointer.y, 50, 25+(17+MAIN_LOG_MAX)*FONT_HEIGHT, 320, FONT_HEIGHT)){
		Grad2DRect(50, 25+(17+MAIN_LOG_MAX)*FONT_HEIGHT, 50+320, 25+(18+MAIN_LOG_MAX)*FONT_HEIGHT, 0x8000ff00, 0x8000ff00, 0x0000ff00, 0x0000ff00);
		if(click){
			smode = 13; g_MiscOptionDispSize++;
			ValueCircular(&g_MiscOptionDispSize, 0, 2);
		}
	}
	if(CheckRect(g_Pointer.x, g_Pointer.y, 50, 30+(19+MAIN_LOG_MAX)*FONT_HEIGHT, 320, FONT_HEIGHT)){
		Grad2DRect(50, 30+(19+MAIN_LOG_MAX)*FONT_HEIGHT, 50+320, 30+(20+MAIN_LOG_MAX)*FONT_HEIGHT, 0x8000ff00, 0x8000ff00, 0x0000ff00, 0x0000ff00);
		if(click){
			smode = 14; g_MiscOptionPluginSort++;
			ValueCircular(&g_MiscOptionPluginSort, 0, 2);
			g_TrainOptionModelSeed->MergeSort((CPlugin **)&g_TrainOptionModelSeed, NULL, 0);
			g_StructOptionModelSeed->MergeSort((CPlugin **)&g_StructOptionModelSeed, NULL, 0);
			g_StationOptionModelSeed->MergeSort((CPlugin **)&g_StationOptionModelSeed, NULL, 0);
			g_RailOptionModelSeed->MergeSort((CPlugin **)&g_RailOptionModelSeed, NULL, 0);
			g_TieOptionModelSeed->MergeSort((CPlugin **)&g_TieOptionModelSeed, NULL, 0);
			g_PierOptionModelSeed->MergeSort((CPlugin **)&g_PierOptionModelSeed, NULL, 0);
			g_RailOptionModelSelect = g_RailOptionModelSeed->Get(g_RailCreate-1);
			g_TieOptionModelSelect = g_TieOptionModelSeed->Get(g_TieCreate-1);
			g_PierOptionModelSelect = g_PierOptionModelSeed->Get(g_PierCreate-1);
			g_GeneralLog.Add("vOCă\[g܂B");
		}
	}
	if(CheckRect(g_Pointer.x, g_Pointer.y, 50, 30+(20+MAIN_LOG_MAX)*FONT_HEIGHT, 320, FONT_HEIGHT)){
		Grad2DRect(50, 30+(20+MAIN_LOG_MAX)*FONT_HEIGHT, 50+320, 30+(21+MAIN_LOG_MAX)*FONT_HEIGHT, 0x8000ff00, 0x8000ff00, 0x0000ff00, 0x0000ff00);
		if(click){
			smode = 15; g_MiscOptionUseUndo++;
			ValueCircular(&g_MiscOptionUseUndo, 0, 1);
			FileResetUndo();
		}
	}
	Text(30, 15+(1+MAIN_LOG_MAX)*FONT_HEIGHT, "_O");
	TextF(50, 15+(2+MAIN_LOG_MAX)*FONT_HEIGHT, "%sAe@@@: %s", TextSw(smode, 0), onoff[g_MiscOptionShadowFlag]);
	TextF(50, 15+(3+MAIN_LOG_MAX)*FONT_HEIGHT, "%s؁@@@: %s", TextSw(smode, 1), onoff[g_MiscOptionTieFlag]);
	TextF(50, 15+(4+MAIN_LOG_MAX)*FONT_HEIGHT, "%sː@@@: %s", TextSw(smode, 2), onoff[g_MiscOptionLineFlag]);
	TextF(50, 15+(5+MAIN_LOG_MAX)*FONT_HEIGHT, "%s[@@: %s", TextSw(smode, 3), allfade[g_MiscOptionRailMode]);
	TextF(50, 15+(6+MAIN_LOG_MAX)*FONT_HEIGHT, "%sq@@@: %s", TextSw(smode, 4), allfade[g_MiscOptionTrainMode]);
	TextF(50, 15+(7+MAIN_LOG_MAX)*FONT_HEIGHT, "%swɁ@@@: %s", TextSw(smode, 5), allfade[g_MiscOptionStationMode]);
	TextF(50, 15+(8+MAIN_LOG_MAX)*FONT_HEIGHT, "%s{݁@@@: %s", TextSw(smode, 6), allfade[g_MiscOptionStructMode]);
	TextF(50, 15+(9+MAIN_LOG_MAX)*FONT_HEIGHT, "%stB^@: %s", TextSw(smode, 7), g_MiscOptionTexFilter ? "`⊮" : "ŋߕ⊮");
	TextF(50, 15+(10+MAIN_LOG_MAX)*FONT_HEIGHT, "%se@@: %s", TextSw(smode, 8), g_MiscOptionProjectionMode ? "se" : "e");
	Text(30, 20+(11+MAIN_LOG_MAX)*FONT_HEIGHT, "o");
	TextF(50, 20+(12+MAIN_LOG_MAX)*FONT_HEIGHT, "%sn̎]: %s", TextSw(smode, 9), spinmode[g_MiscOptionEarthSpinFlag]);
	TextF(50, 20+(13+MAIN_LOG_MAX)*FONT_HEIGHT, "%sAe@: %s", TextSw(smode, 10), onoff[g_MiscOptionFontShadowFlag]);
	TextF(50, 20+(14+MAIN_LOG_MAX)*FONT_HEIGHT, "%sʎj@: %s", TextSw(smode, 11), onoff[g_MiscOptionMagnetFlag]);
	Text(30, 25+(15+MAIN_LOG_MAX)*FONT_HEIGHT, "foCX(vċN)");
	TextF(50, 25+(16+MAIN_LOG_MAX)*FONT_HEIGHT, "%sʃ[h: %s", TextSw(smode, 12), scrmode[g_MiscOptionWindowFlag]);
	TextF(50, 25+(17+MAIN_LOG_MAX)*FONT_HEIGHT, "%sʃTCY: %s", TextSw(smode, 13), scrsize[g_MiscOptionDispSize]);
	Text(30, 30+(18+MAIN_LOG_MAX)*FONT_HEIGHT, "̑");
	TextF(50, 30+(19+MAIN_LOG_MAX)*FONT_HEIGHT, "%s\[g@: %s", TextSw(smode, 14), sortmode[g_MiscOptionPluginSort]);
	TextF(50, 30+(20+MAIN_LOG_MAX)*FONT_HEIGHT, "%sAhD@: %s", TextSw(smode, 15), onoff[g_MiscOptionUseUndo]);
	Text(30, 35+(21+MAIN_LOG_MAX)*FONT_HEIGHT, "Xe[^X");
	TextF(50, 35+(22+MAIN_LOG_MAX)*FONT_HEIGHT, "fvXEXeV: %s", FormatToString(sv3.d3dpp.AutoDepthStencilFormat));
	g_GeneralLog.Show();
	RenderMode(true);
	g_ModeLog.Show();
	ShowFPS2();
	devSetLighting(true);
	devSetState(D3DRS_ZFUNC, D3DCMP_ALWAYS);
	RenderArrow(false, 0.0f);
	EndScene();
	VideoCapture(false);
}

/*
 *	rfI[h
 */
void VideoControl(){
	static int smode, lk;
	bool click = false;
	VEC3 pp;
	POINT pos;
	pos = GetCursorXY();
	if((pos.x!=(svw.winW/2)) || (pos.y!=(svw.winH/2))) lk = 0;
	if(g_ModeChanged) smode = 0;
	switch(SDK_GetKey(VK_LBUTTON)){
	case S_PUSH:
		lk = 1;
		break;
	case S_HOLD:
		break;
	case S_PULL:
		if(lk){
			if(ClickMode()){
				if(g_ModeChanged) return;
			}else{
				click = true;
			}
		}
	default:
		lk = 0;
		break;
	}
	SwitchMode();
	if(SDK_GetKey(VK_UP)==S_PUSH) smode--;
	if(SDK_GetKey(VK_DOWN)==S_PUSH) smode++;
	ValueCircular(&smode, 0, 1);
	switch(smode){
	case 0:
		if(SDK_GetKey(VK_SPACE)==S_PUSH){
			if(g_VideoState = !g_VideoState) g_GeneralLog.Add("^Jn܂B");
			else g_GeneralLog.Add("^~܂B");
		}
		break;
	case 1:
		if(SDK_GetKey(VK_SPACE)==S_PUSH){
			g_VideoFrame = 0;
			g_GeneralLog.Add("JE^Zbg܂B");
		}
		break;
	}
	CursorMove(&pos, &g_PointPos, &g_CameraPos, false);
	SetCursor(svw.winW/2, svw.winH/2);
	pp = CameraSet(g_CameraDir, g_CameraBank, g_CameraDist, &g_CameraPos, &g_PointPos);
	BeginScene();
	devSetState(D3DRS_ZFUNC, D3DCMP_LESSEQUAL);
	g_Pointer = WorldToScreen2(&pp);
	devSetLighting(true);
	ResetMatrix();
	devResetMaterial();
	devSetTexture(0, NULL);
	devSetLighting(false);
	Text(30, 15+(1+MAIN_LOG_MAX)*FONT_HEIGHT, "XN[VbgBe@\");
	TextF(40, 20+(2+MAIN_LOG_MAX)*FONT_HEIGHT, "JEg: %d", g_PictureCount);
	Text(30, 25+(3+MAIN_LOG_MAX)*FONT_HEIGHT, "ȈՃrfIBe@\");
	if(CheckRect(g_Pointer.x, g_Pointer.y, 50, 25+(4+MAIN_LOG_MAX)*FONT_HEIGHT, 320, FONT_HEIGHT)){
		Grad2DRect(50, 25+(4+MAIN_LOG_MAX)*FONT_HEIGHT, 50+320, 25+(5+MAIN_LOG_MAX)*FONT_HEIGHT, 0x8000ff00, 0x8000ff00, 0x0000ff00, 0x0000ff00);
		if(click){
			smode = 0;
			if(g_VideoState = !g_VideoState) g_GeneralLog.Add("^Jn܂B");
			else g_GeneralLog.Add("^~܂B");
		}
	}
	if(CheckRect(g_Pointer.x, g_Pointer.y, 50, 25+(5+MAIN_LOG_MAX)*FONT_HEIGHT, 320, FONT_HEIGHT)){
		Grad2DRect(50, 25+(5+MAIN_LOG_MAX)*FONT_HEIGHT, 50+320, 25+(6+MAIN_LOG_MAX)*FONT_HEIGHT, 0x8000ff00, 0x8000ff00, 0x0000ff00, 0x0000ff00);
		if(click){
			smode = 1; g_VideoFrame = 0;
			g_GeneralLog.Add("JE^Zbg܂B");
		}
	}
	TextF(50, 25+(4+MAIN_LOG_MAX)*FONT_HEIGHT, "%s%s", TextSw(smode, 0), g_VideoState ? "^~" : "^Jn");
	TextF(50, 25+(5+MAIN_LOG_MAX)*FONT_HEIGHT, "%s߂", TextSw(smode, 1));
	TextF(40, 30+(6+MAIN_LOG_MAX)*FONT_HEIGHT, "Xe[^X: %s", g_VideoState ? "^撆" : "~");
	TextF(40, 30+(7+MAIN_LOG_MAX)*FONT_HEIGHT, "t[: %d", g_VideoFrame);
	g_GeneralLog.Show();
	RenderMode(true);
	g_ModeLog.Show();
	ShowFPS2();
	devSetLighting(true);
	devSetState(D3DRS_ZFUNC, D3DCMP_ALWAYS);
	RenderArrow(false, 0.0f);
	EndScene();
	VideoCapture(false);
}

/*
 *	rfI̎Be
 */
void VideoCapture(bool video){
	if(video && g_VideoState){
		char fname[32];
		HDC windc = GetDC(svw.hWnd);
		BitBlt(g_ScreenShot.GetHDC(), 0, 0, DISP_WIDTH, DISP_HEIGHT, windc, 0, 0, SRCCOPY);
		ReleaseDC(svw.hWnd, windc);
		chdir(g_BaseDir);
		chdir("Video");
		sprintf(fname, "%08d.bmp", g_VideoFrame);
		g_ScreenShot.Save(fname);
		if(!(g_VideoFrame%10)) g_GeneralLog.AddF("^撆(%d)", g_VideoFrame);
		g_VideoFrame++;
	}else if(SDK_GetKey(VK_RETURN)==S_PUSH){
		char fname[32];
		HDC windc = GetDC(svw.hWnd);
		BitBlt(g_ScreenShot.GetHDC(), 0, 0, DISP_WIDTH, DISP_HEIGHT, windc, 0, 0, SRCCOPY);
		ReleaseDC(svw.hWnd, windc);
		chdir(g_BaseDir);
		chdir("Picture");
		sprintf(fname, "%08d.bmp", g_PictureCount);
		g_ScreenShot.Save(fname);
		g_GeneralLog.AddF("Lv`(%d)", g_PictureCount);
		CountPicture();
	}
}

/*
 *	XN[Vbg̊t@C̃JEg
 */
void CountPicture(){
	char fname[32];
	FILE *file;
	chdir(g_BaseDir);
	chdir("Picture");
	while(true){
		sprintf(fname, "%08d.bmp", g_PictureCount);
		if(file = fopen(fname, "rb")){
			fclose(file);
			g_PictureCount++;
		}else{
			break;
		}
	}
}

/*
 *	I[h
 */
void ExitDialog(){
	static int smode, lk;
	bool click = false;
	VEC3 pp;
	POINT pos;
	pos = GetCursorXY();
	if((pos.x!=(svw.winW/2)) || (pos.y!=(svw.winH/2))) lk = 0;
	if(g_ModeChanged) smode = 0;
	switch(SDK_GetKey(VK_LBUTTON)){
	case S_PUSH:
		lk = 1;
		break;
	case S_HOLD:
		break;
	case S_PULL:
		if(lk){
			if(ClickMode()){
				if(g_ModeChanged) return;
			}else{
				click = true;
			}
		}
	default:
		lk = 0;
		break;
	}
	SwitchMode();
	if(SDK_GetKey(VK_UP)==S_PUSH) smode--;
	if(SDK_GetKey(VK_DOWN)==S_PUSH) smode++;
	ValueCircular(&smode, 0, 1);
	switch(smode){
	case 0:
		if(SDK_GetKey(VK_SPACE)==S_PUSH) RegisterMode(-1, true);
		break;
	case 1:
		if(SDK_GetKey(VK_SPACE)==S_PUSH) SetLoopFunc(Quit);
		break;
	}
	CursorMove(&pos, &g_PointPos, &g_CameraPos, false);
	SetCursor(svw.winW/2, svw.winH/2);
	pp = CameraSet(g_CameraDir, g_CameraBank, g_CameraDist, &g_CameraPos, &g_PointPos);
	BeginScene();
	devSetState(D3DRS_ZFUNC, D3DCMP_LESSEQUAL);
	g_Pointer = WorldToScreen2(&pp);
	devSetLighting(true);
	ResetMatrix();
	devResetMaterial();
	devSetTexture(0, NULL);
	devSetLighting(false);
	Text(30, 15+(1+MAIN_LOG_MAX)*FONT_HEIGHT, "RailSim I悤ƂĂ܂B");
	if(CheckRect(g_Pointer.x, g_Pointer.y, 50, 15+(2+MAIN_LOG_MAX)*FONT_HEIGHT, 320, FONT_HEIGHT)){
		Grad2DRect(50, 15+(2+MAIN_LOG_MAX)*FONT_HEIGHT, 50+320, 15+(3+MAIN_LOG_MAX)*FONT_HEIGHT, 0x8000ff00, 0x8000ff00, 0x0000ff00, 0x0000ff00);
		if(click){
			smode = 0; RegisterMode(-1, true);
		}
	}
	if(CheckRect(g_Pointer.x, g_Pointer.y, 50, 15+(3+MAIN_LOG_MAX)*FONT_HEIGHT, 320, FONT_HEIGHT)){
		Grad2DRect(50, 15+(3+MAIN_LOG_MAX)*FONT_HEIGHT, 50+320, 15+(4+MAIN_LOG_MAX)*FONT_HEIGHT, 0x8000ff00, 0x8000ff00, 0x0000ff00, 0x0000ff00);
		if(click){
			smode = 1; SetLoopFunc(Quit);
		}
	}
	TextF(50, 15+(2+MAIN_LOG_MAX)*FONT_HEIGHT, "%sIȂ", TextSw(smode, 0));
	TextF(50, 15+(3+MAIN_LOG_MAX)*FONT_HEIGHT, "%sɏI", TextSw(smode, 1));
	g_GeneralLog.Show();
	RenderMode(true);
	g_ModeLog.Show();
	ShowFPS2();
	devSetLighting(true);
	devSetState(D3DRS_ZFUNC, D3DCMP_ALWAYS);
	RenderArrow(false, 0.0f);
	EndScene();
	VideoCapture(false);
}
