//	Cu
#include "lib\udx.h"

//	萔E}N
#include "Const.h"
#include "Macro.h"

extern const int MAIN_LOG_MAX;
extern const int TRAIN_LOG_MAX;
extern const int TDIA_LOG_MAX;

const float TRAIN_SPEED_CTRL = 0.5f;	//	xݒԊu

//	c[֐
#include "ValueArea.h"
#include "SystemCover.h"
#include "CameraControl.h"
#include "SwitchMode.h"
#include "SaveData.h"

//	NX
#include "CLogger.h"
#include "CRailList.h"
#include "CPlugin.h"
#include "CTrainModel.h"
#include "CTrainGroup.h"
#include "CTrainGroupList.h"
#include "CStructList.h"
#include "CStationList.h"

//	OO[o
extern int g_MiscOptionProjectionMode;
extern CRail *g_RailOptionLinkMaster;
extern int g_TrainOptionModels;
extern int g_TrainOptionSelect;
extern int g_TrainOptionListID;
extern int g_TrainOptionIndex;
extern CTrainModel *g_TrainOptionModelSeed;
extern CTrainModel *g_TrainOptionModelSelect;
extern int g_RailSelectFlag;
extern int g_ObjectSelectFlag;
extern float g_CameraDir;
extern float g_CameraBank;
extern float g_CameraDist;
extern float g_Angle;
extern bool g_ModeChanged;
extern bool g_RenderMode;
extern POINT g_Pointer;
extern D3DCOLOR g_SkyColor;
extern VEC3 g_PointPos;
extern VEC3 g_CameraPos;
extern VEC3 g_LinkNormal;
extern CObject g_SurfaceObject;
extern CObject g_TrainDisplayObject;
extern CLogger g_GeneralLog;
extern CLogger g_TrainLog;
extern CLogger g_TrainGroupLog;
extern CLogger g_TrainExpLog;
extern CLogger g_TrainSpecLog;
extern CLogger g_TrainDiaLog;
extern CLogger g_TrainPointExpLog;
extern CLogger g_TrainDiaExpLog;
extern CLogger g_TrainSetExpLog;
extern CLogger g_TrainViewExpLog;
extern CLogger g_ModeLog;
extern CRailList g_RailOptionList;
extern CTrainGroupList g_TrainOptionList;
extern CStructList g_StructOptionList;
extern CStationList g_StationOptionList;

//	֐錾
void RenderOrder();
void VideoCapture(bool);

/*
 *	qҐ[h
 */
void TrainEdit(){
	static int rk, lk, tab, a_up, a_dn;
	static float te_dir = D3DX_PI*1.75f, te_bank = D3DX_PI/6.0f, te_dist = 10.0f;
	int i;
	bool updatelog = false, drawcompass = false, click = false, dclick = false;
	VEC3 pp;
	POINT pos;
	if(g_ModeChanged){
		tab = a_up = a_dn = 0;
		updatelog = true;
		g_TrainOptionList.GetGroup(g_TrainOptionIndex)->SetLog();
	}
	pos = GetCursorXY();
	if((pos.x!=(svw.winW/2)) || (pos.y!=(svw.winH/2))) rk = lk = 0;
	switch(SDK_GetKey(VK_LBUTTON)){
	case S_PULL:
		if(lk>1){
			lk = 0;
			dclick = true;
		}else if(lk){
			lk = DCLICK_DURATION;
			if(ClickMode()){
				if(g_ModeChanged) return;
			}else{
				click = true;
			}
		}
		break;
	case S_PUSH:
		if(!lk) lk = 1;
		break;
	default:
		if(lk>1) lk--;
		break;
	}
	switch(SDK_GetKey(VK_RBUTTON)){
	case S_PULL:
		if(rk>1){
			rk = 0;
			g_TrainOptionList.GetGroup(g_TrainOptionIndex)->PopCar();
		}else if(rk){
			rk = DCLICK_DURATION;
			g_TrainOptionList.GetGroup(g_TrainOptionIndex)->TurnCar();
		}
		break;
	case S_PUSH:
		if(!rk) rk = 1;
		break;
	case S_HOLD:
		if(rk>1) rk--;
		drawcompass = true;
		CameraRotate(&pos, &te_dir, &te_bank);
		break;
	default:
		if(rk>1) rk--;
		SwitchMode();
		if(SDK_GetKey(VK_TAB)>=S_PUSH){
			tab++;
			if(tab==1 || tab>=LONGPUSH){
				if(CheckShift()) g_TrainOptionIndex--; else g_TrainOptionIndex++;
				ValueCircular(&g_TrainOptionIndex, 0, TRAIN_GROUP_MAX-1);
				g_TrainOptionList.GetGroup(g_TrainOptionIndex)->SetLog();
			}
		}else{
			tab = 0;
		}
		if(SDK_GetKey(VK_UP)>=S_PUSH){
			a_up++;
			if(a_up==1 || a_up>=LONGPUSH){
				g_TrainOptionSelect--;
				updatelog = true;
			}
		}else{
			a_up = 0;
		}
		if(SDK_GetKey(VK_DOWN)>=S_PUSH){
			a_dn++;
			if(a_dn==1 || a_dn>=LONGPUSH){
				g_TrainOptionSelect++;
				updatelog = true;
			}
		}else{
			a_dn = 0;
		}
		if(updatelog){
			ValueCircular(&g_TrainOptionSelect, 0, g_TrainOptionModels-1);
			ValueArea(&g_TrainOptionListID, g_TrainOptionSelect-TRAIN_LOG_MAX+4, g_TrainOptionSelect);
		}
		if(SDK_GetKey(VK_RIGHT)==S_PUSH) g_TrainOptionList.GetGroup(g_TrainOptionIndex)->AddCar(g_TrainOptionModelSelect, false);
		if(SDK_GetKey(VK_SPACE)==S_PUSH) g_TrainOptionList.GetGroup(g_TrainOptionIndex)->TurnCar();
		if(SDK_GetKey(VK_LEFT)==S_PUSH) g_TrainOptionList.GetGroup(g_TrainOptionIndex)->PopCar();
		CursorMove(&pos, &g_PointPos, &g_CameraPos, false);
	}
	SetCursor(svw.winW/2, svw.winH/2);
	CameraDistance(&te_dist);
	pp = CameraSet(te_dir, te_bank, te_dist, &V3ZERO, &g_PointPos);
	BeginScene();
	g_RenderMode = false;
	SetDirLight(LIGHT_DEF_DIR, MAKE_CV(1.0f, 1.0f, 1.0f, 1.0f));
	devSetAmbient(0xff808080);
	devSetState(D3DRS_ZFUNC, D3DCMP_LESSEQUAL);
	g_Pointer = WorldToScreen2(&pp);
	devSetLighting(true);
	g_TrainDisplayObject.Render();
	g_TrainOptionList.GetGroup(g_TrainOptionIndex)->Preview();
	ResetMatrix();
	devResetMaterial();
	devSetTexture(0, NULL);
	devSetLighting(false);
	g_GeneralLog.Show();
	for(i = 1; i<TRAIN_LOG_MAX; i++){
		if(CheckRect(g_Pointer.x, g_Pointer.y, 5, 15+(1+MAIN_LOG_MAX+i)*FONT_HEIGHT, 320, FONT_HEIGHT)){
			Grad2DRect(5, 15+(1+MAIN_LOG_MAX+i)*FONT_HEIGHT, 5+320, 15+(2+MAIN_LOG_MAX+i)*FONT_HEIGHT, 0x8000ff00, 0x8000ff00, 0x0000ff00, 0x0000ff00);
			if(i==1){
				if(click){
					if(TRAIN_LOG_MAX-3<g_TrainOptionModels)
						g_TrainOptionListID = g_TrainOptionModels-TRAIN_LOG_MAX+3;
					updatelog = true;
				}else if(SDK_GetKey(VK_LBUTTON)>=S_PUSH && g_TrainOptionListID>0){
					g_TrainOptionListID--;
					lk = 0;
					updatelog = true;
				}
			}else if(i==TRAIN_LOG_MAX-1){
				if(click){
					g_TrainOptionListID = 0;
					updatelog = true;
				}else if(SDK_GetKey(VK_LBUTTON)>=S_PUSH
					&& g_TrainOptionListID<g_TrainOptionModels-TRAIN_LOG_MAX+3){
					g_TrainOptionListID++;
					lk = 0;
					updatelog = true;
				}
			}else if(click && g_TrainOptionListID+i-2<g_TrainOptionModels){
				g_TrainOptionSelect = g_TrainOptionListID+i-2;
				updatelog = true;
			}else if(dclick && g_TrainOptionListID+i-2<g_TrainOptionModels){
				g_TrainOptionList.GetGroup(g_TrainOptionIndex)->AddCar(g_TrainOptionModelSelect, false);
			}
		}
	}
	if(updatelog){
		g_TrainLog.Clear();
		g_TrainLog.AddF("p\ԗ(%d/%d)", g_TrainOptionSelect+1, g_TrainOptionModels);
		g_TrainLog.Add(g_TrainOptionListID ? "" : "");
		g_TrainOptionModelSeed->AddLog(g_TrainOptionListID);
		g_TrainLog.Add(g_TrainOptionListID+TRAIN_LOG_MAX-3<g_TrainOptionModels ? "" : "");
	}
	g_TrainLog.Show();
	g_TrainGroupLog.Show();
	g_TrainExpLog.Show();
	g_TrainSpecLog.Show();
	RenderMode(true);
	g_ModeLog.Show();
	ShowFPS2();
	devSetLighting(true);
	devSetState(D3DRS_ZFUNC, D3DCMP_ALWAYS);
	if(!drawcompass) RenderArrow(false, 0.0f);
	EndScene();
	VideoCapture(false);
}

/*
 *	^sݒ胂[h
 */
void TrainDia(){
	static char *ttype[2] = {"Ԏ", "Ԏ"};
	static char *dtype[3] = {" ", "ܕ t", "ʉ "};
	static int dchange[4] = {1, 1, 1, 5};
	static int dmax[4] = {2, 1, 23, 59};
	static int lk, rk, mdia, dsel;
	static bool edit = false;
	static CTrainGroup *group;
	int i, t;
	bool updatelog = false, click = false, rclick = false;
	VEC3 pp;
	POINT pos;
	pos = GetCursorXY();
	if((pos.x!=(svw.winW/2)) || (pos.y!=(svw.winH/2))) lk = rk = 0;
	if(g_ModeChanged){
		group = g_TrainOptionList.GetGroup(g_TrainOptionIndex);
		group->SetLog();
		group->SetDiaLog();
		edit = false;
	}
	switch(SDK_GetKey(VK_LBUTTON)){
	case S_PUSH:
		lk = 1;
		break;
	case S_HOLD:
		break;
	case S_PULL:
		if(lk){
			if(ClickMode()){
				if(g_ModeChanged) return;
			}else{
				click = true;
			}
		}
	default:
		lk = 0;
		break;
	}
	switch(SDK_GetKey(VK_RBUTTON)){
	case S_PUSH:
		rk = 1;
		break;
	case S_HOLD:
		break;
	case S_PULL:
		if(rk) rclick = true;
	default:
		rk = 0;
		break;
	}
	SwitchMode();
	if(SDK_GetKey(VK_TAB)==S_PUSH){
		if(CheckShift()) g_TrainOptionIndex--; else g_TrainOptionIndex++;
		ValueCircular(&g_TrainOptionIndex, 0, TRAIN_GROUP_MAX-1);
		group = g_TrainOptionList.GetGroup(g_TrainOptionIndex);
		group->SetLog();
		group->SetDiaLog();
		edit = false;
	}
	if(SDK_GetKey('Z')==S_PUSH) mdia = 0;
	if(SDK_GetKey('X')==S_PUSH) mdia = 1;
	if(mdia){
		if(edit){
			if(SDK_GetKey(VK_SPACE)==S_PUSH) edit = false;
			if(SDK_GetKey(VK_LEFT)==S_PUSH){
				group->GetDia()[dsel] -= dchange[dsel];
				updatelog = true;
			}
			if(SDK_GetKey(VK_RIGHT)==S_PUSH){
				group->GetDia()[dsel] += dchange[dsel];
				updatelog = true;
			}
			if(SDK_GetKey(VK_UP)==S_PUSH) dsel--;
			if(SDK_GetKey(VK_DOWN)==S_PUSH) dsel++;
			ValueCircular(&dsel, 0, 3);
			ValueCircular(&group->GetDia()[dsel], 0, dmax[dsel]);
		}else{
			if(SDK_GetKey(VK_UP)==S_PUSH){
				group->GetDiaSelect()--;
				updatelog = true;
			}
			if(SDK_GetKey(VK_DOWN)==S_PUSH){
				group->GetDiaSelect()++;
				updatelog = true;
			}
			if(SDK_GetKey(VK_SPACE)==S_PUSH && group->GetDiaNumber()) edit = true;
		}
		if(SDK_GetKey('A')==S_PUSH){
			group->AddDia();
			edit = true;
			updatelog = true;
		}
		if(SDK_GetKey('S')==S_PUSH){
			group->DeleteDia();
			edit = false;
			updatelog = true;
		}
		if(SDK_GetKey('Q')==S_PUSH){
			group->MoveDia(true);
			edit = false;
			updatelog = true;
		}
		if(SDK_GetKey('W')==S_PUSH){
			group->MoveDia(false);
			edit = false;
			updatelog = true;
		}
		if(updatelog){
			if(group->GetDiaNumber()){
				ValueCircular(&group->GetDiaSelect(), 0, group->GetDiaNumber()-1);
				ValueArea(&group->GetDiaListID(), group->GetDiaSelect()-TDIA_LOG_MAX+4, group->GetDiaSelect());
				if(group->GetDiaNumber()-group->GetDiaListID()+3<TDIA_LOG_MAX
					&& group->GetDiaNumber()>=TDIA_LOG_MAX-3)
					group->GetDiaListID() = group->GetDiaNumber()-TDIA_LOG_MAX+3;
			}else{
				group->GetDiaSelect() = -1;
				group->GetDiaListID() = 0;
			}
		}
	}else{
		if(SDK_GetKey(VK_LEFT)==S_PUSH) group->AddPoint(1);
		if(SDK_GetKey(VK_RIGHT)==S_PUSH) group->AddPoint(2);
		if(SDK_GetKey(VK_BACK)==S_PUSH) group->PopPoint();
		if(SDK_GetKey(VK_DELETE)==S_PUSH) group->ClearPoint();
	}
	CursorMove(&pos, &g_PointPos, &g_CameraPos, false);
	SetCursor(svw.winW/2, svw.winH/2);
	pp = CameraSet(g_CameraDir, g_CameraBank, g_CameraDist, &g_CameraPos, &g_PointPos);
	BeginScene();
	g_RenderMode = false;
	SetDirLight(LIGHT_DEF_DIR, MAKE_CV(1.0f, 1.0f, 1.0f, 1.0f));
	devSetAmbient(0xff808080);
	devSetState(D3DRS_ZFUNC, D3DCMP_LESSEQUAL);
	g_Pointer = WorldToScreen2(&pp);
	devSetLighting(true);
	group->Preview();
	ResetMatrix();
	ResetMatrix();
	devResetMaterial();
	devSetTexture(0, NULL);
	devSetLighting(false);
	if(CheckRect(g_Pointer.x, g_Pointer.y, 5, 15+(2+MAIN_LOG_MAX)*FONT_HEIGHT, 200, FONT_HEIGHT)){
		Grad2DRect(5, 15+(2+MAIN_LOG_MAX)*FONT_HEIGHT, 5+200, 15+(3+MAIN_LOG_MAX)*FONT_HEIGHT, 0x8000ff00, 0x8000ff00, 0x0000ff00, 0x0000ff00);
		if(click) mdia = 0;
	}
	if(CheckRect(g_Pointer.x, g_Pointer.y, 5, 15+(3+MAIN_LOG_MAX)*FONT_HEIGHT, 200, FONT_HEIGHT)){
		Grad2DRect(5, 15+(3+MAIN_LOG_MAX)*FONT_HEIGHT, 5+200, 15+(4+MAIN_LOG_MAX)*FONT_HEIGHT, 0x8000ff00, 0x8000ff00, 0x0000ff00, 0x0000ff00);
		if(click) mdia = 1;
	}
	TextF(5, 15+(2+MAIN_LOG_MAX)*FONT_HEIGHT, "%s|Cgݒ(Z)\n%s_Cݒ(X)", TextSw(mdia, 0), TextSw(mdia, 1));
	if(mdia){
		for(i = 1; i<TDIA_LOG_MAX; i++){
			if(CheckRect(g_Pointer.x, g_Pointer.y, 220, 15+(1+MAIN_LOG_MAX+i)*FONT_HEIGHT, 240, FONT_HEIGHT)){
				Grad2DRect(220, 15+(1+MAIN_LOG_MAX+i)*FONT_HEIGHT, 220+240, 15+(2+MAIN_LOG_MAX+i)*FONT_HEIGHT, 0x8000ff00, 0x8000ff00, 0x0000ff00, 0x0000ff00);
				if(i==1){
					if(click){
						if(TDIA_LOG_MAX-3<group->GetDiaNumber())
							group->GetDiaListID() = group->GetDiaNumber()-TDIA_LOG_MAX+3;
						updatelog = true;
					}else if(SDK_GetKey(VK_LBUTTON)>=S_PUSH && group->GetDiaListID()>0){
						group->GetDiaListID()--;
						lk = 0;
						updatelog = true;
					}
				}else if(i==TDIA_LOG_MAX-1){
					if(click){
						group->GetDiaListID() = 0;
						updatelog = true;
					}else if(SDK_GetKey(VK_LBUTTON)>=S_PUSH
						&& group->GetDiaListID()<group->GetDiaNumber()-TDIA_LOG_MAX+3){
						group->GetDiaListID()++;
						lk = 0;
						updatelog = true;
					}
				}else if(click && group->GetDiaListID()+i-2<group->GetDiaNumber()){
					if(group->GetDiaSelect() ==group->GetDiaListID()+i-2){
						edit = !edit;
					}else{
						group->GetDiaSelect() = group->GetDiaListID()+i-2;
						edit = true;
					}
					updatelog = true;
				}
			}
		}
		if(edit){
			for(i = 0; i<4; i++){
				if(CheckRect(g_Pointer.x, g_Pointer.y, 220, 15+(2+MAIN_LOG_MAX+TDIA_LOG_MAX+i)*FONT_HEIGHT, 240, FONT_HEIGHT)){
					Grad2DRect(220, 15+(2+MAIN_LOG_MAX+TDIA_LOG_MAX+i)*FONT_HEIGHT, 220+240, 15+(3+MAIN_LOG_MAX+TDIA_LOG_MAX+i)*FONT_HEIGHT, 0x8000ff00, 0x8000ff00, 0x0000ff00, 0x0000ff00);
					if(click){
						dsel = i; group->GetDia()[i] += dchange[i];
						updatelog = true;
					}
					if(rclick){
						dsel = i; group->GetDia()[i] -= dchange[i];
						updatelog = true;
					}
				}
			}
			ValueCircular(&group->GetDia()[dsel], 0, dmax[dsel]);
		}
		if(CheckRect(g_Pointer.x, g_Pointer.y, 35, 20+(4+MAIN_LOG_MAX)*FONT_HEIGHT, 170, FONT_HEIGHT)){
			Grad2DRect(35, 20+(4+MAIN_LOG_MAX)*FONT_HEIGHT, 35+170, 20+(5+MAIN_LOG_MAX)*FONT_HEIGHT, 0x8000ff00, 0x8000ff00, 0x0000ff00, 0x0000ff00);
			if(click){
				group->AddDia();
				ValueArea(&group->GetDiaListID(), group->GetDiaSelect()-TDIA_LOG_MAX+4, group->GetDiaSelect());
				edit = true;
				updatelog = true;
			}
		}
		if(CheckRect(g_Pointer.x, g_Pointer.y, 35, 20+(5+MAIN_LOG_MAX)*FONT_HEIGHT, 170, FONT_HEIGHT)){
			Grad2DRect(35, 20+(5+MAIN_LOG_MAX)*FONT_HEIGHT, 35+170, 20+(6+MAIN_LOG_MAX)*FONT_HEIGHT, 0x8000ff00, 0x8000ff00, 0x0000ff00, 0x0000ff00);
			if(click){
				group->DeleteDia();
				if(group->GetDiaNumber()){
					if(group->GetDiaNumber()-group->GetDiaListID()+3<TDIA_LOG_MAX
						&& group->GetDiaNumber()>=TDIA_LOG_MAX-3)
						group->GetDiaListID() = group->GetDiaNumber()-TDIA_LOG_MAX+3;
				}else{
					group->GetDiaSelect() = -1;
					group->GetDiaListID() = 0;
				}
				edit = false;
				updatelog = true;
			}
		}
		if(CheckRect(g_Pointer.x, g_Pointer.y, 35, 20+(6+MAIN_LOG_MAX)*FONT_HEIGHT, 170, FONT_HEIGHT)){
			Grad2DRect(35, 20+(6+MAIN_LOG_MAX)*FONT_HEIGHT, 35+170, 20+(7+MAIN_LOG_MAX)*FONT_HEIGHT, 0x8000ff00, 0x8000ff00, 0x0000ff00, 0x0000ff00);
			if(click){
				group->MoveDia(true);
				edit = false;
				updatelog = true;
			}
		}
		if(CheckRect(g_Pointer.x, g_Pointer.y, 35, 20+(7+MAIN_LOG_MAX)*FONT_HEIGHT, 170, FONT_HEIGHT)){
			Grad2DRect(35, 20+(7+MAIN_LOG_MAX)*FONT_HEIGHT, 35+170, 20+(8+MAIN_LOG_MAX)*FONT_HEIGHT, 0x8000ff00, 0x8000ff00, 0x0000ff00, 0x0000ff00);
			if(click){
				group->MoveDia(false);
				edit = false;
				updatelog = true;
			}
		}
		if(updatelog) group->SetDiaLog();
		if(edit){
			TextF(220, 15+(2+MAIN_LOG_MAX+TDIA_LOG_MAX)*FONT_HEIGHT,
				"%sԐݒ: %s", TextSw(dsel, 0), dtype[group->GetDia()[0]]);
			TextF(220, 15+(3+MAIN_LOG_MAX+TDIA_LOG_MAX)*FONT_HEIGHT,
				"%sԐݒ: %s", TextSw(dsel, 1), ttype[group->GetDia()[1]]);
			TextF(220, 15+(4+MAIN_LOG_MAX+TDIA_LOG_MAX)*FONT_HEIGHT,
				"%s:%02d", TextSw(dsel, 2), group->GetDia()[2]);
			TextF(220, 15+(5+MAIN_LOG_MAX+TDIA_LOG_MAX)*FONT_HEIGHT,
				"%s:%02d", TextSw(dsel, 3), group->GetDia()[3]);
		}
		Text(35, 20+(4+MAIN_LOG_MAX)*FONT_HEIGHT, "_Cǉ(A)\n_C폜(S)\n(Q)\n(W)");
		g_TrainDiaLog.Show();
		g_TrainDiaExpLog.Show();
	}else{
		if(CheckRect(g_Pointer.x, g_Pointer.y, 35, 20+(4+MAIN_LOG_MAX)*FONT_HEIGHT, 170, FONT_HEIGHT)){
			Grad2DRect(35, 20+(4+MAIN_LOG_MAX)*FONT_HEIGHT, 35+170, 20+(5+MAIN_LOG_MAX)*FONT_HEIGHT, 0x8000ff00, 0x8000ff00, 0x0000ff00, 0x0000ff00);
			if(click) group->AddPoint(1);
		}
		if(CheckRect(g_Pointer.x, g_Pointer.y, 35, 20+(5+MAIN_LOG_MAX)*FONT_HEIGHT, 170, FONT_HEIGHT)){
			Grad2DRect(35, 20+(5+MAIN_LOG_MAX)*FONT_HEIGHT, 35+170, 20+(6+MAIN_LOG_MAX)*FONT_HEIGHT, 0x8000ff00, 0x8000ff00, 0x0000ff00, 0x0000ff00);
			if(click) group->AddPoint(2);
		}
		if(CheckRect(g_Pointer.x, g_Pointer.y, 35, 20+(6+MAIN_LOG_MAX)*FONT_HEIGHT, 170, FONT_HEIGHT)){
			Grad2DRect(35, 20+(6+MAIN_LOG_MAX)*FONT_HEIGHT, 35+170, 20+(7+MAIN_LOG_MAX)*FONT_HEIGHT, 0x8000ff00, 0x8000ff00, 0x0000ff00, 0x0000ff00);
			if(click) group->PopPoint();
		}
		if(CheckRect(g_Pointer.x, g_Pointer.y, 35, 20+(7+MAIN_LOG_MAX)*FONT_HEIGHT, 170, FONT_HEIGHT)){
			Grad2DRect(35, 20+(7+MAIN_LOG_MAX)*FONT_HEIGHT, 35+170, 20+(8+MAIN_LOG_MAX)*FONT_HEIGHT, 0x8000ff00, 0x8000ff00, 0x0000ff00, 0x0000ff00);
			if(click) group->ClearPoint();
		}
		Text(35, 20+(4+MAIN_LOG_MAX)*FONT_HEIGHT, "ǉ()\nEǉ()\n1폜(BS)\nS폜(DEL)");
		for(i = 0; (i<TRAIN_POINT_MAX) && (t = group->GetPoint(i)); i++)
			Text(220+i%16*16, 15+(1+MAIN_LOG_MAX)*FONT_HEIGHT+i/16*16, t==1 ? "" : "E");
		t = group->CountPoint();
		TextF(220, 15+(1+MAIN_LOG_MAX)*FONT_HEIGHT+(i/16+1-!(i%16))*16, "|Cgݒ萔: %d", t);
		g_TrainPointExpLog.Show();
	}
	g_GeneralLog.Show();
	g_TrainGroupLog.Show();
	RenderMode(true);
	g_ModeLog.Show();
	ShowFPS2();
	devSetLighting(true);
	devSetState(D3DRS_ZFUNC, D3DCMP_ALWAYS);
	RenderArrow(false, 0.0f);
	EndScene();
	VideoCapture(false);
}

/*
 *	qzu[h
 */
void TrainSet(){
	static int spsetmode = 2, rk, lk;
	float tsps, gndalt = 0.0f;
	bool drawcompass = false;
	VEC3 pp, tgpick;
	POINT pos;
	pos = GetCursorXY();
	if((pos.x!=(svw.winW/2)) || (pos.y!=(svw.winH/2))) rk = lk = 0;
	if(g_ModeChanged) g_TrainOptionList.GetGroup(g_TrainOptionIndex)->SetLog();
	switch(SDK_GetKey(VK_LBUTTON)){
	case S_PUSH:
		lk = 1;
		break;
	case S_HOLD:
		break;
	case S_PULL:
		if(lk){
			if(ClickMode()){
				if(g_ModeChanged) return;
			}else{
				if(g_RailOptionLinkMaster) g_TrainOptionList.GetGroup(g_TrainOptionIndex)
					->Set(g_RailOptionLinkMaster, &g_LinkNormal, CheckShift());
			}
		}
	default:
		lk = 0;
		break;
	}
	switch(SDK_GetKey(VK_RBUTTON)){
	case S_PULL:
		if(rk>1){
			rk = 0;
			g_TrainOptionList.GetGroup(g_TrainOptionIndex)->Remove();
		}else if(rk){
			rk = DCLICK_DURATION;
		}
		break;
	case S_PUSH:
		if(!rk) rk = 1;
		break;
	case S_HOLD:
		drawcompass = true;
		if(g_SurfaceObject.Pick(VEC3(g_CameraPos.x, FIELD_HEIGHT, g_CameraPos.z), -V3UP, &tgpick, NULL)) gndalt = tgpick.y;
		ValueArea(&tgpick.y, CAM_MIN_HIGH, FIELD_HEIGHT);
		CameraRotate(&pos, &g_CameraDir, &g_CameraBank);
		break;
	default:
		SwitchMode();
		if(CheckSlide()){
			drawcompass = true;
			gndalt = CameraSlide(&pos, &g_CameraPos);
		}else{
			CursorMove(&pos, &g_PointPos, &g_CameraPos, true);
		}
		if(SDK_GetKey(VK_TAB)==S_PUSH){
			if(CheckShift()) g_TrainOptionIndex--; else g_TrainOptionIndex++;
			ValueCircular(&g_TrainOptionIndex, 0, TRAIN_GROUP_MAX-1);
			g_TrainOptionList.GetGroup(g_TrainOptionIndex)->SetLog();
		}
		if(SDK_GetKey(VK_DELETE)==S_PUSH) g_TrainOptionList.GetGroup(g_TrainOptionIndex)->Remove();
		if((SDK_GetKey(VK_RIGHT)==S_PUSH) || (SDK_GetKey(VK_LEFT)==S_PUSH)){
			tsps = g_TrainOptionList.GetGroup(g_TrainOptionIndex)->GetSpset();
			spsetmode = (tsps<=0.0f ? 2 : 0)|(tsps>=0.0f ? 4 : 0);
		}
		if(SDK_GetKey(VK_RIGHT)>=S_PUSH) g_TrainOptionList.GetGroup(g_TrainOptionIndex)->SetSpeed(TRAIN_SPEED_CTRL, spsetmode|1);
		if(SDK_GetKey(VK_LEFT)>=S_PUSH) g_TrainOptionList.GetGroup(g_TrainOptionIndex)->SetSpeed(TRAIN_SPEED_CTRL, spsetmode);
		ScanUndoRedo();
	}
	SetCursor(svw.winW/2, svw.winH/2);
	CameraDistance(&g_CameraDist);
	pp = CameraSet(g_CameraDir, g_CameraBank, g_CameraDist, &g_CameraPos, &g_PointPos);
	g_RailOptionList.TryLink(true);
	BeginScene(g_SkyColor);
	devSetState(D3DRS_ZFUNC, D3DCMP_LESSEQUAL);
	SpinEarth();
	g_RailSelectFlag = 8;
	g_ObjectSelectFlag = 0;
	g_Pointer = WorldToScreen2(&pp);
	devSetLighting(true);
	RenderOrder();
	switch(SwitchAlt()){
	case 0:
		ResetMatrix();
		devResetMaterial();
		devSetTexture(0, NULL);
		devSetLighting(false);
		TextF(5, 15+(1+MAIN_LOG_MAX)*FONT_HEIGHT, "J[\: (%d, %d)", g_Pointer.x, g_Pointer.y);
		TextF(5, 15+(2+MAIN_LOG_MAX)*FONT_HEIGHT, "_S: (%.2f, %.2f, %.2f)", g_CameraPos.x, g_CameraPos.y, g_CameraPos.z);
		g_GeneralLog.Show();
		g_TrainGroupLog.Show();
		g_TrainSetExpLog.Show();
		RenderMode(true);
		g_ModeLog.Show();
		g_TrainOptionList.GetGroup(g_TrainOptionIndex)->ShowSpeed();
		ShowFPS2();
		devSetLighting(true);
		devSetState(D3DRS_ZFUNC, D3DCMP_ALWAYS);
		RenderMagnet();
		RenderArrow(drawcompass, gndalt);
		break;
	case 1:
		g_TrainOptionList.GetGroup(g_TrainOptionIndex)->ShowSpeed2();
		MiniStatus();
		break;
	}
	EndScene();
	VideoCapture(true);
}

/*
 *	q_[h
 */
void TrainView(){
	static int lk;
	static int spsetmode = 2, vmode = 0;
	static char *mstr[2] = {"Oσ[h", "^]ȃ[h"};
	int i, tn;
	float tsps, gndalt = 0.0f;
	bool drawcompass = false, click = false;
	VEC3 pp;
	POINT pos;
	if(g_ModeChanged){
		if(!g_TrainOptionList.GetGroup(g_TrainOptionIndex)->IsEnable()){
			for(i = 0; i<TRAIN_GROUP_MAX; i++){
				if(g_TrainOptionList.GetGroup(i)->IsEnable()){
					g_TrainOptionIndex = i;
					g_TrainOptionList.GetGroup(i)->SetLog();
					break;
				}
			}
			if(i==TRAIN_GROUP_MAX){
				g_GeneralLog.Add("zuĂq܂B");
				RegisterMode(2, true);
				return;
			}
		}else{
			g_TrainOptionList.GetGroup(g_TrainOptionIndex)->SetLog();
		}
	}
	pos = GetCursorXY();
	if((pos.x!=(svw.winW/2)) || (pos.y!=(svw.winH/2))) lk = 0;
	switch(SDK_GetKey(VK_LBUTTON)){
	case S_PUSH:
		lk = 1;
		break;
	case S_HOLD:
		break;
	case S_PULL:
		if(lk){
			if(ClickMode()){
				if(g_ModeChanged) return;
			}else{
				click = true;
			}
		}
	default:
		lk = 0;
		break;
	}
	if(SDK_GetKey(VK_RBUTTON)>=S_PUSH){
		drawcompass = true;
		CameraRotate(&pos, &g_CameraDir, &g_CameraBank);
	}else{
		SwitchMode();
		if(SDK_GetKey(VK_TAB)==S_PUSH){
			i = g_TrainOptionIndex;
			if(CheckShift()) tn = -1; else tn = 1;
			do{
				g_TrainOptionIndex += tn;
				ValueCircular(&g_TrainOptionIndex, 0, TRAIN_GROUP_MAX-1);
			} while(!g_TrainOptionList.GetGroup(g_TrainOptionIndex)->IsEnable());
			g_TrainOptionList.GetGroup(g_TrainOptionIndex)->SetLog();
		}
		if(SDK_GetKey(VK_SPACE)==S_PUSH){
			vmode++;
			ValueCircular(&vmode, 0, 1);
			g_GeneralLog.AddF("J: %s", mstr[vmode]);
		}
		if((SDK_GetKey(VK_RIGHT)==S_PUSH) || (SDK_GetKey(VK_LEFT)==S_PUSH)){
			tsps = g_TrainOptionList.GetGroup(g_TrainOptionIndex)->GetSpset();
			spsetmode = (tsps<=0.0f ? 2 : 0)|(tsps>=0.0f ? 4 : 0);
		}
		if(SDK_GetKey(VK_RIGHT)>=S_PUSH) g_TrainOptionList.GetGroup(g_TrainOptionIndex)->SetSpeed(TRAIN_SPEED_CTRL, spsetmode|1);
		if(SDK_GetKey(VK_LEFT)>=S_PUSH) g_TrainOptionList.GetGroup(g_TrainOptionIndex)->SetSpeed(TRAIN_SPEED_CTRL, spsetmode);
		CursorMove(&pos, &g_PointPos, &g_CameraPos, true);
	}
	SetCursor(svw.winW/2, svw.winH/2);
	if(vmode){
		if(g_MiscOptionProjectionMode) vmode = 0;
		g_TrainOptionList.GetGroup(g_TrainOptionIndex)->SetCab();
	}else{
		CameraDistance(&g_CameraDist);
		g_TrainOptionList.GetGroup(g_TrainOptionIndex)->SetCam(g_CameraDir, g_CameraBank, g_CameraDist);
	}
	pp = ArrowSet(&GetVPos(), &g_PointPos);
	g_RailOptionList.TryLink(true);
	BeginScene(g_SkyColor);
	devSetState(D3DRS_ZFUNC, D3DCMP_LESSEQUAL);
	SpinEarth();
	g_RailSelectFlag = 0;
	g_ObjectSelectFlag = 0;
	g_Pointer = WorldToScreen2(&pp);
	devSetLighting(true);
	RenderOrder();
	switch(SwitchAlt()){
	case 0:
		ResetMatrix();
		devResetMaterial();
		devSetTexture(0, NULL);
		devSetLighting(false);
		TextF(5, 15+(2+MAIN_LOG_MAX)*FONT_HEIGHT, "_S: (%.2f, %.2f, %.2f)", pp.x, pp.y, pp.z);
		TextF(5, 15+(3+MAIN_LOG_MAX)*FONT_HEIGHT, "J: %s", mstr[vmode]);
		g_GeneralLog.Show();
		g_TrainGroupLog.Show();
		g_TrainViewExpLog.Show();
		RenderMode(true);
		g_ModeLog.Show();
		g_TrainOptionList.GetGroup(g_TrainOptionIndex)->ShowSpeed();
		ShowFPS2();
		devSetLighting(true);
		devSetState(D3DRS_ZFUNC, D3DCMP_ALWAYS);
		RenderMagnet();
		if(!drawcompass) RenderArrow(false, 0.0f);
		break;
	case 1:
		g_TrainOptionList.GetGroup(g_TrainOptionIndex)->ShowSpeed2();
		MiniStatus();
		break;
	}
	EndScene();
	VideoCapture(true);
}
