//@@@@@@@@@@@@@@@@@@@@@@Copyright (c) 2002 Midikyou
#include"headers.h"
#include"debug.h"
#include"window.h"
#include"graphic.h"
#include"movie.h"

/*============================================================================
  DirectShow̏
============================================================================*/
BOOL InitDirectShow()
{
	DebugHL();
	Debug("InitDirectShow\n");

	//tB^Ot\zpIuWFNg
	FAILED_ASSERT(
		"OtBbNtB^ł܂.",
		CoCreateInstance(
			CLSID_FilterGraph, NULL, CLSCTX_INPROC_SERVER, 
			IID_IGraphBuilder, (void **)&svv.pGraph
		)
	);
	//fBAĐRg[
	FAILED_ASSERT(
		"fBARg[ł܂.",
		svv.pGraph->QueryInterface(
			IID_IMediaControl, (void **)&svv.pMCtrl
		)
	);
	//ʒmCxg
  	FAILED_ASSERT(
		"fBACxgł܂.",
		svv.pGraph->QueryInterface(
			IID_IMediaEventEx, (void **)&svv.pEvent
		)
	);
	return TRUE;
}
/*============================================================================
  DirectShow̉
============================================================================*/
void FreeDirectShow()
{
	DebugHL();
	Debug("FreeDirectShow\n");

	StopMovie();
	RELEASE(svv.pEvent);
	RELEASE(svv.pMCtrl);
	RELEASE(svv.pGraph);
}
/*============================================================================
  [r[Cxgɑ΂nh
============================================================================*/
void OnGrapNotify()
{
	if(svv.pEvent == NULL) return; //[r[@\gpĂ΂邽߃`FbN

	long evCode, param1, param2;

	//SCxgo
	while( SUCCEEDED(svv.pEvent->GetEvent(&evCode, &param1, &param2, 0)) )
	{ 
		//CxgɊ֘A郊\[X
		svv.pEvent->FreeEventParams(evCode, param1, param2);

		if((EC_COMPLETE == evCode) || (EC_USERABORT == evCode))
		{
			StopMovie();
			break;
		} 
	} 
}
/*============================================================================
  [r[Đ

@strFile	:t@C
@
  Đ̓V[̃_O~߂邱ƁB
============================================================================*/
BOOL PlayMovie(char* strFile)
{
	Debug("play(%s) ... ",strFile);

	WCHAR wstr[MAX_PATH];

	MultiByteToWideChar(CP_ACP,0,strFile,-1,wstr,MAX_PATH);

    if( FAILED(svv.pGraph->RenderFile(wstr, NULL)) )
	{
		Debug("can't render.\n");
		return FALSE;
	}
	if( FAILED(svv.pGraph->QueryInterface(IID_IVideoWindow, (void **)&svv.pVWin)) )
	{
		Debug("can't query interface.\n");
		return FALSE;
	}
	if( FAILED(svv.pEvent->SetNotifyWindow((OAHWND)svw.hWnd, WM_GRAPHNOTIFY, 0)) )
	{
		Debug("can't set notify window.\n");
		return FALSE;
	}
	AdjustMovieLayer();

	if( FAILED(svv.pMCtrl->Run()) )
	{
		Debug("can't run media control.\n");
		return FALSE;
	}
	Debug("ok.\n");
	svv.fPlay = TRUE;

	return TRUE;
}
/*============================================================================
  [r[~
============================================================================*/
void StopMovie()
{
	svv.fPlay = FALSE;
	svv.pMCtrl->Stop();
	RELEASE(svv.pVWin);
}
/*============================================================================
  ĐԂ̎擾
============================================================================*/
BOOL GetMovieState()
{
	return svv.fPlay;
}
/*============================================================================
  [r[C[̃TCYNCAg̈ɍ킹
============================================================================*/
void AdjustMovieLayer()
{
	if(svv.pVWin == NULL) return; //[r[@\gpĂ΂邽߃`FbN

	svv.pVWin->put_Owner((OAHWND)svw.hWnd);
	svv.pVWin->put_WindowStyle(WS_CHILD | WS_CLIPSIBLINGS);
	svv.pVWin->SetWindowPosition(0, 0, svw.winW, svw.winH);
}
