//@@@@@@@@@@@@@@@@@@@@@@Copyright (c) 2002 Midikyou
#include"headers.h"
#include"debug.h"
#include"sound.h"
#include"music.h"

/*============================================================================
  DirectMusic̏
============================================================================*/
BOOL InitDirectMusic()
{
	DebugHL();
	Debug("InitDirectMusic\n");

	//[_̍쐬
	FAILED_ASSERT(
		"DirectMusic[_[쐬ł܂.",
		CoCreateInstance(
			CLSID_DirectMusicLoader,NULL,CLSCTX_INPROC,
			IID_IDirectMusicLoader8,(void**)&svm.pLoader
		)
	);
	return TRUE;
}
/*============================================================================
  DirectMusic̉
============================================================================*/
void FreeDirectMusic()
{
	DebugHL();
	Debug("FreeDirectMusic\n");

	FreeMusic();
	RELEASE(svm.pLoader);
}
/*============================================================================
  yf[^̃[h
  
  strFile	:t@C
============================================================================*/
BOOL LoadMusic(char* strFile)
{
	Debug("load(%s) ... ",strFile);

	//Ȃ
	if(svm.pSeg) FreeMusic();

	//JgpX擾UNICODEɕϊ
	char dir[MAX_PATH];
	WCHAR tmp[MAX_PATH];

	GetCurrentDirectory(MAX_PATH,dir);
	MultiByteToWideChar(CP_ACP,0,dir,-1,tmp,MAX_PATH);

	//fBNgw
	svm.pLoader->SetSearchDirectory(GUID_DirectMusicAllTypes,tmp,FALSE);
	MultiByteToWideChar(CP_ACP,0,strFile,-1,tmp,MAX_PATH);

	HRESULT hr;

	//t@CZOgɃ[h
	hr = svm.pLoader->LoadObjectFromFile(
			CLSID_DirectMusicSegment,IID_IDirectMusicSegment8,tmp,(void**)&svm.pSeg
		);

	if(FAILED(hr))
	{
		Debug("can't load object.\n");
		return FALSE;
	}
	Debug("ok.\n");

	//ptH[}X̍쐬
	if(!CreatePerformance()) return FALSE;

	//ZOgptH[}XɃ[h
	svm.pSeg->Download(svm.pPerf);

	return TRUE;
}
/*============================================================================
  yf[^̉
  
  n		:`l
============================================================================*/
void FreeMusic()
{
	StopMusic();
	if(svm.pPerf) svm.pPerf->CloseDown();

	RELEASE(svm.pPerf);
	RELEASE(svm.pSeg);
}
/*============================================================================
  ptH[}X̍쐬
============================================================================*/
BOOL CreatePerformance()
{
	//ptH[}X̍쐬
	FAILED_ASSERT(
		"ptH[}X쐬ł܂.",
		CoCreateInstance(
			CLSID_DirectMusicPerformance,NULL,CLSCTX_INPROC,
			IID_IDirectMusicPerformance8,(void**)&svm.pPerf
		)
	);
	//DirectSound̋C^[tFCX擾
	IDirectSound* pDSound;

	svs.pDS->QueryInterface(IID_IDirectSound,(void**)&pDSound);

	//DirectSoundŃptH[}X
	FAILED_ASSERT(
		"ptH[}Xł܂.",
		svm.pPerf->InitAudio(
			NULL,&pDSound,NULL,
			DMUS_APATH_DYNAMIC_STEREO,64,DMUS_AUDIOF_ALL,NULL)
	);
	RELEASE(pDSound);

	return TRUE;
}
/*============================================================================
  y̍Đ

@f		:[vtOiTRUE[vONAFALSEOFFj
============================================================================*/
void PlayMusic(BOOL f)
{
	if(svm.pSeg == NULL || svm.pPerf == NULL) return;

	svm.pSeg->SetStartPoint(svm.time);
	svm.pSeg->SetRepeats(f ? DMUS_SEG_REPEAT_INFINITE : 0);

	svm.pPerf->PlaySegmentEx(
		svm.pSeg, NULL, NULL, 0, 0,
		&svm.pState, NULL, NULL
	);
}
/*============================================================================
  ÿꎞ~
  
============================================================================*/
void PauseMusic()
{
	if(svm.pSeg == NULL || svm.pPerf == NULL) return;

	svm.pPerf->Stop(NULL,NULL,0,0);
	svm.pState->GetSeek(&svm.time); //~Ԃ擾

	RELEASE(svm.pState);
}
/*============================================================================
  y̒~
============================================================================*/
void StopMusic()
{
	if(svm.pSeg == NULL || svm.pPerf == NULL) return;

	svm.pPerf->Stop(NULL,NULL,0,0);
	svm.time = 0; //os

	RELEASE(svm.pState);
}
/*============================================================================
  y̍ĐԂ擾
============================================================================*/
BOOL GetMusicState()
{
	if(svm.pSeg && svm.pPerf->IsPlaying(svm.pSeg,NULL) == S_OK)
		return TRUE;
	else
		return FALSE;
}
