//@@@@@@@@@@@@@@@@@@@@@@Copyright (c) 2002 Midikyou

BOOL BoxTest(BOX8* pDst,BOX8* pSrc);
BOOL IntersectTriangle(
	const VEC3& orig, const VEC3& dir,
	VEC3& v0, VEC3& v1, VEC3& v2,
	FLOAT* t, FLOAT* u, FLOAT* v );

class CObject
{
	CMesh*		m_pMesh;	//bVENX̃IuWFNg
	CObject*	m_pParent;	//eIuWFNg
	MTX4		m_mtx;		//}gNX
	MTX4		m_mtxOld;	//
	MTX4		m_mtxTmp;	//
	float		m_scale;	//XP[
	float		m_alphaPlus;//lZ
	float		m_alphaAlt;	//փl
	CTexture*	m_pTexAlt;	//փeNX`
	BOOL		m_fRender;	//`tO
	BOX8		m_box;		//E{bNXigXtH[Oj

public:
	static D3DMATERIAL8 matShadow;

	CObject();
	virtual ~CObject();

	void SetMesh(CMesh* pM,VEC3 p=VEC3(0,0,0),float s=1.0f);
	void SetShadowColor(D3DCOLORVALUE cv);
	void Scale(float s);
	void SetScale(float s);
	void SetScale2(float sx, float sy, float sz);

	void SetPosS(VEC3 v);
	void Move(VEC3 v);
	void Move2(VEC3 v);
	void MoveS(VEC3 v);
	void RotX(float v);
	void RotX2(float v);
	void RotY(float v);
	void RotY2(float v);
	void RotZ(float v);
	void RotZ2(float v);
	void RotAxis(VEC3 ax,float v);
	void Billboard();
	void Billboard2();
	void LookAt(VEC3 at);
	void LookAt2(VEC3 at);
	void SetDir(VEC3 dir,VEC3 up=VEC3(0,1,0));

	float GetWScale();
	VEC3 GetPosS();
	VEC3 GetWPos();
	VEC3 GetWRight();
	VEC3 GetWUp();
	VEC3 GetWDir();
	MTX4 GetWMatrix();

	virtual void Render();
	void RenderT();
	void RenderA();
	void RenderAP();
	void RenderSC(D3DMATERIAL8 *mat);
	void RenderShadow(MTX4* pMtx);

	BOX8 GetBox();
	void GetSphere(VEC3* c,float* r);
	BOOL IntersectB(VEC3 pos,VEC3 dir);
	BOOL IntersectS(VEC3 pos,VEC3 dir);
	BOOL Pick(VEC3 pos,VEC3 dir,VEC3* hit,VEC3 tri[]=NULL);
	BOOL IsVisible();

	/*============================================================================
	  `tO̐ݒ
	  
	  f		:TRUE`LAFALSE
	============================================================================*/
	void EnableRender(BOOL f)
	{m_fRender = f;}
	/*============================================================================
	  `tO̎擾
	============================================================================*/
	BOOL IsEnableRender()
	{return m_fRender;}
	/*============================================================================
	  ʒuwi[JWnj
  
	  v		:3DW
	============================================================================*/
	void SetPos(VEC3 v)
	{m_mtx._41 = v.x, m_mtx._42 = v.y, m_mtx._43 = v.z;}
	/*============================================================================
	  ʒu擾i[JWnj
	============================================================================*/
	VEC3 GetPos()
	{return VEC3(m_mtx._41,m_mtx._42,m_mtx._43);}
	/*============================================================================
	  RightxNg擾i[JWnj
	============================================================================*/
	VEC3 GetRight()
	{return VEC3(m_mtx._11,m_mtx._12,m_mtx._13);}
	/*============================================================================
	  UpxNg擾i[JWnj
	============================================================================*/
	VEC3 GetUp()
	{return VEC3(m_mtx._21,m_mtx._22,m_mtx._23);}
	/*============================================================================
	  DirxNg擾i[JWnj
	============================================================================*/
	VEC3 GetDir()
	{return VEC3(m_mtx._31,m_mtx._32,m_mtx._33);}

	/*============================================================================
	@XP[̎擾
	============================================================================*/
	float GetScale()
	{return m_scale;}
	/*============================================================================
	  փeNX`̐ݒ
	============================================================================*/
	void SetTexAlt(CTexture* p)
	{m_pTexAlt = p;}
	/*============================================================================
	  փeNX`̎擾
	============================================================================*/
	CTexture* GetTexAlt()
	{return m_pTexAlt;}
	/*============================================================================
	  փl̐ݒ
	============================================================================*/
	void SetAlphaAlt(float a)
	{m_alphaAlt = a;}
	/*============================================================================
	  փl̎擾
	============================================================================*/
	float GetAlphaAlt()
	{return m_alphaAlt;}
	/*============================================================================
	  Zl̐ݒ
	============================================================================*/
	void SetAlphaPlus(float a)
	{m_alphaPlus = max(-1.0f, min(1.0f, a));}
	/*============================================================================
	   Zl̎擾
	============================================================================*/
	float GetAlphaPlus()
	{return m_alphaPlus;}

	/*============================================================================
	  ϊs̐ݒ
	============================================================================*/
	void SetMatrix(MTX4* pMtx)
	{m_mtx = *pMtx; m_scale = 1;}
	/*============================================================================
	  ϊs̎擾i[JWnj
	============================================================================*/
	MTX4 GetMatrix()
	{return m_mtx;}

	/*============================================================================
	  eIuWFNg̐ݒ
	============================================================================*/
	void SetParent(CObject* p)
	{m_pParent = p;}
	/*============================================================================
	  eIuWFNg̎擾
	============================================================================*/
	CObject* GetParent()
	{return m_pParent;}
	/*============================================================================
	  bV̎擾
	============================================================================*/
	CMesh* GetMesh()
	{return m_pMesh;}
};

/*============================================================================
  E{bNXZbg
============================================================================*/
inline void SetBoxMinMax(BOX8* pB,VEC3 min,VEC3 max)
{
	pB->v[0].x = max.x, pB->v[0].y = max.y, pB->v[0].z = max.z;
	pB->v[1].x = max.x, pB->v[1].y = max.y, pB->v[1].z = min.z;
	pB->v[2].x = max.x, pB->v[2].y = min.y, pB->v[2].z = max.z;
	pB->v[3].x = max.x, pB->v[3].y = min.y, pB->v[3].z = min.z;
	pB->v[4].x = min.x, pB->v[4].y = max.y, pB->v[4].z = max.z;
	pB->v[5].x = min.x, pB->v[5].y = max.y, pB->v[5].z = min.z;
	pB->v[6].x = min.x, pB->v[6].y = min.y, pB->v[6].z = max.z;
	pB->v[7].x = min.x, pB->v[7].y = min.y, pB->v[7].z = min.z;
}
/*============================================================================
  EeXg
  
  c1,r1		:IuWFNgA̒SƔa
  c2,r2		:IuWFNgB̒SƔa
============================================================================*/
inline BOOL SphereTest(VEC3 c1,float r1,VEC3 c2,float r2)
{
	if(D3DXVec3Length(&VEC3(c1-c2)) < r1+r2) return TRUE;
	else return FALSE;
}

//蔲p}N(^^;
#define OBJ_CTRL(o,v) \
{\
	ON_HOLD(DIK_LEFT)  o.Move(VEC3(-v, 0,  0));\
	ON_HOLD(DIK_RIGHT) o.Move(VEC3( v, 0,  0));\
	ON_HOLD(DIK_UP)    o.Move(VEC3(0,  0,  v));\
	ON_HOLD(DIK_DOWN)  o.Move(VEC3(0,  0, -v));\
	ON_HOLD(DIK_PRIOR) o.Move(VEC3(0,  v,  0));\
	ON_HOLD(DIK_NEXT)  o.Move(VEC3(0, -v,  0));\
	ON_HOLD(DIK_V)     o.RotY(-0.05f);\
	ON_HOLD(DIK_B)     o.RotY(0.05f);\
}
