//@@@@@@@@@@@@@@@@@@@@@@Copyright (c) 2002 Midikyou
#include"headers.h"
#include"debug.h"
#include"frame.h"
#include"graphic.h"
#include"vertex.h"
#include"water_mesh.h"

/*============================================================================
  RXgN^
============================================================================*/
CWaterMesh::CWaterMesh()
{
	Init(VEC3(0,0,0),10,10,0.005f);
	SetColor(0xffffffff);
	SetSpeed(0.05f);
	SetGain(1.0f);
}
/*============================================================================
  fXgN^
============================================================================*/
CWaterMesh::~CWaterMesh()
{
}
/*============================================================================
  

  pos	:SW
  w		:(X)
  h		:c(Y)
@d		:UV덷iʂ̍rj
============================================================================*/
void CWaterMesh::Init(VEC3 pos,float w,float h,float d)
{
	for(int y = 0; y < MESH_H+1; y++)
	{
		for(int x = 0; x < MESH_W+1; x++)
		{
			m_cuv[y][x].x = FRAND2(-d, d);
			m_cuv[y][x].y = FRAND2(-d, d);
			m_vec[y][x].x = FRAND2(-d, d);
			m_vec[y][x].y = FRAND2(-d, d);
		}
	}
	m_w  = w;
	m_h  = h;
	m_dw = m_w/MESH_W;
	m_dh = m_h/MESH_H;
	m_pos    = pos;
	m_pos.x -= m_w/2;
	m_pos.y -= m_h/2;
}
/*============================================================================
  ʂɏՌ^

  x		:XW
  y		:YW
  d		:ψ
============================================================================*/
void CWaterMesh::Impact(float x,float y,float d)
{
	int ix = (int)(x/m_dw);
	int iy = (int)(y/m_dh);

	m_cuv[iy][ix].x += d;
	m_cuv[iy][ix].y += d;
}
/*============================================================================
  `Ap[^XV
============================================================================*/
void CWaterMesh::Render()
{
	/* 
		ȉUVωASY http://homepage1.nifty.com/kaneko/
		ɂuqṽvOQlɂĒ܂B
	*/
	//Pt[OUVWۑ
	memcpy(m_ouv,m_cuv,sizeof(m_cuv));

	int x,y;

	//UVW̍Ƃ
	for(y = 1; y < MESH_H; y++)
	{
		for(x = 1; x < MESH_W; x++)
		{
			VEC2 duv(0,0);

			//㉺Eƕς
			duv += m_ouv[y + 1][x] * 0.1f;
			duv += m_ouv[y][x + 1] * 0.1f;
			duv += m_ouv[y][x - 1] * 0.1f;
			duv += m_ouv[y - 1][x] * 0.1f;
			duv -= m_ouv[y][x] * 0.4f;

			//UV̍xZAxUVC
			m_vec[y][x] += duv;
			m_cuv[y][x] += m_vec[y][x] * m_speed;
			m_vec[y][x] *= m_gain; //
		}
	}
	int idx = 0;
	float x1,y1,x2,y2,u1,u2,v1,v2;

	//_̍쐬
	for(y = 0; y < MESH_H; y++)
	{
		for(x = 0; x < MESH_W; x++)
		{
			idx = (y*MESH_W + x)*6;

			x1 = m_pos.x + x*m_dw;
			y1 = m_pos.y + y*m_dh;
			x2 = x1 + m_dw;
			y2 = y1 + m_dh;
			u1 = (float)x/MESH_W;
			v1 = (float)y/MESH_H;
			u2 = (float)(x+1)/MESH_W;
			v2 = (float)(y+1)/MESH_H;

			SetVTX_LX(
				&m_vt[idx  ], x1, y1, 0, m_color,
				u1 + m_cuv[y  ][x  ].x, 1 - (v1 + m_cuv[y  ][x  ].y)
			);
			SetVTX_LX(
				&m_vt[idx+1], x1, y2, 0, m_color,
				u1 + m_cuv[y+1][x  ].x, 1 - (v2 + m_cuv[y+1][x  ].y)
			);
			SetVTX_LX(
				&m_vt[idx+2], x2, y1, 0, m_color,
				u2 + m_cuv[y  ][x+1].x, 1 - (v1 + m_cuv[y  ][x+1].y)
			);
			SetVTX_LX(
				&m_vt[idx+3], x2, y2, 0, m_color,
				u2 + m_cuv[y+1][x+1].x, 1 - (v2 + m_cuv[y+1][x+1].y)
			);
			m_vt[idx+4] = m_vt[idx+2];
			m_vt[idx+5] = m_vt[idx+1];
		}
	}
	//_obt@̍쐬A_O
	m_vtx.Create(m_vt,FVF_LX,sizeof(m_vt));
	m_vtx.RenderTL();
}
